require(ViewPath .. "loadingLayout")
ToastShade = class(Node)
new(Image, "loading.png")

ToastShade.s_level = 51

ToastShade.ctor = function(self, isShowBg, loadingText, isTextAnim)
	self.shadeNode = new(BaseLayer, loadingLayout)
    self:addChild(self.shadeNode)
	self.shadeNode:setLevel(ToastShade.s_level)
    local w, h = self.shadeNode:getSize()

    self.shadeNode:findChildByName("shade_bg"):setVisible(isShowBg or false)
    local textLoading = self.shadeNode:findChildByName("text_loading")
    if loadingText then
        textLoading:setText(loadingText)
        textLoading:setVisible(true)
    else
        textLoading:setVisible(false)
    end
    if isTextAnim then
        self.loadingTextAnim = true
    end
    self:setAlign(kAlignCenter)

end

ToastShade.dtor = function(self)

end

ToastShade.setLevel = function(self, level)
	self.shadeNode:setLevel(level or ToastShade.s_level)
end

ToastShade.play = function(self)
    self.shadeNode:setVisible(true)
	local loading1 = self.shadeNode:findChildByName("loading_white1")
	local loading2 = self.shadeNode:findChildByName("loading_white2")
    loading1:removeProp(199)
    loading2:removeProp(199)

	local x1, y1 = loading1:getPos()
	local x2, y2 = loading2:getPos()
	local centerX1 = x1 + 16
	local centerY1 = -y1 + 10
	local centerX2 = x2 + 58
	local centerY2 = -y2 + 3
	local index = 1
	local angle1 = {0, 60, 117, 175, 237, 300, 360}
	local angle2 = {0, 60, 120, 180, 240, 300, 360}
    local bgNode = self.shadeNode:findChildByName("loading_bg")
    bgNode:removeProp(1)
    
    local animRotate = bgNode:addPropTranslate(1, kAnimRepeat, 120, 0, 0, 0, 0, 0)
    animRotate:setEvent(animRotate, function()
        loading1:removeProp(199)
        loading1:addPropRotateSolid(199, angle1[index], kCenterXY, centerX1, centerY1)
        loading2:removeProp(199)
        loading2:addPropRotateSolid(199, angle2[index], kCenterXY, centerX2, centerY2)
		--loading1:addPropRotate(199, kAnimNormal, 0, 0, angle1[index], angle1[index + 1], kCenterXY, centerX1, centerY1)
		--loading2:addPropRotate(199, kAnimNormal, 0, 0, angle1[index], angle2[index + 1], kCenterXY, centerX2, centerY2)
		index = (index + 1) >= #angle1 and 1 or (index + 1)
	end)

	self.shadeNode:findChildByName("view_loading"):setVisible(true)
    
    if self.loadingTextAnim then  
        local text = self.shadeNode:findChildByName("text_loading")
        text:removeProp(100)
        local timer = text:addPropTranslate(100, kAnimRepeat, 200, 0, 0, 0, 0, 0)
        text:setText(STR_LOAING)
        local pcount = 0
        timer:setEvent(timer, function()
            pcount = pcount + 1
            if pcount > 6 then
                pcount = 0
            end
            local pstr = ""
            for i = 1, pcount do
			        pstr = pstr .. '.'
		    end
		    text:setText(STR_LOAING..pstr);
        end)
    end 
    
end

ToastShade.stop = function(self)
	self.shadeNode:findChildByName("loading_white1"):removeProp(199)
	self.shadeNode:findChildByName("loading_white2"):removeProp(199)
    self.shadeNode:findChildByName("loading_bg"):removeProp(1)
    self.shadeNode:findChildByName("text_loading"):removeProp(100)
	self.shadeNode:setVisible(false)

end

ToastShade.setLoadingText = function(self, str)
    self.shadeNode:findChildByName("text_loading"):setText(str)
end
