
require("manager/windowManager")

local App = class()

function App:run()
	app = self
	StateMachine.getInstance():changeState(States.Load)
end

function App:ctor()
	-- body
	NativeEvent.getInstance():boyaaAd({type = 1, value = 'start'})
	self.mGames = {}
	self.mGameStatus = {}
	self.mGameLatestVersion = {}
end

function App:dtor()
	-- body
	self.mGames = nil
end

function App:isInRoom()
	return kCurrentState == States.Room
end

function App:isInGame()
	return G_RoomCfg:getIsPlaying()
end

function App:checkResponseOk(isSuccess, data, avoidErrorTip)
	if isSuccess and data and data.code == 1 and data.data then
		return true
	end
end


function App:judgeRequestSignInfo()
	local reconnWindow = WindowManager:containsWindowByTag(WindowTag.ReconnMessageBox)
	local guideWindow = WindowManager:containsWindowByTag(WindowTag.GuidePopu)
	if not self:isInRoom() and not reconnWindow and not guideWindow and MyUserData:getIsLogin() and not MySignAwardData:getInit() then
        GameSocketMgr:sendMsg(Command.SIGN_AWARD_PHP_REQUEST, {}, false);
    end
end

-- 大厅连接成功
function App:onSocketConnected()

	-- 开始心跳包
	GameSetting:setDisableReconn(false)
	-- LoginMethod:autoRequestLogin()
	--登录SERVER
	printInfo('Command.LOGIN_SERVER_REQ')
	GameSocketMgr:sendMsg(Command.LOGIN_SERVER_REQ, {});
	GameSocketMgr:startHeartBeat();
end

function App:requestBaseInfo()
	GameSocketMgr:sendMsg(Command.GET_BASEINFO_PHP_REQUEST, {cfgParam = {s1 = 0xf, d1 = 0xff}}, false);
end

function App:onNetErrorBackToLobby()
	-- 如果网络正常 更新域名配置
   	if NativeEvent.getInstance():GetNetAvaliable() == 1 then
   		HallConfig:freshNetConfig(true)
   	end
	-- StateChange.changeState(States.Lobby, {
	-- 	type = StateEvent.SocketClosed,
	-- })
end

function App:onSocketTimeOut()
	printInfo("App:onSocketTimeOut");
end

function App:onSocketSendError()
	printInfo("App:onSocketSendError");
end

-- 主要用于server命令字的超时
function App:onCommandTimeout(cmd)
	--进房间超时
	if cmd == Command.JoinGameReq then
		StateChange.changeState(States.Lobby)
		GameSocketMgr:sendMsg(Command.LogoutRoomReq)
	elseif cmd == Command.SOCKET_EVENT_CONNECTED then --连接服务器失败
		GameSocketMgr:onSocketConnectFailed()
	end
end

--是否加载房间列表
function App:checkAndDownloadRoomList(gameId, curVersion, showLoading)
	-- body
	repeat
		local roomList = MyRoomConfig:get(gameId)
		if not roomList then break end
		local version 	 = roomList:getVersion();
		if curVersion > version then break end
		return true
	until true
	printInfo('gameId ---------------------------------------------------------------- ' .. gameId)
	HttpModule.s_config[HttpModule.s_cmds.GET_ROOM_LIST][HttpConfigContants.URL] = tostring(gameId)
	if gameId == 104 or gameId == 1004 then 
		printInfo("1::::")
		HttpModule.getInstance():execute(HttpModule.s_cmds.GET_MAKHOS_ROOM_LIST, {}, showLoading, true);
	elseif gameId == 1009 then 
		-- 拉取上庄场房间列表
		printInfo("2::::")
		HttpModule.getInstance():execute(HttpModule.s_cmds.GET_DEALER_ROOM_LIST, {}, showLoading, true);
	else
		printInfo("3::::")
		HttpModule.getInstance():execute(HttpModule.s_cmds.GET_ROOM_LIST, {}, showLoading, true);
	end
	return false
end

function App:getRoomFromLevel(gameId, level)
	repeat
		local roomList = MyRoomConfig:get(gameId)
		if not roomList then break end
		for i = 1, roomList:count() do
			local room = roomList:get(i);
			if level == room:getLevel() then
				return room;
			end
		end
	until true
end

--上报
function App:postFrontStaticstics(event)
	-- body
	HttpModule.getInstance():execute(HttpModule.s_cmds.FRONTSTATISTICS, {reportData =  {{id= event}}}, false, true)
end

--获取游戏安装路径
function App:getGameInstallPath( gameId )
	-- body
	local games = MyUserData:getLobbyGames()
	for k, v in pairs(games) do
		if tonumber(v.gameid) == tonumber(gameId) then
			return v.path
		end
	end
    return ""
end
--获取游戏icon地址
function App:getGameIconUrl(gameId)
	-- body
	local games = MyUserData:getLobbyGames()
	for k, v in pairs(games) do
		if tonumber(v.gameid) == tonumber(gameId) then
			return v.icon
		end
	end
	return ''
end
--获取游戏更新码
--function App:getGameUpdateVerUrl(gameId)
--	-- body
--	local games = MyUserData:getLobbyGames()
--	for k, v in pairs(games) do
--		if tonumber(v.gameid) == tonumber(gameId) then
--			return v.updateVerUrl
--		end
--	end
--	return ''
--end
function App:getGameUpdateZipUrl(gameId)
	-- body
	local games = MyUserData:getLobbyGames()
	for k, v in pairs(games) do
		if tonumber(v.gameid) == tonumber(gameId) then
			return v.updateZipUrl
		end
	end
	return ''
end
--获取游戏列表
function App:getGameIds()
	-- body
	local gameids = {}
	local games = MyUserData:getLobbyGames()
	for i = 1, #games do
		table.insert(gameids, tonumber(games[i].gameid))
	end
	return gameids
end


--判断游戏是否已安装
function App:isGameInstalled(gameId)
	-- body
	repeat
		local path = App:getGameInstallPath(gameId)
		if not path then break end
        local curPlatform = System.getPlatform()
		if curPlatform == kPlatformAndroid then
			local absPath = string.format('%s/scripts/%s/%s', PhpManager:getFiles_path(), path, 'version.lua')
			if loadfile(absPath) then
				return true
			end
			local absPath = string.format('%s/update/scripts/%s/%s', PhpManager:getFiles_path(), path, 'version.lua')
			return nil ~= loadfile(absPath)
        elseif curPlatform == kPlatformIOS then
            local absPath = string.format('%s/scripts/%s/%s', PhpManager:getRes_path(), path, 'version.lua')
			if loadfile(absPath) then
				return true
			end
			local absPath = string.format('%s/update/scripts/%s/%s', PhpManager:getFiles_path(), path, 'version.lua')
			return nil ~= loadfile(absPath)
		end
        return true
	until true
	return false
end
--获取某个游戏
function App:getGame(gameId)
	-- body
	local game = nil
	repeat
		game = self.mGames[tonumber(gameId)]
		if game then 
			local roomList = game:getRoomList()
			if not roomList:getInit() then
				game:initRoom(MyRoomConfig:get(gameId))
			end 
			break 
		end
		if app:isGameInstalled(gameId) then
			local path = app:getGameInstallPath(gameId)
			if not path or path == '' then break end
			game = new(require(string.format('%s.%s', path, 'game')), MyRoomConfig:get(gameId))
			self.mGames[tonumber(gameId)] = game
		end
	until true
	return game
end
--重新加载某个游戏
function App:reloadGame(gameId)
    if app:isGameInstalled(gameId) then
		local path = app:getGameInstallPath(gameId)
		if not path or path == '' then 
            return 
        end
        local gamePath = string.format('%s.%s', path, 'game')
        package.loaded[gamePath] = nil
		local game = new(require(string.format('%s.%s', path, 'game')), MyRoomConfig:get(gameId))
		self.mGames[tonumber(gameId)] = game
	end
end
--获取某个游戏的状态
function App:getGameStatus(gameId)
	if not self.mGameStatus[gameId] then
		self.mGameStatus[gameId] = setProxy(new(require('data.lobbyGame')))
	end
	return self.mGameStatus[gameId]
end
--获取某个游戏的当前版本信息
function App:getGameCurVersion(gameId)
	--更新时的路径
	local path = string.format('%s/update/scripts/%s/version.lua', PhpManager:getFiles_path(), app:getGameInstallPath(gameId))
 	local chuck = loadfile(path)
 	if chuck then
 		return chuck() or 100
 	end
 	--安装APK时的路径
 	local path = string.format('%s/scripts/%s/version.lua', PhpManager:getFiles_path(), app:getGameInstallPath(gameId))
 	local chuck = loadfile(path)
 	if chuck then
 		return chuck() or 100
 	end

 	--IOS app .bundle 的资源路径
 	local path = string.format('%s/scripts/%s/version.lua', PhpManager:getRes_path(), app:getGameInstallPath(gameId))
 	local chuck = loadfile(path)
 	if chuck then
 		return chuck() or 100
 	end

 	return 100
end
--设置某个游戏的最新版本信息
--function App:setGameLatestVersion(gameId, version)
--	-- body
--	self.mGameLatestVersion[gameId] = tonumber(version or 0) or 0
--end
----获取某个游戏的最新版本信息
--function App:getGameLatestVersion(gameId)
--	-- body
--	return self.mGameLatestVersion[gameId] or 0
--end

--[[
	下载游戏版本控制
--]]
--function App:downloadGameVerConf()
--	-- body
--	local gameIds = app:getGameIds()
--	for i = 1, #gameIds do
--		local gameId 	 = gameIds[i]
--		if gameId ~= 0 then
--			local curVer 	 = app:getGameCurVersion(gameId);
--			local updateUrl  = string.format('%s%s.lua?v=%d', app:getGameUpdateVerUrl(gameId), curVer, math.floor(os.time() / 600))
--			local updateFile = string.format('scripts/%s/verconf.lua', app:getGameInstallPath(gameId))

--			local file
--			local basePath
--			local folder

--			local s_platform = System.getPlatform()
--			if s_platform == kPlatformIOS  then
--				basePath = "/update/"
--				folder = string.format('scripts/%s/', app:getGameInstallPath(gameId))
--				updateFile = "verconf.lua"

--			end


--			--下载配置文件
--			MyUpdate:download("update", updateUrl, updateFile, self, function (self, jsonData)
--				local status = tonumber(jsonData.status:get_value()) or 0
--				--下载成功
--				if status == 1 then
--					print('download ver config suc')
--					repeat
--						local absPath = string.format('%s/%s', PhpManager:getFiles_path(), updateFile)
--						local s_platform = System.getPlatform()
--						if s_platform == kPlatformIOS  then
--							absPath = PhpManager:getFiles_path() .. basePath .. folder .. updateFile
--						end 
--						print(absPath,"absPath")
--						local chunk   = loadfile(absPath)
--						if not chunk then break end --文件有误
--						local updateTable = chunk()
--						if not updateTable or not updateTable.ver then break end --文件有误
--                        local updateSize = updateTable.size
--						local updateVer = updateTable.ver
--						--设置最新版本
--						app:setGameLatestVersion(gameId, updateVer)
--						return 
--					until true
--					--如果发生错误，则设置最新版本与当前版本一致，以防下载问题，进不了房间
--					if app:isGameInstalled(gameId) then
--						app:setGameLatestVersion(gameId, curVer)
--					end
--				--下载失败
--				elseif status == 0 then
--					print('download ver config faild')
--					--设置最新版本与当前版本一致，以防下载问题，进不了房间
--					if app:isGameInstalled(gameId) then
--						app:setGameLatestVersion(gameId, curVer)
--					end
--				end
--			end,basePath,folder)
--		end
--	end
--end

--统计
function App:staticstics( eventStr )
	-- body
	HttpModule.getInstance():execute(HttpModule.s_cmds.UPDATE_GAME_EVENT, {eventName = eventStr}, false, false)
end

return App