require("core.object")
require("base.baseLayer")

-- 去除gameScene 的版本
BaseController = class(BaseLayer) 
function BaseController:ctor(viewConfig, state, ...)
	BaseLayer.addToRoot(self)
	BaseLayer.setFillParent(self,true,true)
	self.m_state = state
	self.m_ctrl = self.s_controls;
	EventDispatcher.getInstance():register(Event.Message, self, self.onMessageCallDone)
	EventDispatcher.getInstance():register(Event.Socket, self, self.onSocketReceive)
	
end

-- 切换界面完成后 处理业务
function BaseController:dealBundleData(bundleData)
end


function BaseController:resume(bundleData)
	self.m_root:setPickable(true)
	if WindowManager then
		WindowManager:dealWithStateChange()
	end
end

function BaseController:pause()
	self.m_root:setPickable(false);
	EventDispatcher.getInstance():unregister(Event.Message, self, self.onMessageCallDone)
	EventDispatcher.getInstance():unregister(Event.Socket, self, self.onSocketReceive)
end

function BaseController:dtor()
	printInfo("BaseController:dtor")
	EventDispatcher.getInstance():unregister(Event.Message, self, self.onMessageCallDone);
	EventDispatcher.getInstance():unregister(Event.Socket, self, self.onSocketReceive);
end

function BaseController:pushStateStack(obj, func)
	self.m_state:pushStateStack(obj,func);
end

function BaseController:popStateStack()
	self.m_state:popStateStack();
end

function BaseController:stop()
	self.m_root:setVisible(false);
end

function BaseController:run()
	self.m_root:setVisible(true);
	self.m_root:setPickable(false);
end

function BaseController:onBack()

end

BaseController.messageFunMap = {
}

BaseController.commandFunMap = {
}

function BaseController:onMessageCallDone(param, ...)
	if self.messageFunMap[param] then
		self.messageFunMap[param](self,...)
	end
end

function BaseController:onSocketReceive(param, ...)
	if self.commandFunMap[param] then
		self.commandFunMap[param](self,...)
	end
end

function BaseController:moneyIncreaseShare(money)
    if MyUserData:getUserType() == UserType.Visitor then
        if GameSetting:getShareTimesGuest() >= 3 then
            return
        end
    else
        if GameSetting:getShareTimesFb() >= 3 then
            return
        end
    end
    if money >= 10000000 then
		if MyUserData:getUserType() == UserType.Visitor then
			if GameSetting:getMultimillionaireGuest() == 0 then
                WindowManager:showWindow(WindowTag.SharePopu, {content = STR_SHARE_MULTIMILLIONAIRE, strParam = {PhpManager:getGameName()}}, WindowStyle.POPUP)
			end
		else
			if GameSetting:getMultimillionaireFb() == 0 then
                WindowManager:showWindow(WindowTag.SharePopu, {content = STR_SHARE_MULTIMILLIONAIRE, strParam = {PhpManager:getGameName()}}, WindowStyle.POPUP)
			end
		end
	elseif money >= 1000000 and money < 10000000 then
		if MyUserData:getUserType() == UserType.Visitor then
			if GameSetting:getMillionaireGuest() == 0 then
                WindowManager:showWindow(WindowTag.SharePopu, {content = STR_SHARE_MILLIONAIRE, strParam = {PhpManager:getGameName()}}, WindowStyle.POPUP)
				--GameSetting:setMillionaireGuest(1)
                --GameSetting:setShareTimesGuest(GameSetting:getShareTimesGuest() + 1)
				--GameSetting:save()
			end
		else
			if GameSetting:getMillionaireFb() == 0 then
                WindowManager:showWindow(WindowTag.SharePopu, {content = STR_SHARE_MILLIONAIRE, strParam = {PhpManager:getGameName()}}, WindowStyle.POPUP)
				--GameSetting:setMillionaireFb(1)
                --GameSetting:setShareTimesFb(GameSetting:getShareTimesFb() + 1)
				--GameSetting:save()
			end
		end
	end

end