require("gameBase/httpManager");
require("libs/json_wrap");
require("animation/toastShade");

-- 上传包，在电脑本地输入：
-- \\192.168.100.133\wwwroot\w7poker_swf\apkft
-- 获取二维码，在浏览器输入：
-- http://pirates133.by.com/w7poker_swf/apkft/

LOCAL_NET = false

if LOCAL_NET then
	HOST_URL = 'http://gamehall.oa.com/game/hall/index.php'
else
	HOST_URL = 'http://mvbrapo01.boyaagame.com/androidbr/game/hall/index.php'
end

-- Joins = function(t, mtkey)
--     local str = "K";
--     if t == nil or type(t) == "boolean"  or type(t) == "byte" then
--         return str;
--     elseif type(t) == "number" or type(t) == "string" thenpin
--         str = string.format("%sT%s%s", str.."", mtkey, string.gsub(t, "[^a-zA-Z0-9]",""));
--     elseif type(t) == "table" then
--         for k,v in orderedPairs(t) do
--             str = string.format("%s%s=%s", str, tostring(k), Joins(v, mtkey));
--         end
--     end
--     return str;
-- end
Joins = function(data,isSig)
    local str = "";
    local key = {};
    local sig = 0;

    if data == nil then
        return str;
    end

    for i,v in pairs(data) do
        table.insert(key,i);
    end
    table.sort(key);
    for k=1,table.maxn(key) do
        sig = isSig;
        local b = key[k];
        if sig ~= 1 and string.sub(b,1,4) == "sig_" then
            sig = 1;
        end
        local obj = data[b];
        local oType = type(obj);
        local s = "";
        if sig == 1 and oType ~= "table" then
            str = string.format("%s&%s=%s",str.."",b,obj);
        end
        if oType == "table" then
        	local ret = Joins(obj, 0);
        	if ret ~= "" then
        		str = str..ret;
        	end
            -- str = string.format("%s%s=%s",str.."",b,Joins(obj,sig));
        end
    end

    return str;
end

HttpModule = class();
HttpModule.CommonUrl = nil;
HttpModule.s_event = EventDispatcher.getInstance():getUserEvent();

HttpModule.getInstance = function()
	if not HttpModule.s_instance then 
		HttpModule.s_instance = new(HttpModule);
	end
	return HttpModule.s_instance;
end

HttpModule.releaseInstance = function()
	delete(HttpModule.s_instance);
	HttpModule.s_instance = nil;
end

HttpModule.ctor = function(self)
	self.m_httpManager = new(HttpManager,HttpModule.s_config,HttpModule.postDataOrganizer,HttpModule.urlOrganizer);
	EventDispatcher.getInstance():register(HttpManager.s_event,self,self.onHttpResponse);
end

HttpModule.dtor = function(self)
	EventDispatcher.getInstance():unregister(HttpManager.s_event,self,self.onHttpResponse);
	delete(self.m_httpManager);
	self.m_httpManager = nil;
end

HttpModule.postDataOrganizerNoEncode = function(method, data)
	local post_data = {};
   	HttpModule.postDataInit(post_data, data);
    if method and method ~= "" and not string.find( method, "#") then
    	 post_data.method = method;
    end

    if data then
    	if method == 'Feedback.mGetFeedback' or method == 'Feedback.sendFeedback' then
        	post_data.param = data;
	    else
	    	post_data.game_param = data;
	    end
    end
    local signature = HttpModule.joins(post_data.mtkey,post_data);
    
    post_data.sig = string.upper(md5_string(signature));
    
    method = method or "";
    -- 不进行编码
   	print_string(method .. "|api = " .. json.encode(post_data));
	return "api=".. json.encode(post_data);
end
--[[
	post data
]]
HttpModule.postDataOrganizer = function(method, data)
	local post_data = {};
	--初始化基础参数
   	HttpModule.postDataInit(post_data, data);
   	--参数为方法名
    if method and method ~= "" and not string.find( method, "#") then
    	 post_data.method = method;
    end

    if data then
    	if method == 'Feedback.mGetFeedback' or method == 'Feedback.sendFeedback' then
        	post_data.param = data;
	    else
	    	post_data.game_param = data;
	    end
    end
    dump(post_data)
    --md5
    printInfo("sig = "..HttpModule.joins(post_data, 0))
    local md5Str = HttpModule.joins(post_data, 0);
    printInfo("md5str = "..md5Str);
    post_data.sig 	= md5_string(md5Str);
    --json
    local dataStr = HttpModule.dataEncode_lua(json.encode(post_data));
    --print
   	print_string((method or "") .. "|api = " .. dataStr);
	return "api=".. dataStr..(LOCAL_NET and '&demo=1' or "");
end

HttpModule.dataEncode_lua = function(str)

	if str == nil then  
		return "";
	end
	
	local platformStr = sys_get_string("platform");
	if platformStr == kPlatformWin32 then
		str = string.gsub (str, "\n", "\r\n");
      	str = string.gsub (str, "([^%w ])",
         	function (c) return string.format ("%%%02X", string.byte(c)) end);
      	str = string.gsub (str, " ", "+");
		return str;
	end

    -- return NativeEvent.getInstance():encodeStr(str);
    return string.urlencode(str);
end

HttpModule.postDataInit = function(post_data, param_data)
    -- post_data.mid 		= MyUserData:getId();
    -- post_data.username 	= string.format("user_%s", post_data.mid);
    -- post_data.time 		= os.time();
    -- post_data.appkey 	= PhpManager:getAppkey();
    -- post_data.api 		= PhpManager:getApi();
    -- post_data.appid 	= PhpManager:getAppid();
    -- post_data.usertype 	= MyUserData:getUserType();	--Android游客:7 sina用户:2 博雅通行证:12 QQ用户:3
    -- post_data.mtkey 	= MyUserData:getSessionId().."";
    -- post_data.vkey  	= PhpManager:getDevice_id();

    post_data.sesskey 	= MyUserData:getSessionId(); 	--会话ID，登录前此值为空
    post_data.sid 		= param_data.sid or tonumber(PhpManager:getGame());	--平台ID
    post_data.lid 		= MyUserData:getUserType(); 	--登录帐号类型ID(1:FB, 2:游客)
    post_data.version 	= PhpManager:getVersionName() --版本号
    local channel = require("adChannel")		--如果有广告渠道文件，参数里额外加个
    if channel ~= "" then
    	post_data.channel = channel.."_"..(PhpManager:getGame())
    end
    -- post_data.demo 		= 1; 	--是否为测试环境，正式环境不用传此参数
end

HttpModule.joins = function(data, isSig)
  return '['..Joins(data, isSig)..']';
end

HttpModule.urlOrganizer = function(url,method,httpType)
	if httpType == kHttpGet then
		return url;
	end

	if  string.find(method, "#") then
		local indexs =  string.find( method, "#");
	    local m = "";
	    local p = "";
	    if indexs then
	        m = string.sub(method , 1 , indexs-1);
	        p = string.sub(method , indexs + 1 );
	    end
	    if m ~="" and p ~= "" then
    	 	url = url .. "?m=".. m .. "&p=" .. p;
    	elseif m ~= "" and p == "" then 
    		url = url .. "?m=" .. m;
    	elseif m == "" and p ~= "" then 
    		url = url .. "?m=" .. p;
    	end  
    -- else
    -- 	url=url.."?m="..method;
    elseif not string.find(url, "http") then
    	local gameList = MyUserData:getGameList();
    	local gateway = gameList and gameList[url] or {};
    	if gateway['gateway'] then
    		url = gateway['gateway'];
    	end
    end 

	return url;
end

HttpModule.execute = function(self, command, data, isShowLoading, continueLast)
	return self.m_httpManager:execute(command, data, continueLast);
end

-- 根据指定的域名来
HttpModule.executeDirect = function(self, command, domain, data, isShowLoading)
	return self.m_httpManager:executeDirect(command, domain, data);
end

HttpModule.onHttpResponse = function(self,command,errorCode,data, resultStr)
	
	local errMsg = nil;
	if errorCode == HttpErrorType.NETWORKERROR then
		printInfo(command .. "netWorkError")
		errMsg = GameString.get("netWorkError") or "";
		--ToastShade.getInstance():stopTimer();
	elseif  errorCode == HttpErrorType.TIMEOUT then
		printInfo(command .. "netWorkTimeout")
		errMsg = GameString.get("netWorkTimeout") or "";
		--ToastShade.getInstance():stopTimer();
	elseif  errorCode == HttpErrorType.JSONERROR then	
		printInfo(command .. "netWorkJsonError")
		errMsg = GameString.get("netWorkJsonError") or "";
		--ToastShade.getInstance():stopTimer();
	end

	EventDispatcher.getInstance():dispatch(HttpModule.s_event,command,errMsg == nil, errMsg or data, resultStr);
	--ToastShade.getInstance():stopCommand();
end

HttpModule.s_cmds = 
{
	GetServerSite 	= 1,
	GetFeedbackList = 2,
	SendFeedback 	= 3,
	SolveFeedback 	= 4,
	VoteFeedback 	= 5,
	RequestChargeList = 6,
	RequestPayOrder	= 7,
	RequestPayConfig = 8,
	RequestPayConfigForLimit = 9,
	WeChatAccessToken 		 = 10,

	LOGIN_PHP 			 = 11,
	GET_DICE_LOGIN 		 = 13,
	GET_FB_INVITE_AWARD  = 14,
	GET_FB_INVITE_SUC_AWARD = 15,
	GET_BROKEN_MONEY 		= 16,
	GET_PAY_MODE 			= 17,
	GET_PAY_LIST 			= 18,
	GET_PAY_ORDER 			= 19,
	GET_PAY_NOTIFY 			= 20,

	GET_REGISTER_REWARD 	= 22,

    GET_SEND_PROP           = 23,	
    GET_PROP_LIST      	    = 24,	

	GET_HALL_BANKRUPT       = 26,
	GET_HALL_BANKRUPT_TAG   = 27,	
    GET_SEND_GAME_CHIP      = 28,	--送筹码
    FRONTSTATISTICS 		= 29,   --数据统计
    GET_HALL_USER_NEWS      = 30,	--个人消息
    GET_HALL_USER_NOTICES   = 31,	--公告消息
    GET_HALL_USER_NEWS_DEL  = 32,	--删除公告消息
    GET_HALL_USER_NOTICES_DEL = 33,	--删除公告消息
    GET_HALL_USER_NOTICES_AWARD = 34,	--公告消息
    GET_HALL_USER_NOTICES_READED = 35,  --公告已读过
    GET_MARQUEE_NOTICES             = 37,  --获取小喇叭公告
    SET_HALL_ATTENDENCE 			= 36, 	--确认今天签到
    GET_H3_LOGIN 					= 42, 	--鱼虾蟹的登陆，获取在线
    GET_UPGRADE_REWARD				= 43,	--等级礼包
    GET_DUIJIANG_REWARD				= 44,   --兑换码
    GET_GAMEINFO					= 45,	--个人资料
    UPDATE_USER_SEX					= 46,	--修改性别
    UPDATE_USER_NAME				= 47,   --修改昵称
    UPDATE_USER_ICON				= 48,	--更新用户图像
    UPDATE_MEMBER_BEST				= 49, 	--更新用户赢取最大筹码
    INVITE_CONFIG					= 55,	--邀请好友配置

    GET_FRIENDS 					= 56, 	--获取好友列表
    GET_APPLY 						= 57, 	--获取申请列表
    ADD_FRIEND 						= 58, 	--添加好友
    SEARCH_FRIEND 					= 59, 	--获取查询结果
    GET_GIFT 						= 60, 	--获取礼物列表
    GIVING_TIPS						= 63,	--给荷官送小费
    
    FRIEND_ACCEPT 					= 64, 	--接受好友请求
    FRIEND_REFUSE 					= 65, 	--拒绝好友请求
    GET_OTHER_FORM_FRIEND 			= 66, 	--获取他人资料
    SEND_GIFT 						= 67, 	--赠送礼物
    FETCH_GIFT 						= 68, 	--接受礼物
    FRIEND_DELETE 					= 70, 	--好友删除
    
    POST_CLIENTID					= 71,   --上报个推ID
    FRIEND_UNREAD					= 72,   --好友未读

    GET_TASK 						= 73,	--获取任务
    GET_TASK_AWARD 					= 74,	--获取任务奖励
    HAS_TASK_AWARD 					= 75, 	--是否有任务奖励
    GET_ROOM_LIST 					= 76, 	--获取房间列表（所有的游戏都是通过该命令去获取）
    GET_GAME_LOGIN 					= 77, 	--登录某一款游戏（所有的游戏都是通过该命令去获取）

    GET_MAKHOS_ROOM_LIST 			= 81,   --马哈的房间列表
    GET_MAKHOS_LOGIN 				= 82, 	--马哈的登陆，获取在线

    UPDATE_GAME_EVENT 				= 83,   --统计热更新

    GET_URGENT_NOTICE               = 84,   --紧急公告的请求消息
    GET_USER_MONEY                  = 85,   --获取玩家的金币数量，用来必要时同步金钱
    GET_INVITE_TASK_PROGRESS        = 86,   --邀请好友的任务列表
    GET_CASH_AWARDS                 = 87,   --现金币能兑换的商品列表
    EXCHANGE_AWARD_BY_ID            = 88,   --兑换某种商品
    GET_CASH_EXCHANGE_RECORD        = 89,   --现金币兑换记录
    DEL_CASH_EXCHANGE_RECORD        = 90,   --删除兑换记录
    GET_CASH_TASK_FRIEND                   = 91,   --现金币任务
    GET_CASH_TASK_FRIEND_REWARD            = 92,   --领取现金币任务积分
    GET_CASH_TOTAL                  = 93,   --查询自己的现金币积分
    GET_CASH_ON_CLICK_STATISTICS    = 94,   --统计自己的现金币点击次数
    GET_ACTIVITY_REWARD_CONFIG      = 95,   --获取奖励配置
    GET_ACTIVITY_GAME_RECORD        = 96,   --获取活动比赛记录
    GET_ACTIVITY_REWARD_RECORD      = 97,   --获取活动领奖记录
    GET_IS_ACTIVITY_TIME            = 98,   --查询是否处于马哈活动时间
    GET_MAKHOS_ACTIVITY_GAME_RESULT = 99,   --马哈活动结束,查询奖励
    RESET_MAKHOS_WIN_STREAK         = 100,   --离开房间终止连胜
    POST_GCM_BACK_USER_ID           = 101,  --反馈长时间不登陆后谷歌推送的点击统计
    GET_BUDDY_ROOM_LIST             = 102,  --获取好友房列表
    GET_BUDDY_ONLINE_LIST           = 103,  --获取在线好友列表
    SEND_BUDDY_ROOM_INVITE          = 104,  --邀请好友加入好友房
    SEND_ACTIVITY_SHARE_STATISTIC   = 105,  --活动中心分享成功统计
    CHECK_SWITCH_FOR_ALL            = 107,  --所有开关列表，后续需要开关控制的功能都放在这个接口里
    GET_PAY_PROP_LIST               = 108,  -- 获取商城道具列表
    MAKHOS_BUYREGRET                = 109,  -- 单机马哈购买悔棋道具
    GIFT_STORE_SEND                 = 110,  --赠送好友礼物
    GIFT_STORE_BUY                  = 111,  --购买礼物
    GIFT_UPDATE_MINE                = 112,  --更换自己的礼物
    GIFT_GET_ALL_MINE               = 113,  --查询自己的礼物
    GIFT_STORE_GET_LIST             = 114,  --获取礼物列表
    DUMMY_GET_TIPS_COUNT			= 115,  --大米获取提示剩余次数
    GET_USER_ALL_PROPS				= 116,  --获取用户所有的道具数量
    GET_FB_CALLBACK_REWARD_CFG      = 117,  --获取召回奖励配置
    GET_FB_CALLBACK_LIST            = 118,  --获取可召回玩家列表
    GET_FB_CALLBACK_REWARD          = 119,  --获取FB好友召回奖励
    GET_BANKRUPT_RELIEF             = 120,  --破产时请求好友救济
    SEND_REGISTER_GAME_STA          = 121,  --玩家首次进入游戏发送统计请求
    GET_NOTIFICATION_REWARD         = 122,  --点击推送进入游戏领奖
    GET_PROP_CFG_LIST               = 123,  --获取道具配置列表，便于新增拓展道具
    REPORT_DEBUG_INFO               = 124,  --上传调试信息给PHP

    GET_DEALER_ROOM_LIST 			= 125,	--获取上庄场房间列表
    GIFT_GET_BADGE					= 126,	-- 获取用户徽章
    GIFT_WEAR_BADGE					= 127,	-- 用户佩戴徽章
    GET_PRIVATE_ROOM_BILL_LIST      = 128,  --私人房获取房间列表和账单列表
    GET_PRIVATE_ROOM_UNREAD_BILL    = 129,  --获取私人房是否有未读账单

    GET_HALL_ACTIVITY_LIST          = 130,  --大厅活动列表
    GET_HALL_ACTIVITY_REWARD        = 131,  --大厅活动奖励
    HALL_ACTIVITY_JOIN              = 132,  --大厅活动更新用户点击参加活动
    HALL_ACTIVITY_FINISH            = 133,  --大厅活动更新用户完成活动
    GET_ACT_SHARE_URL               = 134,  --大厅活动更新用户完成活动
   
};

HttpModule.loginSuffix 		= "?m=login&p=index";
HttpModule.passportQuickUrl = "http://passport.boyaa.com/user/check"; -- 博雅通行证快速登录

HttpModule.s_config = {}

HttpModule.initUrlConfig = function(self, domainChange)

	local DOMAIN = HallConfig:getDomain()
	HttpModule.s_config = 
	{
		[HttpModule.s_cmds.GetServerSite] = {
			kPhpServerUrl,
			"",
		},
		[HttpModule.s_cmds.GetFeedbackList] = {
			'http://feedback.kx88.net/api/api.php',
			"Feedback.mGetFeedback",
		},
		[HttpModule.s_cmds.SendFeedback] = {
			"http://feedback.kx88.net/api/api.php",
			"Feedback.sendFeedback",
		},
		[HttpModule.s_cmds.SolveFeedback] = {
			"http://feedback.kx88.net/api/api.php",
			"Feedback.mCloseTicket",
		},
		[HttpModule.s_cmds.VoteFeedback] = {
			"http://feedback.kx88.net/api/api.php",
			"Feedback.mPostScore",
		},
		
		[HttpModule.s_cmds.RequestChargeList] = {
			DOMAIN .. "?m=pay&p=getProductProxy&sid=7&appid=%d&pmode=%d", --登录时候根据登录类型来动态设置,
			"",
		},
		[HttpModule.s_cmds.RequestPayOrder] = {
			DOMAIN .. "?m=pay&p=createOrderProxy&id=%d&sitemid=%s&pmode=%s",
			"",
		},
		[HttpModule.s_cmds.RequestPayConfig] = {
			DOMAIN,
			"pay#payconf",
		},
		[HttpModule.s_cmds.RequestPayConfigForLimit] = {
			DOMAIN,
			"pay#payconf"
		},
		[HttpModule.s_cmds.WeChatAccessToken] = {
			'https://api.weixin.qq.com/sns/oauth2/access_token?appid=%s&secret=%s&grant_type=%s',
			""
		},
		[HttpModule.s_cmds.LOGIN_PHP] = {
			HOST_URL,
			""
		},

		[HttpModule.s_cmds.GET_DICE_LOGIN] = {
			'1002',
			"GameServer.load"
		},
		[HttpModule.s_cmds.GET_FB_INVITE_AWARD] = {
			PhpManager:getGame(),
			"Friends.setInviteFriends"
		},
		[HttpModule.s_cmds.GET_FB_INVITE_SUC_AWARD] = {
			PhpManager:getGame(),
			"Friends.inviteFbFriend"
		},
		[HttpModule.s_cmds.GET_BROKEN_MONEY] = {
			PhpManager:getGame(),
			'Task.getReward'
		},
		[HttpModule.s_cmds.GET_PAY_MODE] = {
			PhpManager:getGame(),
			"Payment.getPmode"
		},
		[HttpModule.s_cmds.GET_PAY_LIST] = {
			PhpManager:getGame(),
			"Payment.getAllPayList"
		},
		[HttpModule.s_cmds.GET_PAY_ORDER] = {
			PhpManager:getGame(),
			--"Payment.callPayOrder"
            "Payment.callPayOrderV3"
		},
		[HttpModule.s_cmds.GET_PAY_NOTIFY] = {
			PhpManager:getGame(),
			"Payment.callClientPaymentV3"
		},
		[HttpModule.s_cmds.GET_REGISTER_REWARD] = {   
			PhpManager:getGame(),
			"Award.upRegisterAward"
		},
        [HttpModule.s_cmds.GET_SEND_PROP] = {   
			PhpManager:getGame(),
			"Props.interactiveProps"
		},
        [HttpModule.s_cmds.GET_PROP_LIST] = {   
			PhpManager:getGame(),
			"Props.getUserPropsList"
		},
        
		[HttpModule.s_cmds.GET_HALL_BANKRUPT] = {   
			PhpManager:getGame(),
			"Bankruptcy.bankruptcyGrant"
		},
		[HttpModule.s_cmds.GET_HALL_BANKRUPT_TAG] = {   
			PhpManager:getGame(),
			"Bankruptcy.bankruptcyNums"
		},
        [HttpModule.s_cmds.GET_SEND_GAME_CHIP] = {   
			PhpManager:getGame(),
			"Room.sendInRoomMoney"
		},
		[HttpModule.s_cmds.FRONTSTATISTICS] = {
			PhpManager:getGame(),
			'GameServer.frontStatistics'
		},
		[HttpModule.s_cmds.GET_UPGRADE_REWARD] = {
			PhpManager:getGame(),
			'Level.upGrade'
		},
		[HttpModule.s_cmds.GET_DUIJIANG_REWARD] = {
			PhpManager:getGame(),
			'Invite.checkConversionCode'
		},	
		[HttpModule.s_cmds.GET_HALL_USER_NEWS] = {
			PhpManager:getGame(),
			'Message.getUserMessage'
		},
		[HttpModule.s_cmds.GET_HALL_USER_NEWS_DEL] = {
			PhpManager:getGame(),
			'Message.deleteUserMessage'
		},
		[HttpModule.s_cmds.GET_HALL_USER_NOTICES] = {
			PhpManager:getGame(),
			'Notice.getShowUserNotice'
		},
		[HttpModule.s_cmds.GET_HALL_USER_NOTICES_DEL] = {
			PhpManager:getGame(),
			'Notice.deleteNotice'
		},
		[HttpModule.s_cmds.GET_HALL_USER_NOTICES_AWARD] = {
			PhpManager:getGame(),
			'Notice.receiveUserNotice'
		},
        [HttpModule.s_cmds.GET_HALL_USER_NOTICES_READED] = {
            PhpManager:getGame(),
            'Notice.updateUserNotice'
        },
        [HttpModule.s_cmds.SET_HALL_ATTENDENCE] = {
        	PhpManager:getGame(),
        	"Sign.singnIn",
        },
        [HttpModule.s_cmds.GET_MARQUEE_NOTICES] = {
			PhpManager:getGame(),
			'Notice.getShowUserNotice'
		},
		[HttpModule.s_cmds.GET_H3_LOGIN] = {
			'1003',
			"GameServer.load"
		},
		[HttpModule.s_cmds.GET_GAMEINFO] = {
			PhpManager:getGame(),
			'PerInfo.myGameInfo'
		},
		[HttpModule.s_cmds.UPDATE_USER_SEX] = {
			PhpManager:getGame(),
			'PerInfo.updateUserSex'
		},
		[HttpModule.s_cmds.UPDATE_USER_NAME] = {
			PhpManager:getGame(),
			'PerInfo.updateUserName'
		},
		[HttpModule.s_cmds.UPDATE_USER_ICON] = {
			PhpManager:getGame(),
			'PerInfo.updateUserIcon'
		},
		[HttpModule.s_cmds.UPDATE_MEMBER_BEST] = {
			PhpManager:getGame(),
			'Best.updateMemberBest'
		},
		[HttpModule.s_cmds.INVITE_CONFIG] = {
			PhpManager:getGame(),
			'Invite.getConfigInviteFriends'
		},
		[HttpModule.s_cmds.GET_FRIENDS] = {
			PhpManager:getGame(),
			'Friends.getFriendsList'
--            'Friends.getFriendsListByPage'
		},
		[HttpModule.s_cmds.GET_APPLY] = {
			PhpManager:getGame(),
			'Friends.applyAddFriendsList'
		},
		[HttpModule.s_cmds.ADD_FRIEND] = {
			PhpManager:getGame(),
			'Friends.addFriends'
		},
		[HttpModule.s_cmds.SEARCH_FRIEND] = {
			PhpManager:getGame(),
			'Friends.searchFriends'
		},
		[HttpModule.s_cmds.GET_GIFT] = {
			PhpManager:getGame(),
			'Friends.getGiftList'
		},
		[HttpModule.s_cmds.GIVING_TIPS] = {
			PhpManager:getGame(),
			'Room.givingTips'
		},
		[HttpModule.s_cmds.FRIEND_ACCEPT] = {
			PhpManager:getGame(),
			'Friends.isAgreeAdd'
		},
		[HttpModule.s_cmds.FRIEND_REFUSE] = {
			PhpManager:getGame(),
			'Friends.isAgreeAdd'
		},
		[HttpModule.s_cmds.GET_OTHER_FORM_FRIEND] = {
			PhpManager:getGame(),
			'Friends.friendInfo'
		},
		[HttpModule.s_cmds.SEND_GIFT] = {
			PhpManager:getGame(),
			'Friends.giveChouma'
		},
		[HttpModule.s_cmds.FETCH_GIFT] = {
			PhpManager:getGame(),
			'Friends.receiveChouma'
		},
		[HttpModule.s_cmds.FRIEND_DELETE] = {
			PhpManager:getGame(),
			'Friends.deleteFriends'
		},
		[HttpModule.s_cmds.POST_CLIENTID] = {
			PhpManager:getGame(),
			'Gcm.updateToken'
		},
		[HttpModule.s_cmds.FRIEND_UNREAD] = {
			PhpManager:getGame(),
			'Friends.getApplyGiftNum'
		},
		[HttpModule.s_cmds.GET_TASK] = {
			PhpManager:getGame(),
			'Task.getAllTask'
		},
		[HttpModule.s_cmds.GET_TASK_AWARD] = {
			PhpManager:getGame(),
			'Task.getReward'
		},
		[HttpModule.s_cmds.HAS_TASK_AWARD] = {
			PhpManager:getGame(),
			'Task.unclaimedReward'
		},
		[HttpModule.s_cmds.GET_ROOM_LIST] = {
			'',
			'Room.getConfigRoom'
		},
		[HttpModule.s_cmds.GET_GAME_LOGIN] = {
			'',
			'GameServer.load'
		},
		
		[HttpModule.s_cmds.GET_MAKHOS_ROOM_LIST] = {
			'1004',
			"Room.getNewConfigRoom"
		},
		[HttpModule.s_cmds.GET_MAKHOS_LOGIN] = {
			'1004',
			"GameServer.load"
		},
		[HttpModule.s_cmds.UPDATE_GAME_EVENT] = {
			PhpManager:getGame(),
			'GameServer.updateGameEvent'
		},
        [HttpModule.s_cmds.GET_URGENT_NOTICE] = {
			PhpManager:getGame(),
			'Notice.getShowUserNotice'
		},
        [HttpModule.s_cmds.GET_USER_MONEY] = {
            PhpManager:getGame(),
            'PerInfo.getMoneyAfterPay',
        },
        [HttpModule.s_cmds.GET_INVITE_TASK_PROGRESS] = {
            PhpManager:getGame(),
			'Friends.diamondRewardStep',
        },
        [HttpModule.s_cmds.GET_CASH_AWARDS] = {
            PhpManager:getGame(),
			'Diamond.getAllExRule'
        },
        [HttpModule.s_cmds.EXCHANGE_AWARD_BY_ID] = {
            PhpManager:getGame(),
			'Diamond.exchange',
        },
        [HttpModule.s_cmds.GET_CASH_EXCHANGE_RECORD] = {
            PhpManager:getGame(),
			'Diamond.exHistory',
        },
        [HttpModule.s_cmds.DEL_CASH_EXCHANGE_RECORD] = {
            PhpManager:getGame(),
			'Diamond.exHistory',
        },
        [HttpModule.s_cmds.GET_CASH_TASK_FRIEND] = {
            PhpManager:getGame(),
			'Diamond.getSchedule',
        },
        [HttpModule.s_cmds.GET_CASH_TASK_FRIEND_REWARD] = {
            PhpManager:getGame(),
			'Diamond.getReward',
        },
        [HttpModule.s_cmds.GET_CASH_TOTAL] = {
            PhpManager:getGame(),
            'Diamond.getDiamond',
        },
        [HttpModule.s_cmds.GET_CASH_ON_CLICK_STATISTICS] = {
            PhpManager:getGame(),
            'Diamond.iconClickStatistics',
        },  
        [HttpModule.s_cmds.GET_ACTIVITY_REWARD_CONFIG] = {
            PhpManager:getGame(),
            'MahaWinActivity.getRewardConfig',
        },
        [HttpModule.s_cmds.GET_ACTIVITY_GAME_RECORD] = {
            PhpManager:getGame(),
            'MahaWinActivity.getRecently25PokerLog',
        },
        [HttpModule.s_cmds.GET_ACTIVITY_REWARD_RECORD] = {
            PhpManager:getGame(),
            'MahaWinActivity.getRecently25RewardLog',
        },
        [HttpModule.s_cmds.GET_IS_ACTIVITY_TIME] = {
            PhpManager:getGame(),
            'MahaWinActivity.getActivitySwitch',
        },
        [HttpModule.s_cmds.GET_MAKHOS_ACTIVITY_GAME_RESULT] = {
            PhpManager:getGame(),
            'MahaWinActivity.getWinReward',
        },
        [HttpModule.s_cmds.RESET_MAKHOS_WIN_STREAK] = {
            PhpManager:getGame(),
            'MahaWinActivity.clearUserContinueWinLog',
        },
        [HttpModule.s_cmds.POST_GCM_BACK_USER_ID] = {
            PhpManager:getGame(),
            'Gcm.backUserToD',
        },
        [HttpModule.s_cmds.GET_BUDDY_ROOM_LIST] = {
            PhpManager:getGame(),
            'Friends.friendRoomList',
        },
        [HttpModule.s_cmds.GET_BUDDY_ONLINE_LIST] = {
            PhpManager:getGame(),
            'Friends.getOnlineFriendList',
        },
        [HttpModule.s_cmds.SEND_BUDDY_ROOM_INVITE] = {
            PhpManager:getGame(),
            'Friends.sendPrivateRoomInvite',
        },
        [HttpModule.s_cmds.SEND_ACTIVITY_SHARE_STATISTIC] = {
            PhpManager:getGame(),
            "ActivityCenter.saveShareNum",
        },
        [HttpModule.s_cmds.CHECK_SWITCH_FOR_ALL] = {
            PhpManager:getGame(),
            "SwitchControl.getSwitch",
        },
        [HttpModule.s_cmds.GET_PAY_PROP_LIST] = {
            PhpManager:getGame(),
            'Payment.getPropsPayList',
        },
        [HttpModule.s_cmds.MAKHOS_BUYREGRET] = {
            PhpManager:getGame(),
            'MahaHuiQi.buyHuiQiNum',
        },
	[HttpModule.s_cmds.GIFT_STORE_GET_LIST] = {
            PhpManager:getGame(),
--            'GiftSystem.getGiftConfList',
            'GiftSystem.newGetGiftConfList',
        },
        [HttpModule.s_cmds.GIFT_STORE_SEND] = {
            PhpManager:getGame(),
            'GiftSystem.sendGift',
        },
        [HttpModule.s_cmds.GIFT_STORE_BUY] = {
            PhpManager:getGame(),
            'GiftSystem.buyGift',
         },
        [HttpModule.s_cmds.GIFT_UPDATE_MINE] = {
            PhpManager:getGame(),
            'GiftSystem.wearGift',
        },
        [HttpModule.s_cmds.GIFT_GET_ALL_MINE] = {
            PhpManager:getGame(),
            'GiftSystem.getUserGiftList',
        },
        [HttpModule.s_cmds.GET_BANKRUPT_RELIEF] = {
            PhpManager:getGame(),
            'Bankruptcy.askForHelp',
        },
        [HttpModule.s_cmds.DUMMY_GET_TIPS_COUNT] = {
            PhpManager:getGame(),
            'Props.useProps',
        },
        [HttpModule.s_cmds.GET_USER_ALL_PROPS] = {
            PhpManager:getGame(),
            'Props.getUserAllProps',
        },
        [HttpModule.s_cmds.GET_FB_CALLBACK_REWARD_CFG] = {
            PhpManager:getGame(),
            "Friends.initOldFriendToPlayCfg"
        },
        [HttpModule.s_cmds.GET_FB_CALLBACK_LIST] = {
            PhpManager:getGame(),
            "Friends.callOldFriendToPlayList",
        },
        [HttpModule.s_cmds.GET_FB_CALLBACK_REWARD] = {
            PhpManager:getGame(),
            "Friends.rewardCallOldFriend",
        },
        [HttpModule.s_cmds.SEND_REGISTER_GAME_STA] = {
            PhpManager:getGame(),
            "ActivityCenter.countGameRegisterNum",
        },
        [HttpModule.s_cmds.GET_NOTIFICATION_REWARD] = {
            PhpManager:getGame(),
            "Gcm.rewardMoney",
        },
        [HttpModule.s_cmds.GET_PROP_CFG_LIST] = {
            PhpManager:getGame(),
            "Props.getConfigPropsList",
        },
        [HttpModule.s_cmds.REPORT_DEBUG_INFO] = {
            PhpManager:getGame(),
            "GameServer.findBug",
        },
        [HttpModule.s_cmds.GET_DEALER_ROOM_LIST] = {
			"1009", -- PhpManager:getGame(),
			'Room.getDealerConfigRoom',
        },
        [HttpModule.s_cmds.GIFT_GET_BADGE] = {
            PhpManager:getGame(),
            'GiftSystem.getBadge',
        },
        [HttpModule.s_cmds.GIFT_WEAR_BADGE] = {
            PhpManager:getGame(),
            'GiftSystem.wearBadge',
        },
        [HttpModule.s_cmds.GET_PRIVATE_ROOM_BILL_LIST] = {
            PhpManager:getGame(),
            'Room.getFriendRoomBill',
        },
        [HttpModule.s_cmds.GET_PRIVATE_ROOM_UNREAD_BILL] = {
            PhpManager:getGame(),
            'Room.getFriendRoomBillFlag',
        },
        [HttpModule.s_cmds.GET_HALL_ACTIVITY_LIST] = {
            PhpManager:getGame(),
            'HallActivity.getActivityListV2',
        },
        [HttpModule.s_cmds.GET_HALL_ACTIVITY_REWARD] = {
            PhpManager:getGame(),
            'HallActivity.getActivityReward',
        },
        [HttpModule.s_cmds.HALL_ACTIVITY_JOIN] = {
            PhpManager:getGame(),
            'HallActivity.joinActivity',
        },
        [HttpModule.s_cmds.HALL_ACTIVITY_FINISH] = {
            PhpManager:getGame(),
            'HallActivity.finishActivity',
        },
        [HttpModule.s_cmds.GET_ACT_SHARE_URL] = {
            PhpManager:getGame(),
            'HallActivity.getActShareUrl',
        },
	};

	self.m_httpManager:setConfigMap(HttpModule.s_config);
end