--[[
	场次准入，充值推荐配置
]]

local LevelConfigData = class(require('data.dataList'))

addProperty(LevelConfigData, "time", 0)

--根据场次level
function LevelConfigData:getPamountByLevel(level)
	if not self:getInit() then return end
	level = level or G_RoomCfg:getLevel()
	local levelData = self:getData()
	for key, val in ipairs(levelData) do
		if val:getLevel() == level then
			return val:getRecommend()
		end
	end
	local lastLevelData = levelData[#levelData]
	if lastLevelData then
		printInfo("找不到配置, 返回等级为%s配置额度", lastLevelData:getRecommend() or 0)
		return lastLevelData:getRecommend()
	end
end

-- 根据当前金币返回可进入的level
function LevelConfigData:getSuggestLevelConfigVarMoney(money, gameType)
	local preLevel = G_RoomCfg:getLevel()
	gameType = gameType or G_RoomCfg:getGameType()
	money 	 = money or MyUserData:getMoney()
	local levelData = self:getData()
	-- printInfo("gameType = %d", gameType)
	for key, val in ipairs(levelData) do
		-- printInfo("key = %s, %s, %s", key, val:getGameType(), val:getRequire())
		if val:getGameType() == gameType and money >= val:getRequire() then
			return val
		end
	end
end

function LevelConfigData:getLevelConfig(gameType, level)
	local levelData = self:getData()
	for key, val in ipairs(levelData) do
		if val:getGameType() == gameType and val:getLevel() == level then
			return val
		end
	end
end

return LevelConfigData