local HeadData = require("data.headData")
local UserData = class(HeadData)

addProperty(UserData, "id", 0)
addProperty(UserData, "siteId", 0)
addProperty(UserData, "seatId", 0)
addProperty(UserData, "money", 0)
addProperty(UserData, "exp", 0)
addProperty(UserData, "level", 0)
addProperty(UserData, "levelName", "")
addProperty(UserData, "nick", "")
addProperty(UserData, "isLogin", false)
addProperty(UserData, "wintimes", 0)
addProperty(UserData, "drawtimes", 0)
addProperty(UserData, "losetimes", 0)
addProperty(UserData, "regtime", 0)
addProperty(UserData, "sessionId", "")
addProperty(UserData, "status", 0)
addProperty(UserData, "userType", 2) -- 游客
addProperty(UserData, "isAult", 1)
addProperty(UserData, "curExp", 0)
addProperty(UserData, "needExp", 0)
addProperty(UserData, "title", "")
addProperty(UserData, "isbound", 0)
addProperty(UserData, "isRegister", 0)
addProperty(UserData, "avoidFirstPay", false)
addProperty(UserData, "tarr", {})
addProperty(UserData, "tid", 0)
addProperty(UserData, "boundmsg", "")
addProperty(UserData, 'maxMoney', 0)
addProperty(UserData, 'maxwMoney', 0)
addProperty(UserData, 'cashPoint', 0)

--头像上传临时图片名
addProperty(UserData, "uploadTemp", "")

addProperty(UserData, "thirdToken", "") --第三方token

--骰子
addProperty(UserData, "addrList", {})
addProperty(UserData, "gameList", {})
addProperty(UserData, "urls", {})

addProperty(UserData, "inviteFriend", nil)
--可以召回的玩家列表
addProperty(UserData, "callbackFriend", nil)
addProperty(UserData, "chipTime", 0)

--消息 公告
addProperty(UserData, "newsList", nil)
addProperty(UserData, "noticeList", nil)
addProperty(UserData, "hasUnckeckMsg", false)
addProperty(UserData, "hasNewNews", false)
addProperty(UserData, "hasNewNotice", false)
--好友
addProperty(UserData, "unreadApply", 0)
addProperty(UserData, "unreadGigt", 0)
addProperty(UserData, "unreadBankruptHelp", 0)
--邀请
addProperty(UserData, "invitesum", 0)
addProperty(UserData, "invitemoney", 1000)
addProperty(UserData, "successmoney", 100000)
addProperty(UserData, "leftInviteNum", 50)
addProperty(UserData, "leftCallbackNum", 50)
--任务
addProperty(UserData, "taskList", nil)
addProperty(UserData, "taskAward", 0)
addProperty(UserData, "boxAward", false)
--大厅列表
addProperty(UserData, "lobbyGames", {}) -- {gameid, path, updateline, icon}
--大厅更新
addProperty(UserData, "updateVerUrl", '')
addProperty(UserData, "updateZipUrl", '')
addProperty(UserData, "followFriend", false)
--现金币缓存
addProperty(UserData, "cashGoodsList", nil)
addProperty(UserData, "cashTaskList", nil)
addProperty(UserData, "hasFriendReward", false)
--签到奖励缓存
addProperty(UserData, "attendenceReward", nil)
--小喇叭缓存
addProperty(UserData, "showMsgNum", 0)
addProperty(UserData, "lastUserMsgTime", 0)
addProperty(UserData, "lastSysMsgTime", 0)
--活动中心是否有新活动
addProperty(UserData, "haveActivity", 0)
--礼物列表缓存
addProperty(UserData, "giftList", nil)
--当前自己的礼物，0表示没有
addProperty(UserData, "giftId", nil)
--大米提示按钮次数
addProperty(UserData, "dummyTipsCount", 0)
--道具
addProperty(UserData, "propCount", 0)
--私人房卡
addProperty(UserData, "privateRoomCardCount", 0)
--KS表情
addProperty(UserData, "KSExpressionNum", 0)
--大象表情
addProperty(UserData, "elephantExpressionNum", 0)
--小喇叭数量
addProperty(UserData, "speakerNum", 0)
--道具配置列表
addProperty(UserData, "propCfgList", {})
--私人房是否有未读消息
addProperty(UserData, "hasUnReadBill", false)
--记录马哈单机跳转的层次
addProperty(UserData, "makhosOfflineFlag", 0)
--记录玩家的小喇叭发送记录
addProperty(UserData, "speakerRecord", {})

--防攻击ip数组
addProperty(UserData, "proxyIpList", {})--vip的配置信息
addProperty(UserData, "vipCfg", {})
--vip分数
addProperty(UserData, "vipPoints", 0)
--vip等级
addProperty(UserData, "vipLevel", 0)
function UserData:ctor()

end

function UserData:addMoney(money, animFlag)
    local moneyPre = self:getMoney()
    local moneyNow = moneyPre + money
    if moneyNow < 0 then moneyNow = 0 end

    self:setMoney(moneyNow)
    if animFlag then
        -- 播放金币雨
        AnimationParticles.play(AnimationParticles.DropCoin)
        kEffectPlayer:play('audio_get_gold')
    end
end

local setMoney = UserData.setMoney
function UserData:setMoney(money, animFlag)
    if money and money < 0 then money = 0 end
    setMoney(self, money)

    if animFlag then
        -- 播放金币雨
        AnimationParticles.play(AnimationParticles.DropCoin)
    end
    return self
end

function UserData:addProp(prop)
    self:setPropCount(tonumber(self:getPropCount() or 0) + tonumber(prop or 0))
end

--对外统一的道具处理接口，避免道具的处理散落各处,保留的propCount这些数据只是为了给其他地方绑定用的，以后所有道具的变更用这3个接口处理
function UserData:setPropNum(pnid, count)
    local propId = tonumber(pnid)
    local number = tonumber(count) or 0
    if propId == kIDInterProp then
        self:setPropCount(number)
    elseif propId == KIDDummyTips then
        self:setDummyTipsCount(number)
    elseif propId == kIDPrivateRoomCard then
        self:setPrivateRoomCardCount(number)
    elseif propId == kIDKSExpression then
        self:setKSExpressionNum(number)
    elseif propId == kIDElephantExpression then
        self:setElephantExpressionNum(number)
    elseif propId == kIDSpeaker then
        self:setSpeakerNum(number)
    end
end

function UserData:getPropNum(pnid)
    local propId = tonumber(pnid)
    if propId == kIDInterProp then
        return self:getPropCount() or 0
    elseif propId == KIDDummyTips then
        return self:getDummyTipsCount() or 0
    elseif propId == kIDPrivateRoomCard then
        return self:getPrivateRoomCardCount() or 0
    elseif propId == kIDKSExpression then
        return self:getKSExpressionNum() or 0
    elseif propId == kIDElephantExpression then
        return self:getElephantExpressionNum() or 0
    elseif propId == kIDSpeaker then
        return self:getSpeakerNum() or 0
    end
end

function UserData:addPropNum(pnid, num)
    local propId = tonumber(pnid)
    local number = tonumber(num) or 0
    if propId == kIDInterProp then
        self:setPropCount(self:getPropCount() + number)
    elseif propId == KIDDummyTips then
        self:setDummyTipsCount(self:getDummyTipsCount() + number)
    elseif propId == kIDPrivateRoomCard then
        self:setPrivateRoomCardCount(self:getPrivateRoomCardCount() + number)
    elseif propId == kIDKSExpression then
        self:setKSExpressionNum(self:getKSExpressionNum() + number)
    elseif propId == kIDElephantExpression then
        self:setElephantExpressionNum(self:getElephantExpressionNum() + number)
    elseif propId == kIDSpeaker then
        self:setSpeakerNum(self:getSpeakerNum() + number)
    end
end

function UserData:clear()
    self:setIsLogin(false)
    self:setId(0)
    self:setMoney(0)
    self:setSex(1)
    self:setNick("")
    self:setIsbound(0)
    self:setRegtime(0)
    self:setSessionId("")
    self:setAvoidFirstPay(false)
    self:setBoundmsg("");
    self:setHeadUrl("");
    self:setAddrList({});
    self:setInviteFriend(nil);
    self:setCallbackFriend(nil);
    self:setLeftInviteNum(50);
    self:setLeftCallbackNum(50);
    self:setPropCount(0)
    self:setChipTime(0)
    self:setNewsList(nil);
    self:setNoticeList(nil);
    self:setUnreadApply(0);
    self:setUnreadGigt(0);
    self:setUnreadBankruptHelp(0);
    self:setTaskList(nil);
    self:setTaskAward(0);
    self:setShowMsgNum(0);
    self:setLastUserMsgTime(0);
    self:setLastSysMsgTime(0);
    self:setHaveActivity(0);
    self:setAttendenceReward(nil);
    --支付
    MyPayMode = nil
    self:setGiftList(nil)
    self:setGiftId(nil)
    self:setDummyTipsCount(0);
    self:setPrivateRoomCardCount(0);
    self:setKSExpressionNum(0)
    self:setElephantExpressionNum(0)
    self:setSpeakerNum(0)
    self:setSpeakerRecord({});
	self:setVipCfg(nil)
	self:setVipPoints(0)
	self:setVipLevel(0)
end

function UserData:initUserInfo(data)
    self:setIsLogin(true)
    self:setId(tonumber(data.mid or 0))
    self:setSiteId(tostring(data.sitemid or ""))
    self:setNick(data.name or "")
    self:setMoney(data.money or 0)
    --后台数据库按1是男、2是女存储性别
    if data.msex and tonumber(data.msex) > 0 then
        self:setSex(tonumber(data.msex) - 1)
    else
        self:setSex(0)
    end

    self:setUserType(tonumber(data.lid))
    self:setLevel(data.level or 0)
    -- 头像
    if ToolKit.isValidString(data.miconbig) then
        self:setHeadUrl(data.micon)
    else
        self:setHeadUrl(data.micon)
    end
    -- 胜负平
    self:setWintimes(data.wintimes or 0)
    self:setLosetimes(data.losetimes or 0)
    self:setDrawtimes(data.drawtimes or 0)
    self:setRegtime(tonumber(data.mtime) or 0)
    self:setSessionId(data.sesskey or "")
    self:setStatus(data.status or 0)
    -- 是否绑定
    self:setIsbound(data.isbound or 0)
    self:setBoundmsg(data.boundmsg or "");

    self:setIsRegister(data.register or 0)
    self:setExp(data.exp or 0)
    self:setMaxMoney(data.maxmoney or 0)
    self:setMaxwMoney(data.maxwmoney or 0)
    self:setUnreadApply(0);
    self:setUnreadGigt(0);
    self:setUnreadBankruptHelp(0);
    --活动中心
    self:setHaveActivity(data.haveActivity or 0);
	-- self:setVipLevel(data.vipLevel or 0)
end

return UserData
