local DiceLobbyController 	= class(BaseController)
local roomListItemLayout 	= requireview("view.dice.roomListItemLayout")
local printInfo, printError = overridePrint("DiceLobbyController")

function DiceLobbyController:ctor(viewConfig, ...)
	printInfo("Dice控制器ctor");
    self.mGameId  	= 13002
	--加入骰子SERVER协议
--	self.m_reader		= new(require('dice.protocol.lobby.lobbyReader'))
--	self.m_writer		= new(require('dice.protocol.lobby.lobbyWriter'))
--	GameSocketMgr:addCommonSocketReader(self.m_reader);
--	GameSocketMgr:addCommonSocketWriter(self.m_writer);
	--监听HTTP请求
	EventDispatcher.getInstance():register(HttpModule.s_event, self, self.onHttpRequestsCallBack);
	--返回
	self.m_root:findChildByName("btn_back"):setOnClick(self, function ( self )
		-- body
		StateChange.changeState(States.Lobby, self.mGameId);
	end);
    
    local viewPlayer = self:findChildByName("img_player")
    viewPlayer:findChildByName("btn_headbg"):setOnClick(self, function(self)
        WindowManager:showWindow(WindowTag.UserPopu, {}, WindowStyle.POPUP)
    end)
	viewPlayer:findChildByName("btn_add"):setOnClick(self, function ( self )
		-- body
		WindowManager:showWindow(WindowTag.ShopPopu, {gameType = self.mCurGameType}, WindowStyle.POPUP)
        --self:enter2Scene(WindowTag.ShopPopu, true, WindowStyle.NORMAL);
		app:postFrontStaticstics('clickShoppingMall')
	end);
	--头像
	UIEx.bind(self, MyUserData, "headName", function(value)
		local headView 		= viewPlayer:findChildByName("view_head")
		headView:removeAllChildren();
		local width, height = headView:getSize()
		local imgHead 		= new(Mask, value, "common/head_bg.png");
		imgHead:setSize(width, height)
		headView:addChild(imgHead);
		MyUserData:checkHeadAndDownload()
	end)
	--昵称
	UIEx.bind(self, MyUserData, "nick", function(value)
		viewPlayer:findChildByName("text_nick"):setText(value);
	end)
	--金币
	UIEx.bind(self, MyUserData, "money", function(value)
		chipView = viewPlayer:findChildByName("view_chipnumber");
		chipView:removeAllChildren();
		local chipNode = new(require('common.imageNumber'), {
            ['0'] = chipNumber_map["0.png"],
		    ['1'] = chipNumber_map["1.png"],
		    ['2'] = chipNumber_map["2.png"],
		    ['3'] = chipNumber_map["3.png"],
		    ['4'] = chipNumber_map["4.png"],
		    ['5'] = chipNumber_map["5.png"],
		    ['6'] = chipNumber_map["6.png"],
		    ['7'] = chipNumber_map["7.png"],
		    ['8'] = chipNumber_map["8.png"],
		    ['9'] = chipNumber_map["9.png"],
		    [','] = chipNumber_map["c.png"],
		    ['k'] = chipNumber_map["k.png"],
		    ["m"] = chipNumber_map["m.png"],
		    ["b"] = chipNumber_map["b.png"],
		    ["."] = chipNumber_map["p.png"],
		});	

		chipNode:setNumber(string.format("%s", ToolKit.formatMoney(value)));
		chipNode:setAlign(kAlignLeft);
		chipView:addChild(chipNode);
	end)
    --经验进度条
    self:initLevel()

	--性别
	MyUserData:setSex(MyUserData:getSex());
	MyUserData:setNick(MyUserData:getNick());
	MyUserData:setMoney(MyUserData:getMoney());

	-- 先屏蔽
	-- local canClick = true;
	-- local btnLeft 	= self.m_root:findChildByName("btn_left");
	-- local btnRight 	= self.m_root:findChildByName("btn_right");
	-- btnLeft:enableAnim(false);
	-- btnRight:enableAnim(false);
	-- btnLeft:setOnClick(self, function ( self )
	-- 	-- body
	-- 	if canClick then
	-- 		canClick = false;
	-- 		local imgChecked  = self.m_root:findChildByName("img_checked");
	-- 		local x, y 		  =imgChecked:getPos();
	-- 		local checkedAnim = imgChecked:addPropTranslateWithEasing(1, kAnimNormal, 300, 0, "easeOutSine", "easeOutSine", 0, 0 - x, 0, 0);
	-- 		checkedAnim:setEvent(self, function()
	-- 				checkAndRemoveOneProp(imgChecked, 1);
	-- 				imgChecked:setPos(0, 0);
	-- 				canClick = true;
	-- 		end);
	-- 	end

	-- end);

	-- btnRight:setOnClick(self, function ( self )
	-- 	-- body
	-- 	if canClick then
	-- 		canClick = false;
	-- 		local imgChecked  = self.m_root:findChildByName("img_checked");
	-- 		local x, y 		  =imgChecked:getPos();
	-- 		local checkedAnim = imgChecked:addPropTranslateWithEasing(1, kAnimNormal, 300, 0, "easeOutSine", "easeOutSine", 0, 156 - x, 0, 0);
	-- 		checkedAnim:setEvent(self, function()
	-- 				checkAndRemoveOneProp(imgChecked, 1);
	-- 				imgChecked:setPos(156, 0);
	-- 				canClick = true;
	-- 		end);
	-- 	end
	-- end);

	--快速开始
	local btnStart = self.m_root:findChildByName("btn_quickStart");
	
	btnStart:setOnClick(self, function ( self )
		-- body
		local game = app:getGame(13002) --骰子
		if game then
			local room = game:getRoomFromMoney(MyUserData:getMoney())
			if room then
				game:enterRoom(States.GameLobby, room)
			else
				AlarmTip.play(STR_MONEY_LESS_THAN_MIN)
			end
		end
	end);
	--
	--加载房间列表
	self:loadRoomList();
--    self:bgInAnim();
	--登录
	HttpModule.s_config[HttpModule.s_cmds.GET_GAME_LOGIN][HttpConfigContants.URL] = tostring(13002)
	HttpModule.getInstance():execute(HttpModule.s_cmds.GET_GAME_LOGIN, {}, MyRoomConfig:get(1003) == nil, true);
	
end

function DiceLobbyController:initLevel()
    local lv = tonumber(MyUserData:getLevel())
    local exp = tonumber(MyUserData:getExp()) 
    local percent = 0
	if lv then
		local index = tonumber(lv)
		if index > 0 and index < 60 then
			local x1 = userLevelExp[index].x1 
			local x2 = userLevelExp[index].x2
			if exp > x1 then
				percent = math.ceil(((exp - x1)/(x2 - x1))*100)
				if percent >= 100 then
					percent = 99
				end
			end
		elseif index == 60 then
			percent = 99
		end
	end
    local progress = self:findChildByName("img_progress")
    --经验的底图和背景一起，写死长度
    local maxLen = 164
    local minLen, h = progress:getSize()
    progress:setSize(minLen + (maxLen - minLen) * percent / 100, h)

end

function DiceLobbyController:dtor()
	
	printInfo("LobbyController:dtor")
	EventDispatcher.getInstance():unregister(HttpModule.s_event, self, self.onHttpRequestsCallBack);

--	GameSocketMgr:removeCommonSocketReader(self.m_reader);
--	GameSocketMgr:removeCommonSocketWriter(self.m_writer);
--	delete(self.m_reader);
--	delete(self.m_writer);
--	self.m_reader = nil;
--	self.m_writer = nil;
end

function DiceLobbyController:loadRoomList()
	-- body
    -- local iconPos = {{150, 45}, {510, 25}, {870, 45}, {330, 225}, {700, 225}}
    -- local iconPos = {{50, 45}, {310, 25}, {570, 45}, {910, 45}, {700, 225}}
	local viewRoomList  = self:findChildByName("view_roomlist");
	local w, h 			= viewRoomList:getSize();

	-- local scrollView 	= new(ScrollView, 0, 0, w, h);
 --    scrollView:setName("sv_roomList")
 	local scrollView = self:findChildByName("sv_roomList")
 	scrollView:setDirection(kHorizontal)
--	local row, col 		= 1, 1;
	local game 			= app:getGame(13002)
	local roomList 		= game:getRoomList()

	local w = 30
	for i = 1, roomList and roomList:count() or 0 do
		local room 	 = roomList:get(i);
		local item 	 = SceneLoader.load(roomListItemLayout);
		local lw, lh = item:getSize();

		local node = new(Node);
		local imgPlayer = new(Image, 'lobbyRoom/player_icon.png');
		local imgPlayerW, imgPlayerH = imgPlayer:getSize();
		local textOnline= new(Text, room:getOnline(), 0, 0, kAlignCenter, "", 28, 0xff, 0xE9, 0xD1);
		local textOnlineW, textOnlineH = textOnline:getSize();
		textOnline:setPos(imgPlayerW + 5, (imgPlayerH - textOnlineH) / 2);
		node:addChild(imgPlayer);
		node:addChild(textOnline);
		node:setSize(imgPlayerW + 5 + textOnlineW, math.max(imgPlayerH, textOnlineH));
		node:setAlign(kAlignCenter);
		item:findChildByName("view_online"):addChild(node);
		item:findChildByName("text_ante"):setText(STR_ANTE..room:getAnte());
		item:findChildByName("btn_bg"):setOnClick(self, function ( self )
		-- body
            
			local myMoney = MyUserData:getMoney()
			local room 	  = roomList:get(i)
			local content = nil
			if myMoney < room:getMinchip() then
				content = string.format(STR_MONEY_LESS_THAN_ANTE, room:getMinchip());
			elseif myMoney > room:getMaxchip() then
				content = string.format(STR_MONEY_GREATER_THAN_ANTE, room:getMaxchip());
			else
				game:enterRoom(States.GameLobby, room)
				return ;
			end

			WindowManager:showWindow(WindowTag.LobbyExitPopu, {
			title 	= "",
			close 	= true,
			content = content,
			confirm = STR_EXIT_GAME_CONFIRM,
			confirmFunc = function ()
				-- body
				local game = app:getGame(13002) --骰子
				if game then
					local room = game:getRoomFromMoney(MyUserData:getMoney())
					if room then
						game:enterRoom(States.GameLobby, room)
					else
						AlarmTip.play(STR_MONEY_NOT_ENOUGH)
					end
				end
			end
			}, WindowStyle.POPUP);
			
		end);

		UIEx.bind(textOnline, room, "online", function(value)
			textOnline:setText(tostring(value));
		end)
        --房间等级图标
        --最多只有5个房间图标
        local fileIndex = i > 5 and 5 or i
        local imgLevel = item:findChildByName("img_level")
        imgLevel:setFile(string.format("lobbyRoom/dice/dice_level_%s.png", fileIndex))
        imgLevel:setSize(imgLevel.m_res.m_width, imgLevel.m_res.m_height)
        item:findChildByName("img_levelText"):setFile(string.format("lobbyRoom/dice/text_level_%s.png", fileIndex))
        item:setAlign(kAlignLeft)
        printInfo("item pos w "..w)
        item:setPos(w, 0)
        w = w + item:getSize() + 50
        -- item:setPos(unpack(iconPos[i] or {}))
		scrollView:addChild(item);

	end

	scrollView:setSize(w, h);
	-- viewRoomList:removeAllChildren();
	-- viewRoomList:addChild(scrollView);

--    self:roomInAnim();
end

function DiceLobbyController:bgInAnim()
    local viewTop = self:findChildByName("view_top")
    checkAndRemoveOneProp(viewTop, 1)
    local x, y = viewTop:getAbsolutePos()
    local w, h = viewTop:getSize()
    local deltay = 0 - y - h
    viewTop:addPropTranslateWithEasing(1, kAnimNormal, 600, 0, "easeOutBack", "easeOutBack", 0, 0, deltay, -deltay)
end

function DiceLobbyController:roomInAnim()
    local screenWidth 	= CONFIG_SCREEN_WIDTH
  	local screenHeight 	= CONFIG_SCREEN_HEIGHT

    local viewBottom = self:findChildByName("view_bottom")
    checkAndRemoveOneProp(viewBottom, 1)
    local x, y = viewBottom:getAbsolutePos()
    local w, h = viewBottom:getSize()
    local deltay = -y + h + screenHeight
    viewBottom:addPropTranslateWithEasing(1, kAnimNormal, 600, 100, "easeOutBack", "easeOutBack", 0, 0, deltay, -deltay)
    
    local roomList = self:findChildByName("view_roomlist"):findChildByName("sv_roomList"):getChildren()
    for i = 1, #roomList do
        local room = roomList[i]
        checkAndRemoveOneProp(room, 1)
        local x, y = room:getAbsolutePos()
        local w, h = room:getSize()
        local deltay = -y + h + screenHeight
        room:addPropTranslateWithEasing(1, kAnimNormal, 600, 100 * i, "easeOutBack", "easeOutBack", 0, 0, deltay, -deltay)
    end
end

--HTTP回调
function DiceLobbyController:onHttpRequestsCallBack(command, ...)
	if self.s_severCmdEventFuncMap[command] then
     	self.s_severCmdEventFuncMap[command](self,...)
	end 
end
function DiceLobbyController:onGetRoomList(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		self:loadRoomList();
	end
end

function DiceLobbyController:onGameLogin(isSuccess, data)

	if app:checkResponseOk(isSuccess, data) then
		local gameInfo = data.data
		if gameInfo then
			--下载房间列表
			app:checkAndDownloadRoomList(13002, gameInfo.configVersion.room or 1, true);
			--更新在线人数
			local roomList = app:getGame(13002):getRoomList()
			if roomList then
				local online = gameInfo.onlinenumber;
				for i = 1, roomList:count() do
					local count = online[i] and online[i][2] or 0
					roomList:get(i):setOnline(count)
				end
			end
		end
	end
end

function DiceLobbyController:onBack()
    StateChange.changeState(States.Lobby, self.mGameId);
end
--HTTP事件
DiceLobbyController.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.GET_ROOM_LIST] 	= DiceLobbyController.onGetRoomList,
	[HttpModule.s_cmds.GET_GAME_LOGIN] 	= DiceLobbyController.onGameLogin,
}

return DiceLobbyController;