--[[
	骰子socket发送协议  2015-03-03
]]
local BaseWriter = require("mjSocket.game.baseWriter")
local RoomWriter = class(BaseWriter)
local printInfo, printError = overridePrint("RoomWriter")

function RoomWriter:onGetTableId(packetId, param)
	printInfo("RoomWriter:onGetTableId");
	self.m_socket:writeShort(packetId, param.u16_gameLevel);	-- gamelevel
	self.m_socket:writeInt(packetId, param.u32_gameId); 		-- gameid
	
end
--param:{u32_follow, str_key , str_info}
function RoomWriter:onFollow(packetId, param)
	printInfo("RoomWriter:onFollow");
	self.m_socket:writeInt(packetId, param.u32_follow);			-- u32_follow
	self.m_socket:writeString(packetId, param.str_key); 		--
	self.m_socket:writeString(packetId, param.str_info); 		--
	self.m_socket:writeString(packetId, param.str_followNick); 		--
	
end

--param:{u32_tableId, u32_uid, str_key, str_info, u32_flag}
function RoomWriter:onLoginGame(packetId, param)
	printInfo("RoomWriter:onLoginGame");
	dump(param)
	self.m_socket:writeInt(packetId, param.u32_tableId);	-- 
	self.m_socket:writeInt(packetId, param.u32_uid); 		--
	self.m_socket:writeString(packetId, param.str_key); 	-- 
	self.m_socket:writeString(packetId, param.str_info); 	--
	self.m_socket:writeInt(packetId, param.u32_flag); 	--
end
--param:{u32_seatId, u64_ante}
function RoomWriter:onSitDownInGame(packetId, param)
	printInfo("RoomWriter:onSitDownInGame");
	dump(param)
	self.m_socket:writeInt(packetId, param.u32_seatId -1);	-- 
	self.m_socket:writeInt64(packetId, param.u64_ante); --
end
-- BET_TYPE_BIG				= 1, // 大
-- BET_TYPE_SMALL			= 2, // 小
-- BET_TYPE_THREE			= 3, // 3条
-- BET_TYPE_SPECIAL_THREE	= 4, // 特定3条
-- BET_TYPE_TOTAL_POINTS	= 5, // 猜总点数
-- BET_TYPE_SINGLE_POINTS	= 6, // 猜单个骰子点数
-- bet_type : int (见上面枚举值)
-- param    : int (参数 有的类型需要参数,比如猜几点猜哪个3条,有的类型不需要参数时为0)
-- bet_money: int64 (在该类型上下注的金额)
--param:{u32_betType, u32_param, u64_money}
function RoomWriter:onBet(packetId, param)
	printInfo("RoomWriter:onBet");
	dump(param)
	self.m_socket:writeInt(packetId, param.u32_betType); 
	self.m_socket:writeInt(packetId, param.u32_param);
	self.m_socket:writeInt64(packetId, param.u64_money);
end
-- param:nil
function RoomWriter:onStandUp(packetId, param)
	printInfo("RoomWriter:onStandup");
end
-- param:nil
function RoomWriter:onExitRoom(packetId, param)
	printInfo("RoomWriter:onExitRoom");
end

function RoomWriter:onSendChat(packetId, param)
	self.m_socket:writeString(packetId, param.iChatInfo); 
end

function RoomWriter:onSendFace(packetId, param)
	self.m_socket:writeInt(packetId, param.iFaceType);
	self.m_socket:writeInt(packetId, param.isVipFace);
end

function RoomWriter:onUpdateUserinfor(packetId, param)
	self.m_socket:writeString(packetId, param.userInfo)
end

function RoomWriter:initCommandFuncMap()
	RoomWriter.super.initCommandFuncMap(self)
	require('dice.protocol.protocol')
	local s_clientCmdFunMap = {
		[DICE_GET_TABLEID_REQ]  	= self.onGetTableId,	--
		[DICE_FOLLOW_REQ]  			= self.onFollow,	--
		[DICE_LOGIN_GAME_REQ] 		= self.onLoginGame,
		[DICE_SITDOWN_IN_GAME_REQ] 	= self.onSitDownInGame,
		[DICE_BET_REQ] 				= self.onBet,
		[DICE_STANDUP_REQ] 			= self.onStandUp,
		[DICE_EXIT_ROOM_REQ] 		= self.onExitRoom,
		[DICE_SEND_CHAT]			= self.onSendChat,
		[DICE_SEND_FACE]			= self.onSendFace,
		[DICE_CLIENT_SEND_USERINFOR]           = self.onUpdateUserinfor,
	}
	table.merge(self.s_clientCmdFunMap, s_clientCmdFunMap)
end

return RoomWriter