-- Data:2013-9-4
-- Description:程序入口 
-- Note:

require("config")
require("utils.init")
require("core.init")
require("common.init")
require("gameBase.init")
require("mjSocket/base/socketCmd")

require(ViewPath.."errorPage");

function event_load(width,height)
	System.setLayoutWidth(1280);
    System.setLayoutHeight(720);

   	--删除全部4类对象
	res_delete_group(-1);
	anim_delete_group(-1);
	prop_delete_group(-1);
	drawing_delete_all();
	audio_music_stop(1);
	--同步关闭room/hall socke
	socket_close(kGameSocket, -1)

    printError("----------------------------------------")
    printError("LUA ERROR: " .. tostring(errorMessage) .. "\n")
    printError(debug.traceback("", 2))
    printError("----------------------------------------")

	local errorScene = SceneLoader.load(errorPage);
	errorScene:addToRoot();

	local errorContent = errorScene:getChildByName("centerView"):getChildByName("errorLog");
	local errorTips = System.getLuaError() or "";
	local errorBackBtn = errorScene:getChildByName("centerView"):getChildByName("confirm");
    local imgError = errorScene:findChildByName("img_error")
    
	errorScene:findChildByName("confirmText"):setText(STR_ERROR_RELOGIN)
	DEBUG_MODE = true
 	if ToolKit.isValidString(errorTips) and DEBUG_MODE then
        imgError:setVisible(false)
		errorContent:setVisible(true);
		errorContent:setText(errorTips);
	else
        imgError:setVisible(true)
		errorContent:setVisible(false);
	end
	errorBackBtn:setOnClick(nil,function()
	    delete(errorScene);
		to_lua("main.lua");	
	end);
	PhpManager    = PhpManager    or new(require("mjSocket.base.phpManager"))
	local machineInfo = PhpManager:getMachineInfo();
	local reportStr = (errorTips or "") .. machineInfo;
	NativeEvent.getInstance():ReportLuaError(reportStr);

    --检查错误栈里是否在update文件夹下，放在最后是保证错误上报完成，避免下方的脚本出现错误
    -- local isUpdateError = string.find(errorTips, "update/scripts/")
    -- if isUpdateError then
    --     --删除update文件夹下的scripts脚本
    --     NativeEvent.getInstance():deleteFile({type = "update"})
    --     return
    -- end
    --检查错误栈是否在已知的错误列表下，是的话删除update文件夹
    local errorList = require("common.errorList")
    for i = 1, #errorList do
        local errorStr = errorList[i]
        if string.find(errorTips, errorStr) then
            NativeEvent.getInstance():deleteFile({type = "update"})
            return
        end
    end
end 
