local LoadController 	= require("loadController")
local LoadLayout  		= requireview(ViewPath .. "loadLayout")

local LoadState = class(BaseState);

local printInfo, printError = overridePrint("LoadState")

function LoadState:load()
	LoadState.super.load(self);
	self.m_controller = new(LoadController, LoadLayout, self);
	return true;
end

function LoadState:unload()
	LoadState.super.unload(self);
	delete(self.m_controller);
	self.m_controller = nil;
end

function LoadState:ctor()
	--必须提前初始化
	PhpManager      = PhpManager    	or new(require("mjSocket.base.phpManager"))
	PlatformManager = PlatformManager 	or new(require("platform.platformManager"))
	--全局版本控制器
    MyGameVerManager    = MyGameVerManager or new(require("update.gameVersionManager"))
end

function LoadState:resume(bundleData)
	LoadState.super.resume(self, bundleData)
end



return LoadState