require("ui/ex/mask")
require("atomAnim/atomAnimManager")
--local LobbyCoinNode			= require("lobby/ui/lobbyCoinNode")
local LobbyController = class(BaseController)
local printInfo, printError = overridePrint("LobbyController")
--local IS_INPUT_NAME = false;
function LobbyController:ctor(viewConfig)
	printInfo("大厅控制器ctor")
	--注册HTTP回调
	EventDispatcher.getInstance():register(HttpModule.s_event, self, self.onHttpRequestsCallBack);
	EventDispatcher.getInstance():register(Event.Call, self, self.onNativeCallBack)

	HallConfig:freshNetConfig()
	--初始化UI
	self:loadUi();

	if MyUserData:getMakhosOfflineFlag() == 3 then
		self:findChildByName("view_login"):setVisible(true);
		self:findChildByName("view_ui"):setVisible(false);
	else
		if MyUserData:getId() == 0 then --显示登录界面
			self:findChildByName("view_login"):setVisible(true);
			self:findChildByName("view_ui"):setVisible(false);
			local delayAnim = self:addPropTransparency(1, kAnimNormal, 0, 500, 1.0, 1.0)
			delayAnim:setEvent(self, function (self)
				-- body
				checkAndRemoveOneProp(self, 1)

				--自动登陆
			    EventDispatcher.getInstance():dispatch(Event.Message, "autoLogin", GameSetting:getLoginType())
				--友盟更新
				NativeEvent.getInstance():UpdateByUmeng(1, MyUpdateData:getUmeng(), MyUpdateData:getForce(), 1);
			end)
		else   ---已经登录了
			self:findChildByName("view_login"):setVisible(false);
			self:findChildByName("view_ui"):setVisible(true);
	        --启动小喇叭
	        self.marquee:getSysMsg()
	        self.m_root:findChildByName("scene_bg"):setVisible(true)
	        self.m_root:findChildByName("scene_bg_clear"):setVisible(false)
		end
	end
	
	GameSetting:setLevel(1)
	GameSetting:save()

    --新手引导的第二步在进入游戏后出来才需要处理
    if GameSetting.beginnerStep == "second" then
        self.gameTab:initBeginnerHelpOther()
        GameSetting.beginnerStep = nil
    end
    
--    ToolKit.setNodeGray(self:findChildByName("view_login"))
--    ToolKit.setNodeGray(self:findChildByName("scene_bg_clear"))
    UIEx.bind(self, MySwitchData, "lobbyBg", function(value)
        --需要更换大厅背景图片
        if value ~= "" then
            local imgData = new(require("data.imgData"))
            imgData:setImgUrl(value)
            --背景图片已经下下来了
            if imgData:checkImg() then
                self:findChildByName("scene_bg"):setFile(imgData:getImgName())
            end
        end
    end)
    MySwitchData:setLobbyBg(MySwitchData:getLobbyBg())
end
--与大厅布局相关(适配分辨率)

function LobbyController:loadUi()

	--logo
	if PhpManager:getPackageName()=="com.boyaa.thaicheckers"then
		self:findChildByName("btn_makhosOffline"):setVisible(true)
		self:findChildByName("btn_makhosOffline"):setOnClick(self,function (self)
			--require("makhos.game"):enterOfflineLobby(States.Load)
			MyUserData:setMakhosOfflineFlag(1)
			WindowManager:showWindow(WindowTag.OfflinePopu, {}, WindowStyle.POPUP)
		end)
--		self:findChildByName("btn_facebook"):setPos(0,-50)
--		self:findChildByName("btn_visitor"):setPos(0,50)
	else
		-- self:findChildByName("btn_facebook"):setPos(0,0)
		-- self:findChildByName("btn_visitor"):setPos(0,0)
		self:findChildByName("btn_makhosOffline"):setVisible(false)
	end

	local imgAvatar = self:findChildByName('img_avatar')
	local title = self:findChildByName('img_loginTitle')
	-- 解决手机imgAvatar、title一瞬间由大变小的体验Bug。
	if PhpManager:getPackageName() == "com.boyaa.truco" then
		imgAvatar:setSize(526, 712)
		title:setSize(147, 51)
	end
	-- 
	if PhpManager:getPackageName() == "com.boyaa.buraco" then
		imgAvatar:setSize(526, 712)
		title:setSize(176, 51)
	end	
	imgAvatar:setFile(string.format('login/%s.png', PhpManager:getPackageName()))
	imgAvatar:setSize(imgAvatar.m_res.m_width, imgAvatar.m_res.m_height)

	self:findChildByName('img_loginTitle'):setFile(string.format('login/%s.title.png', PhpManager:getPackageName()))
	title:setSize(title.m_res.m_width,title.m_res.m_height)

    --加载小喇叭
    self.marquee = new(require("lobby.ui.marquee"))
    self.m_root:findChildByName("view_marquee"):addChild(self.marquee)

	--加载游戏列表
	self:loadGameList()
--    self:enterHallAnim()
	--UI的数据绑定
	self:bindUiNotice()
    local viewBottomBtn = self.m_root:findChildByName("view_bottom"):findChildByName("view_grid")

	--信息
	local btnMsg = viewBottomBtn:findChildByName("btn_message")
    btnMsg:findChildByName("text_button"):setText(STR_LOBBY_MSG)
    btnMsg:setOnClick(self, function ( self )
		-- body
		WindowManager:showWindow(WindowTag.NoticePopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickMessage')
	end);
	--好友
	local btnFriend = viewBottomBtn:findChildByName("btn_friend")
    btnFriend:findChildByName("text_button"):setText(STR_LOBBY_FRIEND)
    btnFriend:setOnClick(self, function ( self )
		-- body
		WindowManager:showWindow(WindowTag.FriendPopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickFriends')
	end);
	--任务
	local btnTask = viewBottomBtn:findChildByName("btn_task")
    btnTask:findChildByName("text_button"):setText(STR_LOBBY_TASK)
    btnTask:setOnClick(self, function ( self )
		-- body
		WindowManager:showWindow(WindowTag.TaskPopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickTask')
	end);
    
--反馈
    local btnFeedback = viewBottomBtn:findChildByName("btn_feedback")
    btnFeedback:findChildByName("text_button"):setText(STR_LOBBY_FEEDBACK)
    btnFeedback:setOnClick(self, function(self)
    	WindowManager:showWindow(WindowTag.FeedbackPopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickFeedback')
    end)
--设置
    local btnSetting = viewBottomBtn:findChildByName("btn_setting")
    btnSetting:findChildByName("text_button"):setText(STR_LOBBY_SETTING)
    btnSetting:setOnClick(self, function(self)
        WindowManager:showWindow(WindowTag.SettingPopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickSet')
    end)
    -- 活动中心
	local btnActivity = viewBottomBtn:findChildByName('btn_activity')
    btnActivity:findChildByName("text_button"):setText(STR_LOBBY_ACTIVITY)
    btnActivity:setOnClick(self, function(self)
    	WindowManager:showWindow(WindowTag.ActCenterPopu, {}, WindowStyle.POPUP)
	    --兑奖
	    MyUserData:setHaveActivity(0)
	    --debug是0表示外网，1是内网
	    --NativeEvent.getInstance():openActivity()
	    app:postFrontStaticstics('clickActivity')

	end)

	--商城闪光动画
	local btnExchange = viewBottomBtn:findChildByName("btn_exchange")
    btnExchange:setOnClick(self, function ( self )
		-- body
        WindowManager:showWindow(WindowTag.ShopPopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickShoppingMall')
	end);
    local animFrame = {}
    for i = 1, 30 do
        table.insert(animFrame, string.format("lobby.anim.shopStar%s.png", i))
    end
    local animSprite = new(require('animation.animSprite'), lobby_map, animFrame, 120)
    animSprite:setAlign(kAlignCenter)
    btnExchange:addChild(animSprite:play())


    local viewTop = self:findChildByName("view_top")
	--头像
	viewTop:findChildByName("btn_head"):setOnClick(self, function ( self )
		-- body
        WindowManager:showWindow(WindowTag.UserPopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickPerInfo')
	end);

    --头像处商城按钮
    viewTop:findChildByName("btn_iconShop"):setOnClick(self, function ( self )
		-- body
         WindowManager:showWindow(WindowTag.ShopPopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickShoppingMall')
	end);
	--现金币
	viewTop:findChildByName("btn_cashShop"):setOnClick(self, function ( self )
		WindowManager:showWindow(WindowTag.CashExchangePopu, {}, WindowStyle.POPUP)
        app:postFrontStaticstics('clickCashExchangePopu')
        HttpModule.getInstance():execute(HttpModule.s_cmds.GET_CASH_ON_CLICK_STATISTICS, {}, true, true)
	end);
	viewTop:findChildByName("btn_cashShop"):setVisible(false)
   
	--邀请
	local btnInvite = viewTop:findChildByName("btn_invite")
	local btnOldAct = viewTop:findChildByName("btn_oldAct")
    btnInvite:setOnClick(self, function ( self )
		-- body
		WindowManager:showWindow(WindowTag.FbInvitePopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickInviteFriends')
	end);
	btnOldAct:setOnClick(self, function ( self )
		-- body
		NativeEvent.getInstance():openActivity()
	    app:postFrontStaticstics('clickActivity')
	end);
    checkAndRemoveOneProp(btnInvite, 1)
    local animInviteLight = btnInvite:addPropTranslate(1, kAnimRepeat, 3000, 0, 0, 0, 0, 0)
    animInviteLight:setEvent(nil, function()
        checkAndRemoveOneProp(btnInvite, 2)
        checkAndRemoveOneProp(btnInvite, 3)
        btnInvite:addPropScaleWithEasing(2, kAnimNormal, 1000, 0, "easeInOutSine", "easeInOutSine", 0.9, 0.2, kCenterDrawing)
        btnInvite:addPropScaleWithEasing(3, kAnimNormal, 1000, 1000, "easeInOutSine", "easeInOutSine", 1.1, -0.2, kCenterDrawing)
    end)
    --self:findChildByName("img_inviteLight"):addPropRotate(4, kAnimRepeat, 5000, 0, 0, 360, kCenterDrawing)

    local btnLoginBtn = self:findChildByName("view_login"):findChildByName("view_btnClip")
	--facebook登录
	btnLoginBtn:findChildByName("btn_facebook"):setOnClick(self, function ( self )
		-- body
		GameSocketMgr:closeSocketSync(false)
		MyUserData:clear();
        MySwitchData:clear();
		MyUserData:setUserType(UserType.Facebook);
		NativeEvent.getInstance():login();
		GameSetting:setLoginType(UserType.Facebook);
		GameSetting:save();
		-- self:loginAnim();
	end);
	--visitor登录
	btnLoginBtn:findChildByName("btn_visitor"):setOnClick(self, function ( self )
		-- body

			GameSocketMgr:closeSocketSync(false)
			MyUserData:clear();
            MySwitchData:clear();
			MyUserData:setUserType(UserType.Visitor);
			self:loginAnim();
            --不为游客自动登录
			GameSetting:setLoginType(0);
			GameSetting:save();

			-- PlatformManager:executeAdapter(PlatformManager.s_cmds.LoginBtnClickAdapter, MyUserData:getUserType());
	end);
	self.m_root:findChildByName("btn_debug"):setVisible(DEBUG_MODE)
	self.m_root:findChildByName("btn_debug"):setOnClick(self, function ( self )
		self.mBtnDebugClickTimes = tonumber(self.mBtnDebugClickTimes or 0) + 1
		--if self.mBtnDebugClickTimes > 30 then
			WindowManager:showWindow(WindowTag.TestToolPopu)
		--end
	end)
	
	--旧活动中心
    UIEx.bind(self, MySwitchData, "activityIcon", function(value)
        local viewTool = self:findChildByName("view_tool")
        if value ~= "" then
            local imgData = setProxy(new(require("data.imgData")))
			UIEx.bind(self, imgData, "imgName", function(name)
                local btn_oldAct = viewTool:findChildByName("btn_oldAct")
                --延时保证按钮已经移进来了
                local delayAnim = btn_oldAct:addPropTranslate(1, kAnimNormal, 800, 0, 0, 0, 0, 0)
                delayAnim:setEvent(nil, function()
                    btn_oldAct:setFile(imgData:getImgName())
                    btn_oldAct:setVisible(true)
                    local imgOldAct = viewTool:findChildByName("img_oldAct")
                    imgOldAct:setVisible(true)
                    imgOldAct:addPropRotate(4, kAnimRepeat, 5000, 0, 0, 360, kCenterDrawing)
                end)
		    end)
		    imgData:setImgUrl(value)
        else
            viewTool:findChildByName("img_oldAct"):setVisible(false)
            viewTool:findChildByName("btn_oldAct"):setVisible(false)
        end
    end)
    MySwitchData:setActivityIcon(MySwitchData:getActivityIcon())
 
     UIEx.bind(self, MySwitchData, "fbinviteIcon", function(value)
        local viewTool = self:findChildByName("view_tool")
        if value ~= "" then
            local imgData = setProxy(new(require("data.imgData")))
			UIEx.bind(self, imgData, "imgName", function(name)
                local btn_invite = viewTool:findChildByName("btn_invite")
                --延时保证按钮已经移进来了
                local delayAnim = btn_invite:addPropTranslate(1, kAnimNormal, 800, 0, 0, 0, 0, 0)
                delayAnim:setEvent(nil, function()

                    btn_invite:setFile(imgData:getImgName())
                    btn_invite:setVisible(true)
                    local imgLight = viewTool:findChildByName("img_inviteLight")
                    imgLight:setVisible(true)
                    imgLight:addPropRotate(4, kAnimRepeat, 5000, 0, 0, 360, kCenterDrawing)
                end)
		    end)
		    imgData:setImgUrl(value)
        else
            viewTool:findChildByName("img_inviteLight"):setVisible(false)
            viewTool:findChildByName("btn_invite"):setVisible(false)
        end
    end)
    MySwitchData:setFbinviteIcon(MySwitchData:getFbinviteIcon())

end

function LobbyController:loadGameList()
    local viewGame = self:findChildByName("view_gameList")
    viewGame:removeAllChildren()
    self.gameTab = new(require("lobby.ui.gameTab"))
    self.gameTab:setAlign(kAlignCenter)

    viewGame:addChild(self.gameTab)

end
--与大厅相关的动画

--登录动画
function LobbyController:loginAnim()
    self.m_root:findChildByName("scene_bg"):setVisible(false)
    self.m_root:findChildByName("scene_bg_clear"):setVisible(true)
	self.m_root:findChildByName("view_ui"):setVisible(false);
	self.m_root:findChildByName("view_login"):setVisible(true);
    --显示logo
    self.m_root:findChildByName("img_logo"):setVisible(true)
	local screenWidth 	= CONFIG_SCREEN_WIDTH--System.getScreenWidth();
  	local screenHeight 	= CONFIG_SCREEN_HEIGHT--System.getScreenHeight();
	--local imgAvatar = self.m_root:findChildByName("img_avatar");
    
--人物移动到屏幕1/3动画
--[[
	checkAndRemoveOneProp(imgAvatar, 1);
	checkAndRemoveOneProp(imgAvatar, 2);
	local x, y = imgAvatar:getAbsolutePos();
	local w, h = imgAvatar:getSize();
	local deltax = screenWidth/3 - w/2 - x;
	local avatarAnim = imgAvatar:addPropTranslateWithEasing(1, kAnimNormal, 500, 300, "easeOutSine", "easeOutSine", 0, deltax, 0, 0);
--]]
--[[
	avatarAnim:setEvent(self, function()
			-- checkAndRemoveOneProp(imgAvatar, 1);
			--登录
			--PlatformManager:executeAdapter(PlatformManager.s_cmds.LoginBtnClickAdapter, UserType.Visitor)
            
	end);
	--]]
--[[
	local loginBg = self.m_root:findChildByName("img_login_bg");
	checkAndRemoveOneProp(loginBg, 1);
	checkAndRemoveOneProp(loginBg, 2);
	local x, y = loginBg:getAbsolutePos()
	local w, h = loginBg:getSize();
	local deltax = screenWidth - x;
	loginBg:addPropTranslateWithEasing(1, kAnimNormal, 600, 0, "easeOutSine", "easeOutSine", 0, deltax, 0, 0)
	loginBg:addPropTransparency(2, kAnimNormal, 600, 0, 1.0, 0.6);
--]]
    local loginBg = self.m_root:findChildByName("img_login_bg")

--登录按钮移出屏幕
    local viewBtn = loginBg:findChildByName("view_btn")
    checkAndRemoveOneProp(viewBtn, 1)
    checkAndRemoveOneProp(viewBtn, 2)
    local x, y = viewBtn:getAbsolutePos()
    local w, h = viewBtn:getSize()
    local deltax = screenWidth - x;
    --向右移出屏幕
    viewBtn:addPropTranslateWithEasing(1, kAnimNormal, 600, 0, "easeOutSine", "easeOutSine", 0, deltax, 0, 0) 
    viewBtn:addPropTransparency(2, kAnimNormal, 600, 0, 1.0, 0.6)
--loading下滑至中央
    local viewLoading = loginBg:findChildByName("view_loading")
    checkAndRemoveOneProp(viewLoading, 1)
    local x, y = viewLoading:getPos()
    local bgW, bgH = loginBg:getSize()
    local w, h = viewLoading:getSize()
    local deltay = (bgH - h) / 2 - y
    local moveAnim = viewLoading:addPropTranslateWithEasing(1, kAnimNormal, 600, 0, "easeOutSine", "easeOutSine", 0, 0, 0, deltay)
    moveAnim:setEvent(self, function()
        --加载loading文字和转圈圈效果
		self:loginLoadingAnim();
    end)

end

function LobbyController:loginLoadingAnim()
    local viewLoading = self.m_root:findChildByName("view_login"):findChildByName("view_loading")
    --加载文字和....
    local title = viewLoading:findChildByName("img_loginTitle")
    checkAndRemoveOneProp(title, 1)
    checkAndRemoveOneProp(title, 2)
    local str = ""
    local textLoading = viewLoading:findChildByName("text_tip")
    textLoading:setText(STR_LOAING)
    textLoading:setVisible(true)
    local loadingPointAnim = title:addPropTransparency(1, kAnimRepeat, 200, 0, 1.0, 1.0);
    loadingPointAnim:setEvent(self, function()
        textLoading:setText(STR_LOAING..str)
        str = str.."."
        if string.len(str) > 3 then
            str = ""
        end
    end)
    --加载亮瞎眼的动画
    local loadingBg = viewLoading:findChildByName("img_loading")
    checkAndRemoveOneProp(loadingBg, 1)
    local shineAnim = loadingBg:addPropTransparency(1, kAnimRepeat, 120, 0, 1.0, 1.0)
    local firstIndex = 1
    local SHINE_NUM = 4
    local TOTAL_SHINE_NUM = 13
    --UI加载了12个动画闪烁点用来显示loading过程，同时出现的闪烁点数目是4个
    shineAnim:setEvent(self, function()
        for i = firstIndex, firstIndex - SHINE_NUM + 1, -1 do
            if i <= TOTAL_SHINE_NUM and i >= 1 then
                self:findChildByName("img_p"..i):setVisible(true)
            end
        end
        local unShineIndex = firstIndex - SHINE_NUM 
        if unShineIndex <= TOTAL_SHINE_NUM and unShineIndex >= 1 then
            self:findChildByName("img_p"..unShineIndex):setVisible(false)
        end
        firstIndex = firstIndex + 1 
        if firstIndex > TOTAL_SHINE_NUM + SHINE_NUM then
            firstIndex = 1
        end
    end)

    --延时后自动登录
    local adapterAnim = title:addPropTransparency(2, kAnimNormal, 800, 0, 1.0, 1.0)
    adapterAnim:setEvent(self, function()
        -- lrq 2016-2-16
        checkAndRemoveOneProp(title, 1)
        checkAndRemoveOneProp(title, 2)
        printInfo('ddddddd')
        printInfo('MyUserData:getUserType()' .. MyUserData:getUserType())
        --自动登录
		if MyUserData:getUserType() == UserType.Visitor then
			PlatformManager:executeAdapter(PlatformManager.s_cmds.LoginBtnClickAdapter, MyUserData:getUserType());
		end
    end)
    
end

function LobbyController:logoutAnim(anim)
    self.m_root:findChildByName("scene_bg"):setVisible(false)
    self.m_root:findChildByName("scene_bg_clear"):setVisible(true)

	--self.m_root:findChildByName("img_loading"):setVisible(false);
	self.m_root:findChildByName("view_login"):setVisible(true);
	self.m_root:findChildByName("view_ui"):setVisible(false);
--logo
    self.m_root:findChildByName("img_logo"):setVisible(true)
--删除人物离场动画，人物回到屏幕中央
	local imgAvatar = self.m_root:findChildByName("img_avatar");
	checkAndRemoveOneProp(imgAvatar, 1);
	checkAndRemoveOneProp(imgAvatar, 2);

    --删除背景离开动画，恢复为初始状态
    local loginBg = self.m_root:findChildByName("img_login_bg");
    checkAndRemoveOneProp(loginBg, 1)
    checkAndRemoveOneProp(loginBg, 2)
    --loading文字不可见
    loginBg:findChildByName("text_tip"):setVisible(false)
    --删除button右移动画
    local viewBtn = loginBg:findChildByName("view_btn")
    checkAndRemoveOneProp(viewBtn, 1)
    checkAndRemoveOneProp(viewBtn, 2)
    --删除loading下滑动画
    local viewLoading = loginBg:findChildByName("view_loading")
    checkAndRemoveOneProp(viewLoading, 1)
    --删除亮瞎眼的动画, 13个全部不可见
    local loadingBg = viewLoading:findChildByName("img_loading")
    checkAndRemoveOneProp(loadingBg, 1)
    for i = 1, 13 do
        loadingBg:findChildByName("img_p"..i):setVisible(false)
    end
--底部的more按钮恢复初始状态
    --local viewBottomBtn = self.m_root:findChildByName("view_bottom"):findChildByName("view_grid")
    --viewBottomBtn:findChildByName("img_more_bg"):setVisible(false)
    --viewBottomBtn:findChildByName("btn_moreShow"):setVisible(true)
    --viewBottomBtn:findChildByName("btn_moreHide"):setVisible(false)

	if anim then
        --人物移动回屏幕中央动画
	  	local screenWidth 	= CONFIG_SCREEN_WIDTH
  		local screenHeight 	= CONFIG_SCREEN_HEIGHT
        
		local x, y = imgAvatar:getAbsolutePos();
		local w, h = imgAvatar:getSize();

		--local deltax = (screenWidth - w)/2 - x;
		--local avatarAnim = imgAvatar:addPropTranslateWithEasing(1, kAnimNormal, 500, 0, "easeOutSine", "easeOutSine", deltax, -deltax, 0, 0);
        --保持与离开反方向，从左边进入屏幕
        local deltax = - w / 2 - x
        local avatarAnim = imgAvatar:addPropTranslateWithEasing(1, kAnimNormal, 500, 0, "easeOutSine", "easeOutSine", deltax, -deltax, 0, 0)
        
		--登录方框移动回来的动画
		local loginBg = self.m_root:findChildByName("img_login_bg");
		checkAndRemoveOneProp(loginBg, 1);
		checkAndRemoveOneProp(loginBg, 2);
		local x, y = loginBg:getAbsolutePos()
		local w, h = loginBg:getSize();
		local deltax = screenWidth - x;
		loginBg:addPropTranslateWithEasing(1, kAnimNormal, 600, 100, "easeOutSine", "easeOutSine", deltax, -deltax, 0, 0)
		loginBg:addPropTransparency(2, kAnimNormal, 600, 0, 0.6, 1.0);
	end
end

--进入大厅动画
function LobbyController:hallInAnim()
	--self.m_root:findChildByName("img_loading"):setVisible(false);
	self.m_root:findChildByName("view_ui"):setVisible(true);

 	local screenWidth 	= CONFIG_SCREEN_WIDTH
  	local screenHeight 	= CONFIG_SCREEN_HEIGHT
	
	--人物离场
	local imgAvatar = self.m_root:findChildByName("img_avatar");
	local x, y = imgAvatar:getAbsolutePos();
	local w, h = imgAvatar:getSize();
	local deltax = -((screenWidth - w)/2 + w);
	checkAndRemoveOneProp(imgAvatar, 1);
	checkAndRemoveOneProp(imgAvatar, 2);
	imgAvatar:addPropTranslateWithEasing(1, kAnimNormal, 1000, 0, "easeOutSine", "easeOutSine", 0, deltax, 0, 0)
	imgAvatar:addPropTransparency(2, kAnimNormal, 1000, 0, 1.0, 0.0)

    --logo消失
    self.m_root:findChildByName("img_logo"):setVisible(false)
    --登录画面离开
    local loginBg = self.m_root:findChildByName("img_login_bg");
	checkAndRemoveOneProp(loginBg, 1);
	checkAndRemoveOneProp(loginBg, 2);
	local x, y = loginBg:getAbsolutePos()
	local w, h = loginBg:getSize();
	local deltax = screenWidth - x;
	loginBg:addPropTranslateWithEasing(1, kAnimNormal, 600, 0, "easeOutSine", "easeOutSine", 0, deltax, 0, 0)
	loginBg:addPropTransparency(2, kAnimNormal, 600, 0, 1.0, 0.6);

    --所有按钮进入大厅的动画
	self:enterHallAnim()
end

function LobbyController:enterHallAnim()
    --头像
    local screenWidth 	= CONFIG_SCREEN_WIDTH

	local viewPlayer = self.m_root:findChildByName("view_player");
	checkAndRemoveOneProp(viewPlayer, 1);
	checkAndRemoveOneProp(viewPlayer, 2);
	local x, y = viewPlayer:getAbsolutePos();
	local w, h = viewPlayer:getSize();
	local deltax = -(x + w + 10);
	local animHead = viewPlayer:addPropTranslateWithEasing(1, kAnimNormal, 500, 300, "easeOutSine", "easeOutSine", deltax, 0-deltax, 0, 0)
    viewPlayer:addPropTranslateWithEasing(2, kAnimNormal, 500, 800, "easeOutBack", "easeOutBack", 10, -10, 0, 0)
	--金币底部背景弹出
    local viewMoney = viewPlayer:findChildByName("view_money")
    local imgMoneyBg = viewMoney:findChildByName("img_moneyBg")
    imgMoneyBg:setVisible(false)
    local btnShop = viewMoney:findChildByName("btn_iconShop"):findChildByName("img_iconShop")
    btnShop:setVisible(false)
    animHead:setEvent(nil, function()
        checkAndRemoveOneProp(viewPlayer, 1)
        imgMoneyBg:setVisible(true)
        local w, h = imgMoneyBg:getSize()
        checkAndRemoveOneProp(imgMoneyBg, 1)
        local animScale = imgMoneyBg:addPropScaleXWithEasing(1, kAnimNormal, 200, 0, "easeInOutSine", "easeInOutSine", 0.1, 0.9, kCenterXY, 0, 0)
        --金币按钮出现并开始旋转
        animScale:setEvent(nil, function()
            btnShop:setVisible(true)
            -- checkAndRemoveOneProp(btnShop, 1)
            -- checkAndRemoveOneProp(btnShop, 2)
            -- btnShop:addPropRotateWithEasing(1, kAnimNormal, 1000, 0, "easeOutBack", 0, 180, kCenterDrawing)
            -- btnShop:addPropTransparency(2, kAnimNormal, 300, 0, 0.5, 1.0)
        end)
    end)
    

--各种按钮的挤压
	local imgOldAct = self:findChildByName("img_oldAct")
    local imgInviteLight = self:findChildByName("img_inviteLight")
    imgOldAct:setVisible(false)
    imgInviteLight:setVisible(false)
    local btn_oldAct = self.m_root:findChildByName("btn_oldAct");
	local btnInvite = self.m_root:findChildByName("btn_invite");

	checkAndRemoveOneProp(btnInvite, 1);
	checkAndRemoveOneProp(btnInvite, 2);
    checkAndRemoveOneProp(btnInvite, 3)
	local x, y = btnInvite:getAbsolutePos();
	local w, h = btnInvite:getSize();
	local deltax = screenWidth + w - x + 10;
	local x1, y1 = btn_oldAct:getAbsolutePos();
	local w1, h1 = btn_oldAct:getSize();
	local deltax1 = screenWidth + w - x + 10;
    checkAndRemoveOneProp(btnInvite, 1);
	checkAndRemoveOneProp(btnInvite, 2);
	checkAndRemoveOneProp(btn_oldAct, 1);
	checkAndRemoveOneProp(btn_oldAct, 2);

    btnInvite:addPropTranslateWithEasing(1, kAnimNormal, 300, 500, "easeOutSine", "easeOutSine", deltax, 0-deltax, 0, 0)
    local animInvite = btnInvite:addPropTranslateWithEasing(2, kAnimNormal, 500, 800, "easeOutBack", "easeOutBack", -10, 10, 0, 0)

    animInvite:setEvent(nil, function()
        checkAndRemoveOneProp(btnInvite, 1)
        local animInviteLight = btnInvite:addPropTranslate(1, kAnimRepeat, 3000, 0, 0, 0, 0, 0)
        animInviteLight:setEvent(nil, function()
            checkAndRemoveOneProp(btnInvite, 2)
            checkAndRemoveOneProp(btnInvite, 3)
            btnInvite:addPropScaleWithEasing(2, kAnimNormal, 1000, 0, "easeInOutSine", "easeInOutSine", 1.0, 0.1, kCenterDrawing)
            btnInvite:addPropScaleWithEasing(3, kAnimNormal, 1000, 1000, "easeInOutSine", "easeInOutSine", 1.1, -0.1, kCenterDrawing)

        end)
    end)

	local btnCash = self.m_root:findChildByName("btn_cashShop");
	local x, y = btnCash:getAbsolutePos();
	local w, h = btnCash:getSize();
	local deltax = screenWidth + w - x + 10;
    checkAndRemoveOneProp(btnCash, 1);
	checkAndRemoveOneProp(btnCash, 2);
	btnCash:addPropTranslateWithEasing(1, kAnimNormal, 300, 600, "easeOutSine", "easeOutSine", deltax, 0-deltax, 0, 0)
    btnCash:addPropTranslateWithEasing(2, kAnimNormal, 500, 900, "easeOutBack", "easeOutBack", -10, 10, 0, 0)

	--底部
	local viewBottom = self.m_root:findChildByName("view_bottom");
	local imgBg 	 = viewBottom:findChildByName("img_bg");
	local x, y 		 = imgBg:getAbsolutePos();
	local w, h 		 = imgBg:getSize();
	local deltay 	 = h + 10;
    checkAndRemoveOneProp(imgBg, 1);
    checkAndRemoveOneProp(imgBg, 2);
	imgBg:addPropTranslateWithEasing(1, kAnimNormal, 300, 500, "easeOutSine", "easeOutSine", 0, 0, deltay, 0-deltay)
    imgBg:addPropTranslateWithEasing(2, kAnimNormal, 500, 800, "easeOutBack", "easeOutBack", 0, 0, -10, 10)
	
    --底部的各种图标
    local btnShop = viewBottom:findChildByName("btn_exchange")
    checkAndRemoveOneProp(btnShop, 1)
    checkAndRemoveOneProp(btnShop, 2)
    checkAndRemoveOneProp(btnShop, 3)
    btnShop:addPropTransparency(1, kAnimNormal, 300, 500, 0, 1.0)
    btnShop:addPropScaleWithEasing(2, kAnimNormal, 300, 500, "easeInOutQuad", "easeInOutQuad", 0.7, 0.3, kCenterDrawing, 0, 0)
    btnShop:addPropScaleWithEasing(3, kAnimNormal, 150, 800, "easeInOutQuad", "easeInOutQuad", 1.1, -0.1, kCenterDrawing, 0, 0)
    local btnBottom = {
        viewBottom:findChildByName("btn_friend"),
        viewBottom:findChildByName("btn_task"),
        viewBottom:findChildByName("btn_activity"),
        viewBottom:findChildByName("btn_message"),
        viewBottom:findChildByName("btn_feedback"),
        viewBottom:findChildByName("btn_setting"),
    }
    for i = 1, #btnBottom do
        local btn = btnBottom[i]
        checkAndRemoveOneProp(btn, 1)
        checkAndRemoveOneProp(btn, 2)
        checkAndRemoveOneProp(btn, 3)
        btn:addPropTransparency(1, kAnimNormal, 300, 500 + 100 * i, 0, 1.0)
        btn:addPropTranslateWithEasing(2, kAnimNormal, 300, 500 + 100 * i, "easeOutBack", "easeOutBack", 0, 10, 0, 0)
        btn:addPropTranslateWithEasing(3, kAnimNormal, 300, 800 + 100 * i, "easeOutBack", "easeOutBack", 10, -10, 0, 0)
    end
    
    --游戏列表进入房间动画
    self.gameTab:enterHallAnim()
    --延时2秒启动小喇叭
    self.marquee:getSysMsg()
end

function LobbyController:resume(bundleData)
	LobbyController.super.resume(self)
	self:updateUserInfo()

	self:setRankAwardsNum(MyBaseInfoData:getRankAward());
	self:setTaskAwardsNum(MyBaseInfoData:getTaskAward());

	-- NativeEvent.getInstance():CloseStartScreen()

	--播放背景音乐
	if MyUserData:getId() ~= 0 then
		kMusicPlayer:play(Music.AudioHallBack, true)
	end
    --从私人房出来
    if GameSetting.showPrivateRoomPopu then
        WindowManager:showWindow(WindowTag.PrivateRoomPopu, {}, WindowStyle.NORMAL)
        GameSetting.showPrivateRoomPopu = false
    end

end

function LobbyController:updateUserInfo()
	if MyUserData:getIsLogin() then
		self:setHeadImg(MyUserData:getHeadName())
		self:setMoney(MyUserData:getMoney())
        MyUserData:setNick(MyUserData:getNick())
        self:setExpProgress()

        self:findChildByName("text_level"):setText("Lv."..MyUserData:getLevel())
	end
end

function LobbyController:pause()
	LobbyController.super.pause(self)
end

function LobbyController:dtor()
	EventDispatcher.getInstance():unregister(HttpModule.s_event, self, self.onHttpRequestsCallBack);
	EventDispatcher.getInstance():unregister(Event.onEventResume,self,self.onEventResume);
	EventDispatcher.getInstance():unregister(Event.onEventPause,self,self.onEventPause);
	EventDispatcher.getInstance():unregister(Event.Call, self, self.onNativeCallBack);
	kMusicPlayer:stop(true)
end

function LobbyController:showAddMoneyAnim(...)
	local AddMoneyAnim = require("animation.animAddMoney")
	new(AddMoneyAnim)
		:addTo(self)
		:play( {
			money = ...,
			pos = {x = 220, y = 100},
		})
end
function LobbyController:onBack()
	--NativeEvent.getInstance():showAd(false)
    WindowManager:showWindow(WindowTag.LobbyExitGamePopu, {}, WindowStyle.POPUP)
end

function LobbyController:exitGame()
    --检查启动时游戏升级状态是否正常，不正常恢复到升级前版本
    MyGameVerManager:checkUpdateFinish()
	NativeEvent.getInstance():Exit()
    GameSocketMgr:closeSocketSync()
end


--HTTP回调
function LobbyController:onHttpRequestsCallBack(command, ...)
	if self.s_severCmdEventFuncMap[command] then
     	self.s_severCmdEventFuncMap[command](self,...)
	end 
end

function LobbyController:onEventResume()
	GameSocketMgr:tryReconnect()
end

function LobbyController:onEventPause()
	GameSocketMgr:closeSocketSync()
end
-- 业务方法
-------------------------[[ 与view交互的方法 ]] -----------------------
--设置头像
function LobbyController:setHeadImg(fileName)
	--self.m_root:findChildByName("img_head"):setFile(fileName);
    if self.m_headImage then
		self.m_headImage:removeSelf()
		self.m_headImage = nil;
	end
    local headView = self.m_root:findChildByName("view_player"):findChildByName("view_head"):findChildByName("btn_head")
    local width, height = headView:getSize()
    self.m_headImage = new(Mask, fileName, "common/head_bg.png");
    self.m_headImage:setSize(width, height)
    self.m_headImage:setName("headImage")
    self.m_headImage:setAlign(kAlignCenter)
    self.m_headImage:addTo(headView)
end

--设置金币
function LobbyController:setMoney(money)
	--self.m_root:findChildByName("view_imgMoney"):setText(money);--ToolKit.formatMoney(money)
	local view_money = self.m_root:findChildByName("view_money"):findChildByName("view_imgMoney")
	view_money:removeAllChildren();
	--local moneyNode = new(Image, lobby_map["lobby.lobby_moneynumber.0.png"])

	local moneyNode = new (require('common.imageNumber'), {
		['0'] = lobby_map["lobby.lobby_moneynumber.0.png"],
		['1'] = lobby_map["lobby.lobby_moneynumber.1.png"],
		['2'] = lobby_map["lobby.lobby_moneynumber.2.png"],
		['3'] = lobby_map["lobby.lobby_moneynumber.3.png"],
		['4'] = lobby_map["lobby.lobby_moneynumber.4.png"],
		['5'] = lobby_map["lobby.lobby_moneynumber.5.png"],
		['6'] = lobby_map["lobby.lobby_moneynumber.6.png"],
		['7'] = lobby_map["lobby.lobby_moneynumber.7.png"],
		['8'] = lobby_map["lobby.lobby_moneynumber.8.png"],
		['9'] = lobby_map["lobby.lobby_moneynumber.9.png"],
		[','] = lobby_map["lobby.lobby_moneynumber.c.png"],
		['k'] = lobby_map["lobby.lobby_moneynumber.k.png"],
		["m"] = lobby_map["lobby.lobby_moneynumber.m.png"],
		["b"] = lobby_map["lobby.lobby_moneynumber.b.png"],
		["."] = lobby_map["lobby.lobby_moneynumber.p.png"],
		})
	moneyNode:setNumber(string.format("%s", ToolKit.formatMoney(money)))
    view_money:addChild(moneyNode)
	moneyNode:setAlign(kAlignCenter)
    
    self:moneyIncreaseShare(money)

end

--设置任务领奖个数
function LobbyController:setTaskAwardsNum(num)
    
   if( not self.bubble_task_img ) then
      self.bubble_task_img = self.m_root:findChildByName("bubble_task_img");
   end

   if( not self.bubble_task_txt ) then
      self.bubble_task_txt = self.m_root:findChildByName("bubble_task_txt");
   end
   
   if tonumber(num) and tonumber(num) > 0 then 
       self.bubble_task_img:setVisible(true);
       self.bubble_task_txt:setText(num); 
   elseif(self.bubble_task_img) then   
	   self.bubble_task_img:setVisible(false);
   end

end

--设置排行榜领奖个数
function LobbyController:setRankAwardsNum(num)

   if( not self.bubble_rank_img ) then
      self.bubble_rank_img = self.m_root:findChildByName("bubble_rank_img");
   end

   if( not self.bubble_rank_txt ) then
      self.bubble_rank_txt = self.m_root:findChildByName("bubble_rank_txt");
   end

   if num and tonumber(num) > 0 then 
       self.bubble_rank_img:setVisible(true);
       self.bubble_rank_txt:setText(num); 
   elseif(self.bubble_rank_img) then   
	   self.bubble_rank_img:setVisible(false);
   end
    
end

function LobbyController:bindUiNotice()
    local TIPS_DISDANCE = 150

	UIEx.bind(self, MyUserData, "money", function(value)
		self:setMoney(value)
	end)
	UIEx.bind(self, MyUserData, "nick", function(value)
        ToolKit.formatTextLength(value, self:findChildByName("text_nick"), self:findChildByName("view_nick"):getSize())
--		self:findChildByName("text_nick"):setText(ToolKit.isAllAscci(value) and ToolKit.subStr(value, 12) or ToolKit.subStr(value, 18));
	end)
    UIEx.bind(self, MyUserData, "level", function(value)
        self:findChildByName("text_level"):setText("Lv."..value)
    end)
    UIEx.bind(self, MyUserData, "exp", function(value)
        self:setExpProgress()
    end)

	-- 为头像绑定数据源
	UIEx.bind(self, MyUserData, "headName", function(value)
		self:setHeadImg(value)
		MyUserData:checkHeadAndDownload()
	end)

	-- 是否有好友消息
    local btnFriend = self.m_root:findChildByName("btn_friend")
    UIEx.bind(self, MyUserData, "unreadGigt", function(value)
    	if MyUserData:getUnreadApply() > 0 or MyUserData:getUnreadGigt() > 0 then
		    btnFriend:findChildByName("img_tip"):setVisible(true)
        else
            btnFriend:findChildByName("img_tip"):setVisible(false)
		end
	end)

	UIEx.bind(self, MyUserData, "unreadApply", function(value)		
	   	if MyUserData:getUnreadApply() > 0 or MyUserData:getUnreadGigt() > 0 then
		    btnFriend:findChildByName("img_tip"):setVisible(true)
        else
            btnFriend:findChildByName("img_tip"):setVisible(false)
		end
	end)
    --是否有好友破产消息
    UIEx.bind(self, MyUserData, "unreadBankruptHelp", function(value)
        if MyUserData:getUnreadBankruptHelp() > 0 then
            btnFriend:findChildByName("img_tip"):setVisible(true)
        else
            btnFriend:findChildByName("img_tip"):setVisible(false)
        end
    end)
	-- 是否有消息 
    UIEx.bind(self, MyUserData, "hasUnckeckMsg", function(value)	
        if value then
            self.m_root:findChildByName("btn_message"):findChildByName("img_tip"):setVisible(true)
        else
            self.m_root:findChildByName("btn_message"):findChildByName("img_tip"):setVisible(false)
        end
	end)

    --是否有新活动
    UIEx.bind(self, MyUserData, "haveActivity", function(value)
        if value == 1 then
            self.m_root:findChildByName("btn_activity"):findChildByName("img_tip"):setVisible(true)
        else
            self.m_root:findChildByName("btn_activity"):findChildByName("img_tip"):setVisible(false)
        end
    end)
    MyUserData:setHaveActivity(MyUserData:getHaveActivity())

	UIEx.bind(self, MyUserData, "isLogin", function(value)
		if value then return end
		if self.m_headImage then 
			self.m_headImage:setVisible(false) 
		end
	end)
    
	-- 绑定任务领奖个数
    UIEx.bind(self, MyUserData, "taskAward", function(value)
	   	if value > 0 then
			self.m_root:findChildByName("btn_task"):findChildByName("img_tip"):setVisible(true)
        else
            self.m_root:findChildByName("btn_task"):findChildByName("img_tip"):setVisible(false)
		end
	end)

    
    UIEx.bind(self, MyUserData, "hasFriendReward", function(value)
        if value then
            self.m_root:findChildByName("btn_cashShop"):findChildByName("img_tip"):setVisible(true)
        else
            self.m_root:findChildByName("btn_cashShop"):findChildByName("img_tip"):setVisible(false)
        end
    end)
	

end

function LobbyController:setExpProgress()
    local lv = tonumber(MyUserData:getLevel())
    local exp = tonumber(MyUserData:getExp()) 
    local percent = 0
	if lv then
		local index = tonumber(lv)
		if index > 0 and index < 60 then
			local x1 = userLevelExp[index].x1 
			local x2 = userLevelExp[index].x2
			if exp > x1 then
				percent = math.ceil(((exp - x1)/(x2 - x1))*100)
				if percent >= 100 then
					percent = 99
				end
			end
		elseif index == 60 then
			percent = 99
		end
	end
    --无法获取到底下背景的进度条长度，故而硬编码
    local MAXLEN = 170
    local MINLEN = 5
    local width = (MAXLEN - MINLEN) * percent / 100
    local progress = self:findChildByName("img_levelProgress");
    progress:setSize(MINLEN + width, MINLEN)
end

function LobbyController:handleStartEvent()
    --从fb messenger回复进来的，发送统计事件
        --上报启动方式
print_string("zyh handleStartEvent ")
    if not MyUserData.postStartWay then
        MyUserData.postStartWay = true
        local str = NativeEvent.getInstance():getStartWay()
        local startParam = json.decode(str) or {}
        --1表示从fb messenger启动,兼容以前的apk，现在统一改成fbmessenger
        if startParam.startWay == "fbmessenger" or tonumber(startParam.startWay == 1) then
            app:postFrontStaticstics("startFromMessenger")
            local metadata = json.decode(startParam.metadata or "") or {}
            local game = app:getGame(tonumber(metadata.gameId) or 0)
            if game then
                WindowManager:showWindow(WindowTag.PrivateRoomPopu, {}, WindowStyle.POPUP)
                WindowManager:showWindow(WindowTag.PrivateRoomFbInviteSucPopu, metadata, WindowStyle.POPUP)
            end
        --从推送启动游戏
        elseif startParam.startWay == "notification" then
            print_string("zyh notification param metadata is "..tostring(startParam.metadata))
            local metadata = json.decode(startParam.metadata or "") or {}
            --if ruleid exists, then put it to the php server
            local iRuleId = tonumber(metadata.ruleid)
            if iRuleId and iRuleId ~= 0 then
                HttpModule.getInstance():execute(HttpModule.s_cmds.POST_GCM_BACK_USER_ID, {ruleid = iRuleId}, false, true)
            end
            --如果存在扩展字段，处理扩展信息
            local jumpParam = json.decode(metadata.extend or "")
            if jumpParam then
                if jumpParam.jump == "gameRoom" then
                --游戏列表所有的动画大概要2秒才能结束，在这个时间内会拉游戏列表，结束后再进入房间，如果此时仍获取不到游戏列表，就进不去
                    local timeSprite = self:findChildByName("img_bg")
                    checkAndRemoveOneProp(timeSprite, 1000)
                    local animEnterGame = timeSprite:addPropTranslate(1000, kAnimNormal, 1500, 0, 0, 0, 0, 0);
                    animEnterGame:setEvent(nil, function()
                        local gameId = tonumber(jumpParam.gameId) or 0
                        local game = app:getGame(gameId)
                        if game then
                            local level = tonumber(jumpParam.level)
                            if level and gameId ~= 1004 then
                                local room = game:getRoomFromLevel(level)   
                                if room and room.minchip and room.minchip < MyUserData:getMoney() then
                                    game:enterRoom(States.Lobby, room)
                                else
                                    game:enterRoom()
                                end
                            else
                                game:enterRoom()
                            end
                        end
                        checkAndRemoveOneProp(timeSprite, 1000)
                    end)
                elseif jumpParam.jump == "activityRoom" then
                    NativeEvent.getInstance():openActivity()
                elseif jumpParam.jump == "friendRoom" then
                    WindowManager:showWindow(WindowTag.PrivateRoomPopu, {}, WindowStyle.POPUP)
                elseif jumpParam.jump == "friendSend" then
                    WindowManager:showWindow(WindowTag.FriendPopu, {to = "gift"}, WindowStyle.POPUP)
                --推送里有送钱的奖励，点击后发送回给php
                elseif jumpParam.rewardKey then
                    HttpModule.getInstance():execute(HttpModule.s_cmds.GET_NOTIFICATION_REWARD, {rewardKey = jumpParam.rewardKey}, false, false)
                end
            end
            
        end
    end
end

function LobbyController:onAcceptPrivateRoomInvite(data)
    local game = app:getGame(data.gameId)
    if game and game.enterPrivateRoom then
        game:enterPrivateRoom(States.Lobby, kFalse, data.code)
    end
end

function LobbyController:onShowBeginnerHelp(data)
    --新手引导的第一步必须在注册弹窗关闭后再弹出，所以要等待注册弹窗的关闭事件
    self.gameTab:initBeginnerHelpMain()
    GameSetting.beginnerStep = "second"
end
-----------------------  [[ private 方法]] ------------------------------


-----------------------  [[ Socket 事件]] -------------------------


-------------------------[[ UI 绑定]]
------------------------------------------------------------------------------
function LobbyController:onHeadBtnBtnClick()
	printInfo("onHeadBtnBtnClick")
end

function LobbyController:onBottomShopBtnClick()

end

function LobbyController:onStartBtnClick()
	app:requestEnterRoom(GameConfig:getLastType(), true)
end

-- 清除配置
function LobbyController:onSettingBtnClick()
	printInfo("清除数据，断开连接")
	GameSocketMgr:closeSocketSync(true) --断开后重连
end

--登录
function LobbyController:onFaceBookLogin( )
	-- body
	-- self:logoutAnim();
	MyUserData:setUserType(UserType.Facebook)
	self:loginAnim();
end
--登出
function LobbyController:onLogout()
	-- body
    --退出时手动清空sesskey，防止切换账号不成功
    GameSetting:setSesskey("")
    --切换账号后记录的注册游戏不一定，清空原先记录
    GameSetting:setRegisterGame("")
    GameSetting:save()
	self:logoutAnim(true);
	kMusicPlayer:stop(true)
    NativeEvent.getInstance():boyaaAd({type = 8, value = MyUserData:getId()})
end

--自动登录
function LobbyController:onAutoLogin(loginType)
	-- body
	MyUserData:clear();
    MySwitchData:clear();
	MyUserData:setUserType(loginType);

	if System.getPlatform() == kPlatformWin32 then
        MyUserData:setUserType(UserType.Visitor)
        self:loginAnim();
	elseif UserType.Visitor == loginType then
		GameSocketMgr:closeSocketSync(true)
		self:loginAnim();
	elseif UserType.Facebook == loginType then
		GameSocketMgr:closeSocketSync(true)
		NativeEvent.getInstance():login();
	end

end
--[[
	登陆server成功
]]
function LobbyController:onLoginServer(data)
--玩家在大厅重连回server，刷新金币
    if GameSetting.userPayMode == "iosLinePay" then
        HttpModule.getInstance():execute(HttpModule.s_cmds.GET_USER_MONEY, {}, false, false)
        GameSetting.userPayMode = nil
    end
    --正在游戏中
    local room = data.roomInfo
    if data.isInTable > 0 and room then
        local game = app:getGame(room.gameID)
        if game then
            WindowManager:showWindow(WindowTag.LobbyConfirmPopu, {
                content = STR_RELOGIN_LOBBY_IN_GAME,
                cancel = STR_EXIT_GAME_CANCEL,
                confirm = STR_EXIT_GAME_CONFIRM,
                confirmFunc = function()
                    if room.serverLvl == 100 and game.enterPrivateRoom then
                        game:enterPrivateRoom(States.Lobby, kFalse, 0)
                    else
                        game:enterRoom()
                    end
                end
            }, WindowStyle.POPUP)
        end
    end
end

--native callback
function LobbyController:onNativeCallBack(key, data, result)
	if key == kActivityGoFunction then
	    self:onActivityToFunction(data);
	end
end

-- 处理活动界面事件
function LobbyController:onActivityToFunction(data)
	local target = data.target:get_value(); -- 跳转常量
	if kMessage == target then
		WindowManager:showWindow(WindowTag.NoticePopu, {}, WindowStyle.POPUP)
	elseif kGame == target then
		local param = data.desc;   -- 参数
		if param and type(param) == 'table' then
			local gameId = param.gameid:get_value()
			if gameId then
				local game = app:getGame(gameId)
				if game then
					local level = param.level:get_value()
					if level then
						local room = game:getRoomFromLevel(level)
						if room then
							game:enterRoom(States.Lobby, room)
						else
							game:enterRoom() 
						end
					else
						game:enterRoom()
					end
				else
					AlarmTip.play(STR_GAME_CLOSED);
				end
			end
		end
	elseif kRoom == target then
		local param = data.desc;   -- 参数
		if param and type(param) == 'table' then
			local gameId = param.gameid:get_value()
			if gameId then
				local game = app:getGame(gameId)
				if game then 
					game:enterLobby() 
				else
					AlarmTip.play(STR_GAME_CLOSED);
				end
			end
		end
	elseif kInvite == target then
		WindowManager:showWindow(WindowTag.FbInvitePopu, {}, WindowStyle.POPUP)
	elseif kTask == target then
		WindowManager:showWindow(WindowTag.TaskPopu, {}, WindowStyle.POPUP)
	elseif kShare == target then
		local param = data.desc;   -- 参数
		if param and type(param) == 'table' then
			if param.type and param.type:get_value() == 'facebook' then
				NativeEvent.getInstance():share({
				name = param.name and param.name:get_value() or '',
				caption = param.caption and param.caption:get_value() or '',
				link = param.link and param.link:get_value() or '',
				picture = param.picture and param.picture:get_value() or '',
				message = param.message and param.message:get_value() or '',
                from = "activity",
				})
			end
		end
	elseif kShop == target then
        local param = data.desc;
        local pmode = param and param.pmode:get_value()
        local props = param and param.props:get_value()
		WindowManager:showWindow(WindowTag.ShopPopu, {pmode = pmode, to = props}, WindowStyle.POPUP)
	elseif target == "openLink" then
		local url = data.desc.url and data.desc.url:get_value()
		if url then
			NativeEvent.getInstance():openLink(url)
		end
	end

end

function LobbyController:onLoginPHPResponse(isSuccess, data)
	--登录成功
	if isSuccess and data and 1 == data.code then
        self.m_root:findChildByName("scene_bg"):setVisible(true)
        self.m_root:findChildByName("scene_bg_clear"):setVisible(false)
        
        --游戏列表
        
		self:loadGameList();
        if data.data.isCreate == 1 then
            GameSetting.beginnerStep = "first"
            --上报广告SDK，用户是新注册的
            NativeEvent.getInstance():boyaaAd({type = kADRegister or 2, value = MyUserData:getId(), userType = (MyUserData:getUserType() == UserType.Facebook and "facebook" or "guest")})

        end

        --扫描本地磁盘文件，这个动作放在loadGameList后面，是要保证游戏先分好了类，类内的第一个游戏设置自动下载，其他不自动下载
        MyGameVerManager:loadGameOnDisk()
		--进入大厅动画
		self:hallInAnim();
		--播放大厅背景音乐
		kMusicPlayer:play(Music.AudioHallBack, true)
		--支付的登陆回调
		MyPay:logincb();
		--获取支付码
		if not MyPayMode then
			HttpModule.getInstance():execute(HttpModule.s_cmds.GET_PAY_MODE, {}, true, true);
		end
		--下载dice房间列表
--		local gameIds = app:getGameIds()
--		for i = 1, #gameIds do
--            if gameIds[i] > 0 then
--                --游戏已经安装了才获取房间列表
--                local gameStatus = app:getGameStatus(gameIds[i])
--                if gameStatus:getStatus() == 2 then
--			        app:checkAndDownloadRoomList(gameIds[i], 1, false);
--                end
--            end
--		end
		--检查是否有新的消息

		if data.data.aUser and data.data.aUser.haveMessage then
			MyUserData:setHasUnckeckMsg(tonumber(data.data.aUser.haveMessage or 0) > 0)
		end

		--是否有好友未读消息
		HttpModule.getInstance():execute(HttpModule.s_cmds.FRIEND_UNREAD, {}, false, false);
		--是否有任务奖励
		HttpModule.getInstance():execute(HttpModule.s_cmds.HAS_TASK_AWARD, {mid = MyUserData:getId()}, false, false);
        --检查启动方式
        self:handleStartEvent()
        MyUserData:setMakhosOfflineFlag(0)
        NativeEvent.getInstance():openActivity({isReleated = -2})
	else
		--登录失败
		self:logoutAnim(true);
	end
end

--function LobbyController:onGetDiceRoomList(isSuccess, data)
--	if app:checkResponseOk(isSuccess, data) then

--	end
--end
function LobbyController:onGetFriendUnread(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		MyUserData:setUnreadApply(data.data.applyNum);
    	MyUserData:setUnreadGigt(data.data.giftNum);
	end
end


function LobbyController:updateUserInfos(...)
	self:updateUserInfo()
end

--在大厅如果收到送礼物的广播，接收里的人有我，那么给个toast提示
function LobbyController:onGiftSendBroadcast(data)
    printInfo("LobbyController:onGiftSendBroadcast ")
dump(data)
    local receiver = data.receiver
    local giftId = data.gift
    for i = 1, #receiver do
        if receiver[i] == MyUserData:getId() then
            local giftList = MyUserData:getGiftList() or {}
            local gift = giftList[giftId[1]] and giftList[giftId[1]][giftId[2]]
            if gift then
                AlarmTip.play(string.format(STR_GIFT_GET_FROM_FRIEND, data.name, data.sender, gift:getName()))
            end
        end
    end
end

function LobbyController:onEntireBroadcastRsp(data)
    if data.data then
        --收到全局广播，广播类型是用于小喇叭通知
        if data.data.type and tonumber(data.data.type) == 1 then
            self.marquee:addUserMsg(data.data.info or "", data.data.mid and tonumber(data.data.mid) == MyUserData:getId() or false)
        end
        self.marquee:startMarquee()
    end

end

-----------------------   [[通知事件]]  --------------------------
LobbyController.messageFunMap = {
	["SelectGameType"] 			= LobbyController.onSelectGameType,
	["logout"] 					= LobbyController.onLogout,
	["FaceBooklogin"]			= LobbyController.onFaceBookLogin,
	["LobbyExitGame"] 			= LobbyController.exitGame,
	["autoLogin"] 				= LobbyController.onAutoLogin,
	["loginserver"] 			= LobbyController.onLoginServer,
	["showAddMoneyAnim"] 		= LobbyController.showAddMoneyAnim,
	['updateUserInfo']			= LobbyController.updateUserInfos,
    ["giftSendBroadcast"]       = LobbyController.onGiftSendBroadcast,
    ["acceptPrivateRoomInvite"] = LobbyController.onAcceptPrivateRoomInvite,
    ["showBeginnerHelp"]        = LobbyController.onShowBeginnerHelp,
}

-----------------------   [[ 映射 ]]---------------------------------------
LobbyController.commandFunMap = {
	[Command.ENTIRE_BROADCAST_RSP]  = LobbyController.onEntireBroadcastRsp,
	-- [Command.LoginLobbyRsp]				= LobbyController.onLoginLobbySuccess,
}

LobbyController.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.LOGIN_PHP]			= LobbyController.onLoginPHPResponse,
	[HttpModule.s_cmds.FRIEND_UNREAD] 		= LobbyController.onGetFriendUnread,


}


return LobbyController