local LobbyCoinNode = class(Node, false);

function LobbyCoinNode:ctor(uiPath, ...)
	self.mUiPath = uiPath or
	{
		['0'] = "lobby/number/0.png",
		['1'] = "lobby/number/1.png",
		['2'] = "lobby/number/2.png",
		['3'] = "lobby/number/3.png",
		['4'] = "lobby/number/4.png",
		['5'] = "lobby/number/5.png",
		['6'] = "lobby/number/6.png",
		['7'] = "lobby/number/7.png",
		['8'] = "lobby/number/8.png",
		['9'] = "lobby/number/9.png",
		[','] = "lobby/number/d.png",
		['.'] = "lobby/number/p.png",
		['w'] = "lobby/number/w.png",
		['y'] = "lobby/number/y.png",
	}
	super(self, ...)
 	-- body
 end
function LobbyCoinNode:dtor()

end

function LobbyCoinNode:setNumber( formatNumber )
	-- body
	self:removeAllChildren();

	local x, y = 0, 0;

	for i = 1, string.len(formatNumber) do
		local c = string.sub(formatNumber, i, i);
		local numImg 	= new(Image, self.mUiPath[c]);
		if numImg then
			local w, h = numImg:getSize();
			w = w - 2; -- 调整间距
			if c == ',' then
				w = w - 1;
				x = x - 1;
			elseif c == 'c' then
				w = w + 2;
				x = x + 2;
			end
			numImg:setPos(x, y);
			x = x + w;
			self:addChild(numImg);
			self:setSize(x, h);
		end
	end

	
end

return LobbyCoinNode