require(ViewPath .. "lobbyGameLayout")
require(ViewPath .. "lobbyGameLayout2")
local LobbyGameButton = class(Button, false);

function LobbyGameButton:ctor(gameId, isBig)
	super(self, 'ui/blank.png');
	-- body
	--硬编码ICON拼图

	local iconMap_b = {
		[string.format('%s_2.png', gameId)] = {
			file = string.format('lobby/%s_b.png', gameId),
			x = 2, 
			y = 514,
			width = 466,
			height= 90
		},
		[string.format('%s_1.png', gameId)] = {
			file = string.format('lobby/%s_b.png', gameId),
			x = 2, 
			y = 2,
			width = 466,
			height= 510
		},
	}
   local iconMap_s = {
   		[string.format('%s_1.png', gameId)] = {
			file = string.format('lobby/%s_s.png', gameId),
			x = 2, 
			y = 2,
			width = 202,
			height= 202
		},
		[string.format('%s_2.png', gameId)] = {
			file = string.format('lobby/%s_s.png', gameId),
			x = 2, 
			y = 206,
			width = 294,
			height= 45
		},
	}
   local iconMap = isBig and iconMap_b or iconMap_s
    local suffix = isBig and "b" or "s"
    local layout = isBig and SceneLoader.load(lobbyGameLayout) or SceneLoader.load(lobbyGameLayout2)
	--加载配置
--	local layout = SceneLoader.load(lobbyGameLayout);
    self:addChild(layout);
    self:setSize(layout:getSize());
    --数据
	self.mLobbyGame = app:getGameStatus(gameId) 
	self.mSupperLobbyGame = app:getGameStatus(self:getGameCheckUpdateId(gameId)) 

	--绑定UI ID
	UIEx.bind(self, self.mLobbyGame, "id", function(gameId)
		if gameId == 0 then
			self.mLobbyGame:setStatus(0)
			return 
		end
		local path = 'lobby/'
	    local name = string.format('%s_%s.png', gameId, isBig and "b" or "s")
	    --如果游戏ICON不存在
	    if NativeEvent.getInstance():isFileExist(name, path) ~= 1 then
	    	--设置游戏未开放
	    	self.mLobbyGame:setStatus(0)
			-- 开始下载图片
			if not isBig then
				MyUpdate:downloadImage(app:getGameIconUrl(gameId), path, name, function(status, folder, name)
						--下载成功
						if status == 1 and NativeEvent.getInstance():isFileExist(name, path) == 1 then 
							if app:isGameInstalled(gameId) then
								self.mLobbyGame:setStatus(2)
							else
								self.mLobbyGame:setStatus(1)
							end
						end
				end)
			end
		else
			if app:isGameInstalled(gameId) then --游戏已安装
				self.mLobbyGame:setStatus(2)
			else --游戏未下载
				self.mLobbyGame:setStatus(1)
			end
		end
	end)

    local textStatus = self:findChildByName("text_status")
    textStatus:setText(STR_LOAING)
    local gameBg = self:findChildByName("img_gamebg")
    local gameName = self:findChildByName("img_name")
	UIEx.bind(self, self.mLobbyGame, "status", function(status)
		--游戏安装状态 0 图标未下载 1 游戏未下载 2 游戏已安装
		local gameId = self.mLobbyGame:getId()
		if status == 0 then
			gameBg:setFile('lobby/0.png'); --默认图标
	    	self.mLobbyGame:setChoose(false)
            textStatus:setVisible(false)
            gameBg:setPos(20, 10)
		elseif status == 1 then
			gameBg:setFile(iconMap[string.format('%s_1.png', gameId)])
            gameName:setFile(iconMap[string.format('%s_2.png', gameId)])
		elseif status == 2 then
			self.mLobbyGame:setChoose(true)
            textStatus:setVisible(false)
            gameBg:setPos(-20, 0)
            gameBg:setFile(iconMap[string.format('%s_1.png', gameId)])
            gameName:setFile(iconMap[string.format('%s_2.png', gameId)])
		end
	end)

	UIEx.bind(self, self.mLobbyGame, "choose", function(choose)
		self:findChildByName("btn_chooseroom"):setVisible(choose)
	end)
    local imgProgressBg = self:findChildByName("img_progressBg")
    local maxLen = imgProgressBg:getSize()
    local imgProgress = imgProgressBg:findChildByName("img_progress")
    local minLen, height = imgProgress:getSize()
    local textGameName = self:findChildByName("text_gameName")
	UIEx.bind(self, self.mSupperLobbyGame, "progress", function(progress)
        --progress变更表示在解压或者下载中，此时需要显示提示文字，如果是自动下载的就不提示
        if progress < 100 then
            textStatus:setVisible(true)
            imgProgressBg:setVisible(true)
            imgProgress:setSize((maxLen - minLen) * progress / 100 + minLen, height)
            textGameName:setVisible(false)
        --下载结束，提示消失
        else
            textStatus:setVisible(false)
            textGameName:setVisible(true)
            imgProgressBg:setVisible(false)
        end
	end)
	self.mLobbyGame:setId(gameId)

	self:findChildByName("btn_chooseroom"):setOnClick(self, function ( self )
			-- print_string("btn_chooseroom"..tostring(MyGameVerManager:updateGameFromNet(gameId)))
            if MyGameVerManager:updateGameFromNet(gameId) then
            	print_string("btn_chooseroom"..tostring(self.mOnChooseFunc))
            	 
			    if self.mOnChooseFunc then
				    self.mOnChooseFunc(self.mOnChooseObj)
			    end
            end
		end)

	self:setOnClick(self, function (self)
		-- 如果游戏ICON不存在则游戏未开放
		if MyGameVerManager:updateGameFromNet(gameId) then
		    if self.mOnClickFunc then
			    self.mOnClickFunc(self.mOnClickObj)
		    end
        end
	end)

    local gameList = MyUserData:getGameList() or {}
    local gameType = gameList[tostring(gameId)] or {}
    if not isBig then
    	local imgNum = self:findChildByName("img_playerNum")
    	imgNum:setFile(string.format("lobby/playerNum%s.png", gameType.playerNum or "2"))
    	imgNum:setSize(imgNum.m_res.m_width, imgNum.m_res.m_height)
    end
    if not isBig and gameType.new == 1 then
		self:findChildByName("img_new"):setVisible(true)
	end
    
    -- if isBig then
    --     textGameName:setFontAndSize(kFontTextBold, 44)
    -- end
    -- UIEx.bind(self, self.mLobbyGame, "name", function(value)
    --     textGameName:setText(value)
    -- end)
    -- self.mLobbyGame:setName(gameType.localName or "")

end

function LobbyGameButton:getGameCheckUpdateId(gameId)
	local games = nil
    if MyUserData then
	    games = MyUserData:getLobbyGames()
	end
	if games then
	    for k, v in pairs(games) do
	        if tonumber(v.gameid) == tonumber(gameId) then
	            return v.parentGameId or gameId
	        end
	    end
	end
    return gameId
end

function LobbyGameButton:setOnClickButton(obj, func)
	-- body
	self.mOnClickObj = obj;
	self.mOnClickFunc= func;
end

function LobbyGameButton:setOnChooseRoom(obj, func)
	-- body
	self.mOnChooseObj = obj;
	self.mOnChooseFunc= func;
end

function LobbyGameButton:dtor()

end

function LobbyGameButton:getGameId()
	return self.mLobbyGame:getId()
end


return LobbyGameButton