WindowStyle = {
    NORMAL          = 1,
    TRANSLATE_DOWN  = 2,
    TRANSLATE_UP    = 3,
    TRANSLATE_LEFT  = 4,
    TRANSLATE_RIGHT = 5,
    POPUP           = 6,
}

WindowTag = {
	MessageBox 		= 1,
	MessageBox1 	= 2,
	NoticePopu 		= 3,
	UserPopu 		= 4,
	TaskPopu 		= 6,
	ShopPopu 		= 7,
	SettingPopu		= 8,
	HelpPopu		= 9,
	MessagePopu		= 10,
	RechargePopu 	= 11,
	PortraitPopu 	= 12,
	FeedbackPopu 	= 14,
	
	RoomChat 		= 53,

	ReconnMessageBox = 80,

	GuidePopu = 81,
	TestToolPopu     = 100,

	FriendPopu = 101,
	FbInvitePopu = 102,

	LobbyExitPopu = 103,
	RegisterRewardPopu 			= 105,      --注册
	BankruptPopu 				= 106,      --破产
	SharePopu 					= 107,      --分享
	DuiJiangPopu				= 110,      --兑换码
	DealerProsPopu				= 111,
	FriendInfoPopu 				= 112,      --好友列表里好友个人信息
    UrgentNoticePopu            = 113,      --紧急公告，登陆后即弹
    CashExchangePopu            = 114,      --现金币商品
    CashBuyConfirmPopu          = 116,      --现金币购买确认
    CashBuyNumChangePopu 		= 117,      --现金币购买数量变更
    AttendencePopu 				= 118,      --签到
    LobbyConfirmPopu 			= 119,      --公用的确认弹窗
    RoomPlayerInfoPopu          = 120,      --房间内个人信息弹窗
    PrivateRoomPopu               = 121,      --好友房
    BuddyRoomInvitePopu         = 122,      --好友房邀请弹窗
    GiftStorePopu               = 123,      --礼物系统弹窗
    PrivateRoomBillPopu         = 124,      --私人房账单
    PrivateRoomRenewalPopu      = 125,      --私人房续费弹窗
    PrivateRoomFbInviteSucPopu  = 126,      --私人房fb messenger邀请成功弹窗
    PrivateRoomCreateSucPopu    = 127,      --创建私人房成功提示
    ShopPinNoEdit               = 128,		--支付输入PIN码
    LobbyExitGamePopu           = 129,      --退出游戏弹窗
    ShopBuyConfirmPopu          = 130,      --购买弹窗确认框，带图片
    OfflinePopu                 = 131,		--马哈单机
    ActCenterPopu				= 132,		--大厅活动
    RegisterRewardFinishPopu	= 133,		--注册领取后弹窗
}

-- 弹窗配置表
-- 参数1 弹窗配置表{ 1 为弹窗类， 2为弹窗布局文件 }
-- 参数2 zorder
-- 参数3 关闭后是否销毁
WindowConfigMap = {
	-- config  														zOrder bgTouchHide backHide autoRemove stateRemove
	[WindowTag.MessageBox] 		= 	{ "popu.public.messageBox", "messageBox", 220, false, true, true, true},
	[WindowTag.ReconnMessageBox] = 	{ "popu.public.messageBox", "messageBox", 221, false, true, true, true},
	[WindowTag.MessageBox1] 	= 	{ "popu.public.messageBox1", "messageBox", 220, false, true, true, true},
	[WindowTag.RoomChat] 		= 	{ "popu.room.roomChatPopu", "roomChatPopu", 188, false, true, true, true},
	[WindowTag.NoticePopu] 		= 	{ "popu.lobby.noticePopu", "noticeLayout", 188, false, true, true, true},
	[WindowTag.UserPopu] 		= 	{ "popu.lobby.userPopu", "userLayout", 188, false, true, true, true},
	[WindowTag.TaskPopu] 		= 	{ "popu.lobby.taskPopu", "taskLayout", 180, false, true, true, true},
	[WindowTag.ShopPopu] 		= 	{ "popu.lobby.shopPopu", "shopLayout", 288, false, true, true, true},
	[WindowTag.SettingPopu] 	= 	{ "popu.lobby.settingPopu", "lobbySettingLayout", 188, false, true, true, true},
	[WindowTag.HelpPopu] 		= 	{ "popu.lobby.helpPopu", "helpLayout", 180, false, true, true, true},
	[WindowTag.MessagePopu] 	= 	{ "popu.lobby.messagePopu", "messageBoxLayout", 180, false, true, true, true},
	[WindowTag.PortraitPopu] 	= 	{ "popu.lobby.portraitPopu", "modifyPortraitLayout", 192, false, true, true, true},
	[WindowTag.FeedbackPopu] 	= 	{ "popu.lobby.feedbackPopu", "feedbackLayout", 188, false, true, true, true},

	[WindowTag.RechargePopu] 		= 	{ "popu.public.rechargePopu", "quickPurchaseLayout", 190, false, true, true, true},

	[WindowTag.GuidePopu] 			= 	{ "popu.public.guidePopu", "guidePopu", 188, false, true, true, true},

	[WindowTag.TestToolPopu] 		= 	{ "popu.public.testToolPopu", "testToolPopu", 199, false, true, false, false},

	[WindowTag.FriendPopu] 			= 	{ "popu.lobby.friendPopu", "lobbyFriendPopu", 188, false, true, true, true},
	[WindowTag.FbInvitePopu] 			= 	{ "popu.lobby.fbInvitePopu", "lobbyFbInvitePopu", 188, false, true, true, true},
	[WindowTag.LobbyExitPopu] 			= 	{ "popu.lobby.lobbyConfirmPopu", "lobbyConfirmPopuLayout", 290, false, true, true, true},
	[WindowTag.RegisterRewardPopu]		= 	{ "popu.lobby.registerRewardPopu", "registerRewardPopu2", 288, false, true, true, true},
	[WindowTag.BankruptPopu]			= 	{ "popu.public.bankruptPopu", "bankruptLayout", 288, false, true, true, true},
	[WindowTag.SharePopu]				=   { "popu.public.sharePopu", "sharePopuLayout", 288, true, true, true},
	[WindowTag.DuiJiangPopu]			= 	{ "popu.lobby.duijiangPopu", "duijiangLayout", 288, false, true, true},
	[WindowTag.DealerProsPopu]			= 	{ "popu.room.dealerProsPopu", "dealer_pros_popu", 288, true, true, true, true},
	[WindowTag.FriendInfoPopu]			= 	{ "popu.lobby.friendInfoPopu", "playerInfoLayout", 188, true, true, true, true},
    [WindowTag.UrgentNoticePopu]        =   { "popu.lobby.urgentNoticePopu", "urgentNotice", 288, false, true, true, true},
    [WindowTag.CashExchangePopu]        =   { "popu.lobby.cashExchangePopu", "cashExchangePopuLayout", 180, false, true, true, true},
    [WindowTag.CashBuyConfirmPopu]      =   { "popu.lobby.cashBuyConfirmPopu", "cashBuyConfirmLayout", 188, false, true, true, true},
    [WindowTag.CashBuyNumChangePopu] 	=  	{ "popu.lobby.cashBuyNumChangePopu", "cashBuyNumChangeLayout", 188, false, true, true, true},
    [WindowTag.AttendencePopu] 			=	{ "popu.lobby.attendencePopu", "attendenceLayout", 228, false, true, true, true},
    [WindowTag.LobbyConfirmPopu]        =   { "popu.lobby.lobbyConfirmPopu", "lobbyConfirmPopuLayout", 290, false, true, true, true},
    [WindowTag.RoomPlayerInfoPopu]      =   { "popu.room.roomPlayerInfoPopu", "roomPlayerInfoLayout", 288, false, true, true, true},
    [WindowTag.PrivateRoomPopu]         =   { "popu.lobby.privateRoomPopu", "privateRoomLayout", 180, false, true, true, true},
    [WindowTag.BuddyRoomInvitePopu]     =   { "popu.lobby.buddyRoomInvitePopu", "buddyRoomInvitePopuLayout", 188, false, true, true, true},
    [WindowTag.GiftStorePopu]           =   { "popu.public.giftStorePopu", "giftStorePopuLayout", 288, false, true, true, true},
	[WindowTag.ShopPinNoEdit]			=	{ "popu.public.shopPinNoEdit", "shopPinNoEdit", 288, false, true, true, true},
	[WindowTag.PrivateRoomBillPopu]     =   { "popu.public.privateRoomBillPopu", "privateRoomBillLayout", 188, false, true, true, true},
    [WindowTag.PrivateRoomRenewalPopu]  =   { "popu.room.privateRoomRenewalPopu", "privateRoomRenewalLayout", 180, false, true, true, true},
    [WindowTag.PrivateRoomFbInviteSucPopu]= { "popu.lobby.privateRoomFbInviteSucPopu", "privateRoomFbInviteSucPopu", 188, false, true, true, true},
    [WindowTag.PrivateRoomCreateSucPopu]=   { "popu.room.privateRoomCreateSucPopu", "privateRoomCreateSucLayout", 180, false, true, true, true},
    [WindowTag.LobbyExitGamePopu]       =   { "popu.lobby.lobbyExitGamePopu", "lobbyExitGameLayout", 288, false, true, true, true},
    [WindowTag.ShopBuyConfirmPopu]      =   { "popu.public.shopBuyConfirmPopu", "shopBuyConfirmLayout", 290, false, true, true, true},
    [WindowTag.OfflinePopu]       		=   { "popu.lobby.offlinePopu", "offlinePopuLayout", 188, false, true, true, true},
    [WindowTag.ActCenterPopu] 		    = 	{ "popu.lobby.actCenterPopu", "actCenterPopuLayout", 180, false, true, true, true},
    [WindowTag.RegisterRewardFinishPopu]		= 	{ "popu.lobby.registerRewardFinishPopu", "registerRewardPopu3", 288, false, true, true, true},
}

local WindowManager = class(Node)
local BgAlpha = 180
local BgFadeTime = 200

function WindowManager:ctor()
	self:addToRoot()
	self:setLevel(50)
	self.m_windows = {}
	self:setFillParent(true, true)
end

function WindowManager:showWindow(name, data, style,shadeHide)
	self:createBgShade(shadeHide)

	local window = self:getChildByName(name)
	local winCfg = WindowConfigMap[name]
	local reCreate
	if not window and winCfg then
		local path, viewCfg, zOrder, bgTouchHide, backHide, autoRemove, stateRemove, lpath = unpack(winCfg)
		local cls = require(path)
		local layout = requireview((lpath or ViewPath) .. viewCfg)

		window = new(cls, layout, data) -- _G[viewCfg]
		window:initView(data)
		window:setLevel(zOrder)
		self.m_shadeBg:setLevel(zOrder)
		window:setName(name)
		printInfo("创建弹窗 %s", name)
		window:setConfigFlag(bgTouchHide, backHide, autoRemove, stateRemove)
		window:setAlign(kAlignCenter)
		self:addChild(window)
		table.insert(self.m_windows, window)
		reCreate = true
	elseif window then
		window:updateView(data)
	end
	self:sortWindow()
	window:show(style)
	checkAndRemoveOneProp(self.m_shadeBg, 1002)
	if window and not self.m_shadeBg:getVisible() then
		self.m_shadeBg:setVisible(true)
		local anim = self.m_shadeBg:addPropTransparency(1001, kAnimNormal, BgFadeTime, 0, 0.0, 1.0)
		if anim then
			anim:setEvent(nil, function()
				self.m_shadeBg:removeProp(1001)
			end)
		end
	end

	self:resortLevel()
end


function WindowManager:resortLevel(visibleTb)
	visibleTb = visibleTb or self:getVisibleTb()
	if #visibleTb > 0 then
		self:sortWindow(visibleTb)
		self.m_shadeBg:setLevel(visibleTb[#visibleTb]:getLevel() - 1)
	end
end

--[[
	排序
]]
function WindowManager:sortWindow(windowTb)
	windowTb = windowTb or self.m_windows
	table.sort(self.m_windows, function(node1, node2)
		return node1:getLevel() < node2:getLevel()
	end)
end

function WindowManager:createBgShade(shadeHide)
	self.oldIsHide = self.oldIsHide or nil 
	if self.m_shadeBg then
		if self.oldIsHide~=shadeHide then
			self.m_shadeBg:removeSelf()
			self.oldIsHide=shadeHide
		else
			return
		end
	end
	if shadeHide then
		self.m_shadeBg = UIFactory.createImage("ui/blank.png")
	else
		self.m_shadeBg = UIFactory.createImage("ui/shade.png")
	end
		
	self.m_shadeBg:setFillParent(true, true)
	self.m_shadeBg:setVisible(false)
	self.m_shadeBg:setLevel(1)
	self.m_shadeBg:setEventTouch(self, self.onShadeBgTouch);
	self:addChild(self.m_shadeBg)
end

function WindowManager:onShadeBgTouch(finger_action, x, y, drawing_id_first, drawing_id_current)
	if finger_action ~= kFingerDown then return end
	for i=#self.m_windows, 1, -1 do
		local window = self.m_windows[i]
		if window:isBgTouchHide() and window:getVisible() then
			local success = window:dismiss()
			if success then
				printInfo("success name = %s", window:getName())
				break
			else
				printInfo("false name = %s", window:getName())
				return
			end
		end
	end
end

function WindowManager:onKeyBack()
	for i=#self.m_windows, 1, -1 do
		local window = self.m_windows[i]
		if window:isBackHide() then
			local success = window:dismiss()
			if success then
				return true
			end
		end
	end
end

--[[
	当前有多少弹窗可见
]]
function WindowManager:getVisibleTb()
	local visibleTb = {}
	for k,v in pairs(self.m_windows) do
		if v:getVisible() then
			table.insert(visibleTb, v)
		end
	end
	return visibleTb
end

function WindowManager:onShowEnd(name)
	self.m_shadeBg:setVisible(true)
	checkAndRemoveOneProp(self.m_shadeBg, 1002)
end

function WindowManager:onHidenEnd(name, doClean)
	if doClean then
		for k,v in pairs(self.m_windows) do
			if v:getName() == name then
				table.remove(self.m_windows, k)
				self:removeChild(v, doClean)
				printInfo("销毁弹窗 ！！！！！ %s", name)
				break;
			end
		end
	end
	local visibleTb = self:getVisibleTb()
	self:createBgShade()
	printInfo("弹窗%s关闭成功, 剩余弹窗数量%d, 存在弹窗数量%d", name, #visibleTb, #self.m_windows)
	checkAndRemoveOneProp(self.m_shadeBg, 1001)
	if #visibleTb == 0 and self.m_shadeBg:getVisible() then
		local anim = self.m_shadeBg:addPropTransparency(1002, kAnimNormal, BgFadeTime, 0, 1.0, 0.0)
		if anim then
			anim:setEvent(nil, function()
				self.m_shadeBg:removeProp(1002)
				self.m_shadeBg:setVisible(false)
			end)
		else
			self.m_shadeBg:setVisible(false)
		end
	end
	self:resortLevel(visibleTb)
end

function WindowManager:closeWindowByTag(tag, noAnim)
	for i,v in pairs(self.m_windows) do
		if v:getName() == tag then
			v:dismiss(noAnim)
		end
	end
end

function WindowManager:containsWindowByTag(tag)
	printInfo("containsWindowByTag(tag) = %s", tag)
	for i,v in pairs(self.m_windows) do
		printInfo("name = %s", v:getName())
		if v:getName() == tag then
			return v
		end
	end
end

function WindowManager:dealWithStateChange()
	local indexTb = {}
	for k,v in pairs(self.m_windows) do
		if v:isStateRemove() then
			table.insert(indexTb, k)
		end
	end
	for i=#indexTb, 1, -1 do
		local wnd = self.m_windows[indexTb[i]]
		if wnd:alive() then
			self:onHidenEnd(wnd:getName(), true)
		end
	end
end

return WindowManager
