--[[
	通用的Php消息处理器  2015-03-04
]]
local CommonPhpProcesser = class(SocketProcesser)
local printInfo, printError = overridePrint("CommonPhpProcesser")

function CommonPhpProcesser:ctor()
	-- body
	EventDispatcher.getInstance():register(HttpModule.s_event, self, self.onHttpResponse);
end

function CommonPhpProcesser:dtor()
	-- body
	EventDispatcher.getInstance():unregister(HttpModule.s_event, self, self.onHttpResponse);
end

function CommonPhpProcesser:requestLogin()

end

function CommonPhpProcesser:onHttpResponse( command, ... )
	-- printInfo("CommonPhpProcesser.onHttpResponse");
	-- if not app:checkResponseOk(data) then
	-- 	return
	-- end
	--dd.dd.dd=0;
	-- MyUserData:initUserInfo(data.data);
	-- 
	local func = self.s_httpEventFuncMap[command];
	if func then
		func(self, ...);
	end
	
end

function CommonPhpProcesser:hasSpectialAct(actList)
	if actList then
		for i=1,#actList do
			if tonumber(actList[i].special) == 1 and tonumber(actList[i].rewardStatus) ~= 3 then
				return true
			end
		end
	end
	return false
end

function CommonPhpProcesser:onLoginPhpResponse(isSuccess, data)
	JLog.d('function CommonPhpProcesser:onLoginPhpResponse(isSuccess, data)',data)
	-- writeTabToLog(data,"php登录","1ddd.lua")
	if isSuccess and data then
		if 1 == data.code then
			if data.data then
				local sesskey 	= data.data.sesskey;
				local user 		= data.data.aUser;
				if user then
					user.sesskey = sesskey;
					MyUserData:initUserInfo(user);
					GameConfig:setLastUserType(MyUserData:getUserType())
						  :save()
                    if tonumber(user.recall) == 1 then
                        --召回用户，上报广告SDK
                        NativeEvent.getInstance():boyaaAd({type = 7, value = MyUserData:getId()})
                    end
				end
				local hallip = data.data.hallip;
				if hallip then
					local addrList = {};
					for i = 1, #hallip do
						local addr = {};
						addr.ip, addr.port = string.match(hallip[i], "(%d+.%d+.%d+.%d+):(%d+)");
						table.insert(addrList, addr)
					end
					MyUserData:setAddrList(addrList);
				end
				--URL
				MyUserData:setUrls(data.data.urls or {})
				--游戏列表 102:游戏大厅 1002:骰子
				MyUserData:setGameList(data.data.gameList or {} );
				--大厅游戏列表
				MyUserData:setLobbyGames(data.data.gamesListConfig or {})
				--大厅更新
--				MyUserData:setUpdateUrl(data.data.updateUrl or {})
                
                --请求紧急公告信息
                HttpModule.getInstance():execute(HttpModule.s_cmds.GET_URGENT_NOTICE, {}, true, true)
                --请求邀请好友任务列表
                HttpModule.getInstance():execute(HttpModule.s_cmds.GET_CASH_TASK_FRIEND, {}, true, true)
                --查询道具配置列表
                HttpModule.getInstance():execute(HttpModule.s_cmds.GET_PROP_CFG_LIST, {}, false, false)
                --查询所有开关
				HttpModule.getInstance():execute(HttpModule.s_cmds.GET_USER_ALL_PROPS,{}, false, false)                HttpModule.getInstance():execute(HttpModule.s_cmds.CHECK_SWITCH_FOR_ALL, {}, false, false)
                --查询礼物列表
                HttpModule.getInstance():execute(HttpModule.s_cmds.GIFT_STORE_GET_LIST, {}, false, false)
                --FB邀请和召回的奖励
                HttpModule.getInstance():execute(HttpModule.s_cmds.INVITE_CONFIG,{sid = PhpManager:getGame()}, false, false)
               
				--登录有奖
				local signAward = data.data.signAward
				MyUserData.dailyReward = nil
				
				if signAward then
					--今天没签到
					if signAward.type == 1 then
                        --签到数据
						local attendenceData = {}
                        --FB账号的奖励倍数
                        attendenceData.override = signAward.override
                        --连续签到日子
						attendenceData.signNum = signAward.signNum
                        attendenceData.hasSigned = false
						local configs = signAward.prizelist or {}
						for i = 1, #configs do
							local config = {}
							--金币奖励
							config.type = configs[i].type and tonumber(configs[i].type) or 0
							if config.type == 1 then
								config.money = configs[i].money and tonumber(configs[i].money) or 0
							--金币和道具奖励
							elseif config.type == 2 then
								config.money = configs[i].money and tonumber(configs[i].money) or 0
								config.pnid = configs[i].pnid or 0
								config.props = configs[i].props and tonumber(configs[i].props) or 0
							--现金币奖励
							elseif config.type == 3 then
								config.diamond = configs[i].diamond and tonumber(configs[i].diamond) or 0
							end
							table.insert(attendenceData, config)
						end
						MyUserData.dailyReward = {rewardType = WindowTag.AttendencePopu,  rewardData = attendenceData}
                        MyUserData:setAttendenceReward(attendenceData)
                    else
                        --已经签到，清空签到数据
                        local attendenceData = {}
                        attendenceData.hasSigned = true
                        --FB账号的奖励倍数
                        attendenceData.override = signAward.override
                        --连续签到日子
						attendenceData.signNum = signAward.signNum == 0 and 7 or signAward.signNum
						local configs = signAward.prizelist or {}
						for i = 1, #configs do
							local config = {}
							--金币奖励
							config.type = configs[i].type and tonumber(configs[i].type) or 0
							if config.type == 1 then
								config.money = configs[i].money and tonumber(configs[i].money) or 0
							--金币和道具奖励
							elseif config.type == 2 then
								config.money = configs[i].money and tonumber(configs[i].money) or 0
								config.pnid = configs[i].pnid or 0
								config.props = configs[i].props and tonumber(configs[i].props) or 0
							--现金币奖励
							elseif config.type == 3 then
								config.diamond = configs[i].diamond and tonumber(configs[i].diamond) or 0
							end
							table.insert(attendenceData, config)
						end
                        MyUserData:setAttendenceReward(attendenceData)
					end
				else
					MyUserData:setAttendenceReward(nil)
				end
				if data.data.registerAward then
					local money = data.data.registerAward.addmoney or 0;
					local mtype = data.data.registerAward.type or 0
					local days = data.data.registerAward.days or 0
					local awardList = data.data.registerAward.awardList or {}
                    local propList = data.data.registerAward.propList or {}
                    local gift = data.data.registerAward.gift or {}
					--mtype:1 登录成功 0：登录失败
					if mtype == 1 then
                        MyUserData.dailyReward = {rewardType =WindowTag.RegisterRewardPopu,  rewardData = {money = addmoney, 
                        day = days, awardList = awardList, propList = propList, gift = gift}}
						--WindowManager:showWindow(WindowTag.RegisterRewardPopu, {day = days, addmoney = money, awardList = awardList}, WindowStyle.POPUP)
					else

					end
				end
				MyUserData.hasSpectialAct = 0
				
                if tonumber(data.data.isFirst) == 1 and self:hasSpectialAct(data.data.activityList) then
                	MyUserData.hasSpectialAct = 1
                end

				--在此处添加系统公告
                --HttpModule.getInstance():execute(HttpModule.s_cmds.GET_GAMEINFO,{gameid = 1002, sid = 102}, false, false)
                
				--是否是FB登录,iscreate = 1是首次创建的用户
				if UserType.Facebook == MyUserData:getUserType() then
                    --FB用户存sesskey
                    GameSetting:setSesskey(sesskey)
                    GameSetting:save()
                    if tonumber(data.data.isCreate) == 1 then
					    NativeEvent.getInstance():getFbAppInfo();
                    end
				end
				--广告
				NativeEvent.getInstance():loadAdData(MyUserData:getId(), true)
				--这时网络已断开，重新连接
				printInfo('CommonPhpProcesser tryReconnect()')
				GameSocketMgr:tryReconnect()
                --刷新gcm 的token值
				NativeEvent.getInstance():getClientId({})
                --保留登录广告
			    NativeEvent.getInstance():boyaaAd({type = 3, value = MyUserData:getId()})
			end
			--封号通知，弹窗提示
		elseif data.code == -5 then
            WindowManager:showWindow(WindowTag.LobbyConfirmPopu, {
                content = data.codemsg or "",
                confirm = STR_EXIT_GAME_CONFIRM,
																																 }, WindowStyle.POPUP)
		else
			AlarmTip.play(data.codemsg or "");
		end
		--登录失败，检查是否断网
	elseif NativeEvent.getInstance():GetNetAvaliable() ~= 1 then
			AlarmTip.play(STR_NETWORK_NOT_AVAILABLE)

	end
end
function CommonPhpProcesser:onGetFbInviteAwardResponse(isSuccess, data)

	if isSuccess and data then
		if 1 == data.code then
			if data.data then
				local addmoney 	= tonumber(data.data.addmoney) or 0;
				local money 		= data.data.money or 0;
				if money then
					MyUserData:setMoney(money);
				end
                if addmoney > 0 then
				    AlarmTip.play(string.format(STR_INVITE_AWARD, addmoney));
                end
				--金币雨动画
				AnimationParticles.play(AnimationParticles.DropCoin)
				kEffectPlayer:play('audio_get_gold')
			end
		else
			AlarmTip.play(data.codemsg or "");
		end
	end
end

function CommonPhpProcesser:onGetFbInviteSucAwardResponse(isSuccess, data)
	
	if isSuccess and data then
		if 1 == data.code then
			if data.data then
				local money 		= data.data.money;
				if money then
					MyUserData:setMoney(money);
				end
				AlarmTip.play(data.codemsg or "");
				--金币雨动画
				AnimationParticles.play(AnimationParticles.DropCoin)
				kEffectPlayer:play('audio_get_gold')
			end
		else
			AlarmTip.play(data.codemsg or "");
		end
	end
end

function CommonPhpProcesser:onGetBrokenMoneyResponse(isSuccess, data)
	
	if isSuccess and data then
		if 1 == data.code then
			if data.data then
				local addmoney 	= data.data.addmoney;
				local money 		= data.data.money;
				if money then
					MyUserData:setMoney(money);
				end
				AlarmTip.play(string.format(STR_BROKEN, addmoney))
				--金币雨动画
				AnimationParticles.play(AnimationParticles.DropCoin)
				kEffectPlayer:play('audio_get_gold')
				EventDispatcher.getInstance():dispatch(Event.Message, "hallBankrupt", 0)
			end
		else
			AlarmTip.play(data.codemsg or "");
		end
	end
end

function CommonPhpProcesser:onPayModeResponse( isSuccess, data )
	if app:checkResponseOk(isSuccess, data) then
		MyPayMode = {};
		for i = 1, #data.data do
			local d = data.data[i]
			local payMode = setProxy(new(require('data.payMode')))
			payMode:setId(d.pmode or 0)
			payMode:setName(d.name or 0)
			payMode:setTime(d.time or 0)

			table.insert(MyPayMode, payMode);
		end
	end

end
function CommonPhpProcesser:onPayListResponse( isSuccess, data )
	-- body
	-- {"code":1,"codemsg":"",
	-- "data":[{"id":"123802","sid":"7","appid":"1332","pmode":"240","pamount":"29","discount":"1","pcoins":"0","pchips":"1722600","pcard":"0","item_id":"0","ptype":"0","pnum":"1","getname":"1,722,600\u0e0a\u0e34\u0e1b","desc":"{\"url1\":\"\",\"url2\":\"\",\"desc\":\"\"}","stag":"1","currency":"THB","prid":"36","expire":"0","state":"","device":"1","sortid":"0","etime":"1442310241","status":"2","use_status":"0"},
	-- 		{"id":"123803","sid":"7","appid":"1332","pmode":"240","pamount":"49","discount":"1","pcoins":"0","pchips":"3234000","pcard":"0","item_id":"0","ptype":"0","pnum":"1","getname":"3,234,000\u0e0a\u0e34\u0e1b","desc":"{\"url1\":\"\",\"url2\":\"\",\"desc\":\"\"}","stag":"1","currency":"THB","prid":"36","expire":"0","state":"","device":"1","sortid":"0","etime":"1442310241","status":"2","use_status":"0"},{"id":"123804","sid":"7","appid":"1332","pmode":"240","pamount":"99","discount":"1","pcoins":"0","pchips":"7623000","pcard":"0","item_id":"0","ptype":"0","pnum":"1","getname":"7,623,000\u0e0a\u0e34\u0e1b","desc":"{\"url1\":\"\",\"url2\":\"\",\"desc\":\"\"}","stag":"1","currency":"THB","prid":"36","expire":"0","state":"","device":"1","sortid":"0","etime":"1442310241","status":"2","use_status":"0"},{"id":"123805","sid":"7","appid":"1332","pmode":"240","pamount":"149","discount":"1","pcoins":"0","pchips":"12456400","pcard":"0","item_id":"0","ptype":"0","pnum":"1","getname":"12,456,400\u0e0a\u0e34\u0e1b","desc":"{\"url1\":\"\",\"url2\":\"\",\"desc\":\"\"}","stag":"1","currency":"THB","prid":"36","expire":"0","state":"","device":"1","sortid":"0","etime":"1442310241","status":"2","use_status":"0"}],"time":1442890249,"exetime":1442890249.5111}
	if app:checkResponseOk(isSuccess, data) then
		local pay 	= new(require('data.pay'));
        local originalShop = {}
		for i = 1, #data.data do
			local d = data.data[i]
			local shop = setProxy(new(require('data.shop')));
			
			pay:setMode(tonumber(d.pmode or 0));
			shop:setId(tonumber(d.id or 0));
			shop:setPamount(tonumber(d.pamount or 0));
			shop:setCurrency(d.currency or "$")
			shop:setPchips(tonumber(d.pchips or 0))
            shop:setDiscount(tonumber(d.discount) or 1)
            shop:setPcard(tonumber(d.pcard) or 0)
            shop:setName(d.getname or "")
			shop:setPdesc(string.format('1%s=%s', shop:getCurrency(), ToolKit.skipMoney(math.floor(shop:getPchips() > 0 and shop:getPchips() / shop:getPamount() or 0))));
			shop:setExtra(tonumber(d.extrasend) or 0)
            table.insert(originalShop, shop)
--            pay:add(shop)
		end
        table.sort(originalShop, function(a, b)
            if (a:getExtra() > 0 and b:getExtra() > 0) or (a:getExtra() == 0 and b:getExtra() == 0) then
                return a:getPamount() < b:getPamount()
            else
                return a:getExtra() > b:getExtra()
            end
        end)
        for i = 1, #originalShop do
            pay:add(originalShop[i])
        end

		if MyPayMode then
			for i = 1, #MyPayMode do
				if MyPayMode[i]:getId() == pay:getMode() then
					MyPayMode[i]:setPay(pay)
				end
			end 
		end
	end
end

function CommonPhpProcesser:onPayOrderResponse( isSuccess, data )
	--{"code":1,"codemsg":"","data":{"ORDER":"000713320240BYORDFLG002224938428","SID":"7","APPID":"1332","PMODE":"240","PAMOUNT":"29","PCOINS":"0","PCHIPS":"1722600","PCARD":"0","PNUM":"1","PAYCONFID":123802,"CURRENCY":"THB","DESC":"{\"url1\":\"\",\"url2\":\"\",\"desc\":\"\"}","RET":0,"MSG":"succ","SITEMID":"06DCB1D14E41BBD34FBC6D141F2E5122dddd","user_ip":"172.20.42.146","macid":""},"time":1442902863,"exetime":1442902863.9888}
	if app:checkResponseOk(isSuccess, data) then
        if tonumber(data.data.PMODE) == 621 or  tonumber(data.data.PMODE) == 623 then
            local code = tonumber(data.data.errCode)
            local content = nil
            if code == 200 then
                content = STR_PAY_SUC
           	  -- content =errMsg
            else
                content =STR_PAY_FAILED
            end
            WindowManager:showWindow(WindowTag.LobbyConfirmPopu, {
                content = content,
                confirm = STR_EXIT_GAME_CONFIRM,
            }, WindowStyle.POPUP)
            --IOS 的12call和truemoney都是先输入卡号再到支付中心下单。
            return
        end
		MyPay:pay(data.data.PMODE, data.data);
        
	end
end

function CommonPhpProcesser:onPhpResponse( data )
	-- printf("========[[ 接收PHP命令 0x%04x ]] ============================", data.cmd)
	-- dump(data);
	-- server访问不到php
	if data.status == 404 then
		AlarmTip.play(data.msg)
		return
	end
	local func = self.s_severCmdEventFuncMap[data.cmd];
	if func then
		if data.data then
			func(self, data.data);
		else
			printInfo(string.format("0x%04X数据异常, 请稍后重试", data.cmd))
			AlarmTip.play(string.format("0x%04X数据异常, 请稍后重试", data.cmd))
		end
	end
	GameLoading:onCommandResponse(data.cmd)
end

function CommonPhpProcesser:onPhpTimeout( data )
end

function CommonPhpProcesser:onLoginResponse( data )

	if not app:checkResponseOk(data) then
		return
	end
	-- 本地没有缓存的游戏类型 或者 新注册 则按照推荐的选择玩法
	if GameConfig:getLastType() == 0 or MyUserData:getIsRegister() == 1 then
		local gameId = data.data.game_id or GameType.GBMJ
		local gameType = GameSupportStateMap[gameId] and gameId or GameType.GBMJ
		GameConfig:setLastType(gameType)
			:save()
		-- 通知选择游戏类型
		EventDispatcher.getInstance():dispatch(Event.Message, "SelectGameType", gameType)
	end
	MyUserData:initUserInfo(data.data);
	GameConfig:setLastUserType(data.data.usertype or MyUserData:getUserType())
		:save()
	-- EventDispatcher.getInstance():dispatch(HttpModule.s_event, Command.LOGIN_PHP_REQUEST, data);
end

--系统公告
function CommonPhpProcesser:onNoticeResponse( data )
	
	if app:checkResponseOk(data, true) then

		MyNoticeData:clear();

		for i = 1, #data.data do

			local notice = setProxy(new(require("data.notice")));

			notice:setTitle(data.data[i].title);
			notice:setContent(data.data[i].content)
			notice:setLink_type(data.data[i].link_type);
			notice:setLink_content(data.data[i].link_content);
			notice:setStart_time(data.data[i].start_time);

			MyNoticeData:add(notice);

		end

		EventDispatcher.getInstance():dispatch(HttpModule.s_event, Command.NOTICE_PHP_REQUEST, data);
	end
end

--计费配置
function CommonPhpProcesser:onPayConfigResponse( data )

	EventDispatcher.getInstance():dispatch(HttpModule.s_event, Command.PAY_CONFIG_PHP_REQUEST, data);
end
--计费配置
function CommonPhpProcesser:onPayConfigLimitResponse( data )

	EventDispatcher.getInstance():dispatch(HttpModule.s_event, Command.PAY_CONFIG_LIMIT_PHP_REQUEST, data);
end

--下单
function CommonPhpProcesser:onOrderResponse( data )

	EventDispatcher.getInstance():dispatch(HttpModule.s_event, Command.ORDER_PHP_REQUEST, data);
end

function CommonPhpProcesser:onModifyUserInfoResponse( data )
	if app:checkResponseOk(data) then	
		AlarmTip.play(data.msg)

		if data.data.nick then
			MyUserData:setNick(data.data.nick);
		end

		if data.data.sex then
			MyUserData:setSex(data.data.sex);
		end

		if data.data.tid then
			MyUserData:setTid(data.data.tid);
			local tarr = MyUserData:getTarr();
			MyUserData:setTitle(tarr[tonumber(MyUserData:getTid())]);
		end
	end
end
--更新奖励
function CommonPhpProcesser:onUpdateAwardResponse( data )
	--加金币
	if data.status == 1 then
		MyUserData:addMoney(tonumber(data.data.money or 0), true);
		MyUpdateData:setAward(0);
		ToolKit.setDict("UPDATE", { version = ""});
	else
		AlarmTip.play(data.msg);
	end
	EventDispatcher.getInstance():dispatch(HttpModule.s_event, Command.UPDATE_AWARD_PHP_REQUEST, data);
end

--通知更新奖励
function CommonPhpProcesser:onNotifyUpdateAwardResponse( data )
	--加金币
	if data.status == 1 then
		ToolKit.setDict("UPDATE", { version = "" });
	end
end

function CommonPhpProcesser:onGetRegisterReward( isSuccess, data )
	if isSuccess and data then
		if 1 == data.code then
			if data.data then
				local addmoney = data.data.addmoney
				if addmoney then
					EventDispatcher.getInstance():dispatch(Event.Message, "showAddMoneyAnim", addmoney)
				end
				local money 		= data.data.money;
				if money then
					MyUserData:setMoney(money);
				end
                --有道具奖励数据
                if data.data.props then
                    MyUserData:addPropNum(kIDInterProp, tonumber(data.data.props.face) or 0)
                end
				--金币雨动画
				AnimationParticles.play(AnimationParticles.DropCoin)
				kEffectPlayer:play('audio_get_gold')
			end
		else
			AlarmTip.play(data.codemsg or "");
		end
	end
    if WindowManager:containsWindowByTag(WindowTag.RegisterRewardPopu) then 
		WindowManager:closeWindowByTag(WindowTag.RegisterRewardPopu)
	end
end


function CommonPhpProcesser:onSendProp( isSuccess, data )
	if app:checkResponseOk(isSuccess, data) then
        MyUserData:setPropNum(kIDInterProp, data.data.pcnter)
	end
end
function CommonPhpProcesser:onGetPropList( isSuccess, data )
dump(data)
	if app:checkResponseOk(isSuccess, data) then
        MyUserData:setPropNum(kIDInterProp, data.data[1] and data.data[1].pcnter or 0)
	end
end

function CommonPhpProcesser:onSendChip( isSuccess, data )
  if app:checkResponseOk(isSuccess, data) then
		MyUserData:addMoney(-tonumber(data.data.sendMoney or 0))
	end
end
function CommonPhpProcesser:onGivingTips( isSuccess, data )
  if app:checkResponseOk(isSuccess, data) then
		MyUserData:addMoney(-tonumber(data.data.sendMoney or 0))
	end
end

function CommonPhpProcesser:onHasTaskAward( isSuccess, data )
  if app:checkResponseOk(isSuccess, data) then
  		MyUserData:setTaskAward(tonumber(data.data.unclainedReward));
	end
end


function CommonPhpProcesser:onGetBankruptTag(isSuccess, data)
	if isSuccess and data then
		if 1 == data.code and data.data then
			if data.data.allnum and data.data.nums then
				if data.data.nums < data.data.allnum then
					EventDispatcher.getInstance():dispatch(Event.Message, "hallBankruptTag", data.data.addMoney)
				end
			end
		else
			--
		end
	end
end


function CommonPhpProcesser:onGetHallBankrupt(isSuccess, data)
	if isSuccess and data then
		if 1 == data.code then
			if data.data then
				local addmoney 	= data.data.addmoney;
				local money 		= data.data.money;
				if money then
					MyUserData:setMoney(money);
				end
				AlarmTip.play(string.format(STR_BROKEN, addmoney))
				--金币雨动画
				AnimationParticles.play(AnimationParticles.DropCoin)
				kEffectPlayer:play('audio_get_gold')
				EventDispatcher.getInstance():dispatch(Event.Message, "hallBankrupt", 0)
			end
		else
			AlarmTip.play(data.codemsg or "");
		end
	end
end

function CommonPhpProcesser:onHallUserNoticeAward(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		local award = data.data
		--钱
		if award.money and tonumber(award.money) > 0 then
			MyUserData:addMoney(tonumber(award.money), true);
			
		end
		if award.pinfo then
            for k, v in pairs(award.pinfo) do
                MyUserData:addPropNum(k, tonumber(v.num) or 0)
            end
		end

		AlarmTip.play(STR_GETAWARD_SUC)
	end
end

function CommonPhpProcesser:onGetUpgradeReward(isSuccess, data)
	if isSuccess and data then
		if data.code == 1 then
			if data.data then
				local level = data.data.level
				local addMoney = data.data.addMoney
				local money = data.data.money
				local addProps = data.data.addProps
				if level then
                    WindowManager:showWindow(WindowTag.SharePopu, {content = STR_SHARE_UPGRADE, strParam = {level}, reward = {addMoney, addProps}}, WindowStyle.POPUP)
					GameSetting:setLevel(level)
					GameSetting:save()
				end
				--金币雨动画
				MyUserData:addMoney(tonumber(addMoney) or 0)
				AnimationParticles.play(AnimationParticles.DropCoin)
				kEffectPlayer:play('audio_get_gold')
			end
		end
	end
end

function CommonPhpProcesser:onGetDuijiangReward(isSuccess, data)
	if isSuccess and data then
		if data.code == 1 then
			if data.data then
				local addMoney = data.data.addMoney 
				if tonumber(addMoney) then
					EventDispatcher.getInstance():dispatch(Event.Message, "showAddMoneyAnim", addMoney)
                    AlarmTip.play(string.format(STR_EXCHANGECODE_SUCCESS_MONEY, addMoney))
				end
				local money = data.data.money;
				if money then
					MyUserData:setMoney(money);
				end
				--金币雨动画
				AnimationParticles.play(AnimationParticles.DropCoin)
                
				kEffectPlayer:play('audio_get_gold')
			end
        elseif data.code == -4 then
            AlarmTip.play(STR_EXCHANGECODE_NO_REMAIN)
        elseif data.code == -1 then
            AlarmTip.play(STR_EXCHANGECODE_HAS_DONE)
		else
			AlarmTip.play(STR_CODE_ERROR)
		end
	end
end

function CommonPhpProcesser:onGetMyProsInfo(isSuccess, data)
	if isSuccess and data then
		if data.code == 1 then
			if data.data then
				local addMoney = data.data.addMoney
				if addMoney and type(addMoney) == 'number' then
					EventDispatcher.getInstance():dispatch(Event.Message, "showAddMoneyAnim", addMoney)
				end
			end
		else
			--AlarmTip.play(STR_CODE_ERROR)
		end
	end
end

--修改性别
function CommonPhpProcesser:onUpdateUserSex(isSuccess, data)
	if isSuccess and data then
		if data.code and data.code == 1 then
			AlarmTip.play(STR_UPDATE_SEX_SUCC)
		end
	end
end

--修改昵称
function CommonPhpProcesser:onUpdateUserName(isSuccess, data)
	if isSuccess and data then
		if data.code and data.code == 1 then
			AlarmTip.play(STR_UPDATE_NAME_SUCC)
		end
	end
end

--[[11-03 22:07:41.954: D/lua(10150): requestUrl ===========>> http://gamehall.oa.com/api/gateway.php?sid=102&lid=2
11-03 22:07:41.954: D/lua(10150): resultStr  ===========>> {"code":1,"codemsg":"","data":{"micon":"http:\/\/bycdn5-i.akamaihd.net\/images\/androidtl\/icon\/92\/10092-1446559660.png"},"time":1446559661,"exetime":1446559661.0198}
]]
function CommonPhpProcesser:onUpdateUserIcon(isSuccess, data)
	if isSuccess and data then
		if data.code == 1 and data.data then
			-- 头像
			MyUserData:setHeadUrl(data.data.micon)
			EventDispatcher.getInstance():dispatch(Event.Message, "updateUserInfo", '')
			AlarmTip.play(STR_UPDATE_HEADER_SUCC)
		end
	end
end

function CommonPhpProcesser:onUpdateMemberBest(isSuccess, data)
    --更新个人的最高资产和最高奖励
    if app:checkResponseOk(isSuccess, data) then
        if data.data.maxmoney then
            MyUserData:setMaxMoney(tonumber(data.data.maxmoney) or 0)
        end
        if data.data.maxwmoney then
            MyUserData:setMaxwMoney(tonumber(data.data.maxwmoney) or 0)
        end
    end
end

function CommonPhpProcesser:onInviteConfig(isSuccess, data)
	if isSuccess and data then
		if data.code == 1 and data.data then
			MyUserData:setInvitesum(data.data.sum and data.data.sum or 100)
			MyUserData:setInvitemoney(data.data.invitemoney and data.data.invitemoney or 1000)
			MyUserData:setSuccessmoney(data.data.successmoney and data.data.successmoney or 100000)
			MyUserData:setLeftInviteNum(tonumber(data.data.caninvitenum) or 50)
			MyUserData:setLeftCallbackNum(tonumber(data.data.canrecallnum) or 50)
		end
	end
end
-- 拉去上庄场房间列表
function CommonPhpProcesser:onGetDealerRoomList(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		local gameId = data.data.gameid
		if gameId then
			local roomList = MyRoomConfig:get(gameId) or new(require('data.dataList'))
			--先清除
			roomList:clear()
			--初始化
			local info = data.data;
			for i = 1, #info.room do
				local room = setProxy(new(require('data.room')))
				room:init(info.room[i]);
				roomList:add(room);
			end
			roomList:setVersion(info.configVersion);
			MyRoomConfig:set(gameId, roomList)
			local game = app:getGame(gameId)
			if game then
				game:initRoom(roomList)
			end
		end
	end
end

function CommonPhpProcesser:onGetMakhosRoomList( isSuccess, data )
	if app:checkResponseOk(isSuccess, data) then
		local gameId = data.data.gameid
		if gameId then
			local roomList = MyRoomConfig:get(gameId) or new(require('data.dataList'))
			--先清除
			roomList:clear()
			--初始化
			local info = data.data;
			for i = 1, #info.room do
				local room = setProxy(new(require('data.room')))
				room:init(info.room[i]);
				roomList:add(room);
			end
			roomList:setVersion(info.configVersion);
			MyRoomConfig:set(gameId, roomList)
			local game = app:getGame(gameId)
			if game then
				game:initRoom(roomList)
				game:setRuleTab(data.data.masterPoints)
			end
		end
	end
end

function CommonPhpProcesser:onGetRoomList( isSuccess, data )
	if app:checkResponseOk(isSuccess, data) then
		local gameId = data.data.gameid

		if gameId then
			local roomList = MyRoomConfig:get(gameId) or new(require('data.dataList'))
			--先清除
			roomList:clear()
			--初始化
			local info = data.data;
			for i = 1, #info.room do
				local room = setProxy(new(require('data.room')))
				room:init(info.room[i]);
				roomList:add(room);
			end
			roomList:setVersion(info.configVersion);
			MyRoomConfig:set(gameId, roomList)
			local game = app:getGame(gameId)
			if game then
				game:initRoom(roomList)
			end
		end
	end
end

function CommonPhpProcesser:onUrgentNotice(isSuccess, data)
--紧急公告查看的是个人消息的内容，检查一下用来计算是否有新消息以确定大厅按钮上是否需要显示红点
    local textUrgentNotice = {}
    if app:checkResponseOk(isSuccess, data) then
        if MyUserData:getUserType() == UserType.Visitor then
            if #data.data > GameSetting:getTotalNoticeNumGuest() then
                GameSetting:setTotalNoticeNumGuest(#data.data)
                MyUserData:setHasNewNotice(true)
            end
        else
            if #data.data > GameSetting:getTotalNoticeNumFb() then
                GameSetting:setTotalNoticeNumFb(#data.data)
                MyUserData:setHasNewNotice(true)
            end
        end
        MyUserData:setHasUnckeckMsg(MyUserData:getHasNewNotice())

        --处理需要弹窗的消息
        local messages = data.data 
        for i = 1, #messages do
            if (tonumber(messages[i].popup) == 1) and (tonumber(messages[i].islook) == 0)then
            --if (tonumber(messages[i].popup) == 1) then
                local urgentNotice = {}
                urgentNotice.id = messages[i].id and tonumber(messages[i].id) or 0
                urgentNotice.title = messages[i].title or ""
                urgentNotice.content = messages[i].content or ""
                urgentNotice.reward = tonumber(messages[i].reward) or 0
                urgentNotice.getway = tonumber(messages[i].getway) or 0
                textUrgentNotice[#textUrgentNotice+1] = urgentNotice
           end
        end
    end
    
	MyUserData.textUrgentNotice = nil
	if MyUserData.dailyReward and MyUserData.dailyReward.rewardType == WindowTag.RegisterRewardPopu then
        WindowManager:showWindow(MyUserData.dailyReward.rewardType, MyUserData.dailyReward.rewardData, WindowStyle.POPUP)
        MyUserData.dailyReward = nil
    else
        if #textUrgentNotice ~= 0 then
            MyUserData.textUrgentNotice = textUrgentNotice
            WindowManager:showWindow(WindowTag.ActCenterPopu, 1, WindowStyle.POPUP)
        elseif MyUserData.hasSpectialAct == 1 then
        	WindowManager:showWindow(WindowTag.ActCenterPopu, 0, WindowStyle.POPUP)
        elseif MyUserData.dailyReward and MyUserData.dailyReward.rewardType == WindowTag.AttendencePopu then
            WindowManager:showWindow(WindowTag.ActCenterPopu, 3, WindowStyle.POPUP)
        end
    end
end

function CommonPhpProcesser:onGetCashTaskFriend(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local friendTask = {}
        friendTask.finished = data.data.finished and tonumber(data.data.finished) or 0
        friendTask.aim = data.data.aim and tonumber(data.data.aim) or 0
        friendTask.reward = data.data.reward and tonumber(data.data.reward) or 0
        if friendTask.aim ~= 0 and friendTask.finished == friendTask.aim then
            MyUserData:setHasFriendReward(true)
        end
        MyUserData:setCashTaskList(friendTask)
    end
end

function CommonPhpProcesser:onCheckSwitchForAll(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        MySwitchData:init(data.data)
    end
end

function CommonPhpProcesser:onGetPayPropList(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local pay 	= new(require('data.pay'));
        local originalShop = {}
		for i = 1, #data.data do
			local d = data.data[i]
			local shop = setProxy(new(require('data.shop')));
			
			pay:setMode(tonumber(d.pmode or 0));
			shop:setId(tonumber(d.id or 0));
			shop:setPamount(tonumber(d.pamount or 0));
			shop:setCurrency(d.currency or "$")
			shop:setCount(tonumber(d.pnum or 0))
            shop:setDiscount(tonumber(d.discount) or 1)
            shop:setPcard(tonumber(d.pcard) or 0)
            shop:setName(d.getname or "")
			shop:setPdesc(string.format('1%s=%s', shop:getCurrency(), ToolKit.skipMoney(math.floor(shop:getPchips() > 0 and shop:getPchips() / shop:getPamount() or 0))));
			shop:setExtra(tonumber(d.extrasend) or 0)
            table.insert(originalShop, shop)
--            pay:add(shop)
		end
        table.sort(originalShop, function(a, b)
            if (a:getExtra() > 0 and b:getExtra() > 0) or (a:getExtra() == 0 and b:getExtra() == 0) then
                return a:getPamount() < b:getPamount()
            else
                return a:getExtra() > b:getExtra()
            end
        end)
        for i = 1, #originalShop do
            pay:add(originalShop[i])
        end

		if MyPayMode then
			for i = 1, #MyPayMode do
				if MyPayMode[i]:getId() == pay:getMode() then
					MyPayMode[i]:setProp(pay)
				end
			end 
		end
    end
end

function CommonPhpProcesser:onGiftStoreBuy(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local giftType = tonumber(data.data.giftType)
        local giftId = tonumber(data.data.giftId)
        if giftType and giftId then
            MyUserData:setGiftId({giftType, giftId})
        else
            MyUserData:setGiftId(nil)
        end
        MyUserData:setMoney(tonumber(data.data.money) or 0)
    elseif data and data.code == 4 then
        AlarmTip.play(STR_SORRY_FOR_NO_MONEY)
    elseif data and data.code == 8 then
        AlarmTip.play(STR_GIFT_CD_TIME)
    end
end

function CommonPhpProcesser:onGiftStoreGetList(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local giftList = {}
        --这个表用来记录原始数据，为了后台可以排序，在商城界面用这个数据显示，但是不好查找，所以用giftList里的数据查找。
        giftList.originalData = {}
        local gifts = data.data.giftList or {}
        for i = 1, #gifts do
            local gift = setProxy(new(require("data.giftItemData")))
            gift:init(gifts[i])
            --礼物按type和id做双重索引，用这个表是为了方便寻找
            local giftType = tonumber(gift.type) or 0
            if not giftList[giftType] then
                giftList[giftType] = {}
            end
            giftList[giftType][gift.id] = gift
            table.insert(giftList.originalData, gift)
        end
        MyUserData:setGiftList(giftList)
        local wearGift = data.data.wearGift or {}
        local expireTime = tonumber(wearGift.expireTime) or 0
        --礼物还没过期
        if expireTime > os.time() then
            local giftType = tonumber(wearGift.giftType)
            local giftId = tonumber(wearGift.giftId)
            if giftType and giftId then
                MyUserData:setGiftId({giftType, giftId})
            end
        end
        
    end
end

function CommonPhpProcesser:onGiftUpdateMine(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local giftType = tonumber(data.data.giftType)
        local giftId = tonumber(data.data.giftId)
        if giftType and giftId then
            MyUserData:setGiftId({giftType, giftId})
            AlarmTip.play(STR_CHANGE_GIFT_SUCCESS)
        end
    end
end

function CommonPhpProcesser:onGiftStoreSend(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        MyUserData:setMoney(tonumber(data.data.money) or 0)
--        AlarmTip.play("赠送成功")
    elseif data and data.code == 8 then
        AlarmTip.play(STR_GIFT_CD_TIME)
    end
end

function CommonPhpProcesser:onGetUserAllProps(isSuccess, data)
	JLog.d("初始化道具",data);
	if app:checkResponseOk(isSuccess, data) then
        for k, v in pairs(data.data) do
            MyUserData:setPropNum(v.pnid, v.pcnter)
        end
	end

end

function CommonPhpProcesser:onGetFbCallbackReward(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local addMoney = tonumber(data.data.addMoney) or 0
        if addMoney > 0 then
            AlarmTip.play(string.format(STR_INVITE_AWARD,  addMoney))
        end
        MyUserData:setMoney(tonumber(data.data.money) or 0)
        --金币雨动画
		AnimationParticles.play(AnimationParticles.DropCoin)
		kEffectPlayer:play('audio_get_gold')
    end
end

function CommonPhpProcesser:onGetBankruptRelief(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        AlarmTip.play(STR_GET_RELIEF_SUCCESS)
    end
end

function CommonPhpProcesser:onGetPropCfgList(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local propList = {}
        local lists = data.data or {}
        for i = 1, #lists do
            local prop = setProxy(new(require("data.propsCfgData")))
            prop:init(lists[i])
            propList[tostring(lists[i].pnid)] = prop
        end
        MyUserData.propCfgList = propList
    end
end

function CommonPhpProcesser:onGetUserMoney(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        MyUserData:setMoney(tonumber(data.data.money) or 0)
    end
end

--[[
	通用的（大厅）协议
]]
CommonPhpProcesser.s_severCmdEventFuncMap = {

}
--HTTP 回调
CommonPhpProcesser.s_httpEventFuncMap = {
	[HttpModule.s_cmds.LOGIN_PHP]				= CommonPhpProcesser.onLoginPhpResponse,
	[HttpModule.s_cmds.GET_FB_INVITE_AWARD]		= CommonPhpProcesser.onGetFbInviteAwardResponse,
	[HttpModule.s_cmds.GET_FB_INVITE_SUC_AWARD] = CommonPhpProcesser.onGetFbInviteSucAwardResponse,
	[HttpModule.s_cmds.GET_BROKEN_MONEY] 		= CommonPhpProcesser.onGetBrokenMoneyResponse,
	[HttpModule.s_cmds.GET_PAY_MODE] 			= CommonPhpProcesser.onPayModeResponse,
	[HttpModule.s_cmds.GET_PAY_LIST] 			= CommonPhpProcesser.onPayListResponse,
	[HttpModule.s_cmds.GET_PAY_ORDER] 			= CommonPhpProcesser.onPayOrderResponse,
	[HttpModule.s_cmds.GET_REGISTER_REWARD] 	= CommonPhpProcesser.onGetRegisterReward,

   	[HttpModule.s_cmds.GET_SEND_PROP] 		    = CommonPhpProcesser.onSendProp,
    [HttpModule.s_cmds.GET_PROP_LIST] 		    = CommonPhpProcesser.onGetPropList,
    

	[HttpModule.s_cmds.GET_HALL_BANKRUPT]		= CommonPhpProcesser.onGetHallBankrupt,
	[HttpModule.s_cmds.GET_HALL_BANKRUPT_TAG]   = CommonPhpProcesser.onGetBankruptTag,
    [HttpModule.s_cmds.GET_SEND_GAME_CHIP]      = CommonPhpProcesser.onSendChip,

    [HttpModule.s_cmds.GET_HALL_USER_NOTICES_AWARD] = CommonPhpProcesser.onHallUserNoticeAward,
    [HttpModule.s_cmds.GET_UPGRADE_REWARD]      = CommonPhpProcesser.onGetUpgradeReward,
    [HttpModule.s_cmds.GET_DUIJIANG_REWARD]		= CommonPhpProcesser.onGetDuijiangReward,
    [HttpModule.s_cmds.UPDATE_USER_SEX]         = CommonPhpProcesser.onUpdateUserSex,
    [HttpModule.s_cmds.UPDATE_USER_NAME]        = CommonPhpProcesser.onUpdateUserName,
    [HttpModule.s_cmds.UPDATE_USER_ICON]		= CommonPhpProcesser.onUpdateUserIcon,
    [HttpModule.s_cmds.UPDATE_MEMBER_BEST]      = CommonPhpProcesser.onUpdateMemberBest,
    [HttpModule.s_cmds.INVITE_CONFIG]			= CommonPhpProcesser.onInviteConfig,
    [HttpModule.s_cmds.GIVING_TIPS]				= CommonPhpProcesser.onGivingTips,
    [HttpModule.s_cmds.HAS_TASK_AWARD]			= CommonPhpProcesser.onHasTaskAward,
    
    [HttpModule.s_cmds.GET_MAKHOS_ROOM_LIST]	= CommonPhpProcesser.onGetMakhosRoomList,
    [HttpModule.s_cmds.GET_ROOM_LIST] 			= CommonPhpProcesser.onGetRoomList,
    [HttpModule.s_cmds.GET_URGENT_NOTICE]   	= CommonPhpProcesser.onUrgentNotice,
    [HttpModule.s_cmds.GET_CASH_TASK_FRIEND]    = CommonPhpProcesser.onGetCashTaskFriend,
    [HttpModule.s_cmds.CHECK_SWITCH_FOR_ALL]    = CommonPhpProcesser.onCheckSwitchForAll,
    [HttpModule.s_cmds.GET_PAY_PROP_LIST]       = CommonPhpProcesser.onGetPayPropList,
    [HttpModule.s_cmds.GIFT_STORE_BUY]          = CommonPhpProcesser.onGiftStoreBuy,
    [HttpModule.s_cmds.GIFT_STORE_GET_LIST]     = CommonPhpProcesser.onGiftStoreGetList,
    [HttpModule.s_cmds.GIFT_UPDATE_MINE]        = CommonPhpProcesser.onGiftUpdateMine,
    [HttpModule.s_cmds.GIFT_STORE_SEND]         = CommonPhpProcesser.onGiftStoreSend,
    [HttpModule.s_cmds.GET_USER_ALL_PROPS]      = CommonPhpProcesser.onGetUserAllProps,
    [HttpModule.s_cmds.GET_FB_CALLBACK_REWARD]  = CommonPhpProcesser.onGetFbCallbackReward,
    [HttpModule.s_cmds.GET_BANKRUPT_RELIEF]     = CommonPhpProcesser.onGetBankruptRelief,
    [HttpModule.s_cmds.GET_PROP_CFG_LIST]       = CommonPhpProcesser.onGetPropCfgList,
    [HttpModule.s_cmds.GET_DEALER_ROOM_LIST]	= CommonPhpProcesser.onGetDealerRoomList,
    [HttpModule.s_cmds.GET_USER_MONEY]          = CommonPhpProcesser.onGetUserMoney,
}
return CommonPhpProcesser
