--[[
	通用的socket消息处理器  2015-03-03
]]
local CommonProcesser = class(SocketProcesser)
local printInfo, printError = overridePrint("CommonProcesser")

function CommonProcesser:ctor()
    testCommonProcesser = self
    self.last_time = 0
end




function CommonProcesser:onMapDoNothing(data)
end
function CommonProcesser:onLoginLobbyServerRsp(data)
    EventDispatcher.getInstance():dispatch(Event.Message, "loginserver", data)
end

function CommonProcesser:onBroadcastRsp(data)
    printInfo('CommonProcesser:onBroadcastRsp');
    if data.type == 1 then --加金币
        --统计破产付费率
        if MyUserData:getMoney() <= 1000 then
            app:postFrontStaticstics("bankruptcyPay")
        end
        if data.data and data.data.addMoney then
            MyUserData:addMoney(tonumber(data.data.addMoney) or 0, true)
            AlarmTip.play(string.format(STR_PAY_ACOUNT, data.data.addMoney));
        end
        if data.data and data.data.money then
            MyUserData:setMoney(tonumber(data.data.money) or 0);
        end
        --遍历商品，确定用户购买的价格, 支付上报boyaa广告SDK
        for i = 1, #MyPayMode do
            local shops = MyPayMode[i].pay
            if shops then
                for j = 1, shops:count() do
                    local shop = shops:get(j)
                    if shop:getPchips() == tonumber(data.data.addMoney or 0) then
                        local payMoney = shop:getPamount()
                        local payUnit = shop:getCurrency()
                        NativeEvent.getInstance():boyaaAd({type = 5, value = MyUserData:getId(), pay_money = payMoney or "0", currencyCode = payUnit or "USD"})
                        return
                    end
                end
            end
        end

    elseif data.type == 2 then --好友请求
        AlarmTip.play2Btn(string.format(STR_FRIEND_APPLY_TIPS, data.data.name or ''), 
            'common/btn_refuse.png', 'common/btn_accept.png', self, function (self, which)
            -- body
            if which == 1 then--拒绝
                HttpModule.getInstance():execute(HttpModule.s_cmds.FRIEND_REFUSE,{fid = data.data.id, isagree = 0}, false, false)
                MyUserData:setUnreadApply(MyUserData:getUnreadApply() - 1);
            elseif which == 2 then--接受
                HttpModule.getInstance():execute(HttpModule.s_cmds.FRIEND_ACCEPT,{fid = data.data.id, isagree = 1}, false, false)
                MyUserData:setUnreadApply(MyUserData:getUnreadApply() - 1);
            end
            
            AlarmTip.stop();
        end)
        MyUserData:setUnreadApply(MyUserData:getUnreadApply() + 1);
    elseif data.type == 3 then --好友赠送金币
        MyUserData:setUnreadGigt(MyUserData:getUnreadGigt() + 1);
    elseif data.type == 5 then --有任务完成
        MyUserData:setTaskAward(1)
    elseif data.type == 6 then   --通过好友请求
        AlarmTip.play(string.format(STR_FRIEND_ACCEPT_TIPS, data.data or ""))
    elseif data.type == 7 then --活动加减金币
        if data.data and data.data.money then
            MyUserData:addMoney(tonumber(data.data.money) or 0, true);
        end
    elseif data.type == 8 then    --商城购买道具
        local propType = tonumber(data.data.pnid)
        MyUserData:setPropNum(propType, data.data.count)
        local propCfg = MyUserData:getPropCfgList()
        if propCfg and propCfg[tostring(propType)] then
            AlarmTip.play(string.format(STR_GET_PROP_TIPS, propCfg[tostring(propType)].name or "", data.data.num or ""))
        end
        --遍历商品，确定用户购买的价格, 支付上报boyaa广告SDK
        for i = 1, #MyPayMode do
            local shops = MyPayMode[i].prop
            if shops then
                for j = 1, shops:count() do
                    local shop = shops:get(j)
                    if tonumber(shop:getPcard()) == propType and tonumber(data.data.num) == tonumber(shop:getCount()) then
                        local payMoney = shop:getPamount()
                        local payUnit = shop:getCurrency()
                        NativeEvent.getInstance():boyaaAd({type = 5, value = MyUserData:getId(), pay_money = payMoney or "0", currencyCode = payUnit or "USD"})
                        return
                    end
                end
            end
        end

    elseif data.type == 9 then     --邀请好友加入好友房
        local roomId = tonumber(data.data.roomid)
        local name = data.data.name or ""
        local gameId = tonumber(data.data.gameid) or 0
        local game = app:getGame(gameId)
        if game then
            AlarmTip.play2Btn(string.format(STR_BUDDY_INVITE_TO_GAME, name, game:getName()), 
                "common/btn_ignore.png", "common/btn_accept.png", self, function (self, which)
                if which == 1 then  --拒绝邀请

                elseif which == 2 then  --接受邀请
                    --离开房间的请求
                    EventDispatcher.getInstance():dispatch(Event.Message, "acceptPrivateRoomInvite", {gameId = gameId, roomId = roomId, serverId = tonumber(data.data.serverid)})
                end
                AlarmTip.stop();
            end)
        end
    elseif data.type == 10 then     --收到礼物的广播
        local receiver = data.data.receiver or {}
        if #receiver == 0 then
            return
        end
        local gift = data.data.gift or {}
        --可能会有多个礼物，方便后续扩展
        for k, v in pairs(gift) do
            local giftType = tonumber(k)
            local giftId = tonumber(v)
            if giftType and giftId then
                --如果接受者里头有我，要刷新自己的礼物
                for i = 1, #receiver do
                    if receiver[i] == MyUserData:getId() then
                        MyUserData:setGiftId({giftType, giftId})
                        break;
                    end
                end
                EventDispatcher.getInstance():dispatch(Event.Message, "giftSendBroadcast", {sender = tonumber(data.data.sender), receiver = receiver, gift = {giftType, giftId}, name = data.data.name or ""})
            end
        end
    elseif data.type == 11 then
        --有好友破产求助
        MyUserData:setUnreadBankruptHelp(1)
    --私人房好友邀请广播，用来替代原先的9号广播，php暂时未删除9号广播是因为过渡期的缘故
    elseif data.type == 12 then
        local name = data.data.name or ""
        local expand = data.data.expand or {}
        local gameId = tonumber(expand.gameId) or 0
        local code = tonumber(expand.code) or 0
        local game = app:getGame(gameId)
        if game then
            AlarmTip.play2Btn(string.format(STR_BUDDY_INVITE_TO_GAME, name, game:getName()), 
                "common/btn_ignore.png", "common/btn_accept.png", self, function (self, which)
                if which == 1 then  --拒绝邀请

                elseif which == 2 then  --接受邀请
                    --离开房间的请求
                    EventDispatcher.getInstance():dispatch(Event.Message, "acceptPrivateRoomInvite", {gameId = gameId, code = code})
                end
                AlarmTip.stop();
            end)
        end
    --server通知私人房有新账单生成
    elseif data.type == 13 then
        MyUserData.hasUnReadBill = true
    --私人房没有开赛退回房卡
    elseif data.type == 14 then
        MyUserData:addPropNum(kIDPrivateRoomCard, 1)
        AlarmTip.play(STR_PRIVATE_ROOM_RETURN_CARD)
    elseif data.type == 15 then    --活动加减道具
        local propType = tonumber(data.data.pnid)
        MyUserData:setPropNum(propType, data.data.count)
        local propCfg = MyUserData:getPropCfgList()
        if propCfg and propCfg[tostring(propType)] then
            AlarmTip.play(string.format(STR_GET_PROP_TIPS, propCfg[tostring(propType)].name or "", data.data.num or ""))
        end
    end

end

function CommonProcesser:onEntireBroadcastRsp(data)
    if data.data.type == 2 then
        local flag = false
            
        if MyUserData:getNick() == data.data.sender or MyUserData:getNick() == data.data.receiver then
            flag = true
        else
            local t = os.time()
            if t - self.last_time > 600 then
                self.last_time = t 
                flag = true
            end
        end
        if flag then
            local text_size = 45
            if data.data.sender == data.data.receiver then
                local textNode = ToolKit.createTexts({
                                                    {
                                                        text = "คุณ ",
                                                        size = text_size, 
                                                        r = 0xff,
                                                        b = 0xff,
                                                        g = 0xff
                                                    },
                                                    {
                                                        text = data.data.sender, 
                                                        size = text_size, 
                                                        r = data.data.R, 
                                                        b = data.data.B, 
                                                        g = data.data.G
                                                    },
                                                    {
                                                        text = " ได้ติดตั้ง ",
                                                        size = text_size, 
                                                        r = 0xff,
                                                        b = 0xff,
                                                        g = 0xff
                                                    },
                                                    {
                                                        text = data.data.giftName, 
                                                        size = text_size, 
                                                        r = data.data.r, 
                                                        b = data.data.b, 
                                                        g = data.data.g
                                                    },
                                                    {
                                                        text = " แล้ว รีบมาดูสิ",
                                                        size = text_size, 
                                                        r = 0xff,
                                                        b = 0xff,
                                                        g = 0xff
                                                    },
                                                })
                AlarmTip.add_textnode({textNode,1})
            else
                local textNode = ToolKit.createTexts({
                                                    {
                                                        text = "คุณ ",
                                                        size = text_size, 
                                                        r = 0xff,
                                                        b = 0xff,
                                                        g = 0xff
                                                    },
                                                    {
                                                        text = data.data.sender, 
                                                        size = text_size, 
                                                        r = data.data.R, 
                                                        b = data.data.B, 
                                                        g = data.data.G
                                                    },
                                                    {
                                                        text = " รวยมาก ได้มอบ ",
                                                        size = text_size, 
                                                        r = 0xff,
                                                        b = 0xff,
                                                        g = 0xff
                                                    },
                                                    {
                                                        text = data.data.giftName, 
                                                        size = text_size, 
                                                        r = data.data.r, 
                                                        b = data.data.b, 
                                                        g = data.data.g
                                                    },
                                                    {
                                                        text = " 1 ชิ้นให้คุณ ",
                                                        size = text_size, 
                                                        r = 0xff,
                                                        b = 0xff,
                                                        g = 0xff
                                                    },
                                                    {
                                                        text = data.data.receiver, 
                                                        size = text_size, 
                                                        r = data.data.R, 
                                                        b = data.data.B, 
                                                        g = data.data.G
                                                    },
                                                })
                AlarmTip.add_textnode({textNode,2})
            end
        end
        
    end
end

function CommonProcesser:onServerRetire(data)
    printInfo('CommonProcesser:onServerRetire');
    AlarmTip.play(STR_SERVER_RETIRE);--提醒退休
    EventDispatcher.getInstance():dispatch(Event.Message, "serverRetire", data)
--    StateChange.changeState(States.Lobby);
end

--[[
	通用的（大厅）协议
]]
local onMapDoNothing = CommonProcesser.onMapDoNothing

CommonProcesser.s_severCmdEventFuncMap = {
    [Command.LOGIN_SERVER_RSP]      = CommonProcesser.onLoginLobbyServerRsp, --大厅登录返回
    [Command.BROADCAST_RSP]         = CommonProcesser.onBroadcastRsp,
    [Command.ENTIRE_BROADCAST_RSP]  = CommonProcesser.onEntireBroadcastRsp,
    [Command.SERVER_RETIRE]         = CommonProcesser.onServerRetire,--服务器退休协议
}

return CommonProcesser