require(ViewPath.."attendenceItemLayout")

local AttendencePopu = class(require("popu.gameWindow"))
new(Image, "attendence.png")
require("pintu.attendence")

function AttendencePopu:ctor()
	
end

function AttendencePopu:dtor()

end

function AttendencePopu:initView(data)
	self:findChildByName("btn_close"):setOnClick(self, function(self)
		self:dismiss()
	end)
	
    local viewFb = self:findChildByName("view_fb")
	viewFb:findChildByName("btn_fb"):setOnClick(self, function(self)
		self:dismiss(true);
		NativeEvent.getInstance():logout({});
		EventDispatcher.getInstance():dispatch(Event.Message, "logout", 0)
	end)
    local textToFb = new(Text, STR_ATTENDENCE_TO_FB_LOGIN, 0, 0, kAlignLeft, kFontTextUnderLine, 26, 0x28, 0x4F, 0x8A)
    textToFb:setAlign(kAlignLeft)
    viewFb:findChildByName("btn_fb"):addChild(textToFb)
    viewFb:findChildByName("text_tips2"):setText(string.format(STR_ATTENDENCE_TIPS2, data.override or ""))
    
	local viewTips = self:findChildByName("view_tips")
	viewTips:findChildByName("text_tips1"):setText(STR_ATTENDENCE_TIPS1)

	local viewTitle = self:findChildByName("view_title")
	ToolKit.formatRichText(viewTitle, STR_ATTENDENCE_DAYS, data.signNum or 0,{26, 0xf1, 0xcf, 0x9e}, {30, 0x14, 0xD6, 0x6C})
	--self:initString(self:findChildByName("view_title"), STR_ATTENDENCE_DAYS, data.signNum or 0,{26, 0xf1, 0xcf, 0x9e}, {30, 0x14, 0xD6, 0x6C})

	self.rewardData = data

	self.imgNumber = require('common.imageNumber')
	local monthNumber = {
		['0'] = attendence_map["attendence.month.0.png"],
        ['1'] = attendence_map["attendence.month.1.png"],
        ['2'] = attendence_map["attendence.month.2.png"],
        ['3'] = attendence_map["attendence.month.3.png"],
        ['4'] = attendence_map["attendence.month.4.png"],
        ['5'] = attendence_map["attendence.month.5.png"],
        ['6'] = attendence_map["attendence.month.6.png"],
        ['7'] = attendence_map["attendence.month.7.png"],
        ['8'] = attendence_map["attendence.month.8.png"],
        ['9'] = attendence_map["attendence.month.9.png"],
	}
	local month = new(self.imgNumber, monthNumber)
	month:setNumber(os.date("!*t").month)
	month:setAlign(kAlignCenter)
	self:findChildByName("view_month"):addChild(month)
end

function AttendencePopu:onShowEnd()
	self.super.onShowEnd(self)
	self:initRewards()
    self:findChildByName("btn_confirm"):setOnClick(self, function (self)
        self:findChildByName("btn_confirm"):setEnable(false)
		HttpModule.getInstance():execute(HttpModule.s_cmds.SET_HALL_ATTENDENCE, {}, true, true)
	end)
end

function AttendencePopu:initRewards()
	local curDay = (self.rewardData.signNum or 0) + 1
	self.numImage = {
		['0'] = attendence_map["attendence.number.0.png"],
        ['1'] = attendence_map["attendence.number.1.png"],
        ['2'] = attendence_map["attendence.number.2.png"],
        ['3'] = attendence_map["attendence.number.3.png"],
        ['4'] = attendence_map["attendence.number.4.png"],
        ['5'] = attendence_map["attendence.number.5.png"],
        ['6'] = attendence_map["attendence.number.6.png"],
        ['7'] = attendence_map["attendence.number.7.png"],
        ['8'] = attendence_map["attendence.number.8.png"],
        ['9'] = attendence_map["attendence.number.9.png"],
        ['k'] = attendence_map["attendence.number.k.png"],
        ['m'] = attendence_map["attendence.number.m.png"],
        ['x'] = attendence_map["attendence.number.x.png"],
	}
	
	local svReward = self:findChildByName("sv_attendence")
	svReward:setDirection(kVertical)
	self.rewardItems = {}
	local curPosX, curPosY = 0, 0
	local curColumn = 1
	for i = 1, #self.rewardData do
		local reward = self.rewardData[i]
		local item = self:initRewardItem(reward, i > curDay and 1 or (i == curDay and 2 or 3), i)
		table.insert(self.rewardItems, item)
		item:setPos(curPosX, curPosY)
		svReward:addChild(item)
		local w, h = item:getSize()
		if curColumn + 1 > 7 then
			curColumn = 1
			curPosX = 0
			curPosY = curPosY + h
		else
			curColumn = curColumn + 1
			--间距拉开2个像素，防止靠太近区分不出来
			curPosX = curPosX + w + 2
		end
	end
	--自动滚动，让当前要签到的可视
	local curRow = math.floor((curDay-1) / 7) * 7
	local maxLen = svReward:getViewLength() - svReward:getFrameLength()
	if self.rewardItems[curRow] then
		local x1, y1 = self.rewardItems[curRow]:getPos()
		maxLen = y1 > maxLen and maxLen or y1
		svReward:scrollWithDistance(0 - maxLen)
	end
end

function AttendencePopu:initRewardItem(reward, state, index)
	--state:1,未领奖；2，当前可领奖；3，已领奖
	local item = SceneLoader.load(attendenceItemLayout)
	item:findChildByName("btn_bg"):enableShow(false)
	if state == 3 then
		item:findChildByName("img_attended"):setVisible(true)
		item:findChildByName("img_rewarded"):setVisible(true)
		item:findChildByName("btn_bg"):setEnable(false)
	else
		item:findChildByName("img_unattended"):setVisible(true)
		item:findChildByName("btn_bg"):setEnable(false)
		if state == 2 then
			item:findChildByName("img_choose"):setVisible(true)
			item:findChildByName("btn_bg"):setEnable(true)
			item:findChildByName("btn_bg"):setOnClick(self, function(self)
				HttpModule.getInstance():execute(HttpModule.s_cmds.SET_HALL_ATTENDENCE, {}, true, true)
			end)
		end
	end
	local viewReward = item:findChildByName("view_reward")
	viewReward:findChildByName("text_sequence"):setText(index)
	
	--奖励类型是金币和道具，同时加2个数字
	local viewCount = viewReward:findChildByName("view_count")
	local strImgFile = ""
	local strNameFile = ""
	--1是金币、2是金币和道具、3是现金币
	if reward.type == 1 then
		local imgMoney = new(self.imgNumber, self.numImage)
		imgMoney:setNumber(self:formatNumber(reward.money))
		imgMoney:setAlign(kAlignRight)
		viewCount:addChild(imgMoney)
        strImgFile = attendence_map["attendence.icon_1.png"]
        strNameFile = attendence_map["attendence.name_1.png"]
	elseif reward.type == 2 then
		local imgMoney = new(self.imgNumber, self.numImage)
		imgMoney:setNumber(self:formatNumber(reward.money))
		imgMoney:setAlign(kAlignLeft)
		viewCount:addChild(imgMoney)
		local imgProp = new(self.imgNumber, self.numImage)
		imgProp:setNumber(self:formatNumber(reward.props))
		imgProp:setAlign(kAlignRight)
		viewCount:addChild(imgProp)
        strImgFile = attendence_map["attendence.icon_2.png"]
        strNameFile = attendence_map["attendence.name_2.png"]
	elseif reward.type == 3 then
		local imgCash = new(self.imgNumber, self.numImage)
		imgCash:setNumber(self:formatNumber(reward.diamond))
		imgCash:setAlign(kAlignRight)
		viewCount:addChild(imgCash)
		strImgFile = attendence_map["attendence.icon_3.png"]
        strNameFile = attendence_map["attendence.name_3.png"]
	end
	--更改显示的图片
	local imgReward = viewReward:findChildByName("img_reward")
	imgReward:setFile(strImgFile)
	imgReward:setSize(imgReward.m_res.m_width, imgReward.m_res.m_height)
	local imgName = viewReward:findChildByName("img_name")
	imgName:setFile(strNameFile)
	imgName:setSize(imgName.m_res.m_width, imgName.m_res.m_height)
	--设置按钮点击签到

	return item
end

--金钱统一成**K/M的格式，不带小数点
function AttendencePopu:formatNumber(money)
	local number = money and tostring(money) or ""
	local len = string.len(money)
	if len <= 3 then
		return "x"..number
	elseif len <= 6 then
		return "x"..string.sub(number, 1, len - 3).."k"
	else
		return "x"..string.sub(number, 1, len - 6).."m"
	end
end

function AttendencePopu:onSetHallAttendence(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		--签到成功保存数据
		MyUserData:getAttendenceReward().hasSigned = true

		local rewardDay = self.rewardData.signNum + 1
        --刷新标题
        local viewTitle = self:findChildByName("view_title")
        viewTitle:removeAllChildren()
	    ToolKit.formatRichText(viewTitle, STR_ATTENDENCE_DAYS, rewardDay ,{26, 0xf1, 0xcf, 0x9e}, {30, 0x14, 0xD6, 0x6C})

		local curReward = self.rewardData[rewardDay]
		--local curReward = data.data
		local item = self.rewardItems[rewardDay]
		item:findChildByName("img_attended"):setVisible(true)
		item:findChildByName("img_rewarded"):setVisible(true)
		item:findChildByName("img_unattended"):setVisible(false)
		if curReward and item then
			local strImgFile = ""
			if curReward.type == 1 then
				EventDispatcher.getInstance():dispatch(Event.Message, "showAddMoneyAnim", curReward.money)
				MyUserData:addMoney(curReward.money, true)
                strImgFile = attendence_map["attendence.icon_1.png"]
			elseif curReward.type == 2 then
				EventDispatcher.getInstance():dispatch(Event.Message, "showAddMoneyAnim", curReward.money)
				MyUserData:addMoney(curReward.money, true)
                MyUserData:addPropNum(kIDInterProp, curReward.props)
				strImgFile = attendence_map["attendence.icon_2.png"]
			elseif curReward.type == 3 then
				strImgFile = attendence_map["attendence.icon_3.png"]
			end
			local addIcon = new(Image, strImgFile)
			addIcon:setPos(item:findChildByName("img_reward"):getAbsolutePos())
			self:findChildByName("img_bg"):addChild(addIcon)
			local fromx, fromy = addIcon:getPos()
	        local tox, toy = 100, 50
	        local iconMove = addIcon:addPropTranslateWithEasing(3, kAnimNormal, 500, 0, "easeOutCirc", "easeOutCirc", 0, (tox-fromx), 0, (toy-fromy))
	        iconMove:setEvent(nil, function()
	            self:findChildByName("img_bg"):removeChild(addIcon, true)
	            item:findChildByName("btn_bg"):setEnable(false)
	            if MyUserData:getUserType() == UserType.Visitor then
	            	self:findChildByName("view_fb"):setVisible(true)
	            	self:findChildByName("btn_confirm"):setVisible(false)
	            else
	            	self:dismiss()
	            end
	        end)
		end
    else
        --签到失败，按钮重新使能
        self:findChildByName("btn_confirm"):setEnable(true)
	end
	

end

AttendencePopu.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.SET_HALL_ATTENDENCE] = AttendencePopu.onSetHallAttendence,
}

return AttendencePopu