require(ViewPath.."buddyInviteItem")

local BuddyRoomInvitePopu = class(require("popu.gameWindow"))

function BuddyRoomInvitePopu:ctor()

end

function BuddyRoomInvitePopu:dtor()

end

function BuddyRoomInvitePopu:initView(data)
    self.gameId = data.gameId
    self.showTid = data.showTid
	--房间里的mTableId值，主要用id 房间号tableid 和gameId 游戏ID 两个key的值
	self:findChildByName("btn_close"):setOnClick(self, function(self)
		self:dismiss()
	end)

    local btnInviteFb = self:findChildByName("btn_inviteFB")
    btnInviteFb:findChildByName("text_button"):setText(STR_BUDDY_INVITE_FB)
    btnInviteFb:setOnClick(self, function(self)
        self:dismiss(true)
        local isMessengerExist = NativeEvent.getInstance():isMessengerExist()
        --messenger存在，直接分享到messenger
        if isMessengerExist == 1 then
            app:postFrontStaticstics("openMessenger")
            NativeEvent.getInstance():shareToMessenger({nick = MyUserData:getNick(), gameId = self.gameId or 0, showTid = self.showTid or 0})
        --messenger不存在，打开邀请弹窗
        else
            WindowManager:showWindow(WindowTag.FbInvitePopu, {}, WindowStyle.POPUP);
        end
    end)
end

function BuddyRoomInvitePopu:onShowEnd()
	self:execHttpCmd(HttpModule.s_cmds.GET_BUDDY_ONLINE_LIST, {}, false, true)
	self.super.onShowEnd(self)
end

function BuddyRoomInvitePopu:initInviteList()
	local svList = self:findChildByName("sv_buddyList")
    svList:removeAllChildren()
    svList:setDirection(kVertical)
    
    --没有好友
    local viewTips = self:findChildByName("view_text")
    if #self.buddyList == 0 then
        viewTips:setVisible(true)
        viewTips:findChildByName("text_noData"):setText(STR_BUDDY_NO_FRIEND_ONLINE)
        return
    end
    viewTips:setVisible(false)
    local height = 0
	for i = 1, #self.buddyList do
		local buddy = self.buddyList[i]
		local item = SceneLoader.load(buddyInviteItem)
		
		UIEx.bind(item, buddy, "headName", function(value)
			local viewHead = item:findChildByName("view_head")
			viewHead:removeAllChildren()
			local headImg = new(Mask, value, popu_map["popu.public.head_mask.png"]  or "")
			headImg:setSize(viewHead:getSize())
			headImg:setAlign(kAlignCenter)
			viewHead:addChild(headImg)
            buddy:checkHeadAndDownload()
		end)
		buddy:setHeadName(buddy:getHeadName())

		local viewStatus = item:findChildByName("view_status")
		viewStatus:findChildByName("text_name"):setText(buddy:getName())
		if buddy:getSex() == 0 then
			viewStatus:findChildByName("img_male"):setVisible(true)
		else
			viewStatus:findChildByName("img_female"):setVisible(true)
		end
		viewStatus:findChildByName("text_money"):setText(buddy:getMoney())

        --不在游戏
		if buddy:getGameId() == 0 then
			item:findChildByName("text_roomInfo"):setVisible(false)
		else
			item:findChildByName("text_roomInfo"):setText(buddy:getGameName())
		end

		local viewInvite = item:findChildByName("view_invite")
		viewInvite:findChildByName("text_button"):setText(STR_INVITE)
		local btnInvite = viewInvite:findChildByName("btn_invite")
		local textTips = viewInvite:findChildByName("text_tips")
		btnInvite:setOnClick(self, function(self)
			HttpModule.getInstance():execute(HttpModule.s_cmds.SEND_BUDDY_ROOM_INVITE, {fid = buddy:getId(), expand = {gameId = self.gameId, code = self.showTid},}, false, true)
			btnInvite:setEnable(false)
		end)
		UIEx.bind(item, buddy, "invite", function(value)
			
            --跟我在一个房间，不管invite
		    if buddy:getGameId() == self.gameId and buddy:getRoomId() == self.showTid then
			    textTips:setText(STR_BUDDY_SAME_ROOM)
                textTips:setVisible(true)
                btnInvite:setVisible(false)
		    else
                --不在同一个房间
			    -- 1可以邀请，0不可以
			    btnInvite:setVisible(value == 1)
                btnInvite:setEnable(true)
			    textTips:setVisible(value ~= 1)
		    end

		end)
        buddy:setInvite(buddy:getInvite())
        
		local timerNode = new(require('common.imageNumber'), {
			['0'] = expNumber_map["0.png"],
			['1'] = expNumber_map["1.png"],
			['2'] = expNumber_map["2.png"],
			['3'] = expNumber_map["3.png"],
			['4'] = expNumber_map["4.png"],
			['5'] = expNumber_map["5.png"],
			['6'] = expNumber_map["6.png"],
			['7'] = expNumber_map["7.png"],
			['8'] = expNumber_map["8.png"],
			['9'] = expNumber_map["9.png"],
		});
        timerNode:setAlign(kAlignCenter)
        local viewTimer = viewInvite:findChildByName("view_timer")
        viewTimer:addChild(timerNode)
        local timerStart = false
        UIEx.bind(item, buddy, "leftTime", function(value)
            if value > 0 then
                viewTimer:setVisible(true)
                viewInvite:findChildByName("view_noTimer"):setVisible(false)
                timerNode:setNumber(value)
            else
                viewTimer:setVisible(false)
                viewInvite:findChildByName("view_noTimer"):setVisible(true)
                viewTimer:removeProp(1)
                timerStart = false
                buddy:setInvite(1)
            end
            --计时器还没开始，启动计时器
            if not timerStart then
                timerStart = true
                viewTimer:removeProp(1)
                local animTimer = viewTimer:addPropTranslate(1, kAnimRepeat, 1000, 0, 0, 0, 0, 0)
                animTimer:setEvent(nil, function()
                    buddy:setLeftTime(buddy:getLeftTime() - 1)
                end)
            end
        end)
        buddy:setLeftTime(buddy:getLeftTime())
        
		
        item:setPos(0, height)
        svList:addChild(item)
        local _, h = item:getSize()
        height = height + h
	end

end

function BuddyRoomInvitePopu:onGetBuddyOnlineList(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
        --使用两个table存储buddy的值，第一个是按ID为索引，方便接收邀请应答后更新invite的状态，第二个按显示顺序排，用于顺序加载好友列表
        self.buddyListById = {}
		self.buddyList = {}
		local friendsList = data.data or {}
		for i = 1, #friendsList do
			if friendsList[i].isOnline == 1 then
				local friend = setProxy(new(require("data.buddyData")))
				friend:init(friendsList[i])
				table.insert(self.buddyList, friend)
                self.buddyListById[friend:getId()] = friend
			end
		end
		table.sort(self.buddyList, function(a, b)
            --可以邀请排前面，在大厅的排前面
            if a:getInvite() > b:getInvite() then
                return true
            elseif a:getInvite() == b:getInvite() then
                if a:getGameId() < b:getGameId() then
                    return true
                end
            end
--            --都不在大厅 或者都在大厅
--            if (a:getGameId() > 0 and b:getGameId() > 0) or (a:getGameId() <= 0 and b:getGameId() <= 0) then
--                --可以邀请的排前面
--                if a:getInvite() > b:getInvite() then
--                    return true
--                elseif a:getInvite() == b:getInvite() then
--                    if a:getRoomId() ~= self.showTid and b:getGameId() == self.gameId then
--                        return true
--                    end
--                end
--            --只有一个在大厅，排前面
--            elseif a:getGameId() < b:getGameId() then
--                return true
--            end

            return false
		end)
		self:initInviteList()
	end

end

function BuddyRoomInvitePopu:onSendBuddyRoomInvite(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		--邀请成功，将invite设置为0，不可邀请
		if tonumber(data.data.status) == 2 then
            local id = tonumber(data.data.fid)
            if id and self.buddyListById[id] then
                self.buddyListById[id]:setInvite(0)
                self.buddyListById[id]:setLeftTime(tonumber(data.data.canInviteTime) or 0)
            end
		end
	end
    
end

BuddyRoomInvitePopu.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.GET_BUDDY_ONLINE_LIST] 			= BuddyRoomInvitePopu.onGetBuddyOnlineList,
	[HttpModule.s_cmds.SEND_BUDDY_ROOM_INVITE]			= BuddyRoomInvitePopu.onSendBuddyRoomInvite,

}

return BuddyRoomInvitePopu