require(ViewPath.."buddyRoomListItem")
require(ViewPath.."buddyHeadItem")

local BuddyRoomPopu = class(require("popu.gameWindow"))
new(Image, "buddyRoom.png")

local STATUS_PLAYING = 1
local STATUS_WAITING = 0

function BuddyRoomPopu:ctor()

end

function BuddyRoomPopu:dtor()
	
end


function BuddyRoomPopu:onShowEnd()
	self:execHttpCmd(HttpModule.s_cmds.GET_BUDDY_ROOM_LIST, {}, false, true, self:findChildByName("img_buddyListBg"))
	self.super.onShowEnd(self)
end

function BuddyRoomPopu:initView(data)
	--初始化UI及文字
    local viewPlayer = self:findChildByName("img_player")
    
	viewPlayer:findChildByName("btn_back"):setOnClick(self, function(self)
		self:dismiss()
	end)
    UIEx.bind(self, MyUserData, "headName", function(value)
        local headView = viewPlayer:findChildByName("view_head")
		headView:removeAllChildren()
		local headImg = new(Mask, value, popu_map["popu.public.head_mask.png"]  or "")
		headImg:setSize(headView:getSize())
		headImg:setAlign(kAlignCenter)
		headView:addChild(headImg)
    end)
    MyUserData:setHeadName(MyUserData:getHeadName())
    viewPlayer:findChildByName("text_name"):setText(MyUserData:getNick())
    
    --初始化金钱
    local viewMoney = viewPlayer:findChildByName("view_money")
    local chipNode = new(require('common.imageNumber'), {
			['0'] = lobby_map["lobby.lobby_moneynumber.0.png"],
			['1'] = lobby_map["lobby.lobby_moneynumber.1.png"],
			['2'] = lobby_map["lobby.lobby_moneynumber.2.png"],
			['3'] = lobby_map["lobby.lobby_moneynumber.3.png"],
			['4'] = lobby_map["lobby.lobby_moneynumber.4.png"],
			['5'] = lobby_map["lobby.lobby_moneynumber.5.png"],
			['6'] = lobby_map["lobby.lobby_moneynumber.6.png"],
			['7'] = lobby_map["lobby.lobby_moneynumber.7.png"],
			['8'] = lobby_map["lobby.lobby_moneynumber.8.png"],
			['9'] = lobby_map["lobby.lobby_moneynumber.9.png"],
			['b'] = lobby_map["lobby.lobby_moneynumber.b.png"],
			['m'] = lobby_map["lobby.lobby_moneynumber.m.png"],
			['k'] = lobby_map["lobby.lobby_moneynumber.k.png"],
			['.'] = lobby_map["lobby.lobby_moneynumber.p.png"],
		});	

	chipNode:setNumber(string.format("%s", ToolKit.formatMoney(MyUserData:getMoney())));
	chipNode:setAlign(kAlignLeft);
	viewMoney:addChild(chipNode);
    
    viewPlayer:findChildByName("btn_addMoney"):setOnClick(self, function(self)
        WindowManager:showWindow(WindowTag.ShopPopu, {}, WindowStyle.POPUP)
    end)
    viewPlayer:findChildByName("btn_head"):setOnClick(self, function(self)
        WindowManager:showWindow(WindowTag.UserPopu, {}, WindowStyle.POPUP)
    end)
    -- 初始化经验进度条
    self:initLevel()
    
    local viewBuddyList = self:findChildByName("view_buddyList")
	local btnRefresh = viewBuddyList:findChildByName("btn_refresh")
	btnRefresh:setOnClick(self, function(self)
		self:execHttpCmd(HttpModule.s_cmds.GET_BUDDY_ROOM_LIST, {}, false, true, self:findChildByName("img_buddyListBg"))
		btnRefresh:setEnable(false)
	end)
    viewBuddyList:findChildByName("text_noRoom"):setText(STR_BUDDY_NO_ROOM_LIST)
	self:initCreateRoomList()

    --自动刷新机制，30秒自动刷新一次好友房
    local animRefresh = self:findChildByName("img_buddyListBg"):addPropTranslate(1, kAnimRepeat, 30000, 0, 0, 0, 0, 0)
    animRefresh:setEvent(nil, function()
        self:execHttpCmd(HttpModule.s_cmds.GET_BUDDY_ROOM_LIST, {}, false, true, self:findChildByName("img_buddyListBg"))
		btnRefresh:setEnable(false)
    end)

    --添加反馈弹窗
    self:findChildByName("btn_feedback"):setOnClick(self, function(self)
        WindowManager:showWindow(WindowTag.FeedbackPopu, {feedbackId = 16, chooseGame = false}, WindowStyle.POPUP)
    end)

    --二维码按钮
    local downloadPage = self:findChildByName("img_downloadBg")
    self:findChildByName("btn_download"):setOnClick(self, function(self)
        downloadPage:setVisible(not downloadPage:getVisible())
    end)
    downloadPage:findChildByName("text_scan"):setText(STR_SCAN_CODE_TO_DOWNLOAD)
    downloadPage:findChildByName("text_google"):setText(STR_STORE_DOWNLOAD_PAGE[tonumber(PhpManager:getGame())] or "")
    downloadPage:findChildByName("img_code"):setFile(string.format("buddyRoom/code_%s.png", PhpManager:getGame() or ""))
    --点击空白关闭二维码
    self:findChildByName("img_popuBg"):setEventTouch(self, function(self)
        downloadPage:setVisible(false)
    end)
    downloadPage:setEventTouch(nil, function(self) end)

end

function BuddyRoomPopu:initLevel()
    local lv = tonumber(MyUserData:getLevel())
    local exp = tonumber(MyUserData:getExp()) 
    local percent = 0
	if lv then
		local index = tonumber(lv)
		if index > 0 and index < 60 then
			local x1 = userLevelExp[index].x1 
			local x2 = userLevelExp[index].x2
			if exp > x1 then
				percent = math.ceil(((exp - x1)/(x2 - x1))*100)
				if percent >= 100 then
					percent = 99
				end
			end
		elseif index == 60 then
			percent = 99
		end
	end
    local viewPlayer = self:findChildByName("img_player")
    local progress = viewPlayer:findChildByName("img_progress")
    local maxLen = viewPlayer:findChildByName("img_levelBg"):getSize()
    local minLen, h = progress:getSize()
    progress:setSize(minLen + (maxLen - minLen) * percent / 100, h)

end
--初始化好友房间列表
function BuddyRoomPopu:initBuddyTableList()
    --首先清空好友房列表
    local svRoomList = self:findChildByName("sv_buddyRoomList")
	svRoomList:removeAllChildren()

	local tables = self.buddyTableList
    if #tables == 0 then
        self:findChildByName("text_noRoom"):setVisible(true)
        return
    end
    self:findChildByName("text_noRoom"):setVisible(false)

	local gameStatus = { [STATUS_PLAYING] = STR_BUDDY_GAMEING, [STATUS_WAITING] = ""}
	
	svRoomList:setDirection(kVertical)
	local height = 0
	for i = 1, #tables do
        local gameId = tables[i].gameId
        local game = app:getGame(gameId)
        if game then
		    local item = SceneLoader.load(buddyRoomListItem)
		    item:findChildByName("img_icon"):setFile(buddyRoom_map[string.format("buddyRoom.icon_%s.png", gameId)] or "")
		    --gameInfo:findChildByName("text_gameName"):setText(curGame:getName() or "")
		    item:findChildByName("text_button"):setText(STR_BUDDY_ENTER_ROOM)
		    item:findChildByName("text_gameState"):setText(gameStatus[tables[i].gameStatus] or "")
            item:findChildByName("text_buddyNum"):setText(string.format(STR_BUDDY_NUM_IN_ROOM, #tables[i].playerList))
		    self:initPlayerList(item, tables[i].playerList)
            item:findChildByName("btn_enterRoom"):setOnClick(self, function(self)
                --返回true表示可以进入游戏
		        if MyGameVerManager:updateGameFromNet(gameId) then
                    app:postFrontStaticstics("enterBuddyRoomFromPopu")
                    game:enterBuddyRoom(States.Lobby, kFalse, tables[i].tableId)
                end
            end)
		    item:setAlign(kAlignTop)
		    item:setPos(0, height)
		    svRoomList:addChild(item)
		    local _, h = item:getSize()
		    height = height + h
        end
	end
	svRoomList:setSize(svRoomList:getSize())
end

function BuddyRoomPopu:initPlayerList(item, players)
	local svPlayers = item:findChildByName("sv_head")
	svPlayers:setDirection(kHorizontal)
	svPlayers:removeAllChildren()
	local width = 0
	for i = 1, #players do
		local playerItem = SceneLoader.load(buddyHeadItem)
		UIEx.bind(playerItem, players[i], "headName", function(value)
			local headView = playerItem:findChildByName("view_head")
			headView:removeAllChildren()
			local headImg = new(Mask, value, popu_map["popu.public.head_mask.png"]  or "")
			headImg:setSize(headView:getSize())
			headImg:setAlign(kAlignCenter)
			headView:addChild(headImg)
            players[i]:checkHeadAndDownload()
		end)
        players[i]:setHeadUrl(players[i]:getHeadUrl())
		playerItem:setAlign(kAlignLeft)
		playerItem:setPos(width, 0)
		svPlayers:addChild(playerItem)
		width = width + playerItem:getSize()
	end
	svPlayers:setSize(svPlayers:getSize())
end

--初始化创建列表
function BuddyRoomPopu:initCreateRoomList()
	local svGameList = self:findChildByName("sv_gameList")
	svGameList:setDirection(kVertical)
	svGameList:removeAllChildren()
	local height = 0
	local gameId = app:getGameIds()
	for i = 1, #gameId do
    --暂时只有马哈、ks、双十有好友房
        if gameId[i] == 1004 or gameId[i] == 1005 or gameId[i] == 1006 then
            local curGame = app:getGame(gameId[i])
            --该客户端已经安装了这个游戏
            if curGame then
                local btnCreateRoom = new(Button, buddyRoom_map[string.format("buddyRoom.btn_%s.png", gameId[i]) or ""])
                --点击创建好友房
                btnCreateRoom:setOnClick(self, function(self)
                    curGame:enterBuddyRoom(States.Lobby, kTrue)
                end)
                btnCreateRoom:setPos(0, height)
                btnCreateRoom:setAlign(kAlignTop)
                svGameList:addChild(btnCreateRoom)
                local _, h = btnCreateRoom:getSize()
                height = height + h
            end
        end
	end
	svGameList:setSize(svGameList:getSize())
end

function BuddyRoomPopu:onGetBuddyRoomList(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local roomList = data.data or {}
        self.buddyTableList = {}
        for i = 1 , #roomList do
            local curGameId = tonumber(roomList[i].gameid) or 0
            local game = app:getGame(curGameId)
            --本地上必须先安装了这个游戏才能看见，如果没有可能会有文字和图片的缺失。
            if game then
                local room = {}
                room.gameStatus = tonumber(roomList[i].status) or 1
                room.tableId = tonumber(roomList[i].tid) or 0
                room.gameId = curGameId
                room.userCount = tonumber(roomList[i].userCount) or 0
                room.playerList = {}
                local playerList = roomList[i].userList or {}
                for index = 1, #playerList do
                    local player = setProxy(new(require("data.headData")))
                    player:setSex(playerList[index].msex or 0)
                    player:setHeadUrl(playerList[index].icon or "")
                    table.insert(room.playerList, player)
                end
                table.insert(self.buddyTableList, room)
            end
        end
        table.sort(self.buddyTableList, function(a, b)
            --waiting是0，等待的房间排前面
            if a.gameStatus < b.gameStatus then
                return true
            elseif a.gameStatus == b.gameStatus then
                if a.userCount > b.userCount then
                    return true
                end
            end
            return false
        end)

		self:initBuddyTableList()

    end
    self:findChildByName("btn_refresh"):setEnable(true)
end

BuddyRoomPopu.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.GET_BUDDY_ROOM_LIST] = BuddyRoomPopu.onGetBuddyRoomList,

}

return BuddyRoomPopu