local DailyLoginPopu = class(require("popu.gameWindow"))

function DailyLoginPopu:ctor()
	EventDispatcher.getInstance():register(Event.Message, self, self.onMessageCallDone)
end

function DailyLoginPopu:dtor()
	EventDispatcher.getInstance():unregister(Event.Message, self, self.onMessageCallDone);
end

function DailyLoginPopu:initView(data)

	self.data = data
	self:findChildByName('btn_close'):setOnClick(self, function ( self )
		self:dismiss()
	end)

	self:findChildByName("btn_share"):setOnClick(self, function ( self )
		self:dismiss()
    	STR_SHARE_WIN.name = string.format(STR_SHARE_LOGIN_REWARD, MyUserData:getNick(), PhpManager:getGameName(), PhpManager:getGameName()) 
    	STR_SHARE_WIN.picture = 'http://mvlptldt01-static.akamaized.net/images/login_reward.png'
		NativeEvent.getInstance():share(STR_SHARE_WIN)
	end)
	

	self:findChildByName("btn_confirm"):setOnClick(self, function ( self )
		if self.data.days and (type(self.data.days) == 'number') then
			self:updateView(self.data.days)
			self:updateTip(self.data.days)
		end
		HttpModule.getInstance():execute(HttpModule.s_cmds.GET_LOGIN_REWARD, {}, false, true);
	end)

	self:findChildByName("btn_share"):findChildByName('text_title'):setText(STR_SHARE);
	self:findChildByName("btn_confirm"):findChildByName('text_title'):setText(STR_EXIT_GAME_CONFIRM);
	self:findChildByName('continuous_title'):setText(STR_CONTINUOUS_LOGIN)
	self:findChildByName('title1'):setText(STR_FIRST_DAY)
	self:findChildByName('title2'):setText(STR_SECOND_DAY)
	self:findChildByName('title3'):setText(STR_THIRD_DAY)
	self:findChildByName('title4'):setText(STR_FOUR_DAY)
	self:findChildByName('title5'):setText(STR_FIVE_DAY)
	self:findChildByName('title6'):setText(STR_SIX_DAY)
	--连续登录天数
	if self.data.days and (type(self.data.days) == 'number') then
		self:updateView(self.data.days - 1)
		self:updateTipPre(self.data.days)
	end

end

function DailyLoginPopu:updateTip(day) 
	if MyUserData:getUserType() == UserType.Visitor then
		if day == 1 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 70000, day, 70000))
		elseif day == 2 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 75000, day, 145000))
		elseif day == 3 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 80000, day, 225000))
		elseif day == 4 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 85000, day, 310000))
		elseif day == 5 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 90000, day, 400000))
		elseif day == 6 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 100000, day, 500000))
		elseif day > 6 then
			local num = (day - 6) * 100000 + 500000
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 100000, '6+', num))
		end
	else
		if day == 1 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 120000, day, 120000))
		elseif day == 2 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 130000, day, 250000))
		elseif day == 3 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 140000, day, 390000))
		elseif day == 4 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 150000, day, 540000))
		elseif day == 5 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 160000, day, 700000))
		elseif day == 6 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 180000, day, 880000))
		elseif day > 6 then
			local num = (day - 6) * 180000 + 880000
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 180000, '6+', num))
		end
	end
end

function DailyLoginPopu:updateTipPre(day) 
	if MyUserData:getUserType() == UserType.Visitor then
		if day == 1 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 70000, day, 0))
		elseif day == 2 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 75000, day, 70000))
		elseif day == 3 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 80000, day, 145000))
		elseif day == 4 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 85000, day, 225000))
		elseif day == 5 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 90000, day, 310000))
		elseif day == 6 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 100000, day, 400000))
		elseif day > 6 then
			local num = (day - 6) * 100000 + 400000
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 100000, '6+', num))
		end
	else
		if day == 1 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 120000, day, 0))
		elseif day == 2 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 130000, day, 120000))
		elseif day == 3 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 140000, day, 250000))
		elseif day == 4 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 150000, day, 390000))
		elseif day == 5 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 160000, day, 540000))
		elseif day == 6 then
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 180000, day, 700000))
		elseif day > 6 then
			local num = (day - 6) * 180000 + 700000
			self:findChildByName("text_tip"):setText(string.format(STR_LOGIN_REWARD, 180000, '6+', num))
		end
	end
end

function DailyLoginPopu:updateView(day)
	if day and (type(day) == 'number') then
		if day >= 1 then
			self:findChildByName("yes1"):setVisible(true)
			self:findChildByName("daily1"):setFile("lobby/dailylogin/reward_d.png")
			self:findChildByName("title1"):setColor(0xFF, 0xCD, 0x24)
		else
			self:findChildByName("yes1"):setVisible(false)
		end
		if day >= 2 then
			self:findChildByName("yes2"):setVisible(true)
			self:findChildByName("daily2"):setFile("lobby/dailylogin/reward_d.png")
			self:findChildByName("title2"):setColor(0xFF, 0xCD, 0x24)
		else
			self:findChildByName("yes2"):setVisible(false)
		end
		if day >= 3 then
			self:findChildByName("yes3"):setVisible(true)
			self:findChildByName("daily3"):setFile("lobby/dailylogin/reward_d.png")
			self:findChildByName("title3"):setColor(0xFF, 0xCD, 0x24)
		else
			self:findChildByName("yes3"):setVisible(false)
		end
		if day >= 4 then
			self:findChildByName("yes4"):setVisible(true)
			self:findChildByName("daily4"):setFile("lobby/dailylogin/reward_d.png")
			self:findChildByName("title4"):setColor(0xFF, 0xCD, 0x24)
		else
			self:findChildByName("yes4"):setVisible(false)
		end
		if day >= 5 then
			self:findChildByName("yes5"):setVisible(true)
			self:findChildByName("daily5"):setFile("lobby/dailylogin/reward_d.png")
			self:findChildByName("title5"):setColor(0xFF, 0xCD, 0x24)
		else
			self:findChildByName("yes5"):setVisible(false)
		end
		if day > 5 then
			self:findChildByName("yes6"):setVisible(true)
			self:findChildByName("daily6"):setFile("lobby/dailylogin/reward_d.png")
			self:findChildByName("title6"):setColor(0xFF, 0xCD, 0x24)
		else
			self:findChildByName("yes6"):setVisible(false)
		end
	end
	--
	if MyUserData:getUserType() == UserType.Visitor then
		self:findChildByName("view11"):setVisible(true)
		self:findChildByName("view21"):setVisible(true)
		self:findChildByName("view31"):setVisible(true)
		self:findChildByName("view41"):setVisible(true)
		self:findChildByName("view51"):setVisible(true)
		self:findChildByName("view61"):setVisible(true)
		self:findChildByName("view12"):setVisible(false)
		self:findChildByName("view22"):setVisible(false)
		self:findChildByName("view32"):setVisible(false)
		self:findChildByName("view42"):setVisible(false)
		self:findChildByName("view52"):setVisible(false)
		self:findChildByName("view62"):setVisible(false)
	else
		self:findChildByName("view11"):setVisible(false)
		self:findChildByName("view21"):setVisible(false)
		self:findChildByName("view31"):setVisible(false)
		self:findChildByName("view41"):setVisible(false)
		self:findChildByName("view51"):setVisible(false)
		self:findChildByName("view61"):setVisible(false)
		self:findChildByName("view12"):setVisible(true)
		self:findChildByName("view22"):setVisible(true)
		self:findChildByName("view32"):setVisible(true)
		self:findChildByName("view42"):setVisible(true)
		self:findChildByName("view52"):setVisible(true)
		self:findChildByName("view62"):setVisible(true)
	end
end

function DailyLoginPopu:onMessageCallDone(param, ...)
	if param == 'shareLoginReward' then
		self:shareLoginReward(...)
	end
end

function DailyLoginPopu:shareLoginReward(data)
	self:findChildByName('btn_close'):setVisible(true)
	self:findChildByName("btn_share"):setVisible(true)
	self:findChildByName("btn_confirm"):setVisible(false)
	app:postFrontStaticstics('shareShow')
end

return DailyLoginPopu