require("ui/ex/ScrollViewEx")
require(ViewPath .. "lobbyFbInviteItem")
local FbInvitePopu = class(require("popu.gameWindow"))
require("pintu.friend")

local gTipsData = setProxy({})
gTipsData.inviteNum = 0
gTipsData.callbackNum = 0
gTipsData.selectInviteAll = false
gTipsData.selectCallbackAll = false

function FbInvitePopu:ctor()
	self.callbackFriendList = {}
	self.hasCallbackIds = {}
	self.mFacebookFriendData = {}
	gTipsData.inviteNum = 0
	gTipsData.callbackNum = 0
	gTipsData.selectInviteAll = false
	gTipsData.selectCallbackAll = false
	--读取已经邀请过和召回过的好友ID
	local str = GameSetting:getCallbackIdGuest()
	for id in string.gmatch(str, "(%d*),") do
		self.hasCallbackIds[id] = true
	end
	EventDispatcher.getInstance():register(Event.Call, self,self.OnEventCallBack);
end

function FbInvitePopu:dtor()
	EventDispatcher.getInstance():unregister(Event.Call, self,self.OnEventCallBack);
	--保存新邀请的好友信息
	local str = ""
	local callbackStr = ""
	for k, v in pairs(self.hasCallbackIds) do
		callbackStr = callbackStr..k..","
	end
	GameSetting:setCallbackIdGuest(callbackStr)
	GameSetting:save()

end

function FbInvitePopu:dismiss(...)
	self.super.dismiss(self, ...)
end
function FbInvitePopu:initView(data)
	self:findChildByName("btn_close"):setOnClick(self, function ( self )
		self:dismiss(false, nil, WindowStyle.POPUP);
	end);

	--初始化好友邀请界面
	self:initInviteView()
	--初始化好友召回界面
	self:initCallbackView()

	--初始化切换按钮
	local viewSwitch = self:findChildByName("view_switch")
	local viewBtns = {viewSwitch:findChildByName("view_btnInvite"), viewSwitch:findChildByName("view_btnCallback")}
	local tabView = {self:findChildByName("view_invite"), self:findChildByName("view_callback")}
	for i = 1, #viewBtns do
		viewBtns[i]:findChildByName("btn_unselect"):setOnClick(self, function(self)
			for j = 1, #viewBtns do
				viewBtns[j]:findChildByName("btn_unselect"):setVisible(i ~= j)
				viewBtns[j]:findChildByName("btn_select"):setVisible(i == j)
				tabView[j]:setVisible(i == j)
			end
		end)
	end

	HttpModule.getInstance():execute(HttpModule.s_cmds.GET_FB_CALLBACK_REWARD_CFG, {}, false, false)
	--参数指定跳转到召回页面
	if data.to == "call" then
		local btnCallback = self:findChildByName("view_btnCallback"):findChildByName("btn_unselect")
		btnCallback.m_eventCallback.func(btnCallback.m_eventCallback.obj)
	end
end

function FbInvitePopu:initInviteView()
	self.mHasLoaded		= 0;
	self.mPerLoad			= 15; --每次加载15条
	self.sum = MyUserData:getInvitesum()
	self.invitemoney = MyUserData:getInvitemoney()
	self.successmoney = MyUserData:getSuccessmoney()
	self.inviteNum = 0
	--初始化好友邀请界面
	local viewInvite = self:findChildByName("view_invite")
	local btnSelectAll = viewInvite:findChildByName("btn_selectAll");
	local imgSelectAll = btnSelectAll:findChildByName("img_check");

	local viewInviteNum = viewInvite:findChildByName("view_inviteNum")
	UIEx.bind(self, gTipsData, "inviteNum", function(value)
		printInfo("inviteNum is "..value)
		if value > 0 then	
			local actualRewardNum = value > MyUserData:getLeftInviteNum() and MyUserData:getLeftInviteNum() or value
			actualRewardNum = actualRewardNum > 0 and actualRewardNum or 0
			viewInviteNum:removeAllChildren()
			local str = string.format(STR_INVITE_NUM, value, "%s") 
			ToolKit.formatRichText(viewInviteNum, str, (self.invitemoney or 1000) * actualRewardNum, {24, 0xff, 0xff, 0xff}, {26, 0xff, 0xff, 0x00})
		else
			viewInviteNum:removeAllChildren()
		end
	end)
	gTipsData.inviteNum = gTipsData.inviteNum

	local textSelect = btnSelectAll:findChildByName("text_select")
	UIEx.bind(self, gTipsData, "selectInviteAll", function(value)
							if value then
								textSelect:setText(STR_SELECT_NONE)
								imgSelectAll:setVisible(true)
							else
								textSelect:setText(STR_SELECT_ALL)
								imgSelectAll:setVisible(false)
							end
	end)
	gTipsData.selectInviteAll = gTipsData.selectInviteAll

	btnSelectAll:setOnClick(self, function ( self )
		gTipsData.selectInviteAll = not gTipsData.selectInviteAll
		if not gTipsData.selectInviteAll then
			for i = 1, #self.mFacebookFriendData do
				self.mFacebookFriendData[i]:setCheck(false);
			end
			gTipsData.inviteNum = 0
		else
			if #self.mFacebookFriendData >= 51 then
				for i = 1, 50 do
					self.mFacebookFriendData[i]:setCheck(true);
				end
				for i = 51, #self.mFacebookFriendData do
					self.mFacebookFriendData[i]:setCheck(false);
				end
				gTipsData.inviteNum = 50

			else
				printInfo("set inviteNum "..#self.mFacebookFriendData)
				for i = 1, #self.mFacebookFriendData do
					self.mFacebookFriendData[i]:setCheck(true);
				end
				gTipsData.inviteNum = #self.mFacebookFriendData
			end
		end

	end);
	-- local viewCashTip = viewInvite:findChildByName("view_cashTip")
	-- viewCashTip:removeAllChildren()
	-- ToolKit.formatRichText(viewCashTip, STR_INVITE_TIP2, 3, {24, 0x00, 0x88, 0xff}, {26, 0xff, 0xff, 0x00})

	local btnInvite = viewInvite:findChildByName("btn_invite");
	btnInvite:setOnClick(self, function ( self )
		local inviteToIds = "";
		local count = 0;
		local inviteMax = 50;
		for i = 1, #self.mFacebookFriendData do
			local data = self.mFacebookFriendData[i];
			if data:getCheck() then
				if count < inviteMax then
					if inviteToIds ~= "" then
						inviteToIds = inviteToIds .. "," .. data:getId();
					else
						inviteToIds = data:getId();
					end
				end
				count = count + 1;
			end
		end

		local gameList = MyUserData:getGameList();
		local gateway  = gameList and gameList[PhpManager:getGame()] or {};
		if string.len(inviteToIds) > 0 then
			NativeEvent.getInstance():inviteFbFriend({
					title = "facebook",
					content = string.format(STR_SHARE_FIREND, PhpManager:getGameName()),
					url = gateway['gateway'] or '',
					inviteToIds = inviteToIds,
					expandData = MyUserData:getId(),
					action = "invite",
																							});
		end
	end);
	--请求facebook好友

	viewInvite:findChildByName('text_tip'):setVisible(false)
	local btnCashShop = viewInvite:findChildByName("btn_cashShop")
	btnCashShop:findChildByName("text_cashShop"):setText(STR_GO_TO_CASH_SHOP)
	btnCashShop:setOnClick(nil, function()
		WindowManager:showWindow(WindowTag.CashExchangePopu, {}, WindowStyle.POPUP)
		self:dismiss(true)
	end)

	local inviteFriend = MyUserData:getInviteFriend();
	if inviteFriend then
		self:onGetFbFriendCallback();
	else
		NativeEvent.getInstance():getFbFriend();
	end

	local btnInviteTask = viewInvite:findChildByName("btn_inviteTask")
	btnInviteTask:setOnClick(self, function(self)
		btnInviteTask:setEnable(false)
		HttpModule.getInstance():execute(HttpModule.s_cmds.GET_CASH_TASK_FRIEND, {}, true, true)
	end)
	local viewTask = viewInvite:findChildByName("view_task")
	local imgTask = viewTask:findChildByName("img_taskBg")
	local btnClose = viewTask:findChildByName("btn_taskClose")
	btnClose:setOnClick(self, function(self)
		btnClose:setVisible(false)
		local x, y = viewTask:getPos()
		imgTask:removeProp(1001)
		local anim = imgTask:addPropScaleEase(1001, kAnimNormal, ResDoubleArrayExpIn, 500, -1, 1, 1, 1, 0, kCenterXY, x / 2, y)
		if anim then
			anim:setEvent(nil, function()
				imgTask:removeProp(1001)
				viewTask:setVisible(false)
				viewInvite:findChildByName("btn_inviteTask"):setEnable(true)
			end)
		end
		
	end)
	-- viewTask:findChildByName("text_title"):setText(STR_INVITE_SUCCESS_COUNT)
	viewTask:findChildByName("text_mailTip"):setText(STR_INVITE_MAILINFO)
	HttpModule.getInstance():execute(HttpModule.s_cmds.GET_INVITE_TASK_PROGRESS, {}, true, true)

end

function FbInvitePopu:initCallbackView()
	self.hasLoadedCallback	= 0;
	-- self.selectAllCallback = false
	local viewCallback = self:findChildByName("view_callback")
	local btnSelectAll = viewCallback:findChildByName("btn_selectAll")
	local imgSelectAll = btnSelectAll:findChildByName("img_check");
	local textSelectAll = btnSelectAll:findChildByName("text_select")
	UIEx.bind(self, gTipsData, "selectCallbackAll", function(value)
		if value then
			textSelectAll:setText(STR_SELECT_NONE);
			imgSelectAll:setVisible(true)
		else
			textSelectAll:setText(STR_SELECT_ALL)
			imgSelectAll:setVisible(false)
		end
	end)
	printInfo("MyUserData:getLeftCallbackNum "..MyUserData:getLeftCallbackNum())
	gTipsData.selectCallbackAll = gTipsData.selectCallbackAll
	-- 游客登录，没有此功能，提示FB登录
	if UserType.Visitor == MyUserData:getUserType() then
		local textTips = viewCallback:findChildByName("text_tip")
		textTips:setVisible(true)
		textTips:setText(STR_FB_CALLBACK_LOGIN_FB)
		return
	end

	local viewCallbackNum = viewCallback:findChildByName("view_callbackNum")
	UIEx.bind(self, gTipsData, "callbackNum", function(value)
		print_string("zyh callbackNum is "..value.." left "..MyUserData:getLeftCallbackNum())
		if value > 0 then
			local actualRewardNum = value > MyUserData:getLeftCallbackNum() and MyUserData:getLeftCallbackNum() or value
			actualRewardNum = actualRewardNum > 0 and actualRewardNum or 0
			viewCallbackNum:removeAllChildren()
			local str = string.format(STR_INVITE_NUM, value, "%s")
			ToolKit.formatRichText(viewCallbackNum, str, (self.invitemoney or 1000) * actualRewardNum, {24, 0xff, 0xff, 0xff}, {26, 0xff, 0xff, 0x00})
		else
			viewCallbackNum:removeAllChildren()
		end
	end)
	gTipsData.callbackNum = gTipsData.callbackNum


	--点击全选，再次点击取消全选
	btnSelectAll:setOnClick(self, function(self)
		printInfo("callback btn select all")
		gTipsData.selectCallbackAll = not gTipsData.selectCallbackAll
		--取消全选
		if not gTipsData.selectCallbackAll then
			for i = 1, #self.callbackFriendList do
				self.callbackFriendList[i]:setCheck(false)
			end
			gTipsData.callbackNum = 0
			--全部选中,默认选前面50个
		else
			if #self.callbackFriendList > 51 then
				for i = 1, 50 do
					self.callbackFriendList[i]:setCheck(true)
				end
				for i = 51, #self.callbackFriendList do
					self.callbackFriendList[i]:setCheck(false)
				end
				gTipsData.callbackNum = 50
			else
				for i = 1, #self.callbackFriendList do
					self.callbackFriendList[i]:setCheck(true)
				end
				gTipsData.callbackNum = #self.callbackFriendList
			end
		end

	end)

	--发送邀请按钮
	local btnCallback = viewCallback:findChildByName("btn_callback");
	btnCallback:setOnClick(self, function(self)
		local inviteToIds = "";
		local count = 0
		local inviteMax = 50
		for i = 1, #self.callbackFriendList do
			local data = self.callbackFriendList[i]
			if data:getCheck() then
				if count < inviteMax then
					if inviteToIds ~= "" then
						inviteToIds = inviteToIds .. "," .. data:getId();
					else
						inviteToIds = data:getId();
					end
				end
				count = count + 1;
			end
		end

		local gameList = MyUserData:getGameList();
		local gateway  = gameList and gameList[PhpManager:getGame()] or {};
		if string.len(inviteToIds) > 0 then
			NativeEvent.getInstance():inviteFbFriend({
					title = "facebook",
					content = STR_FB_CALLBACK_SHARE_TIP,
					url = gateway['gateway'] or '',
					inviteToIds = inviteToIds,
					expandData = MyUserData:getId(),
					action = "recall",
																							});
		end
	end)

	if MyUserData:getCallbackFriend() then
		self.callbackFriendList = MyUserData:getCallbackFriend()
		for i = 1, #self.callbackFriendList do
			self.callbackFriendList[i]:setCheck(false)
		end
		self:initCallbackFriendList()
	else
		HttpModule.getInstance():execute(HttpModule.s_cmds.GET_FB_CALLBACK_LIST, {}, false, false)
	end

end

function FbInvitePopu:initInviteFriendList()
	-- body
	local viewInvite = self:findChildByName("view_invite")

	local viewFriends		= viewInvite:findChildByName("view_friends");
	local w, h			= viewFriends:getSize();

	viewFriends:removeAllChildren();

	self.mScrollView	= new(ScrollViewEx, 0, 0, w, h, false);

	self.mScrollView:setOnReachBottom(self, function ( self )
		if self.mHasLoaded < #self.mFacebookFriendData then
			self:initData(self.mHasLoaded + 1, self.mHasLoaded + self.mPerLoad);
		end
	end);
	self.mScrollView:setPos(0, 0);
	viewFriends:addChild(self.mScrollView);

	if not self.selectInviteAll then
		local btnSelectAll = viewInvite:findChildByName("btn_selectAll");
		btnSelectAll.m_eventCallback.func(btnSelectAll.m_eventCallback.obj)
		self.selectInviteAll = true
	end

end
function FbInvitePopu:initData(from, to)
	local kNumOneLine = 4
	-- body
	local viewInvite = self:findChildByName("view_invite")
	local srollviewW= self.mScrollView:getSize();

	if from == 1 then
		self.mHasLoaded = 0;
	end

	local rows		= 1;
	local columns		= 1;
	for i = 1, #self.mFacebookFriendData do

		if i >= from and i <= to then

			self.mHasLoaded = self.mHasLoaded + 1;

			local data = self.mFacebookFriendData[i]
			local item = SceneLoader.load(lobbyFbInviteItem);
			local w, h = item:getSize();

			local delta = (srollviewW - w * kNumOneLine) / (kNumOneLine + 1);

			item:setPos((columns - 1) * w + delta * columns, (h + 20) * (rows - 1) + 10);

			item:findChildByName("btn_check"):setOnClick(self, function ( self )
				data:setCheck(not data:getCheck());
				if data:getCheck() then
					gTipsData.inviteNum = gTipsData.inviteNum + 1
				else
					gTipsData.inviteNum = gTipsData.inviteNum - 1
					gTipsData.selectInviteAll = false
				end
			end);


			UIEx.bind(item, data, "headName", function(value)
				item:findChildByName("img_avatar"):setFile(value);
				data:checkHeadAndDownload();
			end)

			local viewNick = item:findChildByName("view_nick")
			local textNick = viewNick:findChildByName("text_nick")
			UIEx.bind(item, data, "nickname", function(value)
				ToolKit.formatTextLength(value, textNick, viewNick:getSize())
			end)

			UIEx.bind(item, data, "money", function(value)
				item:findChildByName("text_money"):setText("+"..value);
			end)

			UIEx.bind(item, data, "check", function(value)
				if value then
					item:findChildByName("img_check"):setFile(friend_map["friend.invite_user_bg_selected.png"]);
				else
					item:findChildByName("img_check"):setFile(friend_map["friend.invite_user_bg_unselected.png"]);
				end
			end)

			data:setId(data:getId());
			data:setNickname(data:getNickname());
			data:setMoney(data:getMoney());
			data:setHeadUrl(data:getHeadUrl());
			data:setCheck(data:getCheck());
			data:setSex(data:getSex());

			self.mScrollView:addChild(item);
		end

		columns = columns + 1;
		if columns > kNumOneLine then
			columns = 1;
			rows = rows + 1;
		end
	end

	local textTip = self:findChildByName("view_invite"):findChildByName('text_tip')
	if #self.mFacebookFriendData > 0 then
		textTip:setVisible(false)
	else
		textTip:setVisible(true)
		textTip:setText(STR_NO_INVITE_FRIEND);
	end
end

function FbInvitePopu:initTaskProgress()
	local viewInvite = self:findChildByName("view_invite")
	local viewTask = viewInvite:findChildByName("view_task")
	viewTask:findChildByName("btn_taskClose"):setVisible(true)
	
	local stages = self.inviteTaskData
	local svText = viewTask:findChildByName("sv_task")
	local sx,sy = svText:getSize()
	svText:setDirection(kVertical)
	local myInviteNum = self.inviteNum or 0
	local viewTitle = viewTask:findChildByName("view_title")
	viewTitle:removeAllChildren()
	ToolKit.formatRichText(viewTitle, STR_INVITE_SUCCESS_COUNT, myInviteNum, {24, 0xff, 0xff, 0xff}, {26, 0xff, 0xff, 0x00})
	local curProgressIndex = 0
	--initialize the text show the task progress
	for i = 1, #stages do
		local color = {0xff, 0xff, 0xff}
		if i < #stages then
			if stages[i].threshold <= myInviteNum then
				curProgressIndex = i
				color = {0xd8, 0xd8, 0x00}
			end
		else
			if stages[i - 1].threshold < myInviteNum then
				color = {0xd8, 0xd8, 0x00}
			elseif stages[i - 1].threshold == myInviteNum then
				curProgressIndex = i - 2
			end
		end
		local str = ""
		if i < #stages then
			str = string.format(STR_INVITE_SUCCESS_REWARD[stages[i].rewardtype], stages[i - 1] and stages[i - 1].threshold + 1 or 1,stages[i].threshold, stages[i].rewardNum)
		else
			str = string.format(STR_INVITE_SUCCESS_REWARD[i],  stages[i - 1].threshold+ 1,stages[i].rewardNum)
		end
		local textTask = new(TextView, str, sx, 0, kAlignCenter, nil, 15, unpack(color))
		--textTask:setAlign(kAlignCenter)
		local wText, hText = textTask:getSize()
		local svw, svh = svText:getSize()
		textTask:setPos((svw - wText) / 2, (i - 1) * (hText + 10))
		svText:addChild(textTask)
	end
	svText:setSize(svText:getSize())

	local x, y = viewTask:getPos()
	local imgTask = viewTask:findChildByName("img_taskBg")
	local anim = imgTask:addPropScaleEase(1001, kAnimNormal, ResDoubleArrayExpOut, 500, -1, 1, 1, 0, 1, kCenterXY, x / 2, y)
	if anim then
		anim:setEvent(nil, function()
			imgTask:removeProp(1001)
		end)
	end
	viewTask:setVisible(true)
end

function FbInvitePopu:initCallbackFriendList()
	--默认点击全选
	local viewCallback = self:findChildByName("view_callback")
	local btnSelectAll = viewCallback:findChildByName("btn_selectAll")
	if not self.selectCallbackAll then
		self.selectCallbackAll = true
		btnSelectAll.m_eventCallback.func(btnSelectAll.m_eventCallback.obj)
	end
	local textTips = viewCallback:findChildByName("text_tip")
	textTips:setVisible(false)
	if #self.callbackFriendList == 0 then
		textTips:setVisible(true)
		textTips:setText(STR_FB_CALLBACK_NO_FRIEND)
	end

	local viewCallback = self:findChildByName("view_callbackList")
	local w, h = viewCallback:getSize()
	viewCallback:removeAllChildren()
	self.svCallback = new(ScrollViewEx, 0, 0, w, h, false)
	self.svCallback:setOnReachBottom(self, function (self)
		if self.hasLoadedCallback < #self.callbackFriendList then
			self:loadCallbackFriendList(self.hasLoadedCallback + 1, self.hasLoadedCallback + self.mPerLoad)
		end
	end)
	self.svCallback:setPos(0, 0)
	viewCallback:addChild(self.svCallback)
	self:loadCallbackFriendList(1, self.mPerLoad)
end

function FbInvitePopu:loadCallbackFriendList(from, to)
	local kNumOneLine = 4
	if from == 1 then
		self.hasLoadedCallback = 0
	end
	local srollviewW = self.svCallback:getSize();
	local rows = 1
	local columns = 1
	for i = 1, #self.callbackFriendList do
		if i >= from and i <= to then
			self.hasLoadedCallback = self.hasLoadedCallback + 1
			local item = self:initCallbackItem(self.callbackFriendList[i])
			local w, h = item:getSize();
			local delta = (srollviewW - w * kNumOneLine) / (kNumOneLine + 1);
			item:setPos((columns - 1) * w + delta * columns, (h + 20) * (rows - 1) + 10);
			self.svCallback:addChild(item)
		end
		columns = columns + 1;
		if columns > kNumOneLine then
			columns = 1;
			rows = rows + 1;
		end

	end

end

function FbInvitePopu:initCallbackItem(data)
	local viewCallback = self:findChildByName("view_callback")
	local item = SceneLoader.load(lobbyFbInviteItem)
	item:findChildByName("btn_check"):setOnClick(self, function ( self )
		data:setCheck(not data:getCheck());
		if data:getCheck() then
			gTipsData.callbackNum = gTipsData.callbackNum + 1
		else
			gTipsData.callbackNum = gTipsData.callbackNum - 1
			gTipsData.selectCallbackAll = false
		end
	end);

	UIEx.bind(item, data, "headName", function(value)
		item:findChildByName("img_avatar"):setFile(value);
		data:checkHeadAndDownload();
	end)

	local viewNick = item:findChildByName("view_nick")
	local textNick = viewNick:findChildByName("text_nick")
	UIEx.bind(item, data, "nickname", function(value)
		ToolKit.formatTextLength(value, textNick, viewNick:getSize())
	end)
	UIEx.bind(item, data, "money", function(value)
		item:findChildByName("text_money"):setText("+"..value);
	end)
	UIEx.bind(item, data, "check", function(value)
		if value then
			item:findChildByName("img_check"):setFile(friend_map["friend.invite_user_bg_selected.png"]);
		else
			item:findChildByName("img_check"):setFile(friend_map["friend.invite_user_bg_unselected.png"]);
		end

	end)
	data:setNickname(data:getNickname());
	data:setMoney(data:getMoney());
	data:setSex(data:getSex());
	data:setHeadUrl(data:getHeadUrl());
	data:setCheck(data:getCheck());

	return item
end

function FbInvitePopu:onGetFbFriendCallback()
	local data = MyUserData:getInviteFriend()
	print_string("zyh data is "..tostring(data).." status is "..tostring(data and data.status or "data is nil"))
	if data and data.status == 0 then
		for i = 1, #data do
			local swapIndex = math.random(#data)
			local tmp = data[i]
			data[i] = data[swapIndex]
			data[swapIndex] = tmp
		end
		self.mFacebookFriendData = data
		local autoSelectNum = 0
		for i = 1, #data do
			autoSelectNum = autoSelectNum + 1
			data[i]:setCheck(false)
			if autoSelectNum < 51 then
				data[i]:setCheck(gTipsData.selectInviteAll)
			end
		end
		if gTipsData.selectInviteAll then
			gTipsData.inviteNum = autoSelectNum > 50 and 50 or autoSelectNum
		else
			gTipsData.inviteNum = 0
		end
		printInfo("friend num is "..#self.mFacebookFriendData)
		self:initInviteFriendList();
		self:initData(1, self.mPerLoad);
	else
		AlarmTip.play(STR_GET_INVITED_FRIEND_ERR);
	end

end

function FbInvitePopu:onGetInviteTaskProgress(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		self.inviteTaskData = data.data or {}
		-- local maxReward = self.inviteTaskData[#self.inviteTaskData] and self.inviteTaskData[#self.inviteTaskData].rewardNum or 3
		-- local viewCashTip = self:findChildByName("view_invite"):findChildByName("view_cashTip")
		-- viewCashTip:removeAllChildren()
		-- ToolKit.formatRichText(viewCashTip, STR_INVITE_TIP2, maxReward, {24, 0x00, 0x88, 0xff}, {26, 0xff, 0xff, 0x00})

		self:findChildByName("view_invite"):findChildByName("view_cashTip"):findChildByName("text_cashTip"):setText(data.codemsg)
	end
end

function FbInvitePopu:onGetInviteFriendNum(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		self.inviteNum = data.data.invCount and tonumber(data.data.invCount) or 0
		
		if self.inviteTaskData then
			self:initTaskProgress()
		end
	end 
end

function FbInvitePopu:onGetFbCallbackReward(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		self.callbackReward = tonumber(data.data.perReward) or 1000
		self:findChildByName("view_callback"):findChildByName("text_tip2"):setText(data.data.msg or "")
		for i = 1, #self.callbackFriendList do
			self.callbackFriendList[i]:setMoney(self.callbackReward)
		end
	end
end

function FbInvitePopu:onGetFbCallbackList(isSuccess, data)
	-- local str = '{"code":1,"codemsg":"","data":[{"mid":"14069","micon":"https:\/\/graph.facebook.com\/1671558323129489\/picture?type=normal","name":"Doria  Wu","sitemid":"1671558323129489"},{"mid":"21601","micon":"https:\/\/graph.facebook.com\/221461968191307\/picture?type=normal","name":"Crystal Xiong","sitemid":"221461968191307"},{"mid":"19048","micon":"https:\/\/graph.facebook.com\/179982395674762\/picture?type=normal","name":"Park Peng","sitemid":"179982395674762"},{"mid":"19034","micon":"https:\/\/graph.facebook.com\/233629180322123\/picture?type=normal","name":"Jaywill Ou","sitemid":"233629180322123"},{"mid":"22156","micon":"https:\/\/graph.facebook.com\/374583089570708\/picture?type=normal","name":"Doria Ding","sitemid":"255393744822977"},{"mid":"15063","micon":"https:\/\/graph.facebook.com\/161119950929662\/picture?type=normal","name":"\u949f\u96e8\u5b8f","sitemid":"161119950929662"},{"mid":"22159","micon":"https:\/\/graph.facebook.com\/172510193139863\/picture?type=normal","name":"Wu Joan","sitemid":"172510193139863"},{"mid":"22158","micon":"https:\/\/graph.facebook.com\/230469520679684\/picture?type=normal","name":"Doria Wu","sitemid":"230469520679684"},{"mid":"23402","micon":"https:\/\/graph.facebook.com\/148113892272456\/picture?type=normal","name":"Rain Zhong","sitemid":"148113892272456"},{"mid":"30938","micon":"https:\/\/graph.facebook.com\/171926343282639\/picture?type=normal","name":"Huifei Shen","sitemid":"171926343282639"}],"time":1490089601,"exetime":0.010351896286011}'
	-- printInfo("onGetFbCallbackList")
	-- data = json.decode(str)
	-- dump(data)
	if app:checkResponseOk(isSuccess, data) then
		self.callbackFriendList = {}
		local friendList = data.data or {}
		local noinvitecount = 0
		for i = 1, #friendList do
			local friend = friendList[i]
			local callbackFriend = setProxy(new(require("data.facebookFriend")))
			callbackFriend:setId(tostring(friend.sitemid) or "")
			callbackFriend:setNickname(friend.name or "")
			callbackFriend:setHeadUrl(friend.micon or "")
			callbackFriend:setMoney(self.callbackReward or 1000)
			callbackFriend:setCheck(false)
			callbackFriend.userId = tonumber(friend.mid) or 0
			callbackFriend:setSex(1);
			--这个号今天还没有召回过，才显示
			if not self.hasCallbackIds[callbackFriend:getId()] then
				noinvitecount = noinvitecount + 1
				table.insert(self.callbackFriendList, callbackFriend)
				if noinvitecount < 51 then
					callbackFriend:setCheck(gTipsData.selectCallbackAll)
				end
			end
		end
		--如果当前设置为选中，刷新召回选中的人数
		if gTipsData.selectCallbackAll then
			gTipsData.callbackNum = noinvitecount > 50 and 50 or noinvitecount
		else
			gTipsData.callbackNum = 0
		end
		MyUserData:setCallbackFriend(self.callbackFriendList)
		self:initCallbackFriendList()
		-- self.chooseCallbackNum = 0
	end
end

function FbInvitePopu:onSendRecallSuccess(data)
	local ids = {}
	local newCallBackList = {}
	for i = 1, #self.callbackFriendList do
		--没选中的玩家就重新刷新列表，选中的玩家用来发奖励请求
		if not self.callbackFriendList[i]:getCheck() then
			table.insert(newCallBackList, self.callbackFriendList[i])
		else
			table.insert(ids, self.callbackFriendList[i].userId)
			self.hasCallbackIds[tostring(self.callbackFriendList[i]:getId())] = true
		end
	end
	HttpModule.getInstance():execute(HttpModule.s_cmds.GET_FB_CALLBACK_REWARD, {fids = ids}, false, false)
	local leftNum = MyUserData:getLeftCallbackNum() - #ids
	if leftNum < 0 then
		leftNum = 0
	end
	MyUserData:setLeftCallbackNum(leftNum)
	self.callbackFriendList = newCallBackList
	MyUserData:setCallbackFriend(self.callbackFriendList)
	self:initCallbackFriendList()
	gTipsData.callbackNum = 0
end

function FbInvitePopu:OnEventCallBack(key, data)
	if self.callEventFuncMap[key] then
		self.callEventFuncMap[key](self, data)
	end
end

FbInvitePopu.callEventFuncMap = {
	[kGetFbFriend]		= FbInvitePopu.onGetFbFriendCallback,
	["sendFBRecallSuccess"]     = FbInvitePopu.onSendRecallSuccess,
};

FbInvitePopu.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.GET_INVITE_TASK_PROGRESS] = FbInvitePopu.onGetInviteTaskProgress,
	[HttpModule.s_cmds.GET_CASH_TASK_FRIEND] = FbInvitePopu.onGetInviteFriendNum,
	[HttpModule.s_cmds.GET_FB_CALLBACK_REWARD_CFG]  = FbInvitePopu.onGetFbCallbackReward,
	[HttpModule.s_cmds.GET_FB_CALLBACK_LIST]    = FbInvitePopu.onGetFbCallbackList,
}

return FbInvitePopu
