local FeedbackPopu = class(require("popu.gameWindow"))
new(Image, "feedbackPopu.png")
require("pintu.feedback")

function FeedbackPopu:ctor(viewConfig, data)
--	ScrollBar.setDefaultImage("rank/scroller.png");
	--注册HTTP回调
	EventDispatcher.getInstance():register(HttpModule.s_event,self,self.onHttpRequestsCallBack);
	EventDispatcher.getInstance():register(Event.Call, self, self.onNativeCallBack);
	self.mServiceList={};
    self.feedbackId = data.feedbackId or FEEDBACK_APPID
    self.feedbackGame = data.feedbackGame or FEEDBACK_GAME
    self.chooseGame = data.chooseGame or (data.chooseGame == nil)
    self.mGameTitle = ''
end

function FeedbackPopu:dtor()
	--注销HTTP回调
	EventDispatcher.getInstance():unregister(HttpModule.s_event,self,self.onHttpRequestsCallBack);
	EventDispatcher.getInstance():unregister(Event.Call, self, self.onNativeCallBack);
end


function FeedbackPopu:initView(data)
	local backBtn = self:findChildByName("btn_close");
	backBtn:setOnClick(self, function ( self )
		-- body
		self:dismiss(false, false, WindowStyle.POPUP);
	end);

	backBtn:enableAnim(false);

	self.mGameTitle = ""
	self:findChildByName("text_QAtitle"):setText(STR_MY_QUESTION);
	self:findChildByName("text_upload"):setText(STR_UPLOAD_PIC);
    self:findChildByName("text_thankyou"):setText(STR_FEEDBACK_THANKYOU)

	--self:findChildByName("btn_confirm"):setOnClick(self, self.onClickSendBtn);
	self:findChildByName("btn_confirm"):setOnClick(self, function()
        app:postFrontStaticstics('clickFeedBackConfirmBtn')
        local question 	= self.mEtQuestion:getText();
	    local len = string.len(question);
	    if len < 20 then
		    AlarmTip.play(STR_FEEDBACK_MIN_LEN);
		    return ;
	    end
	    if len > 1000 then
		    AlarmTip.play(STR_FEEDBACK_MAX_LEN);
		    return ;
	    end
        if self.chooseGame then
		    self:showChooseGame()
        else
            self:onClickSendBtn()
        end
        --self:changeTextColor()
	end)

	self:findChildByName("btn_upload"):setOnClick(self, function ( self )
		-- body
		self.m_uploadFeedbackFile = "";
		NativeEvent.getInstance():pickPhoto('feedback',"feedbackImage/","/user/images/",nil,"feedback");
        --self:changeTitleColor()
	end);

	--初始化输入
	self.mEtQuestion = self:findChildByName("et_question");
    self.mEtQuestion:setColor(0x6d, 0x41, 0x2B)

	self.mEtQuestion:setHintText(STR_FEEDBACK_INPUT_HINT);

	local param_post = {
							appid 	 = self.feedbackId,
    						ftype 	 = FEEDBACK_FTYPE,
    						game 	 = self.feedbackGame,
    						mid 	 = MyUserData:getId(),
    						username = MyUserData:getNick(),
						};

	HttpModule.getInstance():execute(HttpModule.s_cmds.GetFeedbackList, param_post, false, true);

	-- self.mTextTip = self:findChildByName("text_tips")


	--上传图片
	self.m_uploadFeedbackImg = new(Mask, feedback_map["feedback.photo_mask.png"], feedback_map["feedback.photo_mask.png"]);--feedback/photo.png
	self:findChildByName("view_photo"):addChild(self.m_uploadFeedbackImg);
    self.m_uploadFeedbackImg:setAlign(kAlignCenter);
	self.m_uploadFeedbackImg:setVisible(false);
	self.m_uploadFeedbackFile = "";

	local viewChoose = self:findChildByName("img_chooseBg")
    --viewChoose:findChildByName("text_chooseSend"):setText(STR_FEEDBACK_SEND)
    viewChoose:findChildByName("text_chooseGame"):setText(STR_FEEDBACK_CHOOSEGAME)
	viewChoose:findChildByName("btn_chooseClose"):setOnClick(self, function()
		viewChoose:setVisible(false)
        self:findChildByName("img_popuBg"):setVisible(true)
	end)
end

----------------------------------------------------------------------------------
--ui action 
----------------------------------------------------------------------------------
function FeedbackPopu:onClickSendBtn()

    self:findChildByName("img_popuBg"):setVisible(true)
    self:findChildByName('img_chooseBg'):setVisible(false)

	local question 	= self.mEtQuestion:getText();

	self:sendFeedbackMessage(question, "");
end
----------------------------------------------------------------------------------
--ui update
----------------------------------------------------------------------------------
function FeedbackPopu:updateFeedbackList()
	-- body
	local feedbackScv = self:findChildByName("sc_feedback");
	--设置滚动条
	feedbackScv:setScrollBarWidth(8);
	feedbackScv:removeAllChildren();
	
	local listViewInfoW, listViewInfoH = feedbackScv:getSize();

	local x = 0;
	local y = 0;

	for i = #self.mServiceList, 1, -1 do

		local service = self.mServiceList[i];

		if  service.question then 
			if string.len(service.question) > 0 then
				local n = new(require("popu.lobby.item.feedbackItem"), listViewInfoW, srcollViewInfoH, service, self, self.updateFeedbackScrollView, self, self.sendFeedbackSolve, self, self.sendFeedbackVote);
				n:setPos(x, y);
				feedbackScv:addChild(n);
				local w, h = n:getSize();
				y = y + h + 10;
			end
		end
	end
end

function FeedbackPopu:updateFeedbackScrollView()
	-- body
	local feedbackScv = self:findChildByName("sc_feedback");
	local child = feedbackScv:getChildren();
	feedbackScv.m_nodeH = 0;

	local curx  = 0;
	local cury 	= 0;

	for i = 1, #child do
		child[i]:setPos(curx, cury);
		local x, y = child[i]:getUnalignPos();
		local w, h = child[i]:getSize();

		feedbackScv.m_nodeH = (feedbackScv.m_nodeH > y + h) and feedbackScv.m_nodeH or (y + h);

		cury = cury + h;
	end

	ScrollView.update(feedbackScv);
end

----------------------------------------------------------------------------------
--http send
----------------------------------------------------------------------------------

--发送 反馈消息
function FeedbackPopu:sendFeedbackMessage(question, contact)
	if MyUserData:getId() <= 0 then
		AlarmTip.play(STR_FEEDBACK_LOGIN);
		return;
	end
	
	if self.mLastQuestion == question then
		AlarmTip.play(STR_FEEDBACK_ALREADY);
		return;
	end

	self.mLastQuestion = question;
	
	question = GameString.convert2UTF8(question);
	
	local param_post = {
							appid 	 = self.feedbackId,
    						ftype 	 = FEEDBACK_FTYPE,
    						game 	 = self.feedbackGame,
    						title 	 = self.mGameTitle,
    						fwords 	 = question,
    						fcontact = contact,
    						mid 	 = MyUserData:getId(),
    						username = MyUserData:getNick(),
						};

    app:postFrontStaticstics("clickFeedBackGameType"..tostring(self.mGameId))
	HttpModule.getInstance():execute(HttpModule.s_cmds.SendFeedback, param_post, false, true);

end

--反馈的机型列表
function FeedbackPopu:getFcontact()
	-- local tempFeedList = CreatingViewUsingData.helpView.feedBack.feedList;
	-- local api = PlatformFactory.curPlatform:getPlatformAPI();
	-- local loginType = PlatformFactory.curPlatform:getCurrentUserType();
	-- local fcontact = kNullStringStr;
	-- fcontact = fcontact .. tempFeedList.loginType .. (loginType or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.model_name .. (GameConstant.model_name or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.macAddress .. (GameConstant.macAddress or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.version .. (GameConstant.Version or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.device;
	-- fcontact = fcontact .. tempFeedList.net .. (GameConstant.net or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.ip .. (getPhoneIP() or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.isSdCard .. (GameConstant.isSdCard or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.platformType .. (GameConstant.platformType or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.api .. (GameConstant.api or kNullStringStr);
	-- fcontact = fcontact .. tempFeedList.endingType;
	-- return fcontact;
end

--发送反馈图片
function FeedbackPopu:sendFeedbackImg(fileName, fid,basePath,folder)

	if fileName == "" then
		return ;
	end

	local param_post = {
							param = {
								appid 	 = self.feedbackId,
	    						ftype 	 = FEEDBACK_IMG_FTYPE,
	    						game 	 = self.feedbackGame,
	    						title 	 = self.mGameTitle,
	    						fid 	 = fid,
	    						pfile 	 = fileName,
							},
							method 	 = 'Feedback.mSendFeedBackPicture',
						}
	
	NativeEvent.getInstance():uploadFeedbackImage('http://feedback.kx88.net/api/api.php', fileName, param_post,basePath,folder);					
end
--是否 解决
function FeedbackPopu:sendFeedbackSolve(fid, bSolve )
	--发送请求

	local param_post = {
							appid 	 = self.feedbackId,
    						ftype 	 = FEEDBACK_FTYPE,
    						game 	 = self.feedbackGame,
    						title 	 = self.mGameTitle,
    						fid 	 = fid;
    						solved 	 = bSolve and "1" or "0"; 
						};

	HttpModule.getInstance():execute(HttpModule.s_cmds.SolveFeedback, param_post, false, true);
    
end
--满意度
function FeedbackPopu:sendFeedbackVote(fid, vote )
	--发送请求
	local param_post = {
							appid 	 = self.feedbackId,
    						ftype 	 = FEEDBACK_FTYPE,
    						game 	 = self.feedbackGame,
    						title 	 = self.mGameTitle,
    						fid 	 = fid;
    						score 	 = vote;
						};

	HttpModule.getInstance():execute(HttpModule.s_cmds.VoteFeedback, param_post, false, true);
    
end
----------------------------------------------------------------------------------
--http callback
----------------------------------------------------------------------------------
function FeedbackPopu:onHttpRequestsCallBack(command, ...)
	if FeedbackPopu.httpRequestsCallBackFuncMap[command] then
     	FeedbackPopu.httpRequestsCallBackFuncMap[command](self,...)
	end
end 


--发送反馈回调
function FeedbackPopu:sendFeedbackCallBack(isSuccess, data)

	if not isSuccess or not data or not data.ret then
	    return;
	end
	if isSuccess then

		self.mFid = data.ret.fid or 0;
		if self.mFid == 0 then
			self.mLastQuestion = "";
			AlarmTip.play(STR_FEEDBACK_FAILD);
			return;
		end
		--如果有图片开始上传图片
		 self:sendFeedbackImg(self.m_uploadFeedbackFile, self.mFid,self.m_uploadFeedbackBasePath,self.m_uploadFeedbackfolder);
		

		AlarmTip.play(STR_FEEDBACK_SUC);
		self.mEtQuestion:setText("");
		self.mEtQuestion:setHintText(STR_FEEDBACK_INPUT_HINT);

		local service = {};
		service.question = self.mLastQuestion;
		self.mServiceList[#self.mServiceList + 1] = service;

		--更新反馈列表
		self:updateFeedbackList();

		-- self.mTextTip:setVisible(false);
	
	end
end

--请求反馈列表回调
function FeedbackPopu:requsetFeedbackListCallBack (isSuccess, data )

	if not isSuccess or not data or not data.ret then
	    return;
	end

	if isSuccess then
		local feedbackCount = tonumber(#data.ret);
		if feedbackCount > 0 then
			for k, v in pairs(data.ret) do
				local service = {};
				service.id 		 = v.id or "";
				service.question = v.msgtitle or "";
				service.answer	 = v.rptitle or "";
				service.votescore= v.votescore or "";
				service.readed	 = v.readed or "";
				self.mServiceList[#self.mServiceList + 1] = service;
			end

			self:updateFeedbackList();
		else
			-- self.mTextTip:setVisible(true);
		end
	end
end


function FeedbackPopu:SolveFeedbackCallBack(isSuccess, data )
	
end

function FeedbackPopu:VoteFeedbackCallBack(isSuccess, data )

end

--native callback
function FeedbackPopu:onNativeCallBack(key, result)
	if key == kPickPhoto then
		if key and result then
			if NativeEvent.s_platform == kPlatformIOS then
				local isSucc = result.isSucc:get_value()
				local fromPhoto = result.fromPhoto:get_value()
				local imgName = result.imgName:get_value()
				local folder = result.folder:get_value()
				local basePath = result.basePath:get_value()
				local tag = result.tag:get_value()
				if isSucc == "true" and tag == "feedback" then
					basePath = basePath or ""  -- 引擎已经包含该搜索路径，暂时用不上
					folder = folder or ""
					imgName = imgName or ""
					local fname = folder .. imgName

					self.m_uploadFeedbackImg:setFile(fname);
					self.m_uploadFeedbackImg:setVisible(true);
					--upload image 
					self.m_uploadFeedbackFile = imgName;
					self.m_uploadFeedbackBasePath = basePath
					self.m_uploadFeedbackfolder = folder


				end




			else
				self.m_uploadFeedbackImg:setFile(result.name:get_value());
				self.m_uploadFeedbackImg:setVisible(true);
				--upload image 
				self.m_uploadFeedbackFile = result.name:get_value();


			end
		else
			AlarmTip.play(STR_SAVE_PIC_FAILD);
		end
	elseif key == kUploadFeedbackImage then
		if key and result then
			AlarmTip.play(STR_UPLOAD_PIC_SUC);
			self.m_uploadFeedbackFile = "";
			self.m_uploadFeedbackImg:setFile(feedback_map["feedback.photo_mask.png"]);
			self.m_uploadFeedbackImg:setVisible(false);
		else
			AlarmTip.play(STR_UPLOAD_PIC_FAILD);
		end
		
	end

end

function FeedbackPopu:dismiss(...)
    return FeedbackPopu.super.dismiss(self, ...)
end

function FeedbackPopu:showChooseGame()

    self.mGameId = nil
    self:findChildByName("img_popuBg"):setVisible(false)
    local viewChoose = self:findChildByName('img_chooseBg')
    viewChoose:setVisible(true)

    local SelectItem = require('popu.lobby.item.selectItem')
    

    local gameList = viewChoose:findChildByName('sv_chooseGameList')
    gameList:setDirection(kVertical)
    gameList:setScrollBarWidth(0)
    gameList:removeAllChildren()
    local wList, hList = gameList:getSize()
    local wInterval = math.floor(wList / 3)

    --local gameName = {[1002] = STR_APP_DICE, [1003] = STR_APP_H3, [1004] = STR_APP_MAKHOS, [1005] = "MIXED_TEN", [1006] = "KS", [666] = "OTHER"}

    local curRowNum = 0
    local curColumnNum = 0
    local allSelectItem = {}
    
    local originalGameId = app:getGameIds()
    local gameOptions = {}
    for i = 1, #originalGameId do
        if originalGameId[i] > 0 then
            local curGame = app:getGame(originalGameId[i])
            if curGame then
                local option = {}
                option.id = originalGameId[i]
                option.icon = curGame:getIconFile()
                option.name = curGame:getName()
                table.insert(gameOptions, option)
            end
        end
    end
    local otherOption = {id = 666, icon = feedback_map["feedback.game_666.png"], name = STR_OTHER}
    table.insert(gameOptions, otherOption)

    for i = 1, #gameOptions do
        local gameSelectItem = new(SelectItem, gameOptions[i].icon, gameOptions[i].name)
        local wItem, hItem = gameSelectItem:getSize()
	        gameSelectItem:setPos(curColumnNum * wInterval, curRowNum * (hItem + 15))
	        curColumnNum = curColumnNum + 1
	        if curColumnNum == 3 then
	    	    curRowNum = curRowNum + 1
	    	    curColumnNum = 0
	        end
	        allSelectItem[i] = gameSelectItem
            gameList:addChild(gameSelectItem)
    end

    for i = 1, #gameOptions do
        if allSelectItem[i] then
	        allSelectItem[i]:setOnClick(self, function()
	    	    for j = 1, #gameOptions do
	    		    allSelectItem[j]:setIsChosen(false)
	    	    end
	    	    allSelectItem[i]:setIsChosen(true)
                self.mGameTitle = allSelectItem[i]:getItemTitle()
                self.mGameId = gameOptions[i].id
	        end)
        end
    end

    viewChoose:findChildByName('btn_chooseSend'):setOnClick(self, function()
        app:postFrontStaticstics("clickFeedBackSendBtn")
        if self.mGameTitle ~= '' then
            self:onClickSendBtn()
        else
            AlarmTip.play(STR_FEEDBACK_CHOOSE_FIRST)
        end
     end)

end

function FeedbackPopu:changeTextColor()
    local textInput = self:findChildByName("et_question")
    local strColor = textInput:getText()
    local r, g, b = strColor:match("(%x%x)(%x%x)(%x%x)")
    if r and g and b then
        textInput:setColor(tonumber("0x"..r), tonumber("0x"..g), tonumber("0x"..b))
    end
end

function FeedbackPopu:changeTitleColor()
    local textInput = self:findChildByName("et_question")
    local strColor = textInput:getText()
    local r, g, b = strColor:match("(%x%x)(%x%x)(%x%x)")
    if r and g and b then
        self:findChildByName("text_thankyou"):setColor(tonumber("0x"..r), tonumber("0x"..g), tonumber("0x"..b))
    end
end

--回调函数映射表

FeedbackPopu.httpRequestsCallBackFuncMap = {
	[HttpModule.s_cmds.GetFeedbackList] = FeedbackPopu.requsetFeedbackListCallBack,
	[HttpModule.s_cmds.SendFeedback] 	= FeedbackPopu.sendFeedbackCallBack,
	[HttpModule.s_cmds.SolveFeedback] 	= FeedbackPopu.SolveFeedbackCallBack,
	[HttpModule.s_cmds.VoteFeedback] 	= FeedbackPopu.VoteFeedbackCallBack,
	
}

return FeedbackPopu