--require(ViewPath .. "lobbyPropItem")
require(ViewPath .. "gameinfoItem")
require("pintu.gift")

local FriendInfoPopu = class(require("popu.gameWindow"))

local printInfo, printError = overridePrint("FriendInfoPopu")

function FriendInfoPopu:ctor(viewConfig, data)
	EventDispatcher.getInstance():register(Event.Call, self, self.onNativeCallBack);
	EventDispatcher.getInstance():register(Event.Message, self, self.onMessageCallDone)
    
    self.playerInfo = data.playerInfo
    self.playerInfoCache = data.cache
    --如果之前已经点开查看过该玩家信息，那么就存在缓存里，不需要再请求
    for k, v in pairs(self.playerInfoCache) do
        if v:getId() == tonumber(self.playerInfo:getId()) then
            self.cacheIndex = k
            break;
        end
    end
    
    --data has exist in cache,show data first, after get data then refresh
    if self.cacheIndex then
        self:initViewAfterGetData(self.playerInfoCache[self.cacheIndex])
    else
    --不在缓存里，需要重新请求获取信息,初始化需要显示的游戏胜率和金钱信息
        local originalGameId = app:getGameIds()
        local gameInfo = {}
        for i = 1, #originalGameId do
            if originalGameId[i] > 0 then
                gameInfo[originalGameId[i]] = {}
                gameInfo[originalGameId[i]].winTimes = 0
                gameInfo[originalGameId[i]].loseTimes = 0
                gameInfo[originalGameId[i]].maxWinMoney = 0
            end
        end
        HttpModule.getInstance():execute(HttpModule.s_cmds.GET_OTHER_FORM_FRIEND, {fid = self.playerInfo:getId(), gameid = 1002}, false, false)
        
        --利用旧数据初始化个人信息页面
        local playerInfo = setProxy(new(require("data.playerInfoData")))
	    --playerInfo:init(self.playerInfo)
        playerInfo:setId(self.playerInfo:getId())
        playerInfo:setName(self.playerInfo:getName())
        playerInfo:setMoney(self.playerInfo:getMoney())
        playerInfo:setExp(self.playerInfo:getExp())
        playerInfo:setLevel(self.playerInfo:getLevel())
        playerInfo:setSex(self.playerInfo:getSex())
        playerInfo:setHeadUrl(self.playerInfo:getHeadUrl())
        playerInfo:setGiftId(self.playerInfo:getGiftId() and {self.playerInfo:getGiftId()[1], self.playerInfo:getGiftId()[2]})
        playerInfo:setFrom(data.from)
        playerInfo:setWinRate(gameInfo)
        table.insert(self.playerInfoCache, playerInfo)
        self.cacheIndex = #self.playerInfoCache
        self:initViewAfterGetData(playerInfo)
    end
end

function FriendInfoPopu:dtor()
	EventDispatcher.getInstance():unregister(Event.Call, self, self.onNativeCallBack);
	EventDispatcher.getInstance():unregister(Event.Message, self, self.onMessageCallDone)
end

function FriendInfoPopu:initView(data)
    self:findChildByName("btn_close"):setOnClick(self, function ( self )
		-- body
		self:dismiss();
	end);
    
end

function FriendInfoPopu:initViewAfterGetData(data)
    --初始化按钮功能，不同好友页面打开按钮功能不一样
    local from = data.from
    local btnDoThing = self:findChildByName("btn_dosomething")
    local textBtn = btnDoThing:findChildByName("text_button")
	if from == 'friend' or from == 'gift' then
        --删除好友
        textBtn:setText(STR_FRIEND_DELETE)
		btnDoThing:setOnClick(self, function (self)
			-- body
			HttpModule.getInstance():execute(HttpModule.s_cmds.FRIEND_DELETE,{fid = data:getId()}, true, false)
			self:dismiss()
		end)
		
	elseif from == 'apply' then
        --同意好友申请
		btnDoThing:setFile(popu_map['popu.public.btn_green.png']  or "")
        textBtn:setText(STR_FRIEND_APPLY_ACCEPT)
		btnDoThing:setOnClick(self, function (self)
			-- body
			HttpModule.getInstance():execute(HttpModule.s_cmds.FRIEND_ACCEPT,{fid = data:getId(), isagree = 1}, true, false)
			self:dismiss()
		end)
	elseif from == 'search' then
        --添加好友
		btnDoThing:setFile(popu_map['popu.public.btn_green.png']  or "")
        textBtn:setText(STR_FRIEND_ADD)
		btnDoThing:setOnClick(self, function (self)
			-- body
			HttpModule.getInstance():execute(HttpModule.s_cmds.ADD_FRIEND,{isroom = 0, fid = data:getId(), content = base64.encode(json.encode({
			id 	 = MyUserData:getId(),
			name = MyUserData:getNick()
			}))}, true, false)
			
			self:dismiss()
		end)
	end
    
    --初始化游戏胜率信息列表
    local svGame = self:findChildByName("sv_game")
    svGame:removeAllChildren()
    svGame:setDirection(kVertical)
    svGame:setScrollBarWidth(0)
	local height = 0
    local gameIds = app:getGameIds()
    local winRate = data:getWinRate()
    for i = 1, #gameIds do
        local curWinRate = winRate[gameIds[i]]
        if curWinRate then
            local curGame = app:getGame(gameIds[i])
            if curGame then
                local item = SceneLoader.load(gameinfoItem)
                item:setName(tostring(gameIds[i]))
                item:findChildByName('game1_text'):setText(curGame:getName())
                item:findChildByName('logo1'):setFile(curGame:getIconFile())
                item:setPos(0, height)
                local w, h = item:getSize()
                height = height + h
                svGame:addChild(item)
                --设置按钮点击展开或缩小事件
                local hideBg = item:findChildByName("game_bg1")
                local showBg = item:findChildByName("game_detail")
                item:findChildByName("btn_detail"):setOnClick(self, function(self)
                    if showBg:getVisible() then
                        --隐藏详细信息
                        showBg:setVisible(false)
                        hideBg:setVisible(true)
                        item:setSize(hideBg:getSize())
                    else
                        --展开详细信息
                        showBg:setVisible(true)
                        hideBg:setVisible(false)
                        item:setSize(showBg:getSize())
                    end
                    svGame:reposition()
                    svGame:scrollItemToView(item)
                    svGame:setSize(svGame:getSize())
                end)
            end
        end
    end
    UIEx.bind(self, data, "money", function(value)
        self:findChildByName("text_coin"):setText(value)
    end)
    UIEx.bind(self, data, "winRate", function(value)

        local children = svGame:getChildren()
        for i = 1, #gameIds do
            local curWinRate = value[gameIds[i]]
            local child = svGame:findChildByName(tostring(gameIds[i]))
            if curWinRate and child then
                self:refreshGameInfo(child, curWinRate)
            end
        end
    end)
    data:setWinRate(data:getWinRate())
    local viewPlayer = self:findChildByName("view_common")

    UIEx.bind(self, data, "headName", function(value)
        local headView = viewPlayer:findChildByName("view_portrait")
        headView:removeAllChildren()
	    local width, height = headView:getSize()
	    local headImg = new(Mask, value, popu_map["popu.public.head_mask.png"]  or "");
	    headImg:setSize(width, height)
	    headView:addChild(headImg)
    end)
    data:setHeadName(data:getHeadName())

    --绑定性别,性别放在头像后面设置，因为如果此时headname的图片还未下载下来，setsex的时候会显示默认头像
    viewPlayer:findChildByName("img_male"):setVisible(data:getSex() == 0)
    viewPlayer:findChildByName("img_female"):setVisible(data:getSex() ~= 0)

    viewPlayer:findChildByName("text_nick"):setText(data:getName());
    viewPlayer:findChildByName("text_uid"):setText(data:getId());
    viewPlayer:findChildByName("text_coin"):setText(data:getMoney());
    self:setUserLevel(data:getLevel(), data:getExp())

    local btnGift = self:findChildByName("btn_gift")
    btnGift:setOnClick(self, function(self)
        --赠送礼物，需要广播通知收礼物的人和自己，广播自己是为了刷新自己打开的窗口里的玩家礼物信息
        WindowManager:showWindow(WindowTag.GiftStorePopu, {from = "otherInfo", sendId = {data:getId()}, broadcastId = {MyUserData:getId(), data:getId()}}, WindowStyle.POPUP)
    end)
    UIEx.bind(self, data, "giftId", function(value)
        local giftList = MyUserData:getGiftList()
        if value and value[1] and value[2] and giftList then
            local gift = giftList[value[1]] and giftList[value[1]][value[2]]
            if gift then
                btnGift:setFile(gift:getImgName())
                return
            end
        end
        btnGift:setFile(gift_map["gift.icon_gift.png"])
    end)
    data:setGiftId(data:getGiftId())
end


function FriendInfoPopu:refreshGameInfo(item, data)
    --选项颜色和数值颜色
    local defaultSizeAndColor = {20, 0x5A, 0x32, 0x1D}
    local specialSizeAndColor = {20, 0xFB, 0xE2, 0x69}
    --刷新的时候重新new 的Text，先删掉
    item:findChildByName("view_win_count"):removeAllChildren()
    item:findChildByName("view_win_rate"):removeAllChildren()
    item:findChildByName("view_max_pot"):removeAllChildren()
	local winTimes = data.winTimes or 0
	local losetimes = data.loseTimes or 0

        
    ToolKit.formatRichText(item:findChildByName("view_win_count"), STR_USER_WINCOUNT, tostring(winTimes + losetimes), defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
                    
    if winTimes == 0 and losetimes == 0 then
        ToolKit.formatRichText(item:findChildByName("view_win_rate"), STR_USER_WINRATE, "0%", defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
	else
		local rate = math.ceil((winTimes/(winTimes + losetimes))*100)
        ToolKit.formatRichText(item:findChildByName("view_win_rate"), STR_USER_WINRATE, rate .. '%', defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
	end
    ToolKit.formatRichText(item:findChildByName("view_max_pot"), STR_USER_WIN_MAX_COINS, data.maxWinMoney or 0, defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
end

--设置等级
function FriendInfoPopu:setUserLevel( lv , originalExp)
	-- body
    local viewLevel = self:findChildByName("view_level")
	viewLevel:findChildByName("level_text"):setText("Lv." .. lv);
	--userData:getNeedExp() > 0 and userData:getCurExp() * 100 / userData:getNeedExp() or 0
	local percent = 0
    local exp = tonumber(originalExp)
	if lv then
		local index = tonumber(lv)
		if index > 0 and index < 60 then
			local x1 = userLevelExp[index].x1 
			local x2 = userLevelExp[index].x2
			if exp > x1 then
				percent = math.ceil(((exp - x1)/(x2 - x1))*100)
				if percent >= 100 then
					percent = 99
				end
			end
		elseif index == 60 then
			percent = 99
		end
	end		

	viewLevel:findChildByName('level_percent'):setText(percent .. '%')
    local maxWidth, height = self:findChildByName("level_bg"):getSize()
    local width = (maxWidth - height) * percent/100
    local progress = viewLevel:findChildByName("level_progress");
	progress:setSize(height + width, height);
	
end

function FriendInfoPopu:onOtherFromFriend(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
		local playerInfo = self.playerInfoCache[#self.playerInfoCache]
        playerInfo:init(data.data)
        --由于传进来的self.playerInfo数据里头金币不是最新的，点击查看头像后把金币重新刷新一遍
        self.playerInfo:setMoney(playerInfo:getMoney())
	else

	end
end

function FriendInfoPopu:onMessageCallDone(key, data)
    if key == "giftSendBroadcast" then
printInfo("FriendInfoPopu:onMessageCallDone")
        local receiver = data.receiver
        local giftId = data.gift
        for i = 1, #receiver do
            --收礼物的人正好是弹窗里的玩家，更新他的头像
            if receiver[i] == tonumber(self.playerInfo:getId()) then
                self.playerInfoCache[self.cacheIndex]:setGiftId(giftId)
--修改原先数据，用于好友列表刷新礼物状态
                self.playerInfo:setGiftId(giftId)
                break;
            end
        end
    end
end

--[[
	通用的（大厅）协议
]]
FriendInfoPopu.s_severCmdEventFuncMap = {
  [HttpModule.s_cmds.GET_OTHER_FORM_FRIEND]     = FriendInfoPopu.onOtherFromFriend,
}

return FriendInfoPopu