require(ViewPath .. "lobbyFriendItem")
require(ViewPath .. "lobbyApplyItem")
require(ViewPath .. "lobbySearchItem")
require(ViewPath .. "lobbyFriendGiftItem")

require('ui.ex.ScrollViewEx')
local FriendPopu = class(require("popu.gameWindow"))
new(Image, "friend.png")
require("pintu.friend")

function FriendPopu:ctor()
    self.playerInfoCache = {}
	EventDispatcher.getInstance():register(HttpModule.s_event, self, self.onHttp);
end

function FriendPopu:onHidenEnd(isOtherDismiss)
  	self:writeGiftListToDict()
	self.super.onHidenEnd(self, isOtherDismiss)
end

function FriendPopu:dtor()
  EventDispatcher.getInstance():unregister(HttpModule.s_event, self, self.onHttp);
end

function FriendPopu:initView(data)
	--初始化数据
    self.jumpTo = data.to
    self.mPerLoad 	 	= 10
    self.mFriendList 	= nil
    self.mLoadFriend 	= 1
    self.mApplyList 	= nil
    self.mLoadApply 	= 1
    self.mGiftList 		= nil
    self.mLoadGift 		= 1
    self.mSearchList 	= nil
    local GotData 		= {}
    addProperty(GotData, "got", 0)
    addProperty(GotData, "max", 0)
    self.mGotData = setProxy(new(GotData))
    
    --关闭
    self:findChildByName("btn_close"):setOnClick(self, function ( self )
	    -- body
	    self:dismiss();
    end);
    --好友列表

    local viewFriendList = self:findChildByName("view_friendList")
    local w, h = viewFriendList:getSize()

    self.mFriendSc 	= new(ScrollViewEx, 0, 0, w, h, false);

    self.mFriendSc:setOnReachBottom(self, function ( self )
	    -- body
	    if self.mFriendList and self.mLoadFriend < #self.mFriendList then
		    self:loadFriend(self.mLoadFriend);
	    end

    end);
    viewFriendList:addChild(self.mFriendSc);
    --好友列表中的邀请
    local viewFriend = self:findChildByName("view_friend")
    local btnInvite = viewFriend:findChildByName('btn_invite')
    btnInvite:enableAnim(false)
    btnInvite:setOnClick(self, function (self)
	    -- body
	    self:dismiss(true)
	    WindowManager:showWindow(WindowTag.FbInvitePopu, {}, WindowStyle.NORMAL)
    end)
    btnInvite:findChildByName("text_tips1"):setText(STR_FRIEND_INVITE_TIPS)
    btnInvite:findChildByName("text_tips2"):setText(STR_INVITE_FIREND)
 
    --申请列表
    local viewApply = self:findChildByName("view_apply")
    local w, h = viewApply:getSize()

    self.mApplySc 	= new(ScrollViewEx, 0, 0, w, h, false);

    self.mApplySc:setOnReachBottom(self, function ( self )
	    -- body
	    if self.mApplyList and self.mLoadApply < #self.mApplyList then
		    self:loadApply(self.mLoadApply);
	    end
    end);
    self.mApplySc:setPos(0, 0);
    viewApply:addChild(self.mApplySc);

    --礼物列表
    self.mGiftList = nil
    self.mLoadGift = 1

    local viewGift = self:findChildByName("view_gift")
    local w, h = viewGift:getSize()

    self.mGiftSc 	= new(ScrollViewEx, 0, 0, w, h - 96, false);

    self.mGiftSc:setOnReachBottom(self, function ( self )
	    -- body
	    if self.mGiftList and self.mLoadGift < #self.mGiftList then
		    self:loadGift(self.mLoadGift);
	    end

    end);
    self.mGiftSc:setPos(0, 0);
    viewGift:addChild(self.mGiftSc);

    viewGift:findChildByName("btn_getall"):findChildByName("text_button"):setText(STR_FRIEND_GET_ALL_GIFT)
    viewGift:findChildByName('btn_getall'):setOnClick(self, function (self)
	    -- body
	    local giftList = self.mGiftList
		
	    local giftArr = {}

	    if giftList then
		    for i = 1, #giftList do
			    local gift = giftList[i]
			    if gift:getVisible() then
				    if gift:getGift() then
					    giftArr[gift:getGiftid()] = gift:getId()
				    end
			    end
		    end
	    end
        self:execHttpCmd(HttpModule.s_cmds.FETCH_GIFT,{gift = giftArr }, false, true, self:findChildByName("view_gift"))
        --self:playLoading()
	    --HttpModule.getInstance():execute(HttpModule.s_cmds.FETCH_GIFT,{gift = giftArr }, true, false)
		
    end)
	
    --今天已领取
    UIEx.bind(self, self.mGotData, "got", function(value)
	    local got = value
	    local max = self.mGotData:getMax()
	    local tip = string.format('%s %s/%s', STR_FRIEND_GETTABLE, got, max)
        self:findChildByName("view_gift"):findChildByName('text_lefttip'):setText(tip)
        local btn = self:findChildByName("view_gift"):findChildByName('btn_getall')
        if got < max and (self.mGiftList and #self.mGiftList > 0)then
    	    local enable = false
    	    if self.mGiftList then
			    for i = 1, #self.mGiftList do
				    local gift = self.mGiftList[i]
				    if gift:getGift() then 
					    enable = gift:getGift()
					    break
				    end
			    end
    	    end

    	    if enable then
    		    -- btn:setFile(friend_map['friend.btn_getall.png'])
    		    btn:setGray(false)
                btn:findChildByName("text_button"):setVisible(false)
    		    btn:setEnable(true)
    	    else
    		    -- btn:setFile(friend_map['friend.btn_getall1.png'])
    		    btn:setGray(true)
                btn:findChildByName("text_button"):setVisible(false)
    		    btn:setEnable(false)
    	    end

        else
    	    -- btn:setFile(friend_map['friend.btn_getall1.png'])
    	    btn:setGray(true)
            btn:findChildByName("text_button"):setVisible(false)
    	    btn:setEnable(false)
    	    --礼物列表不可点
    --  		if self.mGiftList then
		    -- 	for i = 1, #self.mGiftList do
		    -- 		local gift = self.mGiftList[i]
		    -- 		if gift:getGift() then gift:setGift(false) end
		    -- 	end
		    -- end
        end
    end)

    self.mGotData:setMax(0)
    self.mGotData:setGot(0)


    --查找好友
    self.mAddFriendView = self:findChildByName("view_middle"):findChildByName("view_addfriend")
    self.mAddFriendView:findChildByName('text_search'):setText(STR_FRIEND_INPUT_TITLE .. ':')
    local etSearch = self.mAddFriendView:findChildByName('et_search')
    etSearch:setHintText(STR_FRIEND_HINT, 0xb2, 0xb2, 0xb2);
    etSearch:setOnTextChange(self, function ( self )
	    local id = etSearch:getText()
	    if string.len(id) > 12 then
		    etSearch:setText(string.sub(id, 1, 12));
	    end
    end);

    self.mAddFriendView:findChildByName('btn_search'):setOnClick(self, function (self)
	    -- body
        self:execHttpCmd(HttpModule.s_cmds.SEARCH_FRIEND,{userid = tonumber(etSearch:getText() or 0) or 0, gameid = 1002}, false, true, self:findChildByName("view_searchResult"))
    end)

    --查找结果
    local viewResult = self:findChildByName("view_searchResult")
    local w, h = viewResult:getSize()

    self.mSearchSc 	= new(ScrollViewEx, 0, 0, w, h, false);

    self.mSearchSc:setOnReachBottom(self, function ( self )
	    -- body
    end);
    self.mSearchSc:setPos(0, 0);
    viewResult:addChild(self.mSearchSc);

    self.mAddFriendView:findChildByName("text_facebooktip"):setText(STR_FRIEND_INVITE_WAY .. ':')


    --点击按钮切换显示页面
    --local tabName  = {"tab_friend", "tab_apply", "tab_gift", "tab_addfriend"}
    --local viewName = {"view_friend", "view_apply", "view_gift", "view_addfriend"}
    local viewButton = self:findChildByName("img_buttons")
    local tabButton = {viewButton:findChildByName("view_btnFriend"),
        viewButton:findChildByName("view_btnApply"),
        viewButton:findChildByName("view_btnGift"),
        viewButton:findChildByName("view_btnAddFriend"),
    }
    local viewAll = self:findChildByName("view_middle")
    local viewName = {
        viewAll:findChildByName("view_friend"),
        viewAll:findChildByName("view_apply"),
        viewAll:findChildByName("view_gift"),
        viewAll:findChildByName("view_addfriend"),
    }
    local clickFun = {self.onClickFriend, self.onClickApply, self.onClickGift, self.onClickAddFriend}

    for i = 1, #tabButton do
        local btnSelect = tabButton[i]:findChildByName("btn_unselect")
        btnSelect:setOnClick(self, function(self)
            --点击按钮后，切换成被选中的按钮，同时隐藏不被选中的
            for j = 1, #tabButton do
                tabButton[j]:findChildByName("btn_unselect"):setVisible(i ~= j)
                tabButton[j]:findChildByName("btn_select"):setVisible(i == j)
                viewName[j]:setVisible(false)
            end
            viewName[i]:setVisible(true)
            clickFun[i](self)
        end)
    end

    self:findChildByName('btn_facebook'):setOnClick(self, function ( self )
	    -- body
	    self:dismiss(true)
	    WindowManager:showWindow(WindowTag.FbInvitePopu, {}, WindowStyle.NORMAL)
		
    end)

    -- 是否有好友消息
    UIEx.bind(self, MyUserData, "unreadGigt", function(value)
        self.m_root:findChildByName("tab_gift"):removeAllChildren()
        if MyUserData:getUnreadGigt() > 0 then
		    if value then
			    local tip = new(Image, 'common/tips.png')
			    tip:setPos(2, 2)
			    tip:setAlign(kAlignTopRight)
			    self.m_root:findChildByName("tab_gift"):addChild(tip)
		    end
	    end
    end)
    UIEx.bind(self, MyUserData, "unreadApply", function(value)
        self.m_root:findChildByName("tab_apply"):removeAllChildren()
        if MyUserData:getUnreadApply() > 0 then
		    if value then
			    local tip = new(Image, 'common/tips.png')
			    tip:setPos(2, 2)
			    tip:setAlign(kAlignTopRight)
			    self.m_root:findChildByName("tab_apply"):addChild(tip)
		    end
	    end
    end)
    --是否有好友求助消息
    UIEx.bind(self, MyUserData, "unreadBankruptHelp", function(value)
        self.m_root:findChildByName("tab_friend"):removeAllChildren()
        if MyUserData:getUnreadBankruptHelp() > 0 then
		    if value then
			    local tip = new(Image, 'common/tips.png')
			    tip:setPos(2, 2)
			    tip:setAlign(kAlignTopRight)
			    self.m_root:findChildByName("tab_friend"):addChild(tip)
		    end
	    end
    end)
    MyUserData:setUnreadGigt(MyUserData:getUnreadGigt())
    MyUserData:setUnreadApply(MyUserData:getUnreadApply())
    MyUserData:setUnreadBankruptHelp(MyUserData:getUnreadBankruptHelp())


    self:findChildByName('view_friend'):findChildByName('text_noDataTip'):setText(STR_FRIEND_NO_FRIEND)
    self:findChildByName('view_apply'):findChildByName('text_noDataTip'):setText(STR_FRIEND_NO_APPLY)
    self:findChildByName('view_gift'):findChildByName('text_noDataTip'):setText(STR_FRIEND_NO_GIFT)

end

function FriendPopu:onShowEnd()
    local btn = self:findChildByName("view_btnFriend"):findChildByName("btn_unselect")
    if self.jumpTo == "gift" then
        btn = self:findChildByName("view_btnGift"):findChildByName("btn_unselect")
    elseif self.jumpTo == "apply" then
        btn = self:findChildByName("view_btnApply"):findChildByName("btn_unselect")
    elseif self.jumpTo == "search" then
        btn = self:findChildByName("view_btnAddFriend"):findChildByName("btn_unselect")
    end
    btn.m_eventCallback.func(btn.m_eventCallback.obj);
    self.super.onShowEnd(self)
end

function FriendPopu:writeGiftListToDict()
	-- body
	local saveInfo = {}
	if self.mGiftList then
		local time = os.time()
		for i = 1, #self.mGiftList do
			local friend = self.mGiftList[i] --setProxy(new(require("data.friendData")))
			--不保存 可以领取 的 ITEM
			printInfo('want save')
			if not friend:getGift() then
				printInfo('not gift' ..friend:getTime() )
				printInfo('not time' ..time )
				if time - friend:getTime() < 6 * 3600 then
					printInfo('yes time')
					table.insert(saveInfo, json.encode({
							fid = friend:getId(),
							roomid = friend:getRoomid(),
							gameid = friend:getGameid(),
							gameName = friend:getGameName(),
							name = friend:getName(),
							money = friend:getMoney(),
							exp = friend:getExp(),
							level = friend:getLevel(),
							isOnline = friend:getIsOnline(),
							mltime = friend:getMltime(),
							visible = friend:getVisible(),
							gift = friend:getGift(),
							canSendMoney = friend:getCanSendMoney(),
							giftid = friend:getGiftid(),
							lv = friend:getLv(),
							time = friend:getTime(),
						}))
				end
			end
		end
		table.insert(saveInfo, 1, json.encode({count = #saveInfo}))
	end

	--save
	ToolKit.setDict( 'FriendGift', saveInfo)
end

function FriendPopu:readGiftListFromDict()
	-- body
	local count = ToolKit.getDict('FriendGift', {'1'} )
	local countJson = count['1']
	if countJson then
		local data = json.decode(countJson)
		if data then 
			local count = data.count or 0
			local keys = {}
			for i = 1, count do
				table.insert(keys, tostring(i + 1))
			end
			local data = ToolKit.getDict('FriendGift', keys )
			local ret = {}
			local time = os.time()
			printInfo('friend.count'..count)
			for i = 1, count do
				local friend = json.decode(data[tostring(i + 1)])
				if time - friend.time < 6 * 3600 then
					printInfo('timetime yes')
					table.insert(ret, friend)
				end
			end
			return ret
		end
	end
end

function FriendPopu:getNameByGameId(gameId, time, gameName)
	-- body
	if gameId == -1 or gameId == 0 then
		return string.format('%s\n%s', STR_FRIEND_LAST_LOGIN, os.date("%Y-%m-%d", time))
	else
		return string.format('%s\n%s', gameName or '', STR_IN_GAME)
	end
end

function FriendPopu:onClickTab( index )
	-- body
	if index == 1 then
		self:onClickFriend()
	elseif index == 2 then
		self:onClickApply()
	elseif index == 3 then
		self:onClickGift()
	elseif index == 4 then
		self:onClickAddFriend()
	end
end

function FriendPopu:onClickFriend()
	if self.mFriendList then
		self:loadFriend(self.mLoadFriend)
	else
        self:execHttpCmd(HttpModule.s_cmds.GET_FRIENDS,{gameid = 1002}, false, true, self:findChildByName("view_friendList"))
        --self.loadingNode[self:findChildByName("view_friendList")].node:setPos(-100, 0)
        --self:playLoading()
		--HttpModule.getInstance():execute(HttpModule.s_cmds.GET_FRIENDS,{gameid = 1002}, true, false)
	end
    MyUserData:setUnreadBankruptHelp(0)
end

function FriendPopu:loadFriend(from)
	-- body
	--清空
	if from == 1 then
		self.mFriendSc:removeAllChildren()
	end
	local loaded = 0
	for i = from, #self.mFriendList do
		if loaded >= self.mPerLoad then break end
		loaded = loaded + 1
		local friend = self.mFriendList[i]

		local item = SceneLoader.load(lobbyFriendItem);
		--头像
		item:findChildByName('btn_head'):setOnClick(self, function ( self )
            WindowManager:showWindow(WindowTag.FriendInfoPopu, {from = "friend", playerInfo = friend, cache = self.playerInfoCache}, WindowStyle.POPUP)
		end)

        local btnSend = item:findChildByName("btn_sendcoin")
        btnSend:findChildByName("text_button"):setText(STR_FRIEND_GIFT_SEND)
		btnSend:setOnClick(self, function ( self )
			-- body
			local gameId = friend:getGameid()
			local roomid = friend:getRoomid()
            --跟随好友进房间
			if roomid > 0 then
				printInfo('gameId='..gameId)
				local game = app:getGame(gameId) --鱼虾蟹
				if game then
                    if friend:getLv() == 100 then
                        self:dismiss(true)
                        WindowManager:showWindow(WindowTag.PrivateRoomPopu, {}, WindowStyle.POPUP)
                        return
                    end
					local room = game:getRoomFromLevel(friend:getLv())
					if room then
                        room.tableId = friend:getRoomid() or 0
						game:enterRoom(States.Lobby, room, friend:getId(), friend:getName())
--                        --跟随好友进入好友房，发送统计
--                        if friend:getLv() == 100 then
--                            app:postFrontStaticstics("enterBuddyRoomFromFollow")
--                        end
					end
				else
					AlarmTip.play(STR_NOT_DOWNLOAD_RRIEND_GAME)
				end
			else
                --点击赠送好友礼物
				HttpModule.getInstance():execute(HttpModule.s_cmds.SEND_GIFT,{fid = friend:getId(), content = base64.encode(json.encode({
			        id   = MyUserData:getId(),
			        name = MyUserData:getNick()
			        }))}, false, false)
					friend:setCanSendMoney(0)
                    friend:setBankrupt(0)
			end
		end)

		UIEx.bind(self, friend, "canSendMoney", function(value)
			if value == 0 then
                --不可赠送，按钮变灰
				btnSend:setFile(popu_map['popu.public.btn_gray.png']  or "")
                local textBtn = btnSend:findChildByName("text_button")
                textBtn:setText(STR_FRIEND_SENT_GIFT, 0, 0, 0xBE, 0x6F, 0x42)
				btnSend:setEnable(false)
			end
		end)

		UIEx.bind(self, friend, "roomid", function(value)
			if value > 0 then
                --好友在游戏中，跟随好友进入房间
				btnSend:setFile(friend_map['friend.btn_follow.png'])
                local textBtn = btnSend:findChildByName("text_button")
                textBtn:setText(STR_FRIEND_FOLLOW_GAME, 0, 0, 0x81, 0x47, 0x40)
				btnSend:setEnable(true)
			end
		end)

		--是否可见
		UIEx.bind(self, friend, "visible", function(value)
			item:setVisible(value)
			self:loadFriend(self.mLoadFriend)
			self.mFriendSc:reposition()
		end)
        UIEx.bind(self, friend, "sex", function(value)
            item:findChildByName("img_male"):setVisible(tonumber(value) == 0)
            item:findChildByName("img_female"):setVisible(tonumber(value) ~= 0)
        end)
        local maxNameLen = item:findChildByName("view_nick"):getSize() - 40
        ToolKit.formatTextLength(friend:getName(), item:findChildByName("text_name"), maxNameLen)
--		item:findChildByName('text_name'):setText(ToolKit.formatNick(friend:getName(), 12))
		item:findChildByName('text_chip'):setText(friend:getMoney())
		item:findChildByName('text_game'):setText(self:getNameByGameId(friend:getGameid(), friend:getMltime(), friend:getGameName()))--

		-- 为头像绑定数据源
		UIEx.bind(self, friend, "headName", function(value)
			local head = new(Mask, value, friend_map["friend.head_mask.png"]);
			local w, h = item:findChildByName("btn_head"):getSize()
			head:setSize(w, h)
			head:setAlign(kAlignCenter)
			item:findChildByName("view_head"):addChild(head)
			friend:checkHeadAndDownload()
		end)
    
        --绑定破产图标
        UIEx.bind(self, friend, "bankrupt", function(value)
            --不可赠送，破产标志不显示
            if friend:getCanSendMoney() == 0 then
                item:findChildByName("img_bankrupt"):setVisible(false)
            else
                --为0表示没破产求助
                item:findChildByName("img_bankrupt"):setVisible(value ~= 0)
            end
        end)
        --绑定金币,点击弹窗显示详细信息后可能刷新
        UIEx.bind(self, friend, "money", function(value)
            item:findChildByName('text_chip'):setText(friend:getMoney())
        end)
		friend:setSex(friend:getSex());
		friend:setHeadUrl(friend:getHeadUrl());
		friend:setCanSendMoney(friend:getCanSendMoney())
		--friend:setGameid(friend:getGameid())
        friend:setBankrupt(friend:getBankrupt())
        friend:setRoomid(friend:getRoomid())
		local w, h = item:getSize()
		item:setPos(0, h * (i - 1))
		item:setAlign(kAlignTop)
		self.mFriendSc:addChild(item)
	end

	self.mLoadFriend = self.mLoadFriend + loaded

	local count = 0
	for k = 1, #self.mFriendList do
		if self.mFriendList[k]:getVisible() then
			count = count + 1
			break
		end
	end

	self:findChildByName('view_friend'):findChildByName('img_noData'):setVisible(count == 0)
end

function FriendPopu:onClickApply()

	if self.mApplyList then
		self:loadApply(self.mLoadApply)
	else
        self:execHttpCmd(HttpModule.s_cmds.GET_APPLY,{gameid = 1002}, false, true, self:findChildByName("view_apply"))
	end

	MyUserData:setUnreadApply(0)
end

function FriendPopu:loadApply(from)
	-- body
	--清空
	if from == 1 then
		self.mApplySc:removeAllChildren()
	end

	local loaded = 0
	for i = from, #self.mApplyList do
		if loaded >= self.mPerLoad then break end
		loaded = loaded + 1
		local apply = self.mApplyList[i]

		local item = SceneLoader.load(lobbyApplyItem);
        --预留图标的宽度
        local maxNameLen = item:findChildByName("view_nick"):getSize() - 40
        ToolKit.formatTextLength(apply:getName(), item:findChildByName("text_name"), maxNameLen)
--		item:findChildByName('text_name'):setText(ToolKit.formatNick(apply:getName(), 12))
		item:findChildByName('text_chip'):setText(apply:getMoney())
		--item:findChildByName('text_game'):setText(self:getNameByGameId(apply:getGameid(), apply:getMltime(), apply:getGameName()))

        local btnAccept = item:findChildByName("btn_accept")
        btnAccept:findChildByName("text_button"):setText(STR_FRIEND_APPLY_ACCEPT)
		btnAccept:setOnClick(self, function ( self )
			-- body
            self:execHttpCmd(HttpModule.s_cmds.FRIEND_ACCEPT,{fid = apply:getId(), isagree = 1}, false, true, self:findChildByName("view_apply"))
            --self:playLoading()
			--HttpModule.getInstance():execute(HttpModule.s_cmds.FRIEND_ACCEPT,{fid = apply:getId(), isagree = 1}, true, false)
		end)

		local btnRefuse = item:findChildByName('btn_refuse')
        btnRefuse:findChildByName("text_button"):setText(STR_FRIEND_APPLY_REFUSE)
        btnRefuse:setOnClick(self, function ( self )
			-- body
			HttpModule.getInstance():execute(HttpModule.s_cmds.FRIEND_REFUSE,{fid = apply:getId(), isagree = 0}, false, false)
			apply:setVisible(false)
		end)

		item:findChildByName('btn_head'):setOnClick(self, function ( self )
            WindowManager:showWindow(WindowTag.FriendInfoPopu, {from = "apply", playerInfo = apply, cache = self.playerInfoCache}, WindowStyle.POPUP)
		end)
		--是否可见
		UIEx.bind(self, apply, "visible", function(value)
			item:setVisible(value)
			self:loadApply(self.mLoadApply)
			self.mApplySc:reposition()
		end)
        UIEx.bind(self, apply, "sex", function(value)
            item:findChildByName("img_male"):setVisible(tonumber(value) == 0)
            item:findChildByName("img_female"):setVisible(tonumber(value) ~= 0)
        end)

		-- 为头像绑定数据源
		UIEx.bind(self, apply, "headName", function(value)
			local head = new(Mask, value, friend_map["friend.head_mask.png"]);
			local w, h = item:findChildByName("btn_head"):getSize()
			head:setSize(w, h)
			head:setAlign(kAlignCenter)
			item:findChildByName("view_head"):addChild(head)
			apply:checkHeadAndDownload()
		end)
		apply:setSex(apply:getSex());
		apply:setHeadUrl(apply:getHeadUrl());

		local w, h = item:getSize()
		item:setPos(0, h * (i - 1))
		item:setAlign(kAlignTop)
		self.mApplySc:addChild(item)
	end

	self.mLoadApply = self.mLoadApply + loaded


	local count = 0
	for k = 1, #self.mApplyList do
		if self.mApplyList[k]:getVisible() then
			count = count + 1
			break
		end
	end

	self:findChildByName('view_apply'):findChildByName('img_noData'):setVisible(count == 0)
	
end

function FriendPopu:onClickGift()

	if self.mGiftList then
		self:loadGift(self.mLoadGift)
	else
        self:execHttpCmd(HttpModule.s_cmds.GET_GIFT,{gameid = 1002}, false, true, self:findChildByName("view_gift"))
	end

	MyUserData:setUnreadGigt(0)
end

function FriendPopu:loadGift(from)
	-- body
	--清空
	if from == 1 then
		self.mGiftSc:removeAllChildren()
	end

	local loaded = 0
	for i = from, #self.mGiftList do
		if loaded >= self.mPerLoad then break end
		loaded = loaded + 1
		local gift = self.mGiftList[i]

		local item = SceneLoader.load(lobbyFriendGiftItem);
        --预留图标的宽度
        local maxNameLen = item:findChildByName("view_nick"):getSize() - 40
        ToolKit.formatTextLength(gift:getName(), item:findChildByName("text_name"), maxNameLen)
--		item:findChildByName('text_name'):setText(ToolKit.formatNick(gift:getName(), 12))
		item:findChildByName('text_chip'):setText(gift:getMoney())
		item:findChildByName('text_game'):setText(self:getNameByGameId(gift:getGameid(), gift:getMltime(), gift:getGameName()))--gift.gameid

        local btnGift = item:findChildByName('btn_getgift')
		btnGift:setOnClick(self, function ( self )
			-- body
			if gift:getGift() then
				if self.mGotData:getGot() < self.mGotData:getMax() then
                    self:execHttpCmd(HttpModule.s_cmds.FETCH_GIFT,{gift = {[gift:getGiftid()] = gift:getId()} }, false, true, self:findChildByName("view_gift"))
				else
					AlarmTip.play(STR_FRIEND_GET_GIFT_LIMIT)
				end
			else
				--回赠
				HttpModule.getInstance():execute(HttpModule.s_cmds.SEND_GIFT,{fid = gift:getId(), content = base64.encode(json.encode({
		        id   = MyUserData:getId(),
		        name = MyUserData:getNick()
		        }))}, false, false)
				--设置不可回赠
				gift:setCanSendMoney(0)
				--重新更新下按钮
				gift:setGift(false)
			end
		end)

		UIEx.bind(self, gift, "gift", function(value)
			local textBtn = btnGift:findChildByName("text_button")
			if value then
                --接受好友礼物
				btnGift:setFile(popu_map['popu.public.btn_green.png']  or "")
                textBtn:setText(STR_FRIEND_GIFT_ACCEPT, 0, 0, 0x10, 0x66, 0x3C)
			else
                --赠送好友礼物
				if gift:getCanSendMoney() > 0 then
					btnGift:setFile(popu_map['popu.public.btn_blue.png']  or "")
                    textBtn:setText(STR_FRIEND_GIFT_SEND, 0, 0, 0x11, 0x46, 0x63)
				else
                    --已经回赠过礼物，按钮变灰
					btnGift:setFile(popu_map['popu.public.btn_gray.png'] or "")
                    textBtn:setText(STR_FRIEND_GIFT_ACCEPT, 0, 0, 0xBE, 0x6F, 0x42)
					btnGift:setEnable(false)
				end
			end
		end)

		item:findChildByName('btn_head'):setOnClick(self, function ( self )
            WindowManager:showWindow(WindowTag.FriendInfoPopu, {from = "gift", playerInfo = gift, cache = self.playerInfoCache}, WindowStyle.POPUP)
		end)

		--是否可见
		UIEx.bind(self, gift, "visible", function(value)
			item:setVisible(value)
			self:loadGift(self.mLoadGift)
            self.mGiftSc:reposition()
		end)
        UIEx.bind(self, gift, "sex", function(value)
            item:findChildByName("img_male"):setVisible(tonumber(value) == 0)
            item:findChildByName("img_female"):setVisible(tonumber(value) ~= 0)
        end)
		-- 为头像绑定数据源
		UIEx.bind(self, gift, "headName", function(value)
			local head = new(Mask, value, friend_map["friend.head_mask.png"]);
			local w, h = item:findChildByName("btn_head"):getSize()
			head:setSize(w, h)
			head:setAlign(kAlignCenter)
			item:findChildByName("view_head"):addChild(head)
			gift:checkHeadAndDownload()
		end)

		gift:setHeadUrl(gift:getHeadUrl());
        gift:setSex(gift:getSex())
		gift:setGift(gift:getGift())

		local w, h = item:getSize()
		item:setPos(0, h * (i - 1))
		item:setAlign(kAlignTop)
		self.mGiftSc:addChild(item)
	end

	self.mLoadGift = self.mLoadGift + loaded

	local count = 0
	for k = 1, #self.mGiftList do
		if self.mGiftList[k]:getVisible() then
			count = count + 1
			break
		end
	end

	self:findChildByName('view_gift'):findChildByName('img_noData'):setVisible(count == 0)
	
end


function FriendPopu:onClickAddFriend()
	-- body
end

function FriendPopu:onLoadSearch(data)
	-- body

	local friend = setProxy(new(require("data.friendData")))
	friend:init(data)
	self.mSearchSc:removeAllChildren()
	local item = SceneLoader.load(lobbySearchItem);
	local w, h = item:getSize()
    --预留图标的宽度
    local maxNameLen = item:findChildByName("view_nick"):getSize() - 40
    ToolKit.formatTextLength(data.name or '', item:findChildByName("text_name"), maxNameLen)
--	item:findChildByName('text_name'):setText(ToolKit.formatNick(tostring(data.name or ''), 12))
	item:findChildByName('text_chip'):setText(tostring(data.money or ''))
    
    local btnAddFriend = item:findChildByName('btn_addfriend')
    btnAddFriend:findChildByName("text_button"):setText(STR_FRIEND_ADD)
	btnAddFriend:setOnClick(self, function ( self )
		-- body
        --发送好友申请
        --好友数量超过上限，提示不可添加好友
        if self.mFriendList and #self.mFriendList >= 200 then
            AlarmTip.play(STR_MY_FRIEND_COUNT_LIMIT)
        else
            self:execHttpCmd(HttpModule.s_cmds.ADD_FRIEND,{isroom = 0, fid = friend:getId(), content = base64.encode(json.encode({
			    id 	 = MyUserData:getId(),
			    name = MyUserData:getNick()
			    }))}, false, true, self:findChildByName("view_searchResult"))
        end
	end)
    UIEx.bind(self, friend, "sex", function(value)
        item:findChildByName("img_male"):setVisible(tonumber(value) == 0)
        item:findChildByName("img_female"):setVisible(tonumber(value) ~= 0)
    end)

	-- 为头像绑定数据源
	UIEx.bind(self, friend, "headName", function(value)
		local head = new(Mask, value, friend_map["friend.head_mask.png"]);
		local w, h = item:findChildByName("btn_head"):getSize()
		head:setSize(w, h)
		head:setAlign(kAlignCenter)
		item:findChildByName("view_head"):addChild(head)
		friend:checkHeadAndDownload()
	end)

	item:findChildByName('btn_head'):setOnClick(self, function ( self )
        WindowManager:showWindow(WindowTag.FriendInfoPopu, {from = "search", playerInfo = friend, cache = self.playerInfoCache}, WindowStyle.POPUP)
	end)
    
	friend:setSex(friend:getSex());
	friend:setHeadUrl(friend:getHeadUrl());
	item:setPos(0, 0)
	item:setAlign(kAlignTop)
	self.mSearchSc:addChild(item)
end

--获取好友列表
function FriendPopu:onFriend(isSuccess,data)
	if app:checkResponseOk(isSuccess, data) then
		self.mFriendList = {}
		self.mLoadFriend = 1
		local friendsList = data.data.friendsList or {}
		for i = 1, #friendsList do
			local param = friendsList[i]
			local friend = setProxy(new(require("data.friendData")))
			friend:init(param)
			table.insert(self.mFriendList, friend)
		end

        table.sort(self.mFriendList, function(a, b)
            --破产了的排前面
            if a:getBankrupt() > b:getBankrupt() then
                return true
            --都破产了，或者都没破产
            elseif a:getBankrupt() == b:getBankrupt() then
                --都在游戏或者都不在游戏，按可以送钱的排序
               if (a:getGameid() > 0 and b:getGameid() > 0) or (a:getGameid() <= 0 and b:getGameid() <= 0) then
                    if a:getCanSendMoney() > b:getCanSendMoney() then
                        return true
                    end
                --一个在游戏，另一个不在，在游戏的排前面
                elseif a:getGameid() > b:getGameid() then
                    return true
                end
            end

--            --破产了的排前面
--            if a:getBankrupt() > b:getBankrupt() then
--                return true
--            --在游戏的排前面，这么写会让玩新游戏的排在玩老游戏的前面，不过不太要紧
--            elseif a:getGameid() > b:getGameid() then
--                return true
--            --能送钱的排前面
--            elseif a:getCanSendMoney() > b:getCanSendMoney() then
--                return true
--            end
            return false
        end)
        
		self:loadFriend(self.mLoadFriend)
	end
    --self:stopLoading()
end
--获取好友列表
function FriendPopu:onApply(isSuccess,data)
	if app:checkResponseOk(isSuccess, data) then
		self.mApplyList = {}
		self.mLoadApply = 1
		local friendsList = data.data
		for i = 1, #friendsList do
			local param = friendsList[i]

			local friend = setProxy(new(require("data.friendData")))
			friend:init(param)
			table.insert(self.mApplyList, friend)
			
		end

		self:loadApply(self.mLoadApply)
	end
    --self:stopLoading()
end

function FriendPopu:onAccept(isSuccess,data)
	if app:checkResponseOk(isSuccess, data) then
		if self.mApplyList then
			local friend = setProxy(new(require("data.friendData")))
			friend:init(data.data)
			for i = 1, #self.mApplyList do
				local apply = self.mApplyList[i]
				if apply:getId() == friend:getId() then
					apply:setVisible(false)
					--添加到好友列表去
					if self.mFriendList then
						table.insert(self.mFriendList, friend)
						self:loadFriend(self.mLoadFriend)
					end
					break
				end
			end
		end
	else
		--失败
		-- 1：成功 -3:自己达到好友上限 -4:好友达到好友上限 -5:已经是好友 -6,-7,-8,-9:插入数据库错误
		local code = data and data.code or 0
		local errText = {
			[-3] = STR_MY_FRIEND_COUNT_LIMIT,
			[-4] = STR_YOUR_FRIEND_COUNT_LIMIT,
			[-5] = STR_BE_FRIEND_ALREADY,
			[-6] = STR_SERVER_ERROR,
			[-7] = STR_SERVER_ERROR,
			[-8] = STR_SERVER_ERROR,
			[-9] = STR_SERVER_ERROR,
			[0] = STR_UNKNOWN_ERROR,
		}
		AlarmTip.play(errText[code or 0])
	end
end
function FriendPopu:onRefuse(isSuccess,data)
end
function FriendPopu:onSendGift(isSuccess,data)
    if app:checkResponseOk(isSuccess, data) then
        
    end
    
end
function FriendPopu:onFetchGift(isSuccess,data)
    
	if app:checkResponseOk(isSuccess, data) then
		
		if data.data.money then
			MyUserData:setMoney(data.data.money, true)
		end
        if not self.mGiftList then
            return
        end
		local addmoney = 0

		for giftid, fid in pairs(data.data.friends.fid or {}) do
			for i = 1, #self.mGiftList do
				local gift = self.mGiftList[i]
				if gift:getId() == fid and gift:getGiftid() == giftid then
					gift:setGift(false)
					addmoney = addmoney + data.data.addMoney
					self.mGotData:setGot(self.mGotData:getGot() + 1)
					break
				end
			end
			
		end
		AlarmTip.play(string.format(STR_FRIEND_GET_GIFT_SUC, addmoney))
		
	end
    --self:stopLoading()
end

function FriendPopu:onDelete(isSuccess,data)
	if app:checkResponseOk(isSuccess, data) then
		if self.mFriendList then
			for i = 1, #self.mFriendList do
				local friend = self.mFriendList[i]
				if tonumber(friend:getId()) == tonumber(data.data.fid) then
					friend:setVisible(false)
					break
				end
			end
		end
	end
end
--获取礼物列表
function FriendPopu:onGift(isSuccess,data)
    
	if app:checkResponseOk(isSuccess, data) then
		self.mGiftList = {}
		self.mLoadGift = 1
		local friendsList = data.data
		local todayGotNum = friendsList.todayGotNum 
		local maxGotNum   = friendsList.maxGotNum
		for i = 1, #friendsList do
			local param  = friendsList[i]
			todayGotNum  = param.todayGotNum
			maxGotNum    = param.maxGotNum
			local friend = setProxy(new(require("data.friendData")))
			friend:init(param)
			table.insert(self.mGiftList, friend)
		end

		self.mGotData:setMax(maxGotNum or 0)
		self.mGotData:setGot(todayGotNum or 0)
		
		--加载历史数据(6小时失效)
		local data = self:readGiftListFromDict()
		if data then
			--排序，先是可以回赠
			table.sort(data, function ( a, b )
				-- body
				return a.canSendMoney > b.canSendMoney
			end)
			for i = 1, #data do
				local friend = setProxy(new(require("data.friendData")))
				friend:init(data[i])
				table.insert(self.mGiftList, friend)
			end
		end
		self:loadGift(self.mLoadGift)
	end
    --self:stopLoading()
end

--申请加为好友
function FriendPopu:onAddFriend(isSuccess,data)
    
	if app:checkResponseOk(isSuccess, data) then
		AlarmTip.play(STR_FRIEND_SEND_APPLY_SUC);
	else 
		if isSuccess and data.code == -3 then
			AlarmTip.play(STR_FRIEND_SEND_APPLY_ALREADY);
		else
			AlarmTip.play(STR_FRIEND_SEND_APPLY_FAILD);
		end
	end
    --self:stopLoading()
end

--查找好友

function FriendPopu:onSearchFriend(isSuccess,data)

	if app:checkResponseOk(isSuccess, data) then
		self:onLoadSearch(data.data)
	else
		AlarmTip.play(STR_FRIEND_SEARCH_FAILD);
	end
    --self:stopLoading()
end

--HTTP回调
function FriendPopu:onHttp(command, ...)
	if self.s_httpEventFuncMap[command] then
     	self.s_httpEventFuncMap[command](self,...)
	end 
end

--Http响应
FriendPopu.s_httpEventFuncMap = {
  [HttpModule.s_cmds.GET_FRIENDS] 	 = FriendPopu.onFriend,
  [HttpModule.s_cmds.GET_APPLY] 	 = FriendPopu.onApply,
  [HttpModule.s_cmds.ADD_FRIEND] 	 = FriendPopu.onAddFriend,
  [HttpModule.s_cmds.SEARCH_FRIEND]  = FriendPopu.onSearchFriend,
  [HttpModule.s_cmds.GET_GIFT]  	 = FriendPopu.onGift,

  [HttpModule.s_cmds.FRIEND_ACCEPT]  = FriendPopu.onAccept,
  [HttpModule.s_cmds.FRIEND_REFUSE]  = FriendPopu.onRefuse,
  [HttpModule.s_cmds.SEND_GIFT]  	 = FriendPopu.onSendGift,
  [HttpModule.s_cmds.FETCH_GIFT]  	 = FriendPopu.onFetchGift,
  [HttpModule.s_cmds.FRIEND_DELETE]  = FriendPopu.onDelete,


}

return FriendPopu