require(ViewPath .. "noticeItemLayout")
require(ViewPath .. "newsItemLayout")
local NoticePopu = class(require("popu.gameWindow"))
new(Image, "notice.png")

function NoticePopu:ctor()
	self.mData = {}
end

function NoticePopu:dtor()
	if self.mData['btn_news'] then
		local messages = self.mData['btn_news']
		local newMessages = {}
		for i = 1, #messages do
			if not messages[i].delete then
				table.insert(newMessages, messages[i])
			end
		end
		MyUserData:setNewsList(newMessages)
		--保存当前的消息数量，下次请求消息数量若没有变化，表示没有新消息，不加载提示点
        if MyUserData:getUserType() == UserType.Visitor then
            GameSetting:setTotalNewsNumGuest(#messages)
        else
            GameSetting:setTotalNewsNumFb(#messages)
        end
        GameSetting:save()
	end
	if self.mData['btn_mail'] then
		local messages = self.mData['btn_mail']
		local newMessages = {}
		for i = 1, #messages do
			if not messages[i].delete then
				table.insert(newMessages, messages[i])
			end
		end
		MyUserData:setNoticeList(newMessages)
		    --保存当前的公告数量，下次请求公告数量若没有变化，表示没有新公告，不加载提示点
        if MyUserData:getUserType() == UserType.Visitor then
            GameSetting:setTotalNoticeNumGuest(#messages)
        else
            GameSetting:setTotalNoticeNumFb(#messages)
        end
        GameSetting:save()
	end
end

function NoticePopu:initView(data)
   
	self:findChildByName("btn_close"):setOnClick(self, function ( self )
		-- body
		self:dismiss();
	end);

	--local btnTitle = {STR_USER_MESSAGE, STR_SYS_MESSAGE}
	local btnName = {'btn_news', 'btn_mail'}
	--local pngName = {'news', 'notice'}
	--local scName  = {'sc_news', 'sc_notice'}
    local btnView = {self:findChildByName("view_userBtn"), self:findChildByName("view_sysBtn")}
    local viewName = {self:findChildByName("view_news"), self:findChildByName("view_notice")}
	local httpCmd = {HttpModule.s_cmds.GET_HALL_USER_NEWS, HttpModule.s_cmds.GET_HALL_USER_NOTICES}
    local hasReaded = {"hasNewNews", "hasNewNotice"}
    local needUpdate = {true, true}
    for i = 1, #btnView do
        local buttons = btnView[i]
        buttons:findChildByName("btn_unselect"):setOnClick(self, function(self)
            --点击按钮后，切换成被选中的按钮，隐藏不被选中的按钮
            for j = 1, #btnView do
                local curButtons = btnView[j]
                curButtons:findChildByName("btn_select"):setVisible(i == j)
                curButtons:findChildByName("btn_unselect"):setVisible(i ~= j)
                viewName[j]:setVisible(false)
            end
            viewName[i]:setVisible(true)
    --每次点击页面后只重新拉取一次数据
            if needUpdate[i] then
                self:execHttpCmd(httpCmd[i], {}, true, not self.mData[btnName[i]], viewName[i])
                needUpdate[i] = false
            end
            MyUserData[hasReaded[i]] = false
        end)
    end
 
    UIEx.bind(self, MyUserData, "hasNewNotice", function(value)
        local viewTips = self:findChildByName("view_mailNotice")
        viewTips:removeAllChildren()
        if value then
			local tip = new(Image, 'common/tips.png')
            viewTips:addChild(tip)
        end
    end)


	--点击事件
	MyUserData:setHasUnckeckMsg(false)
    MyUserData:setHasNewNotice(MyUserData:getHasNewNotice())

end

function NoticePopu:onShowEnd()
    self.super.onShowEnd(self)
        --用旧数据先初始化
    if MyUserData:getNewsList() then
        self.mData["btn_news"] = MyUserData:getNewsList()
        self:initNews()
    end
    if MyUserData:getNoticeList() then
        self.mData["btn_mail"] = MyUserData:getNoticeList()
        self:initNotice()
    end
    local btn = self:findChildByName("view_userBtn"):findChildByName("btn_unselect")
	btn.m_eventCallback.func(btn.m_eventCallback.obj);
end
--根据MyNoticeData初始化消息内容
function NoticePopu:initNews()
	-- body
    local viewNews = self:findChildByName("view_news")
    local imgNoData = viewNews:findChildByName("img_noData")
    imgNoData:findChildByName("text_noDataTip"):setText(STR_NO_MESSAGE)

	local newsScrollView = viewNews:findChildByName("sc_news");

	newsScrollView:removeAllChildren();

	local messages = self.mData['btn_news']

	local y = 0;
	local w, h = newsScrollView:getSize();
	for i = 1, #messages do

		local message = messages[i]

		local item  = SceneLoader.load(newsItemLayout)
		item:findChildByName('text_time'):setText(os.date("%m/%d", message.time))
		local tvMsg = item:findChildByName('text_msg');
		local msgW, msgH = item:findChildByName('text_msg'):getSize();
		tvMsg:setText(message.content);
		tvMsg:setSize(msgW, tvMsg.m_res.m_height);
		local itemW, itemH = item:getSize();
		item:setPos((w - itemW) / 2, y);
		newsScrollView:addChild(item);
		local itemW, itemH = item:getSize();
		y = y + itemH;

		item:findChildByName('btn_delete'):setOnClick(self, function ( self )
			item:setVisible(false)
			message.delete = true
			newsScrollView:reposition()
			--发送删除
			HttpModule.getInstance():execute(HttpModule.s_cmds.GET_HALL_USER_NEWS_DEL, {id = message.id}, false, true);
			local count = 0
            for i = 1, #messages do
                if not messages[i].delete then
                    return
                end
            end
			imgNoData:setVisible(true)

		end)
	end

	newsScrollView:setSize(newsScrollView:getSize())

	if #messages == 0 then
        imgNoData:setVisible(true)
	end
end

--根据MyNoticeData初始化消息内容
function NoticePopu:initNotice()
	-- body
    local viewNotice = self:findChildByName("view_notice")
    local imgNoData = viewNotice:findChildByName("img_noData")
    imgNoData:findChildByName("text_noDataTip"):setText(STR_NO_MESSAGE)

	local newsScrollView = viewNotice:findChildByName("sc_notice");

	newsScrollView:removeAllChildren();

	local messages = self.mData['btn_mail']

	local y = 0;
	local w, h = newsScrollView:getSize();
	for i = 1, #messages do
		local message = messages[i]
		local item = SceneLoader.load(noticeItemLayout)
		item:findChildByName('text_time'):setText(os.date("%m/%d", message.time))
		local tvTitle = item:findChildByName('text_title');
		local titleW, titleH = tvTitle:getSize();
		tvTitle:setColor( 0xfb, 0xfb, 0xff)
		tvTitle:setText(message.title);
		tvTitle:setSize(titleW, tvTitle.m_res.m_height);
		local itemW, itemH = item:getSize();
		item:setPos((w - itemW) / 2, y);
		newsScrollView:addChild(item);
		local itemW, itemH = item:getSize();
		y = y + itemH;
        
        item:findChildByName("text_content"):setText(message.content)
        item:findChildByName("text_content"):setScrollBarWidth(0)
        local btnDelete = item:findChildByName('btn_delete')
        btnDelete:findChildByName("text_delete"):setText(STR_BUTTON_DELETE)
        --有奖励，并且未领奖
        if tonumber(message.reward) == 1 and tonumber(message.isreward or 0) == 0 then
            tvTitle:setColor( 0xf2, 0xe5, 0x47)
            item:findChildByName("btn_getaward"):findChildByName("text_isReward"):setText(STR_FRIEND_GETTABLE)
            item:findChildByName("btn_getaward"):setVisible(true)
            btnDelete:setPos(220, 15)
        end
        
		item:findChildByName('btn_fulltext'):setOnClick(self, function ( self )
			local contentBg = item:findChildByName("img_bg2")
            local titleBg = item:findChildByName("img_bg")
            if contentBg:getVisible() then
                message.isShow = false
                contentBg:setVisible(false)
                titleBg:setVisible(true)
                item:setSize(titleBg:getSize())
            else
                message.isShow = true
                contentBg:setVisible(true)
                titleBg:setVisible(false)
                item:setSize(contentBg:getSize())
                ----有奖励并且没有领的时候按钮要变颜色
                if tonumber(message.reward) == 1 and tonumber(message.isreward) == 0 then
                    item:findChildByName('btn_getaward'):setEnable(true)
                else
                    item:findChildByName('btn_getaward'):setEnable(false)
                    item:findChildByName('btn_getaward'):setGray(true)
                end
                local tvContent = item:findChildByName('text_content');
                --检查内容里是否带了字符串
                local startIndex, endIndex = self:getUrlLinkIndex(message.content)
                if startIndex and endIndex then
                    local btnNotice = item:findChildByName("btn_contentUrl")
                    btnNotice:setVisible(true)
                    btnNotice:setSize(tvContent:getSize())
                    btnNotice:setPos(tvContent:getPos())
                    btnNotice:setOnClick(self, function()
                        NativeEvent.getInstance():openLink(string.sub(message.content, startIndex, endIndex))	
                    end)   
                else
                     item:findChildByName("btn_contentUrl"):setVisible(false)
                end 
            end
            newsScrollView:reposition()
            newsScrollView:setSize(newsScrollView:getSize())
		end)

		btnDelete:setOnClick(self, function ( self )
            local deleteNoticeFun = function()
                local tvContent = item:findChildByName('text_content');
			    item:setVisible(false)
			    message.delete = true
                newsScrollView:reposition()
                newsScrollView:setSize(newsScrollView:getSize())
			    HttpModule.getInstance():execute(HttpModule.s_cmds.GET_HALL_USER_NOTICES_DEL, {id = message.id}, false, true);

			    local count = 0
                for i = 1, #messages do
                    if not messages[i].delete then
                        return
                    end
                end
			    imgNoData:setVisible(true)
            end            

            if tonumber(message.reward) == 1 and tonumber(message.isreward) == 0 then
				WindowManager:showWindow(WindowTag.LobbyConfirmPopu, {
				content = STR_DELETE_NOTICE_CONFIRM,
                cancel = STR_EXIT_GAME_CANCEL,
				confirm = STR_EXIT_GAME_CONFIRM,
				confirmFunc = function ()
					-- body
                    deleteNoticeFun()
				end
			    }, WindowStyle.POPUP);
            else
                deleteNoticeFun();
            end

		end)

		item:findChildByName('btn_getaward'):setOnClick(self, function ( self )
            local btnGetAward = item:findChildByName("btn_getaward")
			btnGetAward:findChildByName("text_isReward"):setText(STR_GOT_TASK_AWARD)
			btnGetAward:setEnable(false)
            btnGetAward:setGray(true)
			item:findChildByName('text_title'):setColor( 0xfb, 0xfb, 0xff)
            self:execHttpCmd(HttpModule.s_cmds.GET_HALL_USER_NOTICES_AWARD, {nid = message.id}, true, true, self:findChildByName("view_notice"))
            message.isreward = 1
            --self:playLoading()
			--HttpModule.getInstance():execute(HttpModule.s_cmds.GET_HALL_USER_NOTICES_AWARD, {nid = message.id}, true, true);
		end)
	end

	newsScrollView:setSize(w, h)

	if #messages == 0 then
        imgNoData:setVisible(true)
	end

end

--HTTP回调

--个人消息
function NoticePopu:onHallUserNews(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		self.mData['btn_news'] = {}
		local messages = data.data;
		for i = 1, #messages do
			local message = {}
			message.id = messages[i].id
			message.type = messages[i].type
			message.content = messages[i].content
			message.status = messages[i].status
			message.from = messages[i].from
			message.time = messages[i].time
			message.delete = false
			table.insert(self.mData['btn_news'], message)
		end

		table.sort(self.mData['btn_news'], function ( msga, msgb )
			-- body
			return msga.time > msgb.time
		end)

		self:initNews()
	end
end
--个人公告

function NoticePopu:onHallUserNotice(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		self.mData['btn_mail'] = {}
		local messages = data.data;
		for i = 1, #messages do
            --图片公告，不显示在消息列表里, --getway 1 是图片公告， 0是普通公告 ， 2 是跑马灯公告
            if tonumber(messages[i].getway) ~= 1 then
			    local message = {}
			    message.id = messages[i].id
			    message.title = messages[i].title
			    message.content = messages[i].content
			    message.popup = messages[i].popup
			    message.islook = messages[i].islook
			    message.reward = messages[i].reward
			    message.isreward = messages[i].isreward
			    message.time = messages[i].time
			    table.insert(self.mData['btn_mail'], message)
                message.isShow = false
                message.delete = false
            end
            
		end
		table.sort(self.mData['btn_mail'], function ( msga, msgb )
			-- body
			return msga.time > msgb.time
		end)
		self:initNotice()
	end
end

function NoticePopu:onHallUserNoticesAward(isSuccess, data)
end

function NoticePopu:getUrlLinkIndex(str)
    local startIndex, endIndex = str:find("(https?://)([%w_.~!*:@&+$/?%%#=-]+)")
    if startIndex and endIndex then
        local lastChar = string.sub(str, endIndex, endIndex)
        if result == "." or result == "," or result == "!" or result =="?" or result == ")" or result ==":"
            or result == '"' or result == "'" then 
            endIndex = endIndex - 1
        end
    end
    return startIndex, endIndex;

end

--[[
	通用的（大厅）协议
]]
NoticePopu.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.GET_HALL_USER_NEWS]      = NoticePopu.onHallUserNews,
	[HttpModule.s_cmds.GET_HALL_USER_NOTICES]   = NoticePopu.onHallUserNotice,
    [HttpModule.s_cmds.GET_HALL_USER_NOTICES_AWARD] = NoticePopu.onHallUserNoticesAward,
}


return NoticePopu