local PayPopu = class(require("popu.gameWindow"))

function PayPopu:initView(data)
	--返回
	self:findChildByName("btn_close"):setOnClick(self, function ( self )
		-- body
		self:dismiss();
	end);

	self:findChildByName("text_goodsInfo"):setText("商品："..(data.goodsInfo.pname or ""));
	self:findChildByName("text_goodsPrice"):setText("价格："..(data.goodsInfo.pamount or "").."元");

	-- self:findChildByName("btn_pay_1"):setOnClick(self, function ( self )
	-- 	-- body
	-- 	self:pay(1);
	-- end);

	-- self:findChildByName("btn_pay_2"):setOnClick(self, function ( self )
	-- 	-- body
	-- 	self:pay(2);
	-- end);

	-- self:findChildByName("btn_pay_3"):setOnClick(self, function ( self )
	-- 	-- body
	-- 	self:pay(3);
	-- end);

	-- self:findChildByName("btn_pay_4"):setOnClick(self, function ( self )
	-- 	-- body
	-- 	self:pay(4);
	-- end);

	local sceneChargeData 	= data.sceneChargeData
	local pamount 			= data.goodsInfo and data.goodsInfo.pamount
	local name 				= data.goodsInfo and data.goodsInfo.name

	-- 是否需要并支持短信支付（短信支付额度限制 单独判断）
	local smsPayCreated = false
	local supportTb = UnitePay.getInstance():getMutiPaySupportTb(false)
	-- 短信支付集合且根据优先级，限额依次调用
	local smsPayTb = UnitePay.getInstance():getMutiSmsPayTb(false)
	-- 用于短信支付
	local createSmsCallBack = function(index)
		local callBack = {
			-- 如果短信不支持或者 取消了短信支付 则显示
			-- 如果是短信支付 则只在短信支付里面按优先级匹配 下一个
			onUnSupported = function(data)
				if smsPayTb[index + 1] then
					local payId = smsPayTb[index + 1].id
					local payInstance = UnitePay.getInstance():getPayByPayId(payId)
					if payInstance then
						payInstance:pay(data, createSmsCallBack(index + 1))
					else
						AlarmNotice.play("当前支付方式不支持，请选择其他支付")
						UnitePay.getInstance():showMutiPay()
					end
				else
					AlarmNotice.play("短信支付超限额，请选择其他支付")
					UnitePay.getInstance():showMutiPay()
				end
			end,
			onCanceled = function(data)
			end
		}
		return callBack
	end
	local creatOtherCallBack = function()
		local callBack = {
			onUnSupported = function(data)
				AlarmNotice.play("当前支付方式不支持，请选择其他支付")
				UnitePay.getInstance():showMutiPay()
			end,
			onCanceled = function(data)
			end
		}
		return callBack
	end

	-- SMS_PAY 		= -1,   -- 短信支付
	-- ALI_PAY			= 2,   -- 支付宝支付
	-- CREDITCARD_PAY	= 3,   -- 信用卡支付
	-- MOBILEMM_PAY	= 4,   -- 移动MM支付
	-- UNICOM_PAY		= 5,   -- 联通沃支付
	-- UNION_PAY		= 6,   -- 银联支付
	-- TELECOM_PAY		= 7,   -- 电信支付
	-- WECHAT_PAY		= 8,   -- 微信支付

	local btnCount = 0;

	for i=1, #supportTb do

		local payId 	= supportTb[i].id
		local config 	= UnitePayConfigMap[payId]
		local imageName = config[1]

		local isSmsPay 		= UnitePay.getInstance():isSupportSmsPayId(payId)
		local payInstance 	= UnitePay.getInstance():getPayByPayId(payId)
		local needCreate 	= false
		
		-- 支付方式不存在或者超出了限额
		if not payInstance or payInstance:isOverLimitByPamout(pamount) then
			needCreate = false
		elseif not isSmsPay then
			needCreate = true
		elseif isSmsPay and payInstance:supportPamount(pamount) and not smsPayCreated then
			needCreate = true
			smsPayCreated = true
		end

		if needCreate then

			printInfo("payId = "..payId);

			btnCount = btnCount + 1;
			if btnCount > 4 then
				break;
			end

			local payBtn = self:findChildByName(string.format("btn_pay_%d", btnCount));

			payBtn:findChildByName("text_text"):setText(config[2] or "");
			payBtn:findChildByName("img_payIcon"):setFile("pay/"..(config[1] or ""));
			
			payBtn:setOnClick(self, function ( self )
				-- body
				payInstance:pay(data, isSmsPay and createSmsCallBack(1) or creatOtherCallBack())
				self:dismiss(true);
			end);

			payBtn:setVisible(true);

		end
	end	
	
end


function PayPopu:pay( type )
	-- body
end

return PayPopu