local RegisterRewardPopu = class(require("popu.gameWindow"))

function RegisterRewardPopu:ctor()

end

function RegisterRewardPopu:dtor()

end

function RegisterRewardPopu:initView(data)
	JLog.d('function RegisterRewardPopu:initView(data)',data)
	self.day = data.day
    self:findChildByName("img_bg"):setEventTouch(nil, function() end)

	self.awards = {}
	self.gifts = {}
	for i = 1, 3 do
		table.insert(self.awards, data.awardList[tostring(i)])
		table.insert(self.gifts, data.gift[tostring(i)])
	end
    self.propList = {}
	if data.propList then
	    for i = 1, 3 do
	        table.insert(self.propList, data.propList[tostring(i)] or "")
	    end
	end

	self:findChildByName("gain"):setOnClick(self, function(self) 
			HttpModule.getInstance():execute(HttpModule.s_cmds.GET_REGISTER_REWARD, {}, false, true)
		end)
	
	self:init_reward()

	--self:playRotateAnim()
end

function RegisterRewardPopu:init_reward()
	local day = self.day

	local d1 = self:findChildByName('day1')
	local d2 = self:findChildByName('day2')
	local d3 = self:findChildByName('day3')

	d1:findChildByName('text1'):setText(string.format('%s Fichas',self.awards[1]))
	d1:findChildByName('text2'):setText(string.format('%s Itens',self.propList[1]))
	if self.gifts[1] == 0 then
		d1:findChildByName('text3'):setVisible(false)
	else
		d1:findChildByName('text1'):setPos(0,-15)
		d1:findChildByName('text2'):setPos(0,10)
		d1:findChildByName('text3'):setPos(0,35)
		d1:findChildByName('text3'):setText('1Presente')
	end

	d2:findChildByName('text1'):setText(string.format('%s Fichas',self.awards[2]))
	d2:findChildByName('text2'):setText(string.format('%s Itens',self.propList[2]))
	if self.gifts[2] == 0 then
		d2:findChildByName('text3'):setVisible(false)
		d2:findChildByName('text1'):setPos(0,-10)
		d2:findChildByName('text2'):setPos(0,20)
	else
		--d2:findChildByName('text3'):setText('Pacote Misterioso')
		d2:findChildByName('text3'):setText('1 Presente')
	end

	-- d3:findChildByName('text1'):setText(string.format('%sFichas',self.awards[3]))
	-- d3:findChildByName('text2'):setText(string.format('%sItens',self.propList[3]))


	local f1 = self:findChildByName("finish1")
	local f2 = self:findChildByName("finish2")
	local f3 = self:findChildByName("finish3")

	local view_gift1 = self:findChildByName('view_gift1')
	local view_gift2 = self:findChildByName('view_gift2')
	local view_gift3 = self:findChildByName('view_gift3')

	local img_light = nil
	local view_star = nil

	if day == 1 then
		f1:setVisible(false)
		f2:setVisible(false)
		f3:setVisible(false)
		d1:setColor(255,255,255)
		d2:setColor(255,255,255)
		d3:setColor(255,255,255)
		view_gift1:findChildByName('img1'):setVisible(false)
		view_gift1:findChildByName('img2'):setVisible(true)
		view_gift2:findChildByName('img1'):setVisible(true)
		view_gift2:findChildByName('img2'):setVisible(false)
		view_gift3:findChildByName('img1'):setVisible(true)
		view_gift3:findChildByName('img2'):setVisible(false)

		view_gift1:setColor(255,255,255)
		view_gift2:setColor(255,255,255)
		view_gift3:setColor(255,255,255)

		img_light = view_gift1:findChildByName('img3')
		view_star = self:findChildByName('view_star1')
	elseif day == 2 then
		f1:setVisible(true)
		f2:setVisible(false)
		f3:setVisible(false)
		d1:setColor(100,100,100)
		d2:setColor(255,255,255)
		d3:setColor(255,255,255)
		view_gift1:findChildByName('img1'):setVisible(true)
		view_gift1:findChildByName('img2'):setVisible(false)
		view_gift2:findChildByName('img1'):setVisible(false)
		view_gift2:findChildByName('img2'):setVisible(true)
		view_gift3:findChildByName('img1'):setVisible(true)
		view_gift3:findChildByName('img2'):setVisible(false)

		view_gift1:setColor(100,100,100)
		view_gift2:setColor(255,255,255)
		view_gift3:setColor(255,255,255)

		img_light = view_gift2:findChildByName('img3')
		view_star = self:findChildByName('view_star2')
	elseif day == 3 then
		f1:setVisible(true)
		f2:setVisible(true)
		f3:setVisible(false)
		d1:setColor(100,100,100)
		d2:setColor(100,100,100)
		d3:setColor(255,255,255)
		view_gift1:findChildByName('img1'):setVisible(true)
		view_gift1:findChildByName('img2'):setVisible(false)
		view_gift2:findChildByName('img1'):setVisible(true)
		view_gift2:findChildByName('img2'):setVisible(false)
		view_gift3:findChildByName('img1'):setVisible(false)
		view_gift3:findChildByName('img2'):setVisible(true)

		view_gift1:setColor(100,100,100)
		view_gift2:setColor(100,100,100)
		view_gift3:setColor(255,255,255)

		img_light = view_gift3:findChildByName('img3')
		view_star = self:findChildByName('view_star3')
	end

	--light
	img_light:setVisible(true)
	img_light:addPropTransparency(122, kAnimRepeat, 1000, 500, 1.0, 0.7)

	--star
	view_star:setVisible(true)
	local star1 = view_star:findChildByName('star1')
	local star2 = view_star:findChildByName('star2')
	star1:addPropScale(1,kAnimRepeat, 800, 500, 1, 0.3, 1, 0.3,kCenterDrawing);
	star2:addPropScale(1,kAnimRepeat, 1000, 500, 1, 0.1, 1, 0.1,kCenterDrawing);
end

function RegisterRewardPopu:dismiss()
    self.super.dismiss(self)
    --注册弹窗，如果需要新手引导，抛出事件
    -- if GameSetting.beginnerStep == "first" then
    --     EventDispatcher.getInstance():dispatch(Event.Message, "showBeginnerHelp")
    -- end

    local data = {}
    local txt = ''
    if self.day == 2 then
    	txt = string.format('Você recebeu %s fichas %s itens %s presente',self.awards[self.day],self.propList[self.day],1)
    else
    	txt = string.format('Você recebeu %s fichas %s itens',self.awards[self.day],self.propList[self.day])
    end
    WindowManager:showWindow(WindowTag.RegisterRewardFinishPopu, {text = txt}, WindowStyle.POPUP)
end

function RegisterRewardPopu:playRotateAnim()
	local spriteMC = self:findChildByName('img_light')
	local dw, dh = spriteMC:getSize()
	spriteMC:addPropRotate(1, kAnimRepeat, 6000, 0, 0, 360, kCenterXY, dw / 2, dh / 2)
	spriteMC:addPropTransparency(2, kAnimLoop, 1000, 0, 1.0, 0.5)
end

return RegisterRewardPopu 