local SettingAndFeedBackPopu = class(require("popu.gameWindow"))

function SettingAndFeedBackPopu:ctor()
--	ScrollBar.setDefaultImage("rank/scroller.png");
	--注册HTTP回调
	EventDispatcher.getInstance():register(HttpModule.s_event,self,self.onHttpRequestsCallBack);
	EventDispatcher.getInstance():register(Event.Call, self, self.onNativeCallBack);
	self.mServiceList={};
end

function SettingAndFeedBackPopu:dtor()
	--注销HTTP回调
	EventDispatcher.getInstance():unregister(HttpModule.s_event,self,self.onHttpRequestsCallBack);
	EventDispatcher.getInstance():unregister(Event.Call, self, self.onNativeCallBack);
end


function SettingAndFeedBackPopu:initView(data)
	local backBtn = self:findChildByName("btn_close");
	backBtn:setOnClick(self, function ( self )
		-- body
		self:dismiss(false, false, WindowStyle.POPUP);
	end);

	backBtn:enableAnim(false);

	self:initSetting()
	self:initFeedBack()
	
	local btnName = {"btn_setting", "btn_feedback"}
	local pngName = {"news", "notice"}
	local viewName = {"view_setting", "view_feedback"}
	local titleName = {STR_SETTING, STR_FEEDBACK}
	local viewTab = self:findChildByName("view_tab")
	for i = 1, #btnName do
		local btn = viewTab:findChildByName(btnName[i])
		btn:findChildByName("text_title"):setText(titleName[i])
		btn:setOnClick(self, function(self)
			btn:setFile(string.format('notice/%s2.png', pngName[i]))
			viewTab:findChildByName(btnName[3 - i]):setFile(string.format('notice/%s1.png', pngName[3 - i]))
			self:findChildByName(viewName[i]):setVisible(true)
			self:findChildByName(viewName[3 - i]):setVisible(false)
		end)
	end

end

function SettingAndFeedBackPopu:initSetting()
--[[
do
        self:findChildByName("view_version"):findChildByName("Button1"):setOnClick(self, function(self)
            local str = HttpModule.s_config[HttpModule.s_cmds.LOGIN_PHP][1]
	        if LOCAL_NET then
	            HttpModule.s_config[HttpModule.s_cmds.LOGIN_PHP][1] = 'http://mvlptldc02.boyaagame.com/androidtl/game/hall/index.php'
                LOCAL_NET = false
            else
                HttpModule.s_config[HttpModule.s_cmds.LOGIN_PHP][1] = 'http://gamehall.oa.com/game/hall/index.php'
                LOCAL_NET = true
            end
        end)
end
--]]
	local viewSetting = self:findChildByName("view_setting")

	viewSetting:findChildByName("text_uid"):setText("ID:"..MyUserData:getId());
	viewSetting:findChildByName("text_nick"):setText(MyUserData:getNick());
	self:setSex(MyUserData:getSex());
	self:setUserHead(MyUserData:getHeadName());

	viewSetting:findChildByName("text_shake"):setText(STR_SHAKE);
	viewSetting:findChildByName("text_music"):setText(STR_MUSIC);
	viewSetting:findChildByName("text_sound"):setText(STR_SOUND);
	viewSetting:findChildByName("text_version"):setText(STR_VERSION);
	viewSetting:findChildByName("text_ver"):setText(PhpManager:getVersionName());
	viewSetting:findChildByName("text_fanspage"):setText(STR_FANSPAGE);
	viewSetting:findChildByName("text_about"):setText(STR_ABOUT);

	viewSetting:findChildByName("text_logout"):setText(STR_LOGOUT);
	viewSetting:findChildByName("text_follow"):setText(STR_FOLLOW);
	viewSetting:findChildByName("text_check"):setText(STR_CHECK);
	viewSetting:findChildByName("text_score"):setText(STR_SCORE)
	--viewSetting:findChildByName("text_poputitle"):setText(STR_SETTING);
	viewSetting:findChildByName("text_score_check"):setText(STR_CHECK)
    viewSetting:findChildByName("text_more"):setText(STR_MORE_GAME)
    viewSetting:findChildByName("text_moreCheck"):setText(STR_CHECK)

	viewSetting:findChildByName("btn_logout"):setOnClick(self, function ( self )
		-- body
		self:dismiss(true);
		NativeEvent.getInstance():logout({});
		EventDispatcher.getInstance():dispatch(Event.Message, "logout", 0)
		
	end);

	--评分
	viewSetting:findChildByName("btn_score"):setOnClick(self, function(self) 
		
		NativeEvent.getInstance():score("")
		end)

	viewSetting:findChildByName("btn_about"):setOnClick(self, function ( self )
		-- body
		-- self:dismiss(true);
		-- WindowManager:showWindow(WindowTag.FeedbackPopu, {}, WindowStyle.NORMAL)
		
	end);
    viewSetting:findChildByName("btn_more"):setOnClick(self, function(self)
        self:dismiss()
        NativeEvent.getInstance():showAd(false)
    end)
	viewSetting:findChildByName("btn_follow"):setOnClick(self, function ( self )
		-- body
		self:dismiss(true);
		local fansPage = {
	        [tostring(GAME_LOBBY_ID.Dice)] = 'https://www.facebook.com/jogododado/',
	        [tostring(GAME_LOBBY_ID.Buraco)] = 'https://www.facebook.com/buracobra/',
	        [tostring(GAME_LOBBY_ID.Truco)] = 'https://www.facebook.com/trucobra/',
	    }
		local link = fansPage[PhpManager:getGame()]
		if link then
			NativeEvent.getInstance():openLink(link)
		end
		
	end);

	local musicSwitch = viewSetting:findChildByName("btn_music")
	musicSwitch:setOnClick(self, function ( self )
		if GameSetting:getMusicVolume() > 0 then
			GameSetting:setMusicVolume(0.0)
			kMusicPlayer:setVolume(0.0)
			musicSwitch:setFile("setting/btn_off.png")
		else
			GameSetting:setMusicVolume(1.0)
			kMusicPlayer:setVolume(1.0)
			musicSwitch:setFile("setting/btn_on.png")
		end
	end);
	
	if GameSetting:getMusicVolume() > 0 then
		musicSwitch:setFile("setting/btn_on.png")
	else
		musicSwitch:setFile("setting/btn_off.png")
	end

	--音效
	local effectSwitch = viewSetting:findChildByName("btn_effect")
	effectSwitch:setOnClick(self, function ( self )
		if GameSetting:getSoundVolume() > 0 then
			GameSetting:setSoundVolume(0.0)
			kEffectPlayer:setVolume(0.0)
			effectSwitch:setFile("setting/btn_off.png")
		else
			GameSetting:setSoundVolume(1.0)
			kEffectPlayer:setVolume(1.0)
			effectSwitch:setFile("setting/btn_on.png")
		end
	end);
	if GameSetting:getSoundVolume() > 0 then
		effectSwitch:setFile("setting/btn_on.png")
	else
		effectSwitch:setFile("setting/btn_off.png")
	end

	viewSetting:findChildByName('btn_portrait'):setEnable(false)
	
end


--设置性别
function SettingAndFeedBackPopu:setSex( sex )
	-- body
	self:setUserHead(MyUserData:getHeadName(sex))
end

function SettingAndFeedBackPopu:setUserHead(headName)
	
	if self.m_headImage then
		self.m_headImage:removeSelf()
		self.m_headImage = nil;
	end
	local viewSetting = self:findChildByName("view_setting")
	local headView 		= viewSetting:findChildByName("view_portrait")
	local width, height = headView:getSize()

	self.m_headImage = new(Mask, headName, "user/head_mask.png");

	self.m_headImage:setSize(width, height)
	
	self.m_headImage:setName("headImage")
	self.m_headImage:addTo(headView)
	UIEx.bind(self.m_headImage, MyUserData, "headName", function(value)
		if MyUserData:getId() ~= 0 then
			self:setUserHead(MyUserData:getHeadName())
		end
	end)
end

function SettingAndFeedBackPopu:onHidenEnd(...)
	SettingAndFeedBackPopu.super.onHidenEnd(self, ...)
	GameSetting:save()
end

function SettingAndFeedBackPopu:initFeedBack()
	self.mGameTitle = ""

	local viewFeedback = self:findChildByName("view_feedback")
	--viewFeedback:findChildByName("text_poputitle"):setText(STR_FEEDBACK);
	viewFeedback:findChildByName("btn_confirm"):findChildByName("text_title"):setText(STR_EXIT_GAME_CONFIRM);
	viewFeedback:findChildByName("text_QAtitle"):setText(STR_MY_QUESTION);
	viewFeedback:findChildByName("text_upload"):setText(STR_UPLOAD_PIC);
    viewFeedback:findChildByName("text_thankyou"):setText(STR_FEEDBACK_THANKYOU)

	viewFeedback:findChildByName("btn_confirm"):setOnClick(self, function()
        app:postFrontStaticstics('clickFeedBackConfirmBtn')
		self:showChooseGame()
	end)

	viewFeedback:findChildByName("btn_upload"):setOnClick(self, function ( self )
		-- body
		self.m_uploadFeedbackFile = "";
		NativeEvent.getInstance():pickPhoto('feedback');
	end);

	--初始化输入
	self.mEtQuestion = viewFeedback:findChildByName("et_question");

	self.mEtQuestion:setHintText(STR_FEEDBACK_INPUT_HINT, 0xbc, 0xf0, 0xff);

	local param_post = {
							appid 	 = FEEDBACK_APPID,
    						ftype 	 = FEEDBACK_FTYPE,
    						game 	 = FEEDBACK_GAME,
    						mid 	 = MyUserData:getId(),
    						username = MyUserData:getNick(),
						};

	HttpModule.getInstance():execute(HttpModule.s_cmds.GetFeedbackList, param_post, false, true);

	-- self.mTextTip = viewFeedback:findChildByName("text_tips")


	--上传图片
	self.m_uploadFeedbackImg = new(Mask, "feedback/photo_mask.png", "feedback/photo_mask.png");--feedback/photo.png
	viewFeedback:findChildByName("view_photo"):addChild(self.m_uploadFeedbackImg);
	self.m_uploadFeedbackImg:setVisible(false);
	self.m_uploadFeedbackFile = "";

	local viewChoose = self:findChildByName("img_chooseBg")
    viewChoose:findChildByName("text_chooseSend"):setText(STR_FEEDBACK_SEND)
    viewChoose:findChildByName("text_chooseGame"):setText(STR_FEEDBACK_CHOOSEGAME)
	viewChoose:findChildByName("btn_chooseClose"):setOnClick(self, function()
		viewChoose:setVisible(false)
        self:findChildByName("img_popubg"):setVisible(true)
	end)
end
----------------------------------------------------------------------------------
--ui action 
----------------------------------------------------------------------------------
function SettingAndFeedBackPopu:onClickSendBtn()
	local viewFeedback = self:findChildByName("view_feedback")
    self:findChildByName("img_popubg"):setVisible(true)
    self:findChildByName('img_chooseBg'):setVisible(false)

	local question 	= self.mEtQuestion:getText();
	self:sendFeedbackMessage(question, "");
end
----------------------------------------------------------------------------------
--ui update
----------------------------------------------------------------------------------
function SettingAndFeedBackPopu:updateFeedbackList()
	-- body
	local viewFeedback = self:findChildByName("view_feedback")
	local feedbackScv = viewFeedback:findChildByName("sc_feedback");
	--设置滚动条
	feedbackScv:setScrollBarWidth(8);
	feedbackScv:removeAllChildren();
	
	local listViewInfoW, listViewInfoH = feedbackScv:getSize();

	local x = 0;
	local y = 0;

	for i = #self.mServiceList, 1, -1 do

		local service = self.mServiceList[i];

		if  service.question then 
			if string.len(service.question) > 0 then
				local n = new(require("popu.lobby.item.feedbackItem"), listViewInfoW, srcollViewInfoH, service, self, self.updateFeedbackScrollView, self, self.sendFeedbackSolve, self, self.sendFeedbackVote);
				n:setPos(x, y);
				feedbackScv:addChild(n);
				local w, h = n:getSize();
				y = y + h + 10;
			end
		end
	end
end

function SettingAndFeedBackPopu:updateFeedbackScrollView()
	-- body
	local viewFeedback = self:findChildByName("view_feedback")
	local feedbackScv = viewFeedback:findChildByName("sc_feedback");
	local child = feedbackScv:getChildren();
	feedbackScv.m_nodeH = 0;

	local curx  = 0;
	local cury 	= 0;

	for i = 1, #child do
		child[i]:setPos(curx, cury);
		local x, y = child[i]:getUnalignPos();
		local w, h = child[i]:getSize();

		feedbackScv.m_nodeH = (feedbackScv.m_nodeH > y + h) and feedbackScv.m_nodeH or (y + h);

		cury = cury + h;
	end

	ScrollView.update(feedbackScv);
end

----------------------------------------------------------------------------------
--http send
----------------------------------------------------------------------------------

--发送 反馈消息
function SettingAndFeedBackPopu:sendFeedbackMessage(question, contact)
	if MyUserData:getId() <= 0 then
		AlarmTip.play(STR_FEEDBACK_LOGIN);
		return;
	end
	
	if self.mLastQuestion == question then
		AlarmTip.play(STR_FEEDBACK_ALREADY);
		return;
	end

	self.mLastQuestion = question;
	
	question = GameString.convert2UTF8(question);
	
	local param_post = {
							appid 	 = FEEDBACK_APPID,
    						ftype 	 = FEEDBACK_FTYPE,
    						game 	 = FEEDBACK_GAME,
    						title 	 = self.mGameTitle,
    						fwords 	 = question,
    						fcontact = contact,
    						mid 	 = MyUserData:getId(),
    						username = MyUserData:getNick(),
						};

    app:postFrontStaticstics("clickFeedBackGameType"..tostring(self.mGameId))
	HttpModule.getInstance():execute(HttpModule.s_cmds.SendFeedback, param_post, false, true);

end

--反馈的机型列表
function SettingAndFeedBackPopu:getFcontact()

end

--发送反馈图片
function SettingAndFeedBackPopu:sendFeedbackImg(fileName, fid)

	if fileName == "" then
		return ;
	end

	local param_post = {
							param = {
								appid 	 = FEEDBACK_APPID,
	    						ftype 	 = FEEDBACK_IMG_FTYPE,
	    						game 	 = FEEDBACK_GAME,
	    						title 	 = self.mGameTitle,
	    						fid 	 = fid,
	    						pfile 	 = fileName,
							},
							method 	 = 'Feedback.mSendFeedBackPicture',
						};
	
	NativeEvent.getInstance():uploadFeedbackImage('http://feedback.kx88.net/api/api.php', fileName, param_post);					
end
--是否 解决
function SettingAndFeedBackPopu:sendFeedbackSolve(fid, bSolve )
	--发送请求

	local param_post = {
							appid 	 = FEEDBACK_APPID,
    						ftype 	 = FEEDBACK_FTYPE,
    						game 	 = FEEDBACK_GAME,
    						title 	 = self.mGameTitle,
    						fid 	 = fid;
    						solved 	 = bSolve and "1" or "0"; 
						};

	HttpModule.getInstance():execute(HttpModule.s_cmds.SolveFeedback, param_post, false, true);
    
end
--满意度
function SettingAndFeedBackPopu:sendFeedbackVote(fid, vote )
	--发送请求
	local param_post = {
							appid 	 = FEEDBACK_APPID,
    						ftype 	 = FEEDBACK_FTYPE,
    						game 	 = FEEDBACK_GAME,
    						title 	 = self.mGameTitle,
    						fid 	 = fid;
    						score 	 = vote;
						};

	HttpModule.getInstance():execute(HttpModule.s_cmds.VoteFeedback, param_post, false, true);
    
end
----------------------------------------------------------------------------------
--http callback
----------------------------------------------------------------------------------
function SettingAndFeedBackPopu:onHttpRequestsCallBack(command, ...)
	if SettingAndFeedBackPopu.httpRequestsCallBackFuncMap[command] then
     	SettingAndFeedBackPopu.httpRequestsCallBackFuncMap[command](self,...)
	end
end 


--发送反馈回调
function SettingAndFeedBackPopu:sendFeedbackCallBack(isSuccess, data)

	if not isSuccess or not data then
	    return;
	end
	if isSuccess then

		self.mFid = data.ret.fid or 0;
		if self.mFid == 0 then
			self.mLastQuestion = "";
			AlarmTip.play(STR_FEEDBACK_FAILD);
			return;
		end
		--如果有图片开始上传图片
		 self:sendFeedbackImg(self.m_uploadFeedbackFile, self.mFid);
		

		AlarmTip.play(STR_FEEDBACK_SUC);
		self.mEtQuestion:setText("");
		self.mEtQuestion:setHintText(STR_FEEDBACK_INPUT_HINT, 0xbc, 0xf0, 0xff);

		local service = {};
		service.question = self.mLastQuestion;
		self.mServiceList[#self.mServiceList + 1] = service;

		--更新反馈列表
		self:updateFeedbackList();

		-- self.mTextTip:setVisible(false);
	
	end
end

--请求反馈列表回调
function SettingAndFeedBackPopu:requsetFeedbackListCallBack (isSuccess, data )
	
	if not isSuccess or not data then
	    return;
	end

	if isSuccess then
		local feedbackCount = tonumber(#data.ret);
		if feedbackCount > 0 then
			for k, v in pairs(data.ret) do
				local service = {};
				service.id 		 = v.id or "";
				service.question = v.msgtitle or "";
				service.answer	 = v.rptitle or "";
				service.votescore= v.votescore or "";
				service.readed	 = v.readed or "";
				self.mServiceList[#self.mServiceList + 1] = service;
			end

			self:updateFeedbackList();
		else
			-- self.mTextTip:setVisible(true);
		end
	end
end


function SettingAndFeedBackPopu:SolveFeedbackCallBack(isSuccess, data )
	
end

function SettingAndFeedBackPopu:VoteFeedbackCallBack(isSuccess, data )

end

--native callback
function SettingAndFeedBackPopu:onNativeCallBack(key, result)
	if key == kPickPhoto then
		if key and result then
			self.m_uploadFeedbackImg:setFile(result.name:get_value());
			self.m_uploadFeedbackImg:setVisible(true);
			--upload image 
			self.m_uploadFeedbackFile = result.name:get_value();
		else
			AlarmTip.play(STR_SAVE_PIC_FAILD);
		end
	elseif key == kUploadFeedbackImage then
		if key and result then
			AlarmTip.play(STR_UPLOAD_PIC_SUC);
			self.m_uploadFeedbackFile = "";
			self.m_uploadFeedbackImg:setFile("feedback/photo_mask.png");
			self.m_uploadFeedbackImg:setVisible(false);
		else
			AlarmTip.play(STR_UPLOAD_PIC_FAILD);
		end
		
	end

end

function SettingAndFeedBackPopu:dismiss(...)
    return SettingAndFeedBackPopu.super.dismiss(self, ...)
end

function SettingAndFeedBackPopu:showChooseGame()
	local viewFeedback = self:findChildByName("view_feedback")
    local question 	= self.mEtQuestion:getText();
	local len = string.len(question);
	if len < 20 then
		AlarmTip.play(STR_FEEDBACK_MIN_LEN);
		return ;
	end
	if len > 1000 then
		AlarmTip.play(STR_FEEDBACK_MAX_LEN);
		return ;
	end
    
    self.mGameTitle = ''
    self.mGameId = nil
    self:findChildByName("img_popubg"):setVisible(false)
    local viewChoose = self:findChildByName('img_chooseBg')
    viewChoose:setVisible(true)

    local SelectItem = require('popu.lobby.item.selectItem')
    

    local gameList = viewChoose:findChildByName('sv_chooseGameList')
    gameList:setDirection(kVertical)
    --gameList:setScrollBarWidth(8)
    gameList:removeAllChildren()
    local wList, hList = gameList:getSize()
    local wInterval = math.floor(wList / 3)

    --local gameName = {[1002] = STR_APP_DICE, [1003] = STR_APP_H3, [1004] = STR_APP_MAKHOS, [1005] = "MIXED_TEN", [1006] = "KS", [666] = "OTHER"}

    local curRowNum = 0
    local curColumnNum = 0
    local allSelectItem = {}
    
    local originalGameId = app:getGameIds()
    local gameOptions = {}
    for i = 1, #originalGameId do
        if originalGameId[i] > 0 then
            local curGame = app:getGame(originalGameId[i])
            if curGame then
                local option = {}
                option.id = originalGameId[i]
                option.icon = curGame:getIconFile()
                option.name = curGame:getName()
                table.insert(gameOptions, option)
            end
        end
    end
    local otherOption = {id = 666, icon = "feedback/game_666.png", name = STR_OTHER}
    table.insert(gameOptions, otherOption)

    for i = 1, #gameOptions do
        local gameSelectItem = new(SelectItem, gameOptions[i].icon, gameOptions[i].name)
        local wItem, hItem = gameSelectItem:getSize()
	        gameSelectItem:setPos(curColumnNum * wInterval, curRowNum * (hItem + 15))
	        curColumnNum = curColumnNum + 1
	        if curColumnNum == 3 then
	    	    curRowNum = curRowNum + 1
	    	    curColumnNum = 0
	        end
	        allSelectItem[i] = gameSelectItem
            gameList:addChild(gameSelectItem)
    end

    for i = 1, #gameOptions do
        if allSelectItem[i] then
	        allSelectItem[i]:setOnClick(self, function()
	    	    for j = 1, #gameOptions do
	    		    allSelectItem[j]:setIsChosen(false)
	    	    end
	    	    allSelectItem[i]:setIsChosen(true)
                self.mGameTitle = allSelectItem[i]:getItemTitle()
                self.mGameId = gameOptions[i].id
	        end)
        end
    end

    viewChoose:findChildByName('btn_chooseSend'):setOnClick(self, function()
        app:postFrontStaticstics("clickFeedBackSendBtn")
        if self.mGameTitle ~= '' then
            self:onClickSendBtn()
        else
            AlarmTip.play(STR_FEEDBACK_CHOOSE_FIRST)
        end
     end)

end
--回调函数映射表

SettingAndFeedBackPopu.httpRequestsCallBackFuncMap = {
	[HttpModule.s_cmds.GetFeedbackList] = SettingAndFeedBackPopu.requsetFeedbackListCallBack,
	[HttpModule.s_cmds.SendFeedback] 	= SettingAndFeedBackPopu.sendFeedbackCallBack,
	[HttpModule.s_cmds.SolveFeedback] 	= SettingAndFeedBackPopu.SolveFeedbackCallBack,
	[HttpModule.s_cmds.VoteFeedback] 	= SettingAndFeedBackPopu.VoteFeedbackCallBack,
	
}

return SettingAndFeedBackPopu