local SettingPopu = class(require("popu.gameWindow"))
new(Image, "setting.png")

function SettingPopu:initView(data)
	--返回
	self:findChildByName("btn_close"):setOnClick(self, function ( self )
		-- body
		self:dismiss();
	end);
    
    local viewInner = self:findChildByName("view_inner")
    viewInner:findChildByName("text_uid"):setText("ID:"..MyUserData:getId());
    viewInner:findChildByName("text_nick"):setText(MyUserData:getNick());
    viewInner:findChildByName("view_top"):findChildByName("text_level"):setText("Lv."..MyUserData:getLevel())
	self:setUserHead(MyUserData:getHeadName());
    viewInner:findChildByName("btn_logout"):setOnClick(self, function ( self )
		-- body
		self:dismiss(true);
		NativeEvent.getInstance():logout({});
		EventDispatcher.getInstance():dispatch(Event.Message, "logout", 0)
		
	end);

    local viewBottom = viewInner:findChildByName("img_bottom")
	viewBottom:findChildByName("text_shake"):setText(STR_SHAKE);
	viewBottom:findChildByName("text_music"):setText(STR_MUSIC);
	viewBottom:findChildByName("text_sound"):setText(STR_SOUND);
	viewBottom:findChildByName("text_version"):setText(STR_VERSION);
	viewBottom:findChildByName("text_ver"):setText(PhpManager:getVersionName());

	viewBottom:findChildByName("text_fanspage"):setText(STR_FANSPAGE);
    viewBottom:findChildByName("text_follow"):setText(STR_FOLLOW);
    viewBottom:findChildByName("text_score"):setText(STR_SCORE)
	viewBottom:findChildByName("text_score_check"):setText(STR_CHECK)
	--self:findChildByName("text_logout"):setText(STR_LOGOUT);
	viewBottom:findChildByName("text_about"):setText(STR_ABOUT);
	viewBottom:findChildByName("text_check"):setText(STR_CHECK);
    viewBottom:findChildByName("text_more"):setText(STR_MORE_GAME)
    viewBottom:findChildByName("text_moreCheck"):setText(STR_CHECK)

	--评分
	viewBottom:findChildByName("btn_score"):setOnClick(self, function(self) 
		
		NativeEvent.getInstance():score("")
		end)

	viewBottom:findChildByName("btn_about"):setOnClick(self, function ( self )
		-- body
		-- self:dismiss(true);
		-- WindowManager:showWindow(WindowTag.FeedbackPopu, {}, WindowStyle.NORMAL)
		
	end);
    viewBottom:findChildByName("btn_more"):setOnClick(self, function(self)
        self:dismiss()
        NativeEvent.getInstance():showAd(false)
    end)

    local fansPage = {
        [tostring(GAME_LOBBY_ID.Dice)] = 'https://www.facebook.com/jogododado/',
        [tostring(GAME_LOBBY_ID.Buraco)] = 'https://www.facebook.com/buracobra/',
        [tostring(GAME_LOBBY_ID.Truco)] = 'https://www.facebook.com/trucobra/',
  
    }
	viewBottom:findChildByName("btn_follow"):setOnClick(self, function ( self )
		-- body
		self:dismiss(true);
        local link = fansPage[PhpManager:getGame()]
        if link then
            NativeEvent.getInstance():openLink(link)
        end
	end);
	
	--音乐
    local musicSwitch = viewBottom:findChildByName("btn_music")
    musicSwitch:setOnClick(self, function(self)
        if GameSetting:getMusicVolume() > 0 then
            GameSetting:setMusicVolume(0.0)
            kMusicPlayer:setVolume(0.0)
        else
            GameSetting:setMusicVolume(1.0)
            kMusicPlayer:setVolume(1.0)
        end
    end)
    UIEx.bind(self, GameSetting, "musicVolume", function(value)
        local switch = value > 0
        musicSwitch:findChildByName("img_on"):setVisible(switch)
        musicSwitch:findChildByName("img_off"):setVisible(not switch)
    end)
    GameSetting:setMusicVolume(GameSetting:getMusicVolume())
	

	--音效
	local effectSwitch = viewBottom:findChildByName("btn_effect")
	effectSwitch:setOnClick(self, function ( self )
		if GameSetting:getSoundVolume() > 0 then
			GameSetting:setSoundVolume(0.0)
			kEffectPlayer:setVolume(0.0)
		else
			GameSetting:setSoundVolume(1.0)
			kEffectPlayer:setVolume(1.0)
		end
	end);
    UIEx.bind(self, GameSetting, "soundVolume", function(value)
        local switch = value > 0
        effectSwitch:findChildByName("img_on"):setVisible(switch)
        effectSwitch:findChildByName("img_off"):setVisible(not switch)
    end)
	GameSetting:setSoundVolume(GameSetting:getSoundVolume())

	self:findChildByName('btn_portrait'):setEnable(false)
end

--设置性别

function SettingPopu:setUserHead(headName)
    local headView 		= self:findChildByName("view_portrait")
    headView:removeAllChildren()
    local imgHead = new(Mask, headName, popu_map["popu.public.head_mask.png"] or "")
    imgHead:setSize(headView:getSize())
    imgHead:setAlign(kAlignCenter)
    headView:addChild(imgHead)
	
end
function SettingPopu:onHidenEnd(...)
	SettingPopu.super.onHidenEnd(self, ...)
	GameSetting:save()
end

return SettingPopu