require(ViewPath .. "shopItemLayout")
require(ViewPath .. "shopItemLayout1")
require(ViewPath .. "shopPayItemLayout")
require(ViewPath .. "shopSwitchButton")

local ID_INTERACTIVIRE_PROP = 2001
local ID_DUMMY_TIPS         = 1000
local ID_PRIVATE_ROOM_CARD  = 3000

local ShopPopu = class(require("popu.gameWindow"))
new(Image, "shop.png")
require("pintu.shop")

function ShopPopu:ctor()
	EventDispatcher.getInstance():register(HttpModule.s_event, self, self.onHttpResponse);
    NativeEvent.getInstance():checkUnfinishIAP()
end

function ShopPopu:dtor(viewConfig, data)
	EventDispatcher.getInstance():unregister(HttpModule.s_event, self, self.onHttpResponse);
    ShopPopu.super.dtor(self, viewConfig,data)
end

function ShopPopu:initView(data)
    self.toPmode = data and tonumber(data.pmode)
    self.toProp = data and data.to == "props"
	self.coinflashs = {};
	local backBtn = self:findChildByName("btn_back");
	backBtn:setOnClick(self, function ( self )
		self:dismiss()--nil, nil, WindowStyle.POPUP);
	end);
	--金币变化回调
	UIEx.bind(self, MyUserData, "money", function(value)
		self:setMoney(value)
	end)
	-- --初始化金币
	self:setMoney(MyUserData:getMoney());

	if not MyPayMode then
        self:execHttpCmd(HttpModule.s_cmds.GET_PAY_MODE, {}, true, true, self:findChildByName("view_loading"))
        --self:playLoading()
		--HttpModule.getInstance():execute(HttpModule.s_cmds.GET_PAY_MODE, {}, true, true);
	else
		self:initPayMode(MyPayMode);
	end

end

function ShopPopu:initPayMode( payMode )
	-- body
	--ScrollBar.setDefaultImage("rank/scroller.png");
	if not payMode then
		return 
	end
	local viewList = self:findChildByName('view_paylist');
	viewList:removeAllChildren();
	local viewWidth, viewHeight = viewList:getSize();
	
	local scPayType = new(ScrollView, 0, 0, viewWidth, viewHeight, false);
	scPayType:setScrollBarWidth(0);

    --客户端可以处理的支付方式
    local path ={	
        [12]={bg = 'popu.public.tab_', icon = 'shop.google_'},
        [240]={bg = 'popu.public.tab_', icon = 'shop.JMT_'},
        [645]={bg = 'popu.public.tab_', icon = 'shop.onetwocall_'},
        [646]={bg = 'popu.public.tab_', icon = 'shop.truemoney_'},
        [474]={bg = 'popu.public.tab_', icon = 'shop.truemoney_'},   --安卓mol trueMoney
        [600]={bg = 'popu.public.tab_', icon = 'shop.e2p_'},         -- 安卓E2P
        [99]={bg = 'popu.public.tab_', icon = 'shop.appStore_'},
        [741]={bg = 'popu.public.tab_', icon = 'shop.JMT_'},        --IOS bluePay
        [621]={bg = 'popu.public.tab_', icon = 'shop.onetwocall_'},
        [625]={bg = 'popu.public.tab_', icon = 'shop.e2p_'},
        [623]={bg = 'popu.public.tab_', icon = 'shop.truemoney_'},
        [601]={bg = 'popu.public.tab_', icon = 'shop.linePay_'},
        [763]={bg = 'popu.public.tab_', icon = 'shop.linePay_'},    --IOS linepay
        [239]={bg = 'popu.public.tab_', icon = 'shop.fortumo_'},
	}
    
    local viewShopList = self:findChildByName('view_shoplist');
    local scGoodsW, scGoodsH = viewShopList:getSize();
    local loadedCount = 0
	for i = 1, #payMode do
		local pay = payMode[i]
        --只有客户端存在的支付方式才处理，减少后台的版本控制
		if path[pay:getId()] then
            local viewGoods = SceneLoader.load(shopSwitchButton)
            viewGoods:setAlign(kAlignCenter)
            viewShopList:addChild(viewGoods)
            local viewSelect = viewGoods:findChildByName("view_select")
            viewSelect:findChildByName("text_money"):setText(STR_CHIP)
            viewSelect:findChildByName("text_prop"):setText(STR_PROP)
            local btnMoney = viewGoods:findChildByName("btn_money")
            btnMoney:enableAnim(false)
            btnMoney:findChildByName("text_button"):setText(STR_CHIP)
            local btnProp = viewGoods:findChildByName("btn_prop")
            btnProp:enableAnim(false)
            btnProp:findChildByName("text_button"):setText(STR_PROP)
            local scGoods = viewGoods:findChildByName("sv_money")
            scGoods:setScrollBarWidth(0);
            local scProp = viewGoods:findChildByName("sv_prop")
            scPayType:setScrollBarWidth(0);
            local viewMoney = viewGoods:findChildByName("view_money")
            local viewProp = viewGoods:findChildByName("view_prop")
            btnMoney:setOnClick(self, function(self)
                viewMoney:setVisible(true)
                viewSelect:findChildByName("img_money"):setVisible(true)
                viewProp:setVisible(false)
                viewSelect:findChildByName("img_prop"):setVisible(false)
            end)
            btnProp:setOnClick(self, function(self)
                viewMoney:setVisible(false)
                viewSelect:findChildByName("img_money"):setVisible(false)
                viewProp:setVisible(true)
                viewSelect:findChildByName("img_prop"):setVisible(true)
            end)
            if pay:getId() == 239 then
                btnProp:setEnable(false)
            end
    
		    local item = SceneLoader.load(shopPayItemLayout);

		    UIEx.bind(item, pay, "status", function(value)
			    local id = pay:getId();
			    local btnBg = item:findChildByName('btn_bg')
                btnBg:setFile(popu_map[string.format("%s%s.png", path[id] and path[id].bg or "", value)] or "");
			    btnBg:setAlign(kAlignCenter);
                btnBg:setSize(btnBg.m_res.m_width, btnBg.m_res.m_height);
                item:setSize(btnBg:getSize());
			    local imgIcon = item:findChildByName('img_icon');
			    imgIcon:setFile(shop_map[string.format("%s%s.png", path[id] and path[id].icon or "", value)] or "");
			    imgIcon:setSize(imgIcon.m_res.m_width, imgIcon.m_res.m_height);
			    viewGoods:setVisible(value == 1)
		    end)

		    UIEx.bind(item, pay, "id", function(value)
			
		    end)

		    UIEx.bind(scGoods, pay, "pay", function(value)
			    if value then
                --true money的，调用支付的输入兑换码窗口
				    if not scGoods:getChildren() or #scGoods:getChildren() == 0 then

					    if pay:getId() == 239 then
                            local gooditem = self:initGoodsFortumo(tonumber(pay:getId()), value)
                            gooditem:setAlign(kAlignCenter)
                            viewMoney:addChild(gooditem)
						    --googleplay 和blue pay 的，显示价格和兑换的金币量，点击确定购买
					    else
                            local wInterval = scGoods:getSize() / 3
                            local curRowNum = 0
                            local curColNum = 0
						    for i = 1, value:count() do
                                local gooditem = self:initGoodsByCash(tonumber(pay:getId()), value, i)
							    local gooditemW, gooditemH = gooditem:getSize();
                                --离最左边保持20像素的距离
                                gooditem:setPos(curColNum * wInterval + 20, curRowNum * (gooditemH + 10) )
                                curColNum = curColNum + 1
                                if curColNum == 3 then
                                    curColNum = 0
                                    curRowNum = curRowNum + 1
                                end

							    scGoods:addChild(gooditem);

						    end
					    end
                        scGoods:setSize(scGoods:getSize())
				    end
			    else
                    self:execHttpCmd(HttpModule.s_cmds.GET_PAY_LIST, {pmode=pay:getId()}, true, true, self:findChildByName("view_loading"))
			    end
		    end)

            UIEx.bind(scProp, pay, "prop", function(value)
                if value then
                    --未加载过再加载
                    if not scProp:getChildren() or #scProp:getChildren() == 0 then
                        --用点卡兑换的，输入兑换码
                        if pay:getId() == 645 or pay:getId() == 646 or pay:getId() == 621 or pay:getId() == 623  or pay:getId() == 474 then           
                            local gooditem = self:initGoodsByCardNum(tonumber(pay:getId()), value)
                            gooditem:setAlign(kAlignCenter)
                            viewProp:addChild(gooditem)
                        --用google checkout和blue pay的，    
                        else
                            local wInterval = scProp:getSize() / 3
                            local curRowNum = 0
                            local curColNum = 0
						    for i = 1, value:count() do
                                local gooditem = self:initGoodsByCash(tonumber(pay:getId()), value, i)
							    local gooditemW, gooditemH = gooditem:getSize();
                                --离最左边保持20像素的距离
                                gooditem:setPos(curColNum * wInterval + 20, curRowNum * (gooditemH + 10) )
							    --gooditem:setPos(0, (gooditemH + 10) * (i - 1));
                                curColNum = curColNum + 1
                                if curColNum == 3 then
                                    curColNum = 0
                                    curRowNum = curRowNum + 1
                                end
                                scProp:addChild(gooditem)
                            end
                        end
                        scProp:setSize(scProp:getSize())
                    end
                else
                    self:execHttpCmd(HttpModule.s_cmds.GET_PAY_PROP_LIST, {pmode = pay:getId()}, true, true, self:findChildByName("view_loading"))
                end
            end)

		    item:findChildByName('btn_bg'):setOnClick(self, function ( self )
		    -- body
				    for i = 1, #payMode do
					    local p = payMode[i];
					    if p ~= pay:getId() then
						    if p:getStatus() ~= 0 then
							    p:setStatus(0);
						    end
					    end
				    end

				    if pay:getStatus() == 0 then
					    pay:setStatus(1);
					    pay:setPay(pay:getPay())
                        pay:setProp(pay:getProp())
				    end
				    app:postFrontStaticstics(pay:getId() == 12 and 'clickCheckout' or 'clickJMT')

		    end);
            loadedCount = loadedCount + 1
		    local w, h = item:getSize();
		    item:setPos(0, (h + 10) * (loadedCount - 1) + 10);
		    scPayType:addChild(item);

		    pay:setId(payMode[i]:getId());
		    pay:setGoods(nil);
		    pay:setStatus(0);

            --需要跳转到指定支付方式
            if self.toPmode then
                if self.toPmode == pay:getId() then
                    pay:setStatus(1);
		            pay:setPay(pay:getPay());
                    pay:setProp(pay:getProp())
                    --需要直接跳到道具界面
                    if self.toProp then
                        btnProp.m_eventCallback.func(btnProp.m_eventCallback.obj)
                    end
                    scPayType:scrollItemToView(item)
                end
            --未指定，跳转到第一个商品
            elseif loadedCount == 1 then
                pay:setStatus(1);
		        pay:setPay(pay:getPay());
                pay:setProp(pay:getProp())
                if self.toProp then
                    btnProp.m_eventCallback.func(btnProp.m_eventCallback.obj)
                end
            end
        end
	end

	scPayType:setSize(scPayType:getSize());
	viewList:addChild(scPayType);

end

function ShopPopu:initShop( payType )
	-- body

end

function ShopPopu:initGoodsFortumo(pmode, value)
    local gooditem = SceneLoader.load(shopItemLayout1);
    gooditem:setAlign(kAlignCenter)
    local propCfgList = MyUserData.propCfgList or {}
    local textGoods = gooditem:findChildByName('tv_goods')
    textGoods:setText("1)92092 ficha for 2.99 BRL\n\n2)185492 ficha for 5.99 BRL\n\n3)310692 ficha for 9.99 BRL\n\n4)528600 ficha for 17.00 BRL")
    textGoods:setScrollBarWidth(0)
    gooditem:findChildByName('btn_buy'):setOnClick(self, function (self)
        MyPay:payOrder(pmode, value:get(1))
    end)
    return gooditem
end

--初始化兑换码的输入
function ShopPopu:initGoodsByCardNum(pmode, value)
    local gooditem = SceneLoader.load(shopItemLayout1);
    gooditem:setAlign(kAlignCenter)
    local propCfgList = MyUserData.propCfgList or {}
	local str = ''
	for i = 1, value:count() do
		local shop = value:get(i);
        local exchangeCount = ToolKit.skipMoney(shop:getPchips())
        local goodsType = STR_CHIP
        local prop = propCfgList[tostring(shop:getPcard())]
        --商品id在道具列表里，属于道具商品
        if prop then
            goodsType = prop.name
            exchangeCount = shop:getCount()
            gooditem:findChildByName("img_chip"):setVisible(false)
            gooditem:findChildByName("img_prop"):setVisible(true)
            gooditem:findChildByName("img_propContent"):setVisible(true)
        end
        local extra = shop:getExtra()
        if extra > 0 then
            exchangeCount = exchangeCount.."+"..ToolKit.formatChip(extra)
        end
		str = str .. string.format('%s) %s%s %s %s %s\n\n', i, shop:getPamount(), shop:getCurrency(), STR_BUY, exchangeCount, goodsType)

	end
	local textGoods = gooditem:findChildByName('tv_goods')
    textGoods:setText(str)
    textGoods:setScrollBarWidth(0)
	gooditem:findChildByName('btn_buy'):setOnClick(self, function (self)
        MyPay:payOrder(pmode, value:get(1))
	end)
    return gooditem
end

function ShopPopu:initGoodsByCash(pmode, value, i)
    local shop = value:get(i)
    local gooditem = SceneLoader.load(shopItemLayout);
    
    --兑换筹码
    local iconFile = gooditem:findChildByName('img_icon')
    local imgFile = nil
    local propCfgList = MyUserData.propCfgList or {}
    local prop = propCfgList[tostring(shop:getPcard())]
    --商品是道具商品
    if prop then
        imgFile = shop_map[string.format("shop.icon_%s.png", prop.keyName or "")]
        --拼图里不存在这张图片，使用商品列表里的图片，从后台下载
        if not imgFile then
            imgFile = prop:getImgName()
        end
        iconFile:setPos(0, 60)
        gooditem:findChildByName("img_shadow"):setVisible(false)
        local strNum = tostring(prop.name)..":"..shop:getCount()
        gooditem:findChildByName('text_goodcount'):setText(shop:getCount().." "..tostring(prop.name))
    else
        --默认兑换金币
        imgFile = shop_map[string.format("shop.chip_%s.png", i > 6 and 6 or i)]
        gooditem:findChildByName('text_goodcount'):setText(ToolKit.skipMoney(shop:getPchips()));
    end
    local extra = shop:getExtra()
    if extra > 0 then
        local imgExtra = gooditem:findChildByName("img_extra")
        imgExtra:setVisible(true)
        imgExtra:findChildByName("text_extra"):setText("+"..ToolKit.formatChip(extra))
    end

    iconFile:setFile(imgFile or "")
    local w, h = iconFile:getSize()
    iconFile:setSize(iconFile.m_res.m_width * h / iconFile.m_res.m_height, h)
--    if shop:getDiscount() < 1 then
--        gooditem:findChildByName("text_discount"):setText(shop:getDiscount())
--    else
--        gooditem:findChildByName("view_discount"):setVisible(false)
--    end
    gooditem:findChildByName('text_goodinfo'):setText(shop:getPdesc());
    gooditem:findChildByName('text_money'):setText(string.format("%s%s", shop:getPamount(), shop:getCurrency()));
							
    gooditem:findChildByName('btn_buy'):setOnClick(self, function (self)
	    MyPay:payOrder(pmode, shop, imgFile)
    end)
    return gooditem
end

function ShopPopu:setMoney( money )
	-- body
    local text_money = self:findChildByName("img_payModeBg"):findChildByName("text_money")
    text_money:setText(tonumber(money) or 0)
end

function ShopPopu:onHttpResponse( command, ... )
	-- body
	local func = self.s_httpEventFuncMap[command];
	if func then
		func(self, ...);
	end
end

function ShopPopu:onPayModeResponse(isSuccess, data)
	self:initPayMode(MyPayMode);
    --self:stopLoading()
end

function ShopPopu:onPayListResponse(isSuccess, data)

    --self:stopLoading()
end


--[[
	通用的（大厅）协议
]]
ShopPopu.s_httpEventFuncMap = {
	[HttpModule.s_cmds.GET_PAY_MODE] 		= ShopPopu.onPayModeResponse,
	[HttpModule.s_cmds.GET_PAY_LIST] 		= ShopPopu.onPayListResponse,

}



return ShopPopu