require(ViewPath .. "taskItemLayout")
local TaskPopu = class(require("popu.gameWindow"))
new(Image, "task.png")
require("pintu.task")

local PROGRESS_LEN_MAX = 135
local PROGRESS_LEN_MIN = 28

function TaskPopu:ctor()
	-- body
end

function TaskPopu:dtor()
    MyUserData:setTaskList(self.mTask)
end

function TaskPopu:initView(data)
	--返回
	self.mInRoom = data.inRoom
	local btnClose = self:findChildByName("btn_close");
	btnClose:setOnClick(self, function ( self )
		-- body
		self:dismiss();
	end);

	self.mTask 	 = MyUserData:getTaskList() or new(require("data.taskData"))
	self.mScTask = self:findChildByName("sc_task");

end

function TaskPopu:onShowEnd()
    self:execHttpCmd(HttpModule.s_cmds.GET_TASK, {mid = MyUserData:getId()}, true, self.mTask:count() == 0, self:findChildByName("view_inner"))
    self.super.onShowEnd(self)
    self:initTask()
end

function TaskPopu:initTask()
	-- body
	self.mScTask:removeAllChildren();
--增加签到任务
    local attendenceData = MyUserData:getAttendenceReward()
--还未签到，显示在第一个
    local curHeight = 0
  --  if attendenceData and not attendenceData.hasSigned then
  --      local item = self:initAttendenceItem()
  --      item:setPos(0, curHeight)
   --     local w, h = item:getSize()
   --     curHeight = curHeight + h
  --      self.mScTask:addChild(item)
 --   end
	for i = 1, self.mTask:count() do
		local item = self:createItem(self.mTask:get(i));
		local w, h = item:getSize();
        item:setPos(0, curHeight)
        curHeight = curHeight + h
		--item:setPos(0, (i - 1) * (h));
		self.mScTask:addChild(item);
	end
--已经签到了，放在末尾
 --   if attendenceData and attendenceData.hasSigned then
   --     local item = self:initAttendenceItem()
    --    item:setPos(0, curHeight)
   --     self.mScTask:addChild(item)
   -- end

	self.mScTask:setSize(self.mScTask:getSize());
end

function TaskPopu:createItem(data)
	local item = SceneLoader.load(taskItemLayout);
	item:findChildByName("img_icon"):setFile(task_map['task.icon_level_1.png'])--(task_map[string.format("%s.%s","task", data:getIcon())] or "");
	if item:findChildByName("img_icon").m_res.m_width == -1 then
		item:findChildByName("img_icon"):setFile(task_map[string.format("%s.%s","task", 'icon_default.png')]);
	end

	UIEx.bind(self, data, "name", function(value)
		item:findChildByName("text_title"):setText(value);
	end)

	UIEx.bind(self, data, "process", function(value)
		local cur, total = string.match(value, '(%d+)/(%d+)')
		cur = tonumber(cur or 0)
		total = tonumber(total or 0)
		item:findChildByName("text_progress"):setText(value);
		local progress = item:findChildByName("img_progress");
		--44为9宫格的宽度，该宽度iamge类没有保存，故无法获到，只能硬编码
		local percent = total ~= 0 and cur/total or 0;
		local width = (PROGRESS_LEN_MAX - PROGRESS_LEN_MIN) * percent;
		progress:setSize(PROGRESS_LEN_MIN + width, progress.m_res.m_height);
	end)

	UIEx.bind(self, data, "reward", function(value)
		local reward = value   
        --金币奖励
		if reward.coins then
			item:findChildByName("text_coin"):setText(ToolKit.skipMoney(reward.coins or 0));
        --道具奖励
        elseif reward.props then
            local propList = MyUserData.propCfgList or {}
            for k, v in pairs(reward.props) do
                local id = tostring(k)
                local count = tonumber(v)
                --拼图里有道具的图片，用拼图的，没有就用道具配置列表里的，便于扩展
                if propList[id] then
                    local imgFile = task_map[string.format("task.icon_%s.png", propList[id].keyName or "")]
                    if not imgFile then
                        imgFile = propList[id]:getImgName()
                    end
                    item:findChildByName("img_rewardIcon"):setFile(imgFile)
                    item:findChildByName("text_coin"):setText(count or "")
                    break
                end
            end
		end
	end)
-- 领奖状态 0未完成任务，1已完成任务，2已领奖
	UIEx.bind(self, data, "rewardStatus", function(value)
		local btnFile = {
			[0] = popu_map['popu.public.btn_yellow.png']  or "",
			[1] = popu_map['popu.public.btn_green.png']  or "",
			[2] = popu_map['popu.public.btn_gray.png']  or "",
		}
		local btn = item:findChildByName("btn_task")
		btn:setFile(btnFile[value])
		local title = btn:findChildByName("text_btnTitle")
		if value == 0 then
			title:setText(STR_DO_TASK, 0, 0, 0x99, 0x53, 0x32);
			if self.mInRoom then 
				item:findChildByName("btn_task"):setVisible(false) 
			end
		elseif value == 1 then
			title:setText(STR_GET_TASK_AWARD, 0, 0, 0x17, 0x50, 0x35);
		elseif value == 2 then
			title:setText(STR_GOT_TASK_AWARD, 0, 0, 0xC1, 0x77, 0x40);
			btn:setEnable(false)
		end

	end)
	item:findChildByName("btn_task"):setOnClick(self, function ( self )
		-- body
		local rewardStatus = data:getRewardStatus()
		if rewardStatus == 0 then
			local other = data:getOther()

			if other.jump == 1 then --打开FACEBOOK
				WindowManager:showWindow(WindowTag.FbInvitePopu, {}, WindowStyle.NORMAL)
            elseif other.jump == 2 then
                WindowManager:showWindow(WindowTag.FbInvitePopu, {to = "call"}, WindowStyle.NORMAL)
			elseif other.jump > 1000 then
				local game = app:getGame(other.jump)
				if game then 
					if other.level > 0 then
						game:enterRoom(nil, game:getRoomFromLevel(other.level)) 
					else
						game:enterRoom() 
					end
				end

			elseif other.jump == 0 then
				local gameId = tonumber(app:getGameIds()[1] or 0)
				local game = app:getGame(gameId)
				if game then 
					if other.level > 0 then
						game:enterRoom(nil, game:getRoomFromLevel(other.level)) 
					else
						game:enterRoom() 
					end
				end
			end
		elseif rewardStatus == 1 then
            self:execHttpCmd(HttpModule.s_cmds.GET_TASK_AWARD, {tid = data:getId()}, true, true, self:findChildByName("view_inner"))
		elseif rewardStatus == 2 then
		end
	end)

	data:setName(data:getName())
	data:setProcess(data:getProcess())
	data:setReward(data:getReward())
	data:setRewardStatus(data:getRewardStatus())

	return item;
end

--返回index
function TaskPopu:findTaskById( id )
	-- body
	if id then
		for i = 1, self.mTask:count() do
			local task = self.mTask:get(i) 
			if tonumber(task:getId()) == tonumber(id) then
				return task
			end
		end
	end
end
--个人消息
function TaskPopu:onGetTask(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		local tasks = data.data
		self.mTask:clear()
        local rewardCount = 0
		for i = 1, #tasks do
			local task = setProxy(new(require('data.task')))
			task:init(tasks[i]);
			self.mTask:add(task)
            --有未领奖的任务数量
            if tasks[i].rewardStatus == 1 then
                rewardCount = rewardCount + 1
            end
		end
        MyUserData:setTaskAward(rewardCount)
	end
	self:initTask()
end

function TaskPopu:onGetTaskAward(isSuccess, data)
	if app:checkResponseOk(isSuccess, data) then
		local task = self:findTaskById(tonumber(data.data.tid))
		if task then task:setRewardStatus(2) end
		AlarmTip.play(data.data.reward)
        if data.data.money then
		    MyUserData:addMoney(data.data.money or 0, true)
        elseif data.data.props then
            local props = data.data.props
            local count = MyUserData:getPropNum(props.pid) + (tonumber(props.num) or 0)
            MyUserData:setPropNum(props.pid, count)
        end
        --领奖，可领数目-1
        MyUserData:setTaskAward(MyUserData:getTaskAward() - 1)
	end
end

--初始化签到任务
function TaskPopu:initAttendenceItem()
    local item = SceneLoader.load(taskItemLayout);
    if self.mInRoom then 
		item:findChildByName("btn_task"):setVisible(false) 
	end
    item:findChildByName("img_icon"):setFile(task_map["task.icon_attendence.png"])
    item:findChildByName("view_award"):setVisible(false)
    item:findChildByName("text_title"):setText(STR_ATTENDENCE_TASK)
    local attendenceData = MyUserData:getAttendenceReward()
    local progress = item:findChildByName("img_progress");
    local width, height = progress:getSize()
--已经签到
     item:findChildByName("text_progress"):setText("1/1")
    --硬编码122像素，进度条100%
    progress:setSize(PROGRESS_LEN_MAX, height)
    if attendenceData.hasSigned then
       
        local btn = item:findChildByName("btn_task")
        local title = btn:findChildByName("text_btnTitle")
		title:setText(STR_GOT_TASK_AWARD, 0, 0, 0xC1, 0x77, 0x40);
        btn:setEnable(false)
        btn:setFile(popu_map['popu.public.btn_gray.png']  or "")
    else
--还未签到
        local btn = item:findChildByName("btn_task")
        local title = btn:findChildByName("text_btnTitle")
		title:setText(STR_DO_TASK, 0, 0, 0x99, 0x53, 0x32);
        btn:setFile(popu_map['popu.public.btn_yellow.png']  or "")
        btn:setOnClick(self, function(self)
            self:dismiss()
            WindowManager:showWindow(WindowTag.AttendencePopu, MyUserData:getAttendenceReward(), WindowStyle.POPUP)
        end)
    end

    return item
end

TaskPopu.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.GET_TASK]      = TaskPopu.onGetTask,
	[HttpModule.s_cmds.GET_TASK_AWARD]= TaskPopu.onGetTaskAward,
}

return TaskPopu