local TelRegisterPopu = class(require("popu.gameWindow"))

function TelRegisterPopu:initView(data)
	--返回
	self:findChildByName("btn_close"):setOnClick(self, function ( self )
		-- body
		self:dismiss();
	end);

	--初始化UI
	local etTel  = self:findChildByName("et_tel");
	local etPsw  = self:findChildByName("et_psw");
	local etCode = self:findChildByName("et_code");

	
	--获取验证码
	local btnSecurityCode = self:findChildByName("btn_security_code");
	btnSecurityCode:setOnClick(self, function ( self )
		-- body
		local tel = etTel:getText();
		if not ToolKit.isValidTelNo(tel) then
			AlarmTip.play("请输入正确的11位手机号码");
			return ;
		end
		
		GameSocketMgr:sendMsg(Command.REGISTER_SECURITY_CODE_PHP_REQUEST, {['phone']=tel, ["act"]="reg"}, false);
		btnSecurityCode:setPickable(false);
		local viewTime 	= self:findChildByName("view_time");
		local anim 	 	= viewTime:addPropTranslate(0, kAnimRepeat, 1000, 0, 0, 0, 0, 0);
		local second 	= 60;
		local textTime 	= self:findChildByName("text_time");
		textTime:setText(string.format("重新获取%dS", second));
        anim:setDebugName("register | anim")
        anim:setEvent(self, function (self)
        	-- body
        	second = second - 1;

        	if second < 0 then
        		textTime:setText("");
        		viewTime:removeProp(0);
        		btnSecurityCode:setPickable(true);
        		return ;
        	end

        	textTime:setText(string.format("重新获取%dS", second));
        end);

	end);

	
	--确定
	self:findChildByName("btn_comfirm"):setOnClick(self, function ( self )
		-- body
		
		local tel = etTel:getText();
		local psw = etPsw:getText();
		local code = etCode:getText();
		if not ToolKit.isValidTelNo(tel) then
			AlarmTip.play("请输入正确的11位手机号码");
			return ;
		end

		local pswLen = string.len(psw);

		if pswLen < 6 or  pswLen > 16 then
			AlarmTip.play("密码长度不合法");
			return ;
		end

		if string.len(code) < 4 then
			AlarmTip.play("请输入有效的验证码");
			return ;
		end

		GameConfig:setLastUserType(UserType.Phone)
			:setLastLoginData({
				username = tel,
				password = psw,
				verifycode = code,
				act = 'reg',
			})
		GameSocketMgr:closeSocketSync(true)
		--self:dismiss(true);
	end);

	

	etTel:setHintText("输入手机号码", 0x96, 0x96, 0x96);
	etPsw:setHintText("输入密码", 0x96, 0x96, 0x96);
	etCode:setHintText("输入验证码", 0x96, 0x96, 0x96);

end
--注册验证码
function TelRegisterPopu:onRegisterSecurityCodeResponse( data )
	if data.status ~= 1 then
		local viewTime = self:findChildByName("view_time");
		if not viewTime:checkAddProp(0) then
			viewTime:removeProp(0);
		end
		local textTime 	= self:findChildByName("text_time");
		textTime:setText("");
		self:findChildByName("btn_security_code"):setPickable(true);

		AlarmTip.play(data.msg or "获取验证码失败，请重新获取");
	end
end
--注册成功
function TelRegisterPopu:onLoginResponse( data )
	if data.status == 1 then
		self:dismiss(true);
	end
end
--[[
	通用的（大厅）协议
]]
TelRegisterPopu.s_severCmdEventFuncMap = {
	[Command.REGISTER_SECURITY_CODE_PHP_REQUEST] 	= TelRegisterPopu.onRegisterSecurityCodeResponse,
	[Command.LOGIN_PHP_REQUEST] 					= TelRegisterPopu.onLoginResponse,
}

return TelRegisterPopu