
local urgentNoticePopu = class(require("popu.gameWindow"))

function urgentNoticePopu:ctor()

end

function urgentNoticePopu:dtor()

end

function urgentNoticePopu:initView(data)
    local curIndex = 1
       
    --getway 1 是图片公告， 0是普通公告 ， 2 是跑马灯公告
    self:initNotice(data[curIndex])
    self:findChildByName("btn_readed"):setOnClick(self, function()
        if curIndex > #data then
            return
        end
        --公告带奖励，点击领奖，不带奖励，点击通知已读
        if (data[curIndex].reward == 1) then
            HttpModule.getInstance():execute(HttpModule.s_cmds.GET_HALL_USER_NOTICES_AWARD, {nid = data[curIndex].id}, true, true);
        else
            HttpModule.getInstance():execute(HttpModule.s_cmds.GET_HALL_USER_NOTICES_READED, {id = data[curIndex].id}, true, true)
        end

        curIndex = curIndex + 1
        if curIndex < #data + 1 then
           self:initNotice(data[curIndex])
        else
            self:dismiss()
        end
        
    end)
end

function urgentNoticePopu:initNotice(data)
--0是普通的文本公告，1是图片公告，由图片区域显示，2是跑马灯公告，格式同1， 3是跳转活动中心的公告
 --gateway是1的时候表示的是带图片的公告，图片名称是content里的链接的最后的文件名，如果图片不存在，则去下载图片。
    if data.getway == 1 then
        self:setImageNotice(data)
    elseif data.getway == 3 then
        self:initActivityNotice(data)
    else
        self:setNotice(data)
    end

end

function urgentNoticePopu:setNotice(data)
    self:findChildByName("view_imageNotice"):setVisible(false)
    self:findChildByName("view_textNotice"):setVisible(true)
    self:findChildByName("text_btnReaded"):setText(data.reward == 1 and STR_URGENT_NOTICE_GETREWARD or STR_URGENT_NOTICE_READED) 
    local textTitle = self:findChildByName("text_urgentTitle")
    textTitle:setText(data.title)
    local textNotice = self:findChildByName("text_urgentNotice")
    textNotice:setText(data.content)
    local tmpText = self:findChildByName("text_urgentTitle2")
    tmpText:setText(data.title)
    if tmpText.m_res:getWidth() > textTitle.m_res:getWidth() then
        tmpText:setVisible(false)
        textTitle:setVisible(true)
        textTitle:setText(data.title)
    else
        tmpText:setVisible(true)
        textTitle:setVisible(false)
    end

    local startIndex, endIndex = self:getUrlLinkIndex(data.content)
    local btnNotice = self:findChildByName("btn_notice")
    if startIndex and endIndex then
        btnNotice:setVisible(true)
        btnNotice:setOnClick(self, function()
            NativeEvent.getInstance():openLink(string.sub(data.content, startIndex, endIndex))	
        end)
    else
        btnNotice:setVisible(false)
    end

end

function urgentNoticePopu:setImageNotice(data)
    if data.reward == 1 then
        self:findChildByName("btn_readed"):setVisible(true)
        self:findChildByName("text_btnReaded"):setText(STR_URGENT_NOTICE_GETREWARD)
    else
        self:findChildByName("btn_readed"):setVisible(false)
        HttpModule.getInstance():execute(HttpModule.s_cmds.GET_HALL_USER_NOTICES_READED, {id = data.id}, true, true)
    end
    self:findChildByName("view_textNotice"):setVisible(false)
    local viewImg = self:findChildByName("view_imageNotice")
    viewImg:setVisible(true)
    viewImg:findChildByName("btn_close"):setOnClick(self, function(self)
        self:dismiss()
    end)
    local startIndex, endIndex = self:getUrlLinkIndex(data.content)
    if startIndex and endIndex then
        local strLink = string.sub(data.content, startIndex, endIndex)
        --找出最后一个/的位置，在这之后的就是本地图片的名字
        local lastSeperatorIndex = string.reverse(strLink):find("/")
        local imgName = strLink:sub(strLink:len() - lastSeperatorIndex + 2, strLink:len())

        if imgName then
            --链接带了文件名，本地找下有木有
            local imgNotice = viewImg:findChildByName("img_notice")
            if NativeEvent.getInstance():isFileExist(imgName, "noticeImage/") == 1 then
                imgNotice:setFile("noticeImage/"..imgName)
                imgNotice:setSize(imgNotice.m_res.m_width, imgNotice.m_res.m_height)
            else
                local imgData = setProxy(new(require("data.imgData")))
                UIEx.bind(self, imgData, "imgName", function(value)
                    imgNotice:setFile(imgData:getImgName())
                    local wImg, hImg = imgNotice:getSize()
                    imgNotice:setSize(imgNotice.m_res.m_width, imgNotice.m_res.m_height)
                end)
                imgData:setImgUrl(strLink)
            end
        end
    end
    
end

function urgentNoticePopu:initActivityNotice(data)
    self:setNotice(data)
    local btnJump = self:findChildByName("btn_jump")
    btnJump:setVisible(true)
    btnJump:setOnClick(self, function(self)
        self:dismiss()
        NativeEvent.getInstance():openActivity()
	    app:postFrontStaticstics('clickActivity')
    end)
    local textJump = new(Text, STR_NOTICE_PARTICIPATE, 0, 0, kAlignCenter, kFontTextUnderLine, 28, 0x28, 0x4F, 0x8A)
    textJump:setAlign(kAlignCenter)
    btnJump:addChild(textJump)
end

function urgentNoticePopu:getUrlLinkIndex(str)
    local startIndex, endIndex = str:find("(https?://)([%w_.~!*:@&+$/?%%#=-]+)")
    if startIndex and endIndex then
        local lastChar = string.sub(str, endIndex, endIndex)
        if result == "." or result == "," or result == "!" or result =="?" or result == ")" or result ==":"
            or result == '"' or result == "'" then 
            endIndex = endIndex - 1
        end
    end
    return startIndex, endIndex;

end

function urgentNoticePopu:dismiss()
    self.super.dismiss(self, MyUserData.dailyReward)
    if MyUserData.dailyReward then
        WindowManager:showWindow(MyUserData.dailyReward.rewardType, MyUserData.dailyReward.rewardData, WindowStyle.POPUP)
        MyUserData.dailyReward = nil
    end
end

return urgentNoticePopu