require(ViewPath .. "gameinfoItem")
require(ViewPath .. "giftItemInBagLayout")
require("pintu.gift")
local UserPopu = class(require("popu.gameWindow"))

local printInfo, printError = overridePrint("UserPopu")
local NUM_IN_ONE_LINE = 4

function UserPopu:ctor()
	self.index = 1
	self.game1Tag = true
    self.gameInfo = {}
    self.gameInfoById = {}
    self.gameInfoItems = {}
    self.giftList = {}
	EventDispatcher.getInstance():register(Event.Call, self, self.onNativeCallBack);
    
    local originalGameId = app:getGameIds()
    local gameId = {}
    for i = 1, #originalGameId do
        if originalGameId[i] > 0 then
            gameId[#gameId + 1] = originalGameId[i]
        end
    end
    
    for i = 1, #gameId do
        local gameInfo = {}
        gameInfo.gameId = gameId[i]
        gameInfo.wintimes = 0
        gameInfo.losetimes = 0
        gameInfo.maxmoney = 0
        gameInfo.maxwmoney = 0
        table.insert(self.gameInfo, gameInfo)
        self.gameInfoById[gameId[i]] = gameInfo
    end
   
    HttpModule.getInstance():execute(HttpModule.s_cmds.GIFT_GET_ALL_MINE, {}, false, false)
    HttpModule.getInstance():execute(HttpModule.s_cmds.GET_USER_ALL_PROPS, {}, false, false)
end

function UserPopu:dtor()
	EventDispatcher.getInstance():unregister(Event.Call, self, self.onNativeCallBack);
end

function UserPopu:initView(data)
	self:findChildByName("btn_close"):setOnClick(self, function ( self )
		-- body
		self:dismiss();
	end);
    local viewCommon = self:findChildByName("view_common")
	--修改头像
	local btnPortrait = viewCommon:findChildByName("btn_portrait")
    btnPortrait:setOnClick(self, function ( self )
		-- body
		if MyUserData:getUserType() == UserType.Visitor then
			WindowManager:showWindow(WindowTag.PortraitPopu, {})
		else
			MyUserData:refreshHead()
		end
	end);
    self:setUserHead(MyUserData:getHeadName())

    local btnGift = viewCommon:findChildByName("btn_gift")
    btnGift:setOnClick(self, function(self)
        WindowManager:showWindow(WindowTag.GiftStorePopu, {from = "myInfo"}, WindowStyle.POPUP)
    end)

    --礼物绑定
    UIEx.bind(self, MyUserData, "giftId", function(value)
        local giftList = MyUserData:getGiftList()
        if value and value[1] and value[2] and giftList then
            local gift = giftList[value[1]] and giftList[value[1]][value[2]]
            if gift then
                btnGift:setFile(gift:getImgName())
                return
            end
        end
        btnGift:setFile(gift_map["gift.icon_gift.png"])
    end)
    MyUserData:setGiftId(MyUserData:getGiftId())

    --兑奖
	viewCommon:findChildByName("btn_duijiang"):setOnClick(self, function ( self )
		-- body
		self:dismiss(true);
		WindowManager:showWindow(WindowTag.DuiJiangPopu, {}, WindowStyle.POPUP)
		app:postFrontStaticstics('clickConversionCode')
	end);
	
	local viewNick = self:findChildByName("view_nick")
    --性别
	viewNick:findChildByName("btn_sex"):setOnClick(self, function ( self )
		-- body
		if MyUserData:getUserType() == UserType.Visitor then
			self:setSex(self.m_sex == 1 and 0 or 1);
			HttpModule.getInstance():execute(HttpModule.s_cmds.UPDATE_USER_SEX,{msex = (self.m_sex + 1), sid = 102}, false, false)
            --HttpModule.getInstance():execute(HttpModule.s_cmds.UPDATE_USER_SEX,{msex = self.m_sex, sid = 102}, false, false)
			MyUserData:setSex(self.m_sex)
		end
	end);
    --姓名
	local editNick = viewNick:findChildByName("et_nick");
	if MyUserData:getUserType() == UserType.Visitor then
        btnPortrait:findChildByName("img_headRefresh"):setVisible(false)
		editNick:setEnable(true)
	else
        viewNick:findChildByName("img_edit"):setVisible(false)
        btnPortrait:findChildByName("img_tips"):setVisible(false)
        btnPortrait:findChildByName("img_headRefresh"):setVisible(true)
		editNick:setEnable(false)
	end
    --去除边上的编辑按钮长度，最长的nick长度限制，再留点空隙
    local nickMaxLen = viewNick:findChildByName("view_textNick"):getSize() - viewNick:findChildByName("img_edit"):getSize() - 10
	editNick:setOnTextChange(self, function ( self )

		local nickName = editNick:getText()
		if nickName == nil or nickName == '' then
		
		else
            --计算下修改后的text的实际长度
            local newText = new(Text, nickName, 0, 0, kAlignCenter, "", editNick.m_fontSize, 0xff, 0xff, 0xff)
			if newText:getSize() > nickMaxLen then
                AlarmTip.play(STR_CHANGE_NAME_FAIL)
                editNick:setText(MyUserData:getNick())
			else
				HttpModule.getInstance():execute(HttpModule.s_cmds.UPDATE_USER_NAME,{name = nickName, sid = 102}, false, false)
				MyUserData:setNick(nickName)
			end
		end
	end);
    UIEx.bind(self, MyUserData, "nick", function(value)
        editNick:setText(value)
    end)
    MyUserData:setNick(MyUserData:getNick())

    --金币信息
    local viewCoin = viewCommon:findChildByName("view_coin")
    viewCoin:findChildByName('addmoney_btn'):setOnClick(self, function(self) 
        WindowManager:showWindow(WindowTag.ShopPopu, {}, WindowStyle.POPUP)
        self:dismiss(true)
	end)
    local textCoin = viewCoin:findChildByName("text_coin")
    UIEx.bind(self, MyUserData, "money", function(value)
        textCoin:setText(value)
    end)
    MyUserData:setMoney(MyUserData:getMoney())
    viewCommon:findChildByName("text_uid"):setText(MyUserData:getId())

    --切换按钮
    local viewSwitch = self:findChildByName("view_switch")
	local btnView = {viewSwitch:findChildByName("view_userSelf"), viewSwitch:findChildByName("view_props")}
    local viewInfo = self:findChildByName("view_info")
    local viewBag = self:findChildByName("view_bag")
    local viewName = {viewInfo, viewBag}

    for i = 1, #btnView do
    	local buttons = btnView[i]
        buttons:findChildByName("btn_unselect"):setOnClick(self, function(self)
            --点击按钮后，切换成被选中的按钮，隐藏不被选中的按钮
            for j = 1, #btnView do
                local curButtons = btnView[j]
                curButtons:findChildByName("btn_select"):setVisible(i == j)
                curButtons:findChildByName("btn_unselect"):setVisible(i ~= j)
                viewName[j]:setVisible(false)
            end
            viewName[i]:setVisible(true)
        end)
    end
    --游戏信息界面
    local svGameInfo = viewInfo:findChildByName("sv_gameInfo")
    svGameInfo:setDirection(kVertical)
    svGameInfo:setScrollBarWidth(0)
    local height = 0
	for i = 1, #self.gameInfo do
        --设置游戏的名字和图标
        local curGame = app:getGame(self.gameInfo[i].gameId)
        if curGame then
            local item = SceneLoader.load(gameinfoItem)
            item:findChildByName('game1_text'):setText(curGame:getName())
            item:findChildByName('logo1'):setFile(curGame:getIconFile())
		    self:refreshGameInfo(item, self.gameInfo[i])
            self.gameInfoItems[self.gameInfo[i].gameId] = item
            item:setPos(0, height)
            local w, h = item:getSize()
            height = height + h
            svGameInfo:addChild(item)
            --设置按钮点击展开或缩小事件
            local hideBg = item:findChildByName("game_bg1")
            local showBg = item:findChildByName("game_detail")
            local update = false
            item:findChildByName("btn_detail"):setOnClick(self, function(self)
                if not update then 
                    update = true
                    HttpModule.getInstance():execute(HttpModule.s_cmds.GET_GAMEINFO, {gameid = self.gameInfo[i].gameId}, false, true)
                end
                if showBg:getVisible() then
                    --隐藏详细信息
                    showBg:setVisible(false)
                    hideBg:setVisible(true)
                    item:setSize(hideBg:getSize())
                else
                    --展开详细信息
                    showBg:setVisible(true)
                    hideBg:setVisible(false)
                    item:setSize(showBg:getSize())
                end
                svGameInfo:reposition()
                svGameInfo:scrollItemToView(item)
                svGameInfo:setSize(svGameInfo:getSize())
            end)
        end
	end

    --等级
    self:setUserLevel(MyUserData:getLevel());
	--性别
	self:setSex(tonumber(MyUserData:getSex()));

    --背包
    local svBag = viewBag:findChildByName("sv_bag")
    svBag:findChildByName("text_propsName"):setText(STR_PROP)
    local textPropCount = svBag:findChildByName("pros_count_text")
    UIEx.bind(self, MyUserData, "propCount", function(value)
        textPropCount:setText(value)
    end)
    textPropCount:setText(MyUserData:getPropNum(kIDInterProp))
    
    local imgCard = svBag:findChildByName("img_roomCard")
    imgCard:findChildByName("text_cardName"):setText(STR_PRIVATE_ROOM_CARD_NAME)
    local textPrivateRoomCard = imgCard:findChildByName("text_cardCount")
    UIEx.bind(self, MyUserData, "privateRoomCardCount", function(value)
        textPrivateRoomCard:setText(value)
    end)
    textPrivateRoomCard:setText(MyUserData:getPropNum(kIDPrivateRoomCard))
    
end

function UserPopu:refreshGameInfo(item, data)
    --选项颜色和数值颜色
    local defaultSizeAndColor = {20, 0x5A, 0x32, 0x1D}
    local specialSizeAndColor = {20, 0xFB, 0xE2, 0x69}
    --刷新的时候重新new 的Text，先删掉
    item:findChildByName("view_win_count"):removeAllChildren()
    item:findChildByName("view_win_rate"):removeAllChildren()
    item:findChildByName("view_max_pot"):removeAllChildren()
    if data.wintimes and data.losetimes then
	    local winTimes = tonumber(data.wintimes)
	    local losetimes = tonumber(data.losetimes)
        
        ToolKit.formatRichText(item:findChildByName("view_win_count"), STR_USER_WINCOUNT, tostring(winTimes + losetimes), defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
                    
        if winTimes == 0 and losetimes == 0 then
            ToolKit.formatRichText(item:findChildByName("view_win_rate"), STR_USER_WINRATE, "0%", defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
	    else
		    local rate = math.ceil((winTimes/(winTimes + losetimes))*100)
            ToolKit.formatRichText(item:findChildByName("view_win_rate"), STR_USER_WINRATE, rate .. '%', defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
	    end

    else
        ToolKit.formatRichText(item:findChildByName("view_win_count"), STR_USER_WINCOUNT, "0", defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
        ToolKit.formatRichText(item:findChildByName("view_win_rate"), STR_USER_WINRATE, '0%', defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
    end
    ToolKit.formatRichText(item:findChildByName("view_max_pot"), STR_USER_WIN_MAX_COINS, data.maxwmoney and data.maxwmoney or 0, defaultSizeAndColor, specialSizeAndColor, kAlignLeft)
end

function UserPopu:setUserHead(headName)
	
	if self.m_headImage then
		self.m_headImage:removeSelf()
		self.m_headImage = nil;
	end

	local headView 		= self:findChildByName("view_portrait")
	local width, height = headView:getSize()

	self.m_headImage = new(Mask, headName, popu_map["popu.public.head_mask.png"]  or "");
	self.m_headImage:setSize(width, height)
	self.m_headImage:setName("headImage")
	self.m_headImage:addTo(headView)
	UIEx.bind(self.m_headImage, MyUserData, "headName", function(value)
		if MyUserData:getId() ~= 0 then
			self:setUserHead(MyUserData:getHeadName())
		end
	end)
end

--设置性别
function UserPopu:setSex( sex )
	-- body
	if not sex or sex == 0 then
		self:findChildByName("btn_sex"):setFile(popu_map["popu.public.male.png"]  or "");
		self.m_sex = 0;
	elseif sex == 1 then
		self:findChildByName("btn_sex"):setFile(popu_map["popu.public.female.png"]  or "");
		self.m_sex = 1;
	end
	self:setUserHead(MyUserData:getHeadName(sex))
end

--设置等级
function UserPopu:setUserLevel( lv )
	-- body
	self:findChildByName("level_text"):setText("Lv." .. lv);
	--userData:getNeedExp() > 0 and userData:getCurExp() * 100 / userData:getNeedExp() or 0
	local percent = 0
	local exp = tonumber(MyUserData:getExp()) 
	if lv then
		local index = tonumber(lv)
		if index > 0 and index < 60 then
			local x1 = userLevelExp[index].x1 
			local x2 = userLevelExp[index].x2
			if exp > x1 then
				percent = math.ceil(((exp - x1)/(x2 - x1))*100)
				if percent >= 100 then
					percent = 99
				end
			end
		elseif index == 60 then
			percent = 99
		end
	end		
	
	-- --26为9宫格的宽度，该宽度iamge类没有保存，故无法获到，只能硬编码
	-- local percent1 = 0
	-- local width = (progress.m_res.m_width) * tonumber(percent) / 100 ;
	self:findChildByName('level_percent'):setText(percent .. '%')

    --用的1像素的图片拉伸
    local levelBg = self:findChildByName("view_level"):findChildByName("level_bg")
    local maxWidth, height = levelBg:getSize()
	local width = (maxWidth - height) * percent/100--curDownload / totalSize;
    local progress = self:findChildByName("level_progress");
	progress:setSize(height + width, height);
	
end

function UserPopu:initGiftList()
    --前两个分别是互动道具和私人房卡道具, 巴西没有私人房卡
    local row, column = 0, 1
    local viewGift = self:findChildByName("sv_bag")
    local wInterval = viewGift:getSize() / NUM_IN_ONE_LINE
    local deltaX, deltaY = viewGift:findChildByName("image_pros"):getPos()
    for i = 1, #self.giftList do
        local giftItem = self:initGiftItem(self.giftList[i])
        
        local w, h = giftItem:getSize()
        giftItem:setPos(deltaX + wInterval * column, deltaY + row * (h + 10))    
        viewGift:addChild(giftItem)    
        column = column + 1
        if column >= NUM_IN_ONE_LINE then
            column = 0
            row = row + 1
        end
    end
end

function UserPopu:initGiftItem(gift)
    local giftItem = SceneLoader.load(giftItemInBagLayout)
        
    giftItem:findChildByName("text_name"):setText(gift:getName())
    local textTime = giftItem:findChildByName("text_time")
    UIEx.bind(giftItem, gift, "time", function(value)
        local text = ""
        if value < 86400 then
            text = math.ceil(value / 3600)..STR_HOUR
        else
            text = math.floor(value / 86400)..STR_DAY
            local hour = math.ceil((value % 86400) / 3600)
            if hour > 0 then
                text = text..hour..STR_HOUR
            end
        end
        textTime:setText(text)
        gift:setExpireTime(text)
    end)
    gift:setTime(gift:getTime())

    local imgIcon = giftItem:findChildByName("img_icon")
    imgIcon:setFile(gift:getImgName())
    UIEx.bind(giftItem, gift, "imgName", function(value)
        imgIcon:setFile(value)
    end)
        
    giftItem:findChildByName("btn_bg"):setOnClick(self, function(value)
        local myCurGift = MyUserData:getGiftId()
        --更换和佩戴的不是同一个礼物才发请求。
        if (myCurGift and (myCurGift[1] ~= gift:getType() or myCurGift[2] ~= gift:getId())) or (not myCurGift) then
            local myNewGift = {}
            myNewGift[tostring(gift:getType())] = gift:getId()
            HttpModule.getInstance():execute(HttpModule.s_cmds.GIFT_UPDATE_MINE, {gift = myNewGift}, false, false)
        end
    end)

    return giftItem
end

--native callback
function UserPopu:onNativeCallBack(key, result)
	if key == kTakePhoto or key == kPickPhoto then
		if result then
			-- 兼容Android 和 IOS 接口处理
			if NativeEvent.s_platform == kPlatformIOS then
				local isSucc = result.isSucc:get_value()
				local fromPhoto = result.fromPhoto:get_value()
				local imgName = result.imgName:get_value()
				local folder = result.folder:get_value()
				local basePath = result.basePath:get_value()
				local tag = result.tag:get_value()
				if isSucc == "true" and tag == "headImage" then
					basePath = basePath or ""  -- 引擎已经包含该搜索路径，暂时用不上
					folder = folder or ""
					imgName = imgName or ""

					local fname = folder .. imgName
					MyUserData:setUploadTemp(fname);
					self.m_headImage:setFile(fname);
					if MyUserData:getUrls() and  MyUserData:getUrls().updateicon then
						NativeEvent.getInstance():uploadHeadImage(MyUserData:getUrls().updateicon, imgName, 1,basePath,folder);
					end
				elseif isSucc == "false" then
					return

				end

			else
				MyUserData:setUploadTemp(result.name:get_value());
				self.m_headImage:setFile(result.name:get_value());
				--upload image
				if MyUserData:getUrls() and  MyUserData:getUrls().updateicon then
					NativeEvent.getInstance():uploadImage(MyUserData:getUrls().updateicon, result.name:get_value(), 1);
				end
 			end
		else
			AlarmTip.play(STR_SVAE_HEARD_ERROR);
		end
	end

end

function UserPopu:onGetGameInfo(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local gameId = tonumber(data.data.gameid) or 0
        if self.gameInfoById[gameId] then
            self.gameInfoById[gameId].wintimes = tonumber(data.data.wintimes) or 0
            self.gameInfoById[gameId].losetimes = tonumber(data.data.losetimes) or 0
            self.gameInfoById[gameId].maxmoney = tonumber(data.data.maxmoney) or 0
            self.gameInfoById[gameId].maxwmoney = tonumber(data.data.maxwmoney) or 0
            self:refreshGameInfo(self.gameInfoItems[gameId], self.gameInfoById[gameId])
        end

    end
end

function UserPopu:onGiftAllMine(isSuccess, data)

    if app:checkResponseOk(isSuccess, data) then
        self.giftList = {}
        local curTime = os.time()
        local gifts = data.data or {}
        giftList = MyUserData:getGiftList() or {}
        for i = 1, #gifts do
            local giftType = tonumber(gifts[i].giftType) or 0
            local giftId = tonumber(gifts[i].giftId) or 0
            --给的礼物id数据正常，礼物列表里能找到对应的
            local gift = giftList[giftType] and giftList[giftType][giftId]
            if gift then
                local expireTime = tonumber(gifts[i].expireTime) or 0
                local leftTime = expireTime - curTime
                --还有剩余时间，表示礼物未过期
                if leftTime > 0 then
                    local newGift = setProxy(new(require("data.giftItemData")))
                    newGift:setType(gift:getType())
                    newGift:setId(gift:getId())
                    newGift:setName(gift:getName())
                    newGift:setImgUrl(gift:getImgUrl())
                    newGift:setTime(leftTime)
                    if leftTime < 86400 then
                        newGift:setExpireTime(math.ceil(leftTime / 3600)..STR_HOUR)
                    else
                        newGift:setExpireTime(math.ceil(leftTime / 86400)..STR_DAY)
                    end
                    table.insert(self.giftList, newGift)
                end
            end
        end
            
        self:initGiftList()
    end
end

function UserPopu:onGiftUpdateMine(isSuccess, data)

end

function UserPopu:onGiftStoreBuy(isSuccess, data)
    --购买成功后，刷新礼物的有效时间，如果之前没有，那就增加新的礼物
    if app:checkResponseOk(isSuccess, data) then
        local giftType = tonumber(data.data.giftType)
        local giftId = tonumber(data.data.giftId)
        local giftList = MyUserData:getGiftList() or {}
        local checkGift = giftList[giftType] and giftList[giftType][giftId]
        --检查返回礼物的正确性
        if checkGift then
            local expireTime = checkGift:getTime()
            for i = 1, #self.giftList do
                local gift = self.giftList[i]
                if gift:getId() == giftId and gift:getType() == giftType then
                    --本来有这个礼物，刷新他的有效时间。礼物原先的剩余时间，再加上礼物的时效，就是新的有效时间
                    local leftTime = expireTime + gift:getTime()
                    gift:setTime(leftTime)
                    return
                end
            end

            --本来没有这个礼物，新增一个
            local newGift = setProxy(new(require("data.giftItemData")))
            newGift:setType(checkGift:getType())
            newGift:setId(checkGift:getId())
            newGift:setName(checkGift:getName())
            newGift:setImgUrl(checkGift:getImgUrl())
            newGift:setTime(checkGift:getTime())
            table.insert(self.giftList, newGift)
            local giftItem = self:initGiftItem(newGift)
            local viewBg = self:findChildByName("sv_bag")
            local deltaX, deltaY = viewBg:findChildByName("image_pros"):getPos()
            --新增的礼物图标在view中是第 #children + 1 个孩子，据此计算位置
            local children = viewBg:getChildren()
            local row = math.floor(#children / NUM_IN_ONE_LINE)
            local col = #children % NUM_IN_ONE_LINE

            local wInterval = viewBg:getSize() / NUM_IN_ONE_LINE   
            local w, h = giftItem:getSize()
            giftItem:setPos(deltaX + wInterval * col, deltaY + row * (h + 10))    
            viewBg:addChild(giftItem)
        end
    end
end

--[[
	通用的（大厅）协议
]]

UserPopu.s_severCmdEventFuncMap = {
    [HttpModule.s_cmds.GET_GAMEINFO]            = UserPopu.onGetGameInfo,
    [HttpModule.s_cmds.GIFT_GET_ALL_MINE]       = UserPopu.onGiftAllMine,
    [HttpModule.s_cmds.GIFT_UPDATE_MINE]        = UserPopu.onGiftUpdateMine,
    [HttpModule.s_cmds.GIFT_STORE_BUY]          = UserPopu.onGiftStoreBuy,
}


return UserPopu