local UserRulePopu = class(require("popu.gameWindow"))

function UserRulePopu:ctor()
    GameSetting:setIsSecondScene(true)
	EventDispatcher.getInstance():register(Event.Call, self, self.onNativeCallBack);
end

function UserRulePopu:dtor()

	EventDispatcher.getInstance():unregister(Event.Call, self, self.onNativeCallBack);
end

function UserRulePopu:initView(data)
	local closeBtn = self:findChildByName("btn_back");
	closeBtn:setOnClick(self, function ( self )
		-- body
		self:dismiss(true);
	end);
	closeBtn:enableAnim(false);
	self:findChildByName("text_title"):setText(data.title);

	NativeEvent.getInstance():openRule(data.url);

	GameLoading:addPhpCommand(Command.GET_RULE_PHP_REQUEST);

	--创建动画
	 local rotationX, rotationY = 24 * System.getScreenWidth() / System.getLayoutWidth(), 3 * System.getScreenHeight() / System.getLayoutHeight();
    local decorateNode = self:findChildByName("img_decorate_r2");
    decorateNode:setLevel(2);
    self:findChildByName("img_decorate_r"):setLevel(3);
    decorateNode:addPropRotateWithEasing(1, kAnimLoop, 800, 0, 'easeInOutSine', -10, 20, kCenterXY, rotationX, rotationY)

end

function UserRulePopu:dismiss(param)
    GameSetting:setIsSecondScene(false)
	NativeEvent.getInstance():closeRule();
	GameLoading:onCommandResponse(Command.GET_RULE_PHP_REQUEST);

	local platform = System.getPlatform();
	if platform ~= kPlatformAndroid then --android登录
		return self.super.dismiss(self, param);
	end
end
--native callback
function UserRulePopu:onNativeCallBack(key, result)
	if key == "ruleFinish" then
		GameLoading:onCommandResponse(Command.GET_RULE_PHP_REQUEST);
	elseif key == "ruleClose" then
		self.super.dismiss(self, true);
	elseif key == "keyBack" then
		self:dismiss(self, true);
	end


end

return UserRulePopu