local BankruptPopu = class(require("popu.gameWindow"))
new(Image, "broke.png")
require("pintu.broke")

function BankruptPopu:ctor(viewLayout, data)
	EventDispatcher.getInstance():register(Event.Message, self, self.onMessageCallDone)
	HttpModule.getInstance():execute(HttpModule.s_cmds.GET_HALL_BANKRUPT_TAG, {gameSid = data.gameId or 0, level = data.level or 0}, false, true)
    HttpModule.getInstance():execute(HttpModule.s_cmds.GET_FB_CALLBACK_REWARD_CFG, {}, false, false)
end

function BankruptPopu:dtor()
	EventDispatcher.getInstance():unregister(Event.Message, self, self.onMessageCallDone)
end

function BankruptPopu:initView(data)

	self.sum = MyUserData:getInvitesum()
	self.invitemoney = MyUserData:getInvitemoney()
	self.successmoney = MyUserData:getSuccessmoney()
	self:findChildByName('button_text3'):setText(STR_GET_BROKEN)
	self:findChildByName('button_text1'):setText(STR_NOW_GO)
	self:findChildByName('content1'):setText(string.format(STR_INVITE_INFO, self.invitemoney and self.invitemoney or 500, self.successmoney and self.successmoney or 100000))
	self:findChildByName('content3'):setText(string.format(STR_BANKRUPT_TIP, 0))
	--关闭
	self:findChildByName('btn_close'):setOnClick(self, function(self) 
		self:dismiss()
	end)
	--邀请
	self:findChildByName('btn_invite'):setOnClick(self, function(self) 
		self:dismiss(true)
		WindowManager:showWindow(WindowTag.FbInvitePopu, {}, WindowStyle.NORMAL)
	end)

	--领取
	self:findChildByName('btn_getRelief'):setOnClick(self, function(self) 
        
		if data.state == 0 then
			HttpModule.getInstance():execute(HttpModule.s_cmds.GET_BROKEN_MONEY, {tid = 7}, false, true)
		else
			HttpModule.getInstance():execute(HttpModule.s_cmds.GET_HALL_BANKRUPT, {}, true, true)
		end 
	end)
    local svInner = self:findChildByName("sv_inner")
	if data.state then
		if data.state == 0 then
			svInner:findChildByName("img_relief"):setVisible(true)
            svInner:reposition()
--            viewItems:findChildByName("img_invite"):setPos(0, 120)
--		    viewItems:findChildByName("img_shop"):setPos(0, 240)
--            viewItems:findChildByName("img_help"):setPos(0, 360)
		elseif data.state == 1 then
            svInner:findChildByName("img_relief"):setVisible(false)
            svInner:reposition()
--		    viewItems:findChildByName("img_invite"):setPos(0, 0)
--		    viewItems:findChildByName("img_shop"):setPos(0, 120)
--            viewItems:findChildByName("img_help"):setPos(0, 240)
		end
	end
    svInner:setSize(svInner:getSize())

	if not MyPayMode or #MyPayMode == 0 then
		--没有支付方式，拉取一次
        self:execHttpCmd(HttpModule.s_cmds.GET_PAY_MODE, {}, true, true)
	else
		--checkout或者jmt支付,  优先显示JMT支付
		self:choosePayMode()
	end

    local viewHelp = self:findChildByName("img_help")
    viewHelp:findChildByName("content_help"):setText(STR_ASK_RELIEF_TIPS)
    local btnHelp = viewHelp:findChildByName("btn_help")
    btnHelp:findChildByName("button_text"):setText(STR_ASK_RELIEF_FROM_FRIEND)
    btnHelp:setOnClick(self, function(value)
        HttpModule.getInstance():execute(HttpModule.s_cmds.GET_BANKRUPT_RELIEF, {}, false, false)
        btnHelp:setEnable(false)
    end)

    local viewCallback = self:findChildByName("img_callback")
    local str = string.format(STR_BANKRUPT_CALLBACK_TIP1, 1000).."\n\n"..STR_BANKRUPT_CALLBACK_TIP2
    viewCallback:findChildByName("content_callback"):setText(str)
    local btnCallback = viewCallback:findChildByName("btn_callback")
    btnCallback:findChildByName("button_text"):setText(STR_FRIEND_CALLBACK)
    btnCallback:setOnClick(self, function(value)
        self:dismiss(true)
        WindowManager:showWindow(WindowTag.FbInvitePopu, {to = "call"}, WindowStyle.POPUP)
    end)

end

function BankruptPopu:choosePayMode()
    for i = 1, #MyPayMode do
   	    if MyPayMode[i]:getId() == 240 or 741 then
   		    printInfo('有jmt支付')
   		    self:showPayType(MyPayMode[i])
   		    return
   	    end
    end
    printInfo('没有jmt支付')
    --选择第一个支付方式
    if MyPayMode[1] then
        self:showPayType(MyPayMode[1])
    end
end

function BankruptPopu:showPayType(payMode)
    --已经有商品列表数据了
    if payMode:getPay() then
	    --默认使用最小额度的商品
        local pay = payMode:getPay()
	    local shop = pay:get(1)
	    if shop then
		    self:findChildByName('content2'):setText(ToolKit.skipMoney(shop:getPchips()).." ("..shop:getPdesc()..")")
		    self:findChildByName("button_text2"):setText(string.format("%s%s", shop:getPamount(), shop:getCurrency()))
            --已经拉取到商品数据，可以让用户购买了
            self:findChildByName('btn_shop'):setOnClick(self, function(self)
                app:postFrontStaticstics("bankruptAndBuyCoins")
                MyPay:payOrder(payMode:getId(), shop, shop_map["shop.chip_6.png"])
--                WindowManager:showWindow(WindowTag.ShopBuyConfirmPopu, {

--                    title = STR_JMT_BUY_CONFIRM,
--                    content = shop:getName(),
--                    confirm = STR_EXIT_GAME_CONFIRM,
--                    imgIcon = ,
--                    confirmFunc = function()

----                        self:execHttpCmd(HttpModule.s_cmds.GET_PAY_ORDER, {id=shop:getId(),pmode = payMode:getId(), sitemid = MyUserData:getSiteId(), mid = MyUserData:getId()}, true, true)
--                        self:dismiss()
--                    end,
--                }, WindowStyle.POPUP)
            end)
	    end
        
    else
        --没有商品列表数据，再拉一次
        self:execHttpCmd(HttpModule.s_cmds.GET_PAY_LIST, {pmode=payMode:getId()}, true, true)
    end
end

function BankruptPopu:enter2Scene( type, needLogin, style )
	-- if needLogin and not app:checkCanEnter2Scene() then return end
	-- body
	WindowManager:showWindow(type, {gameType = self.mCurGameType}, style);
end

function BankruptPopu:onMessageCallDone(param, data)
    local viewItems = self:findChildByName("view_inner")
	if param == 'hallBankruptTag' then
        local imgRelief = viewItems:findChildByName("img_relief")
		imgRelief:setVisible(true)
        imgRelief:findChildByName('content3'):setText(string.format(STR_BANKRUPT_TIP, data and data or 0))
--        viewItems:findChildByName("img_invite"):setPos(0, 120)
--		viewItems:findChildByName("img_shop"):setPos(0, 240)
--        viewItems:findChildByName("img_help"):setPos(0, 360)
	elseif param == 'hallBankrupt' then
        --领取破产补助的选项要消失，其他选项要往上放
		viewItems:findChildByName("img_relief"):setVisible(false)
--		viewItems:findChildByName("img_invite"):setPos(0, 0)
--		viewItems:findChildByName("img_shop"):setPos(0, 120)
--        viewItems:findChildByName("img_help"):setPos(0, 240)
	end
    local svInner = viewItems:findChildByName("sv_inner")
    svInner:reposition()
    svInner:setSize(svInner:getSize())
end

function BankruptPopu:onGetPayMode(isSuccess, data)
--拉倒商城列表后再拉取默认商品列表
    if app:checkResponseOk(isSuccess, data) then
        self:choosePayMode()
    end
end

function BankruptPopu:onGetPayList(isSuccess, data)
--拉取到商品列表，继续走选默认商品的流程
    if app:checkResponseOk(isSuccess, data) then
        self:choosePayMode()
    end
end

function BankruptPopu:onGetBankruptRelief(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        self:findChildByName("img_help"):setVisible(false)
    end
end

function BankruptPopu:onGetFbCallbackReward(isSuccess, data)
    if app:checkResponseOk(isSuccess, data) then
        local moeny = tonumber(data.data.perReward) or 1000
        local viewCallback = self:findChildByName("img_callback")
        local str = string.format(STR_BANKRUPT_CALLBACK_TIP1, moeny).."\n"..(data.data.msg or "")
        viewCallback:findChildByName("content_callback"):setText(str)
    end
end

BankruptPopu.s_severCmdEventFuncMap = {
    [HttpModule.s_cmds.GET_PAY_MODE]        = BankruptPopu.onGetPayMode,
    [HttpModule.s_cmds.GET_PAY_LIST]        = BankruptPopu.onGetPayList,
    [HttpModule.s_cmds.GET_BANKRUPT_RELIEF]     = BankruptPopu.onGetBankruptRelief,
    [HttpModule.s_cmds.GET_FB_CALLBACK_REWARD_CFG]  = BankruptPopu.onGetFbCallbackReward,
}

return BankruptPopu