require(ViewPath.."giftItemLayout")

local GiftStorePopu = class(require("popu.gameWindow"))
require('ui.ex.ScrollViewEx')

function GiftStorePopu:ctor(viewConfig, data)
    self.giftList = MyUserData.giftList and MyUserData.giftList.originalData or {}
    self.selectGift = nil
    self.broadcastId = data.broadcastId or {}
    self.sendId = data.sendId or {}
    self.from = data.from or ""
    --礼物列表为空，请求礼物列表
    if #self.giftList == 0 then
        self:execHttpCmd(HttpModule.s_cmds.GIFT_STORE_GET_LIST, {}, false, false)
    end
end

function GiftStorePopu:dtor()

end

function GiftStorePopu:onShowEnd()
    self.super.onShowEnd(self)
    if #self.giftList ~= 0 then
        self:loadGift()
        --默认选中第一个商品
        local child = self.svGift:getChildren() and self.svGift:getChildren()[1]
        if child then
            btn = child:findChildByName("btn_bg")
            btn.m_eventCallback.func(btn.m_eventCallback.obj)
            self.selectItem = child
        end
    end
end

function GiftStorePopu:initView(data)
    self:initButtons()
end

function GiftStorePopu:initButtons()
    local imgBg = self:findChildByName("img_popuBg")
    imgBg:findChildByName("btn_close"):setOnClick(self, function(self)
        self:dismiss()
    end)

    UIEx.bind(self, MyUserData, "money", function(value)
        imgBg:findChildByName("text_money"):setText(ToolKit.formatMoney(value))
    end)
    MyUserData:setMoney(MyUserData:getMoney())
    local viewBtns = imgBg:findChildByName("view_bottom")
    local btnBuy = viewBtns:findChildByName("btn_buy")
    --需要收到广播通知的Id，用于在房间内购买道具，赠送道具后推送给同桌玩伴们的ID的广播
    btnBuy:setOnClick(self, function(self)
        if self.selectGift then
            --金币不够
            if self.selectGift:getId() == 21 then
                if MyUserData:getMoney() < 1000000 then
                    AlarmTip.play(STR_SEND_GIFT_TIP)
                    return
                end
            elseif self.selectGift:getCostType() == 1 and MyUserData:getMoney() < self.selectGift:getPrice() then
                AlarmTip.play(STR_SORRY_FOR_NO_MONEY)
                return
            end
            local gift = {}
            local giftType = tostring(self.selectGift:getType()) or ""
            gift[giftType] = {}
            gift[giftType][tostring(self.selectGift:getId())] = 1
            self:execHttpCmd(HttpModule.s_cmds.GIFT_STORE_BUY, {giftArr = gift, broadcastId = self.broadcastId}, false, true)
            btnBuy:setEnable(false)
            self:dismiss()
        end
    end)

    --送礼物协议，需要一个礼物列表，sendID我要送的人的ID，broadcastId是需要知道赠送行为发生的人的ID，sendALl的时候两者一样。name是赠送人的名字，用于toast提示
    local btnSendAll = viewBtns:findChildByName("btn_sendAll")
    btnSendAll:setOnClick(self, function(self)
        if self.selectGift then
            if self.selectGift:getId() == 21 then
                if MyUserData:getMoney() - self.selectGift:getPrice() * #self.broadcastId < 500000 then
                    AlarmTip.play(STR_SORRY_FOR_NO_MONEY)
                    return
                end
            elseif self.selectGift:getCostType() == 1 and MyUserData:getMoney() < self.selectGift:getPrice() * #self.broadcastId then
                AlarmTip.play(STR_SORRY_FOR_NO_MONEY)
                return
            end
            local gift = {}
            local giftType = tostring(self.selectGift:getType()) or ""
            gift[giftType] = self.selectGift:getId()
            app:postFrontStaticstics("giftSendAll")
            self:execHttpCmd(HttpModule.s_cmds.GIFT_STORE_SEND, {giftArr = gift, sendId = self.broadcastId, broadcastId = self.broadcastId, name = MyUserData:getNick()}, false, true)
            btnSendAll:setEnable(false)
            self:dismiss()
        end
    end)

    local btnSend = viewBtns:findChildByName("btn_send")
    btnSend:setOnClick(self, function(self)
        if self.selectGift then
            if self.selectGift:getId() == 21 then
                if MyUserData:getMoney() < 1000000 then
                    AlarmTip.play(STR_SEND_GIFT_TIP)
                    return
                end
            elseif self.selectGift:getCostType() == 1 and MyUserData:getMoney() < self.selectGift:getPrice() then
                AlarmTip.play(STR_SORRY_FOR_NO_MONEY)
                return
            end
            local gift = {}
            local giftType = tostring(self.selectGift:getType()) or ""
            gift[giftType] = self.selectGift:getId()
            app:postFrontStaticstics("giftSendOne")
            self:execHttpCmd(HttpModule.s_cmds.GIFT_STORE_SEND, {giftArr = gift, sendId = self.sendId, broadcastId = self.broadcastId, name = MyUserData:getNick()}, false, true)
            dump({giftArr = gift, sendId = self.sendId, broadcastId = self.broadcastId, name = MyUserData:getNick()})
            btnSend:setEnable(false)
            self:dismiss()
        end
    end)

    --弹窗的来源，myInfo从个人信息处来，打开给自己购买
    if self.from == "myInfo" then
        btnSendAll:setVisible(false)
        btnSend:setVisible(false)
        btnBuy:setVisible(true)
        btnBuy:setAlign(kAlignCenter)
        --游戏里查看自己信息，可以购买或者赠送全桌
    elseif self.from == "myInfoInGame" then
        btnSendAll:setVisible(true)
        btnSend:setVisible(false)
        btnBuy:setVisible(true)
        --游戏里查看他人信息，可以赠送或者赠送全桌
    elseif self.from == "otherInfoInGame" then
        btnSendAll:setVisible(true)
        btnSend:setVisible(true)
        btnBuy:setVisible(false)
        --好友里查看他人信息，只可以赠送
    elseif self.from == "otherInfo" then
        btnSendAll:setVisible(false)
        btnSend:setVisible(true)
        btnBuy:setVisible(false)
        btnSend:setAlign(kAlignCenter)
    end
end

function GiftStorePopu:loadGift()
    self.loadedGift = 1
    self.giftCount = #self.giftList
    local viewGift = self:findChildByName("view_giftList")
    local w, h = viewGift:getSize()
    self.svGift = new(ScrollViewEx, 0, 0, w, h, false)
    self.svGift:setDirection(kVertical)
    self.svGift:setOnReachBottom(self, function ( self )
        if self.loadedGift < self.giftCount then
            self:initGiftList();
        end
    end);
    self.svGift:setAlign(kAlignCenter)
    viewGift:addChild(self.svGift)
    self:initGiftList()
end

function GiftStorePopu:initGiftList()
    local NUM_IN_ONE_LINE = 3
    --分次加载避免太卡，每次最多加载15个
    local PERLOAD = 15
    local hasLoadNum = 0
    local wInterval = self.svGift:getSize() / NUM_IN_ONE_LINE
    for i = self.loadedGift, #self.giftList do
        local gift = self.giftList[i]
        if gift.price > 0 then
            local item = self:initGiftItem(gift)
            local w, h = item:getSize()
            local svChildren = self.svGift:getChildren()
            local svChildNum = svChildren and #svChildren or 0
            local row = math.floor(svChildNum / NUM_IN_ONE_LINE)
            local column = svChildNum % NUM_IN_ONE_LINE
            item:setPos(30 + wInterval * column, 10 + row * (h + 15))
            self.svGift:addChild(item)
            hasLoadNum = hasLoadNum + 1
        end
        self.loadedGift = self.loadedGift + 1
        if hasLoadNum >= PERLOAD then
            break
        end
    end
    self.svGift:setSize(self.svGift:getSize())
end

function GiftStorePopu:initGiftItem(gift)
    local item = SceneLoader.load(giftItemLayout)
    item:findChildByName("text_giftName"):setText(gift:getName() or "")
    item:findChildByName("text_time"):setText(gift:getExpireTime() or "")
    local node = new(Node)
    node:setAlign(kAlignCenter)
    local w = 0
    if gift:getCostType() == 1 then
        local imgIcon = new(Image, "gift/iconMoney.png")
        imgIcon:setAlign(kAlignLeft)
        node:addChild(imgIcon)
        w = imgIcon:getSize()
    end
    local textPrice = new(Text, gift:getPrice(), 0, 0, kAlignCenter, "", 28, 0xFD, 0xF8, 0x51)
    textPrice:setAlign(kAlignLeft)
    textPrice:setPos(w, 0)
    node:addChild(textPrice)
    w = w + textPrice:getSize()
    local viewCost = item:findChildByName("view_cost")
    local _, h = viewCost:getSize()
    node:setSize(w, h)
    viewCost:addChild(node)

    local viewImg = item:findChildByName("view_giftImg")
    local wGift = viewImg:getSize()
    local imgGift = viewImg:findChildByName("img_gift")
    UIEx.bind(item, gift, "imgName", function(value)
        imgGift:setFile(value)
        imgGift:setSize(wGift, imgGift.m_res.m_height / imgGift.m_res.m_width * wGift)
    end)
    gift:setImgName(gift:getImgName())

    item:findChildByName("btn_bg"):setOnClick(self, function(self)
        self.selectGift = gift
        if self.selectItem then
            self.selectItem:findChildByName("img_select"):setVisible(false)
        end
        self.selectItem = item
        item:findChildByName("img_select"):setVisible(true)
    end)

    item:findChildByName("img_laba"):setVisible(gift:getId() == 21)
    return item
end

function GiftStorePopu:onGiftStoreGetList(isSuccess, data)

    if app:checkResponseOk(isSuccess, data) then
        self.giftList = MyUserData.giftList and MyUserData.giftList.originalData or {}
        if #self.giftList > 0 then
            printInfo("#self.giftList = "..#self.giftList)
            self:loadGift()
        end
    end
end

function GiftStorePopu:onGiftStoreSend(isSuccess, data)
    self:findChildByName("btn_sendAll"):setEnable(true)
    self:findChildByName("btn_send"):setEnable(true)
end

function GiftStorePopu:onGiftStoreBuy(isSuccess, data)
    self:findChildByName("btn_buy"):setEnable(true)
end

GiftStorePopu.s_severCmdEventFuncMap = {
    [HttpModule.s_cmds.GIFT_STORE_GET_LIST]    = GiftStorePopu.onGiftStoreGetList,
    [HttpModule.s_cmds.GIFT_STORE_SEND]        = GiftStorePopu.onGiftStoreSend,
    [HttpModule.s_cmds.GIFT_STORE_BUY]         = GiftStorePopu.onGiftStoreBuy,
}

return GiftStorePopu
