require(ViewPath.."privateRoomBillLayout")
require(ViewPath.."privateRoomChooseGameItem")

local PrivateRoomBillPopu = class(require("popu.gameWindow"))

function PrivateRoomBillPopu:ctor()

end

function PrivateRoomBillPopu:initView(data)
    local gameId = data.gameId or 1006
    local money = data.money
    local billList = data.billList or {}
    table.sort(billList, function(a, b)
        return a.cost > b.cost
    end)
    
    local viewTop = self:findChildByName("view_top")
    local headBg = viewTop:findChildByName("img_head")
    local width, height = headBg:getSize()
	local imgHead = new(Mask, MyUserData.headName, "common/head_bg.png");
    imgHead:setSize(width, height)
    headBg:addChild(imgHead)
--    :setText(MyUserData.nick)
    ToolKit.formatTextLength(MyUserData.nick, viewTop:findChildByName("text_name"), 100)
    local game = app:getGame(gameId) 
    viewTop:findChildByName("text_billTip"):setText(string.format(STR_PRIVATE_ROOM_BILL_TIP, game.name or ""))
    --leaveFlag 是1 是非正常离开，有未结算牌局
    if data.leaveFlag == 1 then
        local node = new(Node)
        node:setAlign(kAlignBottomLeft)
        local textTip = new(Text, STR_PRIVATE_ROOM_ESCAPE_TIP, 0, 0, kAlignRight, "", 22, 0xff, 0x00, 0x00)
        textTip:setAlign(kAlignRight)
        node:addChild(textTip)
        local imgTip = new(Image, "privateRoom/icon_espace.png")
        imgTip:setAlign(kAlignRight)
        imgTip:setPos(textTip.m_res.m_width + 5)
        node:addChild(imgTip)
        node:setSize(textTip.m_res.m_width + 5 + imgTip.m_res.m_width, 50)
        node:setPos(100, 0)
        viewTop:addChild(node)
    end
--    viewTop:findChildByName("img_tip"):setVisible(data.leaveFlag == 1)
--    local textTip = viewTop:findChildByName("text_tip")
--    textTip:setVisible(data.leaveFlag == 1)
--    textTip:setText(STR_PRIVATE_ROOM_ESCAPE_TIP)

    local viewBottom = self:findChildByName("view_bottom")
    viewBottom:findChildByName("text_billTitle"):setText(STR_PRIVATE_ROOM_BILL_TITLE)
    svBill = viewBottom:findChildByName("sv_bill")
    svBill:setDirection(kVertical)
    local h = 0
    local myMoneyFlag = false
    local textMyCost = viewTop:findChildByName("text_money")
    textMyCost:setText(money)
    for i = 1, #billList do
        local name = billList[i].nick or ""
        local money = billList[i].cost or 0
        if money > 0 then
            money = "+"..money
        end
        local node = new(Node)
        node:setSize(svBill:getSize(), 50)
        local textName = new(Text, name, 0, 0, kAlignLeft, "", 24, 0x9a, 0x68, 0x4d)
        ToolKit.formatTextLength(name, textName, 200)
        node:addChild(textName)
        local textMoney = new(Text, money, 0, 0, kAlignRight, "", 24, 0x9a, 0x68, 0x4d)
        textMoney:setPos(20, 0)
        textMoney:setAlign(kAlignRight)
        node:addChild(textMoney)
        node:setPos(0, h)
        h = h + 50
        svBill:addChild(node)
    end
    svBill:setSize(svBill:getSize())

    local btnConfirm = self:findChildByName("btn_confirm")
    btnConfirm:setOnClick(self, function()
        self:dismiss(true)
        StateChange.changeState(States.Lobby);
    end)
    self:findChildByName("img_bg"):setEventTouch(nil, function()
        self:dismiss(true)
        if data.callbackFunc then
            data.callbackFunc()
        end
        
    end)
end

function PrivateRoomBillPopu:dotr()

end

return PrivateRoomBillPopu