require("pintu.gift")

local RoomPlayerInfoPopu = class(require("popu.gameWindow"))
new(Image, "hongdong/hongdong.png")

function RoomPlayerInfoPopu:ctor(viewConfig, data)
    EventDispatcher.getInstance():register(HttpModule.s_event, self, self.onHttpRequestsCallBack);
    EventDispatcher.getInstance():register(Event.Message, self, self.onMessageCallDone)
    self.playerInfo = data.player
    self.present = data.present
    self.gameId = data.gameId
    self.curPlayerData = nil
    self.seatId = data.seatId or 0
    self.playerIds = data.playerIds or {}

    local player = self.playerInfo
    
    if player:getId() == MyUserData:getId() then
        self.curPlayerData = self:initDataForSelf()
    --是他人的信息，用房间内的个人信息先初始化
    else
        self.curPlayerData = self:initDataForOther(player) 
    end
    --制造好了数据，初始化页面，再请求php，有数据后再刷新数据
    self:initViewAfterGetData()
    self:execHttpCmd(HttpModule.s_cmds.GET_OTHER_FORM_FRIEND, {fid = player:getId(), gameid = self.gameId}, false, false)
end

function RoomPlayerInfoPopu:dtor()
    EventDispatcher.getInstance():unregister(HttpModule.s_event, self, self.onHttpRequestsCallBack);
    EventDispatcher.getInstance():unregister(Event.Message, self, self.onMessageCallDone)
end

function RoomPlayerInfoPopu:initViewAfterGetData()
    local player     = self.curPlayerData

    local viewPlayer = self:findChildByName("view_top")
    UIEx.bind(self, player, "money", function(value)
        viewPlayer:findChildByName('text_chip'):setText(value)
    end)

    local maxLen = viewPlayer:findChildByName("view_nick"):getSize() - viewPlayer:findChildByName("img_male"):getSize() - 10
    UIEx.bind(self, player, "name", function(value)
        ToolKit.formatTextLength(value, viewPlayer:findChildByName('text_name'), maxLen)
    end)

    UIEx.bind(self, player, "sex", function(value)
        if value == 0 then
            viewPlayer:findChildByName("img_male"):setVisible(true)
            viewPlayer:findChildByName("img_female"):setVisible(false)
        else
            viewPlayer:findChildByName("img_male"):setVisible(false)
            viewPlayer:findChildByName("img_female"):setVisible(true)
        end
    end)
    
    UIEx.bind(self, player, "id", function(value)
        if value == 0 then
            self:dismiss();
        else
            viewPlayer:findChildByName('text_id'):setText('ID:'..value);
        end
    end)

    UIEx.bind(self, player, "headName", function(value)
        local headView = viewPlayer:findChildByName("img_head");--view_phead
        headView:removeAllChildren();
        local width, height = headView:getSize()
        local imgHead     = new(Mask, value, room_map["popu.room.playerinfo.head_mask.png"]);
        imgHead:setSize(width, height)
        headView:addChild(imgHead);
        player:checkHeadAndDownload()
    end)
    
    UIEx.bind(self, player, "level", function(value)
        viewPlayer:findChildByName("text_lv"):setText('Lv.'..value)
    end)
  
    --只和losetimes绑定，注意losetimes的设置要在wintimes之后
    UIEx.bind(self, player, "losetimes", function(value)
        self:setWinRate(player)
    end)
    self:setWinRate(player)

    UIEx.bind(self, player, "canSendApply", function(value)
        local btnAdd = self:findChildByName("btn_addfriend")
        local btnNotAdd = self:findChildByName("img_notAddFriend")
        if player:getId() == MyUserData:getId() or value == 0 then
            btnAdd:setVisible(false)
            btnNotAdd:setVisible(true)
        else
            btnAdd:setVisible(true)
            btnNotAdd:setVisible(false)
        end
    end)

    --礼物按钮
    local btnGift = self:findChildByName("btn_gift")
    btnGift:setOnClick(self, function(self)
        if player:getId() == MyUserData:getId() then
            WindowManager:showWindow(WindowTag.GiftStorePopu, {from = "myInfoInGame", broadcastId = self.playerIds}, WindowStyle.POPUP)
        else
            WindowManager:showWindow(WindowTag.GiftStorePopu, {from = "otherInfoInGame", sendId = {player:getId()}, broadcastId = self.playerIds}, WindowStyle.POPUP)
        end
    end)
    UIEx.bind(self, player, "giftId", function(value)
        local giftList = MyUserData:getGiftList()
        if value and value[1] and value[2] and giftList then
            local gift = giftList[value[1]] and giftList[value[1]][value[2]]
            if gift then
                btnGift:setFile(gift:getImgName())
                return
            end
        end
        btnGift:setFile(gift_map["gift.icon_gift.png"])
    end)

    local btnAddMoney = viewPlayer:findChildByName("btn_addMoney")
    if player:getId() == MyUserData:getId() then
        btnAddMoney:setVisible(true)
        btnAddMoney:setOnClick(nil, function()
            self:dismiss(true)
            WindowManager:showWindow(WindowTag.ShopPopu, {}, WindowStyle.POPUP)
        end)
    end
    
    player:setId(player:getId())
    player:setMoney(player:getMoney())
    player:setName(player:getName())
    player:setSex(player:getSex())
    player:setHeadUrl(player:getHeadUrl());
    player:setCanSendApply(player:getCanSendApply())
    player:setLevel(player:getLevel())
    player:setLosetimes(player:getLosetimes())
    player:setGiftId(player:getGiftId())

    self:findChildByName("btn_addfriend"):setOnClick(self, function ( self )
    -- body
        HttpModule.getInstance():execute(HttpModule.s_cmds.ADD_FRIEND,{isroom = 1, fid = player:getId(), content = base64.encode(json.encode({
        id   = MyUserData:getId(),
        name = MyUserData:getNick()
        }))}, false, false)
        player:setCanSendApply(0)

    end)
    
    --send btnchip
    self:initSendChip()
    self:initPropView()
end

function RoomPlayerInfoPopu:initSendChip(player)
    local present = self.present
    local viewGift = self:findChildByName("view_gift")
    if not present then
        viewGift:setVisible(false)
        return
    end
    local player = self.curPlayerData
    local btnName = {
      [1] = 'btn_chip1',
      [2] = 'btn_chip2',
      [3] = 'btn_chip3',
      [4] = 'btn_chip4',
    }
    
    for j = 1, #btnName do
        local btnChip = viewGift:findChildByName(btnName[j])
        btnChip:findChildByName("text_title"):setText(ToolKit.formatChip(present[j]))
        if player:getId() == MyUserData:getId() then
            btnChip:setEnable(false)
        else
            btnChip:setOnClick(self, function ( self )
                if self.seatId <= 0 then
                    AlarmTip.play(STR_SORRY_FOR_SEND_CHIP_BEFORE_SITDOWN);
                    return 
                end
                local lastTime = MyUserData:getChipTime()
                local curTime   = os.time()
                if curTime - lastTime < 60 then
                    AlarmTip.play(string.format(STR_SORRY_FOR_SEND_CHIP_TOO_FREQUEENTLY, 60));
                    return 
                end
                MyUserData:setChipTime(curTime)
                if MyUserData:getMoney() >= present[j] then
                    HttpModule.getInstance():execute(HttpModule.s_cmds.GET_SEND_GAME_CHIP,{fid = player:getId(), gid=1002, money = present[j]}, false, true);
                    self:dismiss();
                else
                    AlarmTip.play(STR_SORRY_FOR_NO_MONEY);
                end
            end)
            
        end
    end
end

function RoomPlayerInfoPopu:initPropView()
    local player = self.curPlayerData
    local btnName = {
        [1] = 'btn_egg',
        [2] = 'btn_pouwater',
        [3] = 'btn_rose',
        [4] = 'btn_kiss',
        [5] = 'btn_beer',
        [6] = 'btn_tomoto',
        [7] = 'btn_dog',
        [8] = 'btn_harmmer',
        [9] = 'btn_bom',
        [10] = 'btn_tissue',
        [11] = 'btn_ghost',
        [12] = 'btn_pumpkin',
    }
    for i = 1, #btnName do
        self:findChildByName(btnName[i]):setOnClick(self, function ( self )
            local count = MyUserData:getPropNum(kIDInterProp)
            if self.seatId <= 0 then
                AlarmTip.play(STR_SORRY_FOR_SEND_PROP_BEFORE_SITDOWN);
                return 
            end

            if count > 0 then
                HttpModule.getInstance():execute(HttpModule.s_cmds.GET_SEND_PROP,{fid = player:getId(), id=2000 + i}, false, true);
                self:dismiss();
            else
                WindowManager:showWindow(WindowTag.LobbyConfirmPopu, {
                    content = STR_SORRY_FOR_NO_PROP,
                    cancel = STR_EXIT_GAME_CANCEL,
                    confirm = STR_BUY,
                    confirmFunc = function()
                        WindowManager:showWindow(WindowTag.ShopPopu, {to = "props"}, WindowStyle.POPUP)
                    end,
                }, WindowStyle.POPUP)
                self:dismiss(true)
            end
        end);
    end
    
end

--加好友
function RoomPlayerInfoPopu:onAddFriend(issuccess,data)
    if issuccess and data and data.code == 1 then
        self:dismiss()
    else
      self:findChildByName("btn_addfriend"):setVisible(true)
      self:findChildByName("img_notAddFriend"):setVisible(false)
      AlarmTip.play(STR_FRIEND_SEND_APPLY_ALREADY)
    end
end

--HTTP回调
function RoomPlayerInfoPopu:onHttpRequestsCallBack(command, ...)
  if self.s_httpEventFuncMap[command] then
      self.s_httpEventFuncMap[command](self,...)
  end 
end

function RoomPlayerInfoPopu:onGetFriendInfo(isSuccess, data)
dump(data)
    if app:checkResponseOk(isSuccess, data) then
        if self.curPlayerData then
            self.curPlayerData:init(data.data)
            --存在该游戏的具体胜负次数，显示此胜率
            local gameTimes = data.data[tostring(self.gameId)]
            if gameTimes then
                self.curPlayerData:setWintimes(tonumber(gameTimes.win) or 0)
                self.curPlayerData:setLosetimes(tonumber(gameTimes.lose) or 0)
            end
        end
    else
    -- AlarmTip.play('无结果');
    end
end

function RoomPlayerInfoPopu:initDataForSelf()
    local playerInfo = setProxy(new(require("data.playerInfoData")))
    playerInfo:setId(MyUserData:getId())
    playerInfo:setName(MyUserData:getNick())
    playerInfo:setMoney(MyUserData:getMoney())
    playerInfo:setLevel(MyUserData:getLevel())
    playerInfo:setSex(MyUserData:getSex())
    playerInfo:setHeadUrl(MyUserData:getHeadUrl())
    playerInfo:setGiftId(MyUserData:getGiftId() and {MyUserData:getGiftId()[1], MyUserData:getGiftId()[2]})
    playerInfo:setCanSendApply(0)
    playerInfo:setWintimes(-1)
    return playerInfo
end

function RoomPlayerInfoPopu:initDataForOther(player)
    local playerInfo = setProxy(new(require("data.playerInfoData")))
    playerInfo:setId(player:getId())
    playerInfo:setName(player:getNick())
    playerInfo:setMoney(player:getChip())
    playerInfo:setSex(player:getSex())
    playerInfo:setHeadUrl(player:getHeadUrl())
    playerInfo:setLevel("...")
    playerInfo:setWintimes(-1)
    playerInfo:setCanSendApply(1)
    playerInfo:setGiftId(player:getGiftId() and {player:getGiftId()[1], player:getGiftId()[2]})
    return playerInfo
end

function RoomPlayerInfoPopu:setWinRate(player)
    if player:getWintimes() == -1 then
        self:findChildByName("text_win"):setText(string.format('%s:...', STR_WINRATE))
        return
    end
    local winStr = '100%'
    local total  = player:getWintimes() + player:getLosetimes()
    if total > 0 then
        winStr = string.format('%2.f', player:getWintimes() * 100 / total) .. '%'
    end
    self:findChildByName("text_win"):setText(string.format('%s:%s', STR_WINRATE, winStr))
end

function RoomPlayerInfoPopu:onMessageCallDone(key, data)
    if key == "giftSendBroadcast" then
        local receiver = data.receiver
        local giftId = data.gift
        for i = 1, #receiver do
            --收礼物的人正好是弹窗里的玩家，更新他的头像
            if receiver[i] == self.playerInfo:getId() then
                self.curPlayerData:setGiftId(giftId)
                break;
            end
        end
    end
end

--Http响应
RoomPlayerInfoPopu.s_httpEventFuncMap = {
  [HttpModule.s_cmds.GET_SEND_PROP]        = RoomPlayerInfoPopu.onSendProp,
  [HttpModule.s_cmds.GET_PROP_LIST]        = RoomPlayerInfoPopu.onGetPropList,
  [HttpModule.s_cmds.GET_SEND_GAME_CHIP]   = RoomPlayerInfoPopu.onSendChip,
  [HttpModule.s_cmds.ADD_FRIEND]           = RoomPlayerInfoPopu.onAddFriend,
  [HttpModule.s_cmds.GET_OTHER_FORM_FRIEND]   = RoomPlayerInfoPopu.onGetFriendInfo,
}

return RoomPlayerInfoPopu