--这个lua脚本在main.lua之前运行
function create_program()

	local PROGRAM_DATA_TYPE_ATTRIB = 1;
	local PROGRAM_DATA_TYPE_UNIFORM = 2;
	local PROGRAM_DATA_TYPE_TEXTURE = 3;
	local PROGRAM_DATA_TYPE_INDEX = 4;

	local PROGRAM_ATTRIB_SIZE1 = 1;
	local PROGRAM_ATTRIB_SIZE2 = 2;
	local PROGRAM_ATTRIB_SIZE3 = 3;
	local PROGRAM_ATTRIB_SIZE4 = 4;

	local PROGRAM_UNIFORM_FLOAT_SIZE1 = 1;
	local PROGRAM_UNIFORM_FLOAT_SIZE2 = 2;
	local PROGRAM_UNIFORM_FLOAT_SIZE3 = 3;
	local PROGRAM_UNIFORM_FLOAT_SIZE4 = 4;

	local PROGRAM_UNIFORM_INT_SIZE1 = 11;
	local PROGRAM_UNIFORM_INT_SIZE2 = 12;
	local PROGRAM_UNIFORM_INT_SIZE3 = 13;
	local PROGRAM_UNIFORM_INT_SIZE4 = 14;

	local PROGRAM_UNIFORM_MATRIX_2X2 = 22;
	local PROGRAM_UNIFORM_MATRIX_3X3 = 33;
	local PROGRAM_UNIFORM_MATRIX_4X4 = 44;

	local PROGRAM_TEXTURE_SIZE = 0;
	local PROGRAM_INDEX_SIZE = 2;

	--变灰shader
	program_create("image2d_gray");
	local vs=[==[
				uniform   mat4 u_mvp_matrix; 
			 	attribute vec3 a_position;   
			 	attribute vec2 a_tex_coord;  
			 	varying   vec2 v_tex_coord;  
			 	void main()                  
			 	{                            
			    	gl_Position = u_mvp_matrix * vec4(a_position,1); 
			    	v_tex_coord = a_tex_coord;
			 	}          
			]==]

	local fs=[==[
				precision mediump float;
			 	uniform sampler2D texture0;
			 	uniform vec4 u_color;
			 	varying vec2 v_tex_coord;
			 	void main()                                 
			 	{                                           
              		vec4 color = texture2D(texture0,v_tex_coord);
              		float gray = dot(color.rgb, vec3(0.299, 0.587, 0.114)); 
              		gl_FragColor= u_color*vec4(gray,gray,gray,color.a);
			 	}   			 
			]==]
	program_set_shader_source("image2d_gray", vs, fs );

	program_add_parameter("image2d_gray", PROGRAM_DATA_TYPE_UNIFORM, 44,"u_mvp_matrix");
	program_add_parameter("image2d_gray", PROGRAM_DATA_TYPE_ATTRIB, 3,"a_position");
	program_add_parameter("image2d_gray", PROGRAM_DATA_TYPE_ATTRIB, 2,"a_tex_coord");
	program_add_parameter("image2d_gray", PROGRAM_DATA_TYPE_UNIFORM, 4,"u_color");
	program_add_parameter("image2d_gray", PROGRAM_DATA_TYPE_INDEX, 2,"index");
	program_add_parameter("image2d_gray", PROGRAM_DATA_TYPE_TEXTURE, 0,"texture0");

	--模糊shader
	program_create("image2d_blur");
	local vs=[==[
				uniform   mat4 u_mvp_matrix; 
			 	attribute vec3 a_position;   
			 	attribute vec2 a_tex_coord;  
			 	varying   vec2 v_tex_coord;  
			 	void main()                  
			 	{                            
			    	gl_Position = u_mvp_matrix * vec4(a_position,1); 
			    	v_tex_coord = a_tex_coord;
			 	}          
			]==]

	local fs=[=[
				precision mediump float;

				varying vec2 v_tex_coord;
				uniform sampler2D texture0;
				//uniform vec4 u_color;

				uniform vec2 resolution;//模糊对象的实际分辨率
				uniform float blurRadius;//半径
				uniform float sampleNum;//间隔的段数

				vec4 blur(vec2);

				void main(void)
				{
					vec4 color = texture2D(texture0,v_tex_coord);
				    vec4 col = blur(v_tex_coord); //* color.rgb;
				    gl_FragColor = col;
				}

				vec4 blur(vec2 p)
				{
				    if (blurRadius > 0.0 && sampleNum > 1.0)
				    {
				        vec4 col = vec4(0);
				        vec2 unit = 1.0 / resolution.xy;//单位坐标

				        float r = blurRadius;
				        float sampleStep = r / sampleNum;

				        float count = 0.0;
				        //遍历一个矩形，当前的坐标为中心点，遍历矩形中每个像素点的颜色
				        for(float x = -r; x < r; x += sampleStep)
				        {
				            for(float y = -r; y < r; y += sampleStep)
				            {
				                float weight = (r - abs(x)) * (r - abs(y));//权重，p点的权重最高，向四周依次减少
				                col += texture2D(texture0, p + vec2(x * unit.x, y * unit.y)) * weight;
				                count += weight;
				            }
				        }
				        //得到实际模糊颜色的值
				        return col / count;
				    }

				    return texture2D(texture0, p);
				}
			]=]
	program_set_shader_source("image2d_blur", vs, fs );

	program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_UNIFORM, 44,"u_mvp_matrix");
	program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_ATTRIB, 3,"a_position");
	program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_ATTRIB, 2,"a_tex_coord");
	-- program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_UNIFORM, 4,"u_color");
	program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_INDEX, 2,"index");
	program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_TEXTURE, 0,"texture0");
	program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_UNIFORM, 1,"blurRadius");
	program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_UNIFORM, 1,"sampleNum");
	program_add_parameter("image2d_blur", PROGRAM_DATA_TYPE_UNIFORM, 2,"resolution");
end

create_program();

