local ImageNumber = require('truco.common.imageNumber')
local AUDIO 	= require('truco.res.audio.config')
local Countdown = class(Node)

function Countdown:ctor(path, obj, func)
	self:setSize(400, 200)
	self.uiPath_ = path or {
		-- ['0'] = "truco/room/downnumber/0.png",
		['1'] = "truco/room/downnumber/0.png",
		['2'] = "truco/room/downnumber/1.png",
		['3'] = "truco/room/downnumber/2.png",
		['4'] = "truco/room/downnumber/3.png",
	}
	self.obj_ = obj
	self.func_ = func
	-- 
	self.downNum_ = new(ImageNumber, self.uiPath_)
	self.downNum_:setAlign(kAlignCenter)
	self:addChild(self.downNum_)
end
-- 设置回调函数
function Countdown:setCallback(callback)
	self.func_ = callback
end
-- 
function Countdown:playGo(times)
	self:setNumber(times)
	local oneSecondAnim = self:addPropTransparency(1, kAnimRepeat, 1000, 0, 1, 1)
	oneSecondAnim:setEvent(self, function ( self )
		times = times - 1
		if times <= 0 then
			checkAndRemoveOneProp(self, 1)
			-- if self.func_ then self.func_(self.obj_, 0) end

			self.downNum_:addPropTransparency(1, kAnimRepeat, 300, 0, 1, 0)
			local scaleAnim = self.downNum_:addPropScale(2, kAnimNormal, 300, 0, 1.0, 3.0, 1.0, 3.0, kCenterDrawing)
			scaleAnim:setEvent(self, function(self)
				checkAndRemoveOneProp(self.downNum_, 1)
				checkAndRemoveOneProp(self.downNum_, 2)

				if self.func_ then self.func_(self.obj_, 0) end
			end)
		else
			self:setNumber(times)
			if self.func_ then self.func_(self.obj_, times) end
		end
	end)
end

function Countdown:setNumber(times)
	kEffectPlayer:play(AUDIO.GAME_START_TIMER)

	local w, h = self.downNum_:getSize()
	self.downNum_:setNumber(string.format("%s", times))
	checkAndRemoveOneProp(self.downNum_, 1)
	-- local downAnim = self.downNum_:addPropScale(1,kAnimNormal, 100, 0, 1, 1, 1, 0.2,kCenterXY, w / 2, h)
	-- downAnim:setEvent(self, function ( self )
	-- 	checkAndRemoveOneProp(self.downNum_, 1)
	-- 	local upAnim = self.downNum_:addPropScale(1,kAnimNormal, 100, 0, 1, 1, 0.2, 1.0,kCenterXY, w / 2, h)
	-- 	upAnim:setEvent(self, function (self)
	-- 		checkAndRemoveOneProp(self.downNum_, 1)
	-- 		local downAnim = self.downNum_:addPropScale(1,kAnimNormal, 100, 0, 1, 1, 1, 0.95,kCenterXY, w / 2, h)
	-- 		downAnim:setEvent(self, function ( self )
	-- 			checkAndRemoveOneProp(self.downNum_, 1)
	-- 			self.downNum_:addPropScale(1,kAnimNormal, 100, 0, 1, 1, 0.95, 1.0,kCenterXY, w / 2, h)
	-- 		end)
	-- 	end)
	-- end)
end

function Countdown:dtor()
	-- body
end

return Countdown