
local Anim = class(Node);

function Anim:ctor(anim_pics,delay,repeatCount,inteval,picture)
	self.m_animEndCallBack = {};
	if picture==nil then
		self.animPic = new(Image, anim_pics[1]);
		self:addChild(self.animPic);
	else
		self.animPic = picture
	end

	self.anim_pics = anim_pics
	self.delay = delay
	self.repeatCount = repeatCount
	self.inteval = inteval
end

function Anim:play()
	self:setVisible(true);
	self:stop();

	local animParam = {
		frames = self.anim_pics,		--动画帧表，file or ResImage
		inteval = self.inteval or 100,			-- 每帧显示的时间
		repeatCount = self.repeatCount or -1,
		delay = self.delay or 0,			-- 多长时间后开始播放动画
		onComplete = function()
			if self.m_animEndCallBack.func then
				self.m_animEndCallBack.func(self)
			end
		end,
		DebugName = "Anim.play"
	}

	self.animPic:playAnimation(animParam);
end

function Anim:getSize()
	return self.animPic:getSize()
end

function Anim:setScale(scaleX,scaleY)
	self.animPic:addPropScaleSolid(100,scaleX,scaleY)
end

function Anim:setAlign(align)
	align = align or kAlignCenter
	self.super.setAlign(self,align)
	self.animPic:setAlign(align)
end

function Anim:stop()
	self.animPic:stopAnimation()
end

function Anim:dtor()
	self:stop();
end

--动画播放结束回调
function Anim:setOnAnimEnd(obj,func)
	self.m_animEndCallBack.obj = obj;
	self.m_animEndCallBack.func = func;
end

return Anim