local Card 		= require("truco.card.card")
local AUDIO 	= require('truco.res.audio.config')
local CardManager = class()
addProperty(CardManager, "delegate", nil)
addProperty(CardManager,"outcards",{})
local PER_CARD_NUM  = 3
local CARD_POS = {
	[4] = {
		--Y = -105,
		Y = -50,
		X = 415,
	},
	[3] = {
		X = 0,
		Y = -50,
	},
	[2] = {
		X = 0,
		Y = 0,
	},
	[1] = {
		X = 0,
		Y = -50,
	},
	['angle'] = {
		Left = -25,
		Right = 25,
	},
}

-- local out_scale_x = 0.59
-- local out_scale_y = 0.63
local out_scale_x = 0.8
local out_scale_y = 0.82

--local self_card_dx = 127
local self_card_dx = 130

function CardManager:get_small_card(players)
	local small_cards = {}
	for m=1,#players do
		small_cards[m] = {}
		local ui = players[m]:getUi()
		for j=1,3 do
			local small_card = ui:findChildByName("player_info"):findChildByName('card'..j)
			small_card:setVisible(false)
			small_cards[m][j] = small_card
		end
	end
end

function CardManager:getInstance()
	if self._instance == nil then 
		self._instance = new(CardManager)
	end
	return self._instance
end

function CardManager:getCardsDealNum(i,playerNum)
	if i > 0 and i <= playerNum then
		return 1
	elseif i > playerNum and i <= playerNum*2 then
		return 2
	elseif i > playerNum*2 and i <= playerNum*3 then
		return 3
	end
	return 0
end

function CardManager:dealCards2(cardValues,cardHeap,players,flag)
	local i = 1 
	local m = 1
	local index = 1
	local posx1,posy1 = cardHeap:getAbsolutePos()
	local small_cards = self:get_small_card(players)
	local delayAnim = self.delegate:addPropTranslate(50, kAnimRepeat, 120, 0, 0, 0, 0, 0)
	local max_card = self.delegate.mTableId:getMaxCard()

	delayAnim:setEvent(self, function ()
		if i>(PER_CARD_NUM*#players) then
			checkAndRemoveOneProp(self.delegate, 50)
			return
		end
		local ui = players[m]:getUi()
		local view_cards = ui:findChildByName("view_cards")
		local posx2,posy2 = view_cards:getAbsolutePos()
		local offsetx = posx1 - posx2
		local offsety = posy1 - posy2
		local cardType = 0
		local cardValue = 0
		local startAngle=0
		local rotateAngle = 0
		local anchorx = 0.5
		local anchory = 0.5
		local moveX = 0 
		local moveY = 0
		
		local card = nil
		local cards_num = self:getCardsDealNum(i,#players)
		local localSeatId = players[m]:getLocalSeatId()
		local small_card = ui:findChildByName("player_info"):findChildByName('card')

		if  localSeatId == 4 then  --自己 在底部
			if flag == 1 then
				cardType, cardValue = math.floor(cardValues[index]/16), cardValues[index]%16
			end
			startAngle = 0
			anchorx = 0.5
			anchory = 1
			moveY = CARD_POS[4].Y
			moveX = CARD_POS[4].X+(cards_num-1)*self_card_dx
		elseif localSeatId == 1 then  --右手家 
			startAngle = 0
			anchorx=1
			anchory = 0.5
			moveX = CARD_POS[1].X
			moveY = CARD_POS[1].Y
		elseif localSeatId == 2 then  --对家 ，顶部
			startAngle = 0
			anchorx = 0.5
			anchory = 0
			moveX = CARD_POS[2].X
			moveY = CARD_POS[2].Y
		elseif localSeatId == 3 then  -- 左手家
			startAngle = 0
			anchorx=0
			anchory = 0.5
			moveX = CARD_POS[3].X
			moveY = CARD_POS[3].Y
		end 
		
		card = new(Card, cardType, cardValue, players[m]:getLocalSeatId())
		if flag == 0 then
			card:render(0, 0,players[m]:getLocalSeatId())
			if cardValues then
				card:setByte(cardValues[index])
			else
				card:setByte(0)
			end
		end

		card:setDelegate(self)

		card:rotateTo(0,startAngle,0,0,function() --下一帧执行
			view_cards:addChild(card)
			card:setPos(offsetx,offsety)
			card:moveTo(200,moveX,moveY,function ( )
				card:setVisible(localSeatId == 4)
				card:findChildByName('img_max'):setVisible(localSeatId == 4 and cardValue == max_card)
				ui:findChildByName("player_info"):findChildByName('card'..cards_num):setVisible(localSeatId ~= 4)
			end)
			kEffectPlayer:play(AUDIO.ChuPai)
		end)	
		i=i+1
		m=m+1
		if m%(#players+1) == 0 then 
		   m=1
		   index = index+1
	   end
	end)
end

--发牌
function CardManager:dealCards(cardValues,cardHeap,players,flag) --flag 1 自己的牌是正面  0 自己的牌是背面（11:11 赛点 ，跟随好友）
	local i = 1 
	local m = 1
	local index = 1
	local posx1,posy1 = cardHeap:getAbsolutePos()
	local small_cards = self:get_small_card(players)
	local delayAnim = self.delegate:addPropTranslate(50, kAnimRepeat, 120, 0, 0, 0, 0, 0)
	local max_card = self.delegate.mTableId:getMaxCard()
	local card_pos = {160,168,176}

	delayAnim:setEvent(self, function ()
		if i>(PER_CARD_NUM*#players) then
			checkAndRemoveOneProp(self.delegate, 50)
			return
		end
		local ui = players[m]:getUi()
		local view_cards = ui:findChildByName("view_cards")
		local posx2,posy2 = view_cards:getAbsolutePos()
		local offsetx = posx1 - posx2
		local offsety = posy1 - posy2
		local cardType = 0
		local cardValue = 0
		local startAngle=0
		local rotateAngle = 0
		local anchorx = 0.5
		local anchory = 0.5
		local moveX = 0 
		local moveY = 0
		
		local card = nil
		local cards_num = self:getCardsDealNum(i,#players)
		local localSeatId = players[m]:getLocalSeatId()
		local small_card = ui:findChildByName("player_info"):findChildByName('card')

		if  localSeatId == 4 then  --自己 在底部
			if flag == 1 then
				cardType, cardValue = math.floor(cardValues[index]/16), cardValues[index]%16
			end
			startAngle = 0
			anchorx = 0.5
			anchory = 1
			moveY = CARD_POS[4].Y
			moveX = CARD_POS[4].X+(cards_num-1)*self_card_dx
		elseif localSeatId == 1 then  --右手家 
			startAngle = 0
			anchorx=1
			anchory = 0.5
			moveX = 10
			moveY = 0
		elseif localSeatId == 2 then  --对家 ，顶部
			startAngle = 0
			anchorx = 0.5
			anchory = 0
			moveX = card_pos[index]
			moveY = 0
		elseif localSeatId == 3 then  -- 左手家
			startAngle = 0
			anchorx=0
			anchory = 0.5
			moveX =card_pos[index]
			moveY = 0
		end 
		
		card = new(Card, cardType, cardValue, players[m]:getLocalSeatId())
		if flag == 0 then
			card:render(0, 0,players[m]:getLocalSeatId())
			if cardValues then
				card:setByte(cardValues[index])
			else
				card:setByte(0)
			end
		end

		card:setDelegate(self)

		view_cards:addChild(card)
		card:setPos(offsetx,offsety)
		card:moveTo(200,moveX,moveY,function ( )
			card:setVisible(localSeatId == 4)
			card:findChildByName('img_max'):setVisible(localSeatId == 4 and cardValue == max_card)
			ui:findChildByName("player_info"):findChildByName('card'..cards_num):setVisible(localSeatId ~= 4)
		end)

		kEffectPlayer:play(AUDIO.ChuPai)

		i=i+1
		m=m+1
		if m%(#players+1) == 0 then 
		   m=1
		   index = index+1
	   end
	end)
	
end
--重连直接设置手牌
function CardManager:setHandCards(player,isCardOver,isSelfOpt,cardValues,cnt)
	if not player then return end
	local localSeatId = player:getLocalSeatId()
	local ui = player:getUi()
	local rotateAngle = 0
	local anchorx = 0.5
	local anchory = 0.5
	local moveX = 0 
	local moveY = 0
	local view_cards = ui:findChildByName("view_cards")
	view_cards:removeAllChildren()

	local max_card = self.delegate.mTableId:getMaxCard()
	
	for i = 1 , cnt ,1 do
		local card = new(Card, 0, 0, localSeatId)
		card:setDelegate(self)
		if localSeatId == 4 then
			if cardValues and #cardValues>0 then
				if isCardOver==false then
					local cardType, cardValue = math.floor(cardValues[i]/16), cardValues[i]%16
					card:findChildByName('img_max'):setVisible(cardValue == max_card)
					
					card:render(cardType, cardValue,localSeatId)
				end	
				card:setByte(cardValues[i])
			end
			anchorx = 0.5
	    	anchory = 1
	    	moveY = CARD_POS[4].Y
	    	moveX = CARD_POS[4].X+(i-1)*self_card_dx
		else
			if localSeatId == 1 then
				anchorx=1
				anchory = 0.5
				moveX = CARD_POS[1].X
				moveY = CARD_POS[1].Y
			elseif localSeatId == 2 then
				
				anchorx = 0.5
				anchory = 0
	    		moveX = CARD_POS[2].X
				moveY = CARD_POS[2].Y
			elseif localSeatId == 3 then
				
				anchorx=0
				anchory = 0.5
				moveX = CARD_POS[3].X
				moveY = CARD_POS[3].Y
			end
		end
		
		view_cards:addChild(card)
		card:setPos(moveX,moveY)
		card:setVisible(localSeatId == 4)
		
		ui:findChildByName("player_info"):findChildByName('card'..i):setVisible(localSeatId ~= 4)

	end
	self:closeCardPanel(player)
	
end
--获取剩下手牌数量
function CardManager:getLastCardCount(player)
	local count = 0 
	local ui = player:getUi()
	local view_cards = ui:findChildByName("view_cards")
	local cards = view_cards:getChildren()
	for i,card in pairs(cards) do
		if card:getIsOut()==false then
			count = count+1
		end
	end

	return count 
end

--合牌 只有玩家自己
function CardManager:closeCardPanel(player)
	--if player:getId() ~= MyUserData:getId() then return end
	if not player then return end
	if not (player:getId() == MyUserData:getId() or (self.delegate.mFollowId and tonumber(self.delegate.mFollowId) == player:getId())) then
		return
	end

	local ui = player:getUi()
 	local view_cards = ui:findChildByName("view_cards")
	local cards = view_cards:getChildren()
	local count = self:getLastCardCount(player)
	local m = 1

	local moveY = CARD_POS[4].Y
	local moveX = CARD_POS[4].X

 	--------------
 	local tmp_cards = {}
 	for i=1,3 do
 		if cards[i] and (not cards[i]:getIsOut()) then
 			table.insert(tmp_cards,cards[i])
 		end
 	end

 	if count == 2 and #tmp_cards == 2 then
 		moveX =  CARD_POS[4].X+self_card_dx-66
 		tmp_cards[1]:moveTo(300,moveX,moveY)
 		moveX =  CARD_POS[4].X+self_card_dx+66
 		tmp_cards[2]:moveTo(300,moveX,moveY)
 	elseif count == 1 and #tmp_cards == 1 then
 		moveX =  CARD_POS[4].X+self_card_dx
 		tmp_cards[1]:moveTo(300,moveX,moveY)
 	end
end
--展牌 只有玩家自己
function CardManager:openCardPanel(player)
 	-- local ui = player:getUi()
 	-- if ui then
	 -- 	local view_cards = ui:findChildByName("view_cards")
		-- local cards = view_cards:getChildren()
		-- local count = self:getLastCardCount(player)
		-- local m=1
	 -- 	for i,card in pairs(cards) do
		-- 	if card:getIsOut() == false then
		-- 		card:rotateTo(300,0,0.5,0)
		-- 		if count == 1 then
		-- 			card:moveTo(300,CARD_POS[4].X-30,20)	
		-- 		elseif	count == 2 then
		-- 			if m == 1 then
		-- 				card:moveTo(300,CARD_POS[4].X-80,20)	
		-- 			elseif m==2 then
		-- 				card:moveTo(300,CARD_POS[4].X-80+120,20)	
		-- 			end
					
		-- 		elseif	count == 3 then
		-- 			card:moveTo(300,CARD_POS[4].X+(m-2)*120,20)	
		-- 		end 
				
		-- 		m= m+1
		-- 	end
	 -- 	end
	
 	-- end
end
--出牌动画
function CardManager:outCard(value,cardHeap,player,flag)

	local localSeatId = player:getLocalSeatId()
	local seatid = player:getSeatId()
	local heapPosx,heapPosy = cardHeap:getAbsolutePos()
	
	local heapW,heapH = cardHeap:getSize()
	local ui = player:getUi()
	local card_view =  ui:findChildByName("view_cards")
	local cards = card_view:getChildren()
	local cards_num = self:getLastCardCount(player)
	local cardType, cardValue = math.floor(value/16), value%16
	local max_card = self.delegate.mTableId:getMaxCard()

	if localSeatId == 4 then
		for i,card in pairs(cards) do
			if (card:getByte() == value or (self.delegate.mFollowId and tonumber(self.delegate.mFollowId) >0)) and card ~= self.outcards[seatid] then
				card:scale(out_scale_x,out_scale_y)
				card:rotateTo(200,0,0.5,0.5)
				local px,py = card:getAbsolutePos()
				local offx,offy = heapPosx-px,heapPosy-py
				local posx , posy = card:getPos()
				local cw,ch = card:getSize()
				if flag == 0 then
					card:render(0,0,4)
				else
					card:render(cardType, cardValue,4)
				end
				card:findChildByName('img_max'):setVisible(cardValue == max_card and flag ~= 0)
				--card:moveTo(300,posx+offx+(heapW-cw)/2+8,posy+offy+15)
				card:moveTo(300,posx+offx,posy+offy+ch-30)
				card:setIsOut(true)
				self.outcards[seatid]=card
				break;
			end
		end
	elseif localSeatId == 3 then
		for i,card in pairs(cards) do
			if card and card ~= self.outcards[seatid] then
				if flag == 0 then
					card:render(0,0,3)
				else
					card:render(cardType, cardValue,3)
				end
				
				card:setVisible(true)
				card:scale(out_scale_x,out_scale_y)
				--card:rotateTo(0,270,0.5,0.5)
				card:rotateTo(0,0,0.5,0.5)
				local cw,ch = card:getSize()
				local px,py = card:getAbsolutePos()
				local offx,offy = heapPosx-px+heapW/2-cw,heapPosy-py
				local posx , posy = card:getPos()
				card:moveTo(300,posx+offx-290,posy+offy)
				card:setIsOut(true)
				self.outcards[seatid]=card

				card:findChildByName('img_max'):setVisible(cardValue == max_card and flag ~= 0)
				local small_card = ui:findChildByName("player_info"):findChildByName('card'..cards_num)
				if small_card then small_card:setVisible(false) end
				break;
			end
		end

	elseif localSeatId == 2 then
		for i,card in pairs(cards) do
			if card and card ~= self.outcards[seatid] then
				if flag == 0 then
					card:render(0,0,2)
				else
					card:render(cardType, cardValue,2)
				end
				card:setVisible(true)
				card:scale(out_scale_x,out_scale_y)
				--card:rotateTo(0,180,0.5,0.5)
				card:rotateTo(0,0,0.5,0.5)
				local cw,ch = card:getSize()
				local px,py = card:getAbsolutePos()
				local offx,offy = heapPosx-px,heapPosy-py
				local posx , posy = card:getPos()
				--card:moveTo(300,posx+offx+(heapW-cw)/2+20,posy+offy-ch)
				--card:moveTo(300,posx+offx+(heapW-cw)/2-10,posy+offy-ch-50)
				card:moveTo(300,posx+offx,posy+offy-ch-52)
				card:setIsOut(true)
				self.outcards[seatid]=card

				card:findChildByName('img_max'):setVisible(cardValue == max_card and flag ~= 0)
				local small_card = ui:findChildByName("player_info"):findChildByName('card'..cards_num)
				
				if small_card then small_card:setVisible(false) end
				break;
			end
		end
	elseif localSeatId == 1 then
		for i,card in pairs(cards) do
			if card and card ~= self.outcards[seatid] then
				if flag == 0 then
					card:render(0,0,1)
				else
					card:render(cardType, cardValue,1)
				end
				card:setVisible(true)
				card:scale(out_scale_x,out_scale_y)
				--card:rotateTo(0,90,0.5,0.5)
				card:rotateTo(0,0,0.5,0.5)
				local cw,ch = card:getSize()
				local px,py = card:getAbsolutePos()
				local offx,offy = heapPosx+heapW/2-px,heapPosy-py
				local posx,posy = card:getPos()
				card:moveTo(300,posx+offx+300,posy+offy)
				card:setIsOut(true)
				self.outcards[seatid]=card

				card:findChildByName('img_max'):setVisible(cardValue == max_card and flag ~= 0)
				local small_card = ui:findChildByName("player_info"):findChildByName('card'..cards_num)
				if small_card then small_card:setVisible(false) end
				break;
			end
		end
	end
end
--发送出牌消息
function CardManager:sendCardData(card)
	self.delegate:sendDropCmd(card)
end

function CardManager:allOwnCardEnable(enble)
	-- body
end
function CardManager:showMaxCard(seatid)
	kEffectPlayer:play(AUDIO.TRUCO_FOLLOW)

	if not seatid then
		for i=1,4 do
			local card = self.outcards[i]
			if card then
				card:setSelectIcon(true)
			end
		end
		return
	end
	local card = self.outcards[seatid]
	if card then
		card:setSelectIcon(true)
	end
end
--收牌动画
function CardManager:cardMoveToHeap(card,cardHeap)	--牌移动到牌堆
	if card then
		card:render(0,0,4)
		card:addPropTransparency(1, kAnimNormal, 200, 0, 1, 0);
		local  heapx,heapy  = cardHeap:getAbsolutePos()
		local cardx,cardy = card:getAbsolutePos()
		local offx,offy = heapx-cardx,heapy-cardy
		local posx,posy = card:getPos()
		card:moveTo(200,posx+offx,posy+offy,function ( )
			checkAndRemoveOneProp(card,1024)
			card:removeSelf()
			card = nil
		end)

	end
end
function CardManager:moveOutCardToHeap(cardHeap) --打出去的牌移动到牌堆
	for i,card in ipairs(self.outcards) do
		self:cardMoveToHeap(card,cardHeap)
	end
	self.outcards={}
end

function CardManager:finishMoveOutCardToHeap(cardHeap) --打出去的牌移动到牌堆
	for i,card in ipairs(self.outcards) do
		card:removeSelf()
	end
	self.outcards={}
end

function CardManager:moveLastCardToHeap(players,cardHeap)--剩余手牌牌移动到牌堆
	for k,player in ipairs(players) do
		if player then
			local ui = player:getUi()
			if ui then
				local view_cards = ui:findChildByName("view_cards")
				local cards = view_cards:getChildren()
				for k,card in pairs(cards) do
					card:addPropScale(1024,kAnimNormal, 150, 0, 0.8, 0.6, 0.8, 0.6,kCenterDrawing);
					self:cardMoveToHeap(card,cardHeap)
				end
			end
		end
	end
end

function CardManager:finishMoveLastCardToHeap(players,cardHeap)--剩余手牌牌移动到牌堆
	for k,player in ipairs(players) do
		if player then
			local ui = player:getUi()
			if ui then
				local view_cards = ui:findChildByName("view_cards")
				local cards = view_cards:getChildren()
				for k,card in pairs(cards) do
					checkAndRemoveOneProp(card,1024)
					checkAndRemoveOneProp(card, 15)
					card:removeSelf()
				end
			end
		end
	end
end
---------------------------


function CardManager:showOrHideUnderCard(cardHeap,cardvalue)
	local card = cardHeap:findChildByName("undercard")
	if not card then
	    card = new(Card, 3, 3, 4)
		card:scale(out_scale_x*0.92,out_scale_y*0.92)
		card:setLevel(-1)
		card:setName("undercard")
		cardHeap:addChild(card)
	end
	local cardw,cardh = card:getSize()
	if cardvalue>0 then
		local cardType, cardValue = math.floor(cardvalue/16), cardvalue%16
		card:rotateTo(300,-8,0.3,1)
		--card:moveTo(300,-10,20)
		card:moveTo(300,-15,5)
		card:render(cardType, cardValue,4)
		kEffectPlayer:play(AUDIO.DEALER_CARD_IN)
	else
		card:rotateTo(300,0,0.3,1)
		--card:moveTo(300,20,20)
		card:moveTo(300,0,0)
		kEffectPlayer:play(AUDIO.DEALER_CARD_IN)

		--隐藏手牌
		local mPlayer = self.delegate.mPlayer
		for i=1,4 do
			if mPlayer[i] and mPlayer[i]:getId() > 0 then
				local ui = mPlayer[i]:getUi()
				ui:findChildByName('card1'):setVisible(false)
				ui:findChildByName('card2'):setVisible(false)
				ui:findChildByName('card3'):setVisible(false)
			end
		end
	end
end

function CardManager:finishHideUnderCard(cardHeap)
	local card = cardHeap:findChildByName("undercard")
	if not card then
	    return
	end
	--隐藏手牌
	local mPlayer = self.delegate.mPlayer
	for i=1,4 do
		if mPlayer[i] and mPlayer[i]:getId() > 0 then
			local ui = mPlayer[i]:getUi()
			ui:findChildByName('card1'):setVisible(false)
			ui:findChildByName('card2'):setVisible(false)
			ui:findChildByName('card3'):setVisible(false)
		end
	end
end

return CardManager