--[[

local PLAYER_STATUS = {
    PLAYER_STATUS_DISCONNECT = -1,
    PLAYER_STATUS_LOGIN = 0,    	 --登录
    PLAYER_STATUS_SIT = 1,      	 --坐下
    PLAYER_STATUS_PLAYING = 2,  	 --玩牌
	PLAYER_STATUS_TRUCO = 3,    	 --准备
    PLAYER_STATUS_USEAI = 4,    	 --托管
}

]]--
local Player = class(require("data.headData"))

addProperty(Player, "id", 0)			-- 用户id
addProperty(Player, "seatId", 0)		-- 玩家座位号
addProperty(Player, "chip", 0)			-- 携带金额
addProperty(Player, "nick", "")			-- 匿名
-- addProperty(Player, "headUrl", "")		-- 头像url
addProperty(Player, "giftId", nil)      --当前佩戴的礼物
addProperty(Player, "status", 0)      --玩家坐下后的状态，详见PLAYER_STATUS
addProperty(Player, "cardCnt", 0)      --在玩玩家剩余手牌数
addProperty(Player, "score", 0)      --玩家分数
addProperty(Player, "readyTime",0)
addProperty(Player, "isReady", false)
addProperty(Player, "cards", nil)

addProperty(Player, "userInfo", "")

addProperty(Player, "betCount", 0)
addProperty(Player, "bet", {})
addProperty(Player, "localSeatId", 0)
addProperty(Player, "sitdownAnim", false)
addProperty(Player, "inAnim", false)
addProperty(Player, "ui", nil)
addProperty(Player, "win", nil)
addProperty(Player,"chipTime",{})--暂时不用了
addProperty(Player,"goodCount",0)

addProperty(Player,"statusIcon",-1)  -- 玩家状态图标 1为出牌思考状态,2为同意加倍，3为不同意加倍，4叫分标志
addProperty(Player, "statusScore", 3)
addProperty(Player,"headStyleIdx", 0) -- 同伴样式
addProperty(Player,"ai", 0) 			-- 托管状态
addProperty(Player,"downNum", -1)      -- 等待倒计时
addProperty(Player,"exchangeChip", 0)
addProperty(Player, "imgIcon", nil)	-- 状态图标
-- addProperty(Player, "imgIcon", nil) -- 状态图标
addProperty(Player,"showInfo", false)
addProperty(Player,"isWinner", false)

function Player:ctor()
	
end

function Player:clear()
	self:clearPlayer()
	self:setHeadStyleIdx(0)
end
-- 
function Player:clearPlayer()
	self:setId(0)
	-- self:setSeatId(0)--不需要删除，与生俱来
	self:setChip(0)
	self:setNick("")
	self:setBet({})
	self:setBetCount(0)
	-- self:setLocalSeatId(0)
	self:setSitdownAnim(false)
	self:setInAnim(false)
	self:setWin(nil)
    self:setChipTime({}) --筹码时间
    self:setGoodCount(0) --清除道具
    self:setGiftId(nil)
    self:setStatusIcon(-1) -- 玩家状态图标 1为出牌思考状态,2为同意加倍，3为不同意加倍，4叫分标志
    self:setReadyTime(0)
    
    self:setDownNum(-1)
    self:setAi(false)
    self:setIsReady(false)
    self:setShowInfo(false)
	self:setIsWinner(false)
end
-- 
function Player:init(data)
    self:setId(data.uid)
	self:setSeatId(data.seatId)
	
	self:setChip(data.chip)
	self:setCardCnt(data.cardCnt)
	self:setScore(data.score)
	self:setStatus(data.status)
	self:setAi(data.isAi == 1 and true or false)

	self:setUserInfo(data.userInfo)
	local userInfo = json.decode(data.userInfo)  or {}
	self:setNick(userInfo.nick)
	self:setSex(userInfo.sex or 0)
	self:setHeadUrl(userInfo.micon or "")
	self:setGiftId(userInfo.giftId)
    self:setShowInfo(true)
end
-- 
function Player:initPlayer(data)
	if data.uid == self:getId() then
		self:setSeatId(data.seatId)
		self:setScore(data.score)
		self:setStatus(data.status)
	end
end
-- 
function Player:addChip(chip)
	-- body
	local oldChip = self:getChip();
	local chip 	= oldChip + chip;
	if chip < 0 then
		chip = 0;
	end
	self:setChip(chip)
end

function Player:clearTurnData()

end
-- 
function Player:resetStatus()

end

function Player:clone()
    local player = new(require("truco.data.player"))
    player:setId(self:getId())
    player:setSeatId(self:getSeatId())
    player:setId(self:getId())-- 用户id
    player:setSeatId(self:getSeatId())-- 玩家座位号
    player:setChip(self:getChip())-- 携带金额
    player:setNick(self:getNick())-- 匿名
    player:setGiftId(self:getGiftId())--当前佩戴的礼物
    player:setStatus(self:getStatus())--玩家坐下后的状态，详见PLAYER_STATUS
    player:setCardCnt(self:getCardCnt())--在玩玩家剩余手牌数
    player:setScore(self:getScore())--玩家分数
    player:setReadyTime(self:getReadyTime())
    player:setIsReady(self:getIsReady())
    player:setCards(self:getCards())
    player:setUserInfo(self:getUserInfo())
    player:setBetCount(self:getBetCount())
    player:setBet(self:getBet())
    player:setLocalSeatId(self:getLocalSeatId())
    player:setSitdownAnim(self:getSitdownAnim())
    player:setInAnim(self:getInAnim())
    player:setUi(self:getUi())
    player:setWin(self:getWin())
    player:setChipTime(self:getChipTime())
    player:setGoodCount(self:getGoodCount())
    player:setStatusIcon(self:getStatusIcon())-- 玩家状态图标 1为出牌思考状态,2为同意加倍，3为不同意加倍，4叫分标志
    player:setStatusScore(self:getStatusScore())
    player:setHeadStyleIdx(self:getHeadStyleIdx())-- 同伴样式
    player:setAi(self:getAi())-- 托管状态
    player:setDownNum(self:getDownNum())-- 等待倒计时
    player:setExchangeChip(self:getExchangeChip())
    player:setImgIcon(self:getImgIcon())-- 状态图标
    player:setSex(self:getSex())
    return player
end

function Player:cloneOtherPlayer(p)
    self:setId(p:getId())-- 用户id
    self:setSeatId(p:getSeatId())-- 玩家座位号
    self:setChip(p:getChip())-- 携带金额
    self:setNick(p:getNick())-- 匿名
    self:setGiftId(p:getGiftId())--当前佩戴的礼物
    self:setStatus(p:getStatus())--玩家坐下后的状态，详见PLAYER_STATUS
    self:setCardCnt(p:getCardCnt())--在玩玩家剩余手牌数
    self:setScore(p:getScore())--玩家分数
    self:setReadyTime(p:getReadyTime())
    self:setIsReady(p:getIsReady())
    self:setCards(p:getCards())
    self:setUserInfo(p:getUserInfo())
    self:setBetCount(p:getBetCount())
    self:setBet(p:getBet())
    self:setLocalSeatId(p:getLocalSeatId())
    self:setSitdownAnim(p:getSitdownAnim())
    self:setInAnim(p:getInAnim())
    self:setUi(p:getUi())
    self:setWin(p:getWin())
    self:setChipTime(p:getChipTime())
    self:setGoodCount(p:getGoodCount())
    self:setStatusIcon(p:getStatusIcon())-- 玩家状态图标 1为出牌思考状态,2为同意加倍，3为不同意加倍，4叫分标志
    self:setStatusScore(p:getStatusScore())
    self:setHeadStyleIdx(p:getHeadStyleIdx())-- 同伴样式
    self:setAi(p:getAi())-- 托管状态
    self:setDownNum(p:getDownNum())-- 等待倒计时
    self:setExchangeChip(p:getExchangeChip())
    self:setImgIcon(p:getImgIcon())-- 状态图标
    self:setSex(p:getSex())
    self:setHeadUrl(p:getHeadUrl())
    return self
end

return Player  