local TableId = class()
local PLAY_CARD_TIME = 15
local TWO_MATCH_CNT = 3

addProperty(TableId, "id", 1)
addProperty(TableId, "isInTable", 0)
addProperty(TableId, "gameLevel", 0)
addProperty(TableId, "ante", 0)	-- 游戏底注
addProperty(TableId, "status", 0) -- 桌子状态 0 已结束 1 游戏进行中 
addProperty(TableId, "leftTime", 0) -- 当前状态超时剩余时间 (-1---表示无超时时间)
addProperty(TableId, "oprUid", -1) -- 当前操作的玩家
addProperty(TableId, "oprSeatId", 0) -- 当前操作玩家的座位号
addProperty(TableId, "round", 0)	-- 当前是第几回合（一轮三回合）
addProperty(TableId, "match", 0)	-- 当前是第几局（一共打三局）
addProperty(TableId, "isTruco", 0) 	-- 1标识为有人叫分
addProperty(TableId, "lastTrucoUid", -1) -- 最近一次叫分的玩家
addProperty(TableId, "lastTrucoScore", -1) -- 叫分的分数
addProperty(TableId, "baseScore", -1) -- 该轮底分1,3,6,12
addProperty(TableId, "betScore", -1) -- 根据1369来区分叫分按钮
addProperty(TableId, "manilhascard", -1) -- 最大的牌（是比被翻过来的那张牌大一点的牌）
addProperty(TableId, "viraCardValue", -1) -- 被翻过来的那张牌

addProperty(TableId, "name", "")
addProperty(TableId, "count", 0) -- 人数
addProperty(TableId, "gameId", 0)
addProperty(TableId, "start", false)
addProperty(TableId, "path", -1) --出牌方向 0顺时针 1逆时针
addProperty(TableId, "times", 0)

addProperty(TableId, "playCardTime", PLAY_CARD_TIME)
addProperty(TableId, "totalCardTime", PLAY_CARD_TIME)
addProperty(TableId, "remainPlayCardTime", 0)
addProperty(TableId, "reconn", false)  --输赢
addProperty(TableId, "readyTime", 0)  --准备时间

addProperty(TableId, "maxTimes", 0) -- 桌子出牌阶段，统一出牌超时时间
addProperty(TableId, "maxCard", 0)


addProperty(TableId, "startGamePlayerList", nil)  -- 开始游戏 玩家同伴关系
addProperty(TableId, "handCardValues", {})  -- 当前玩家的手牌
addProperty(TableId, "selfScore", 0)        -- 自己的分值
addProperty(TableId, "rivalScore", 0)	    -- 对手的分值


addProperty(TableId, "currentRound", 0)	-- 当前是第几回合
addProperty(TableId, "matchCnt", 0)	    -- 共几场
addProperty(TableId, "currentMatch", 0)	-- 当前第几场
addProperty(TableId, "selfRoundStatus", {-1, -1, -1})	-- 自己每一回合状态
addProperty(TableId, "rivalRoundStatus", {-1, -1, -1})	-- 对手每一回合状态
addProperty(TableId, "selfWinMathCnt", 0)	-- 自己赢了多少场
addProperty(TableId, "rivalWinMathCnt", 0)	-- 对手赢了多少场
addProperty(TableId, "score", 0)	-- 用于刷新界面双方的积分
addProperty(TableId, "isMatchPoint", false)	 -- 是否是赛点
addProperty(TableId, "acceptTrucoSeatId", 0) -- 接受叫分的玩家SeatId
addProperty(TableId, "acceptTrucoRound", -1) -- 接受叫分的回合
-- 接受叫分的回合
TableId.DEFAULT_TRUCO_STATUS = 0   -- -1标识双方都可以叫truco或加分，非-1的情况为接受叫分的玩家seatId(本一局中只有接受叫分玩家才能继续叫分)
TableId.INVALIDE_ROUND_ID = -1

-- 判断是否可以
function TableId:isValidateTrucoRule(seatId)
	self.acceptTrucoSeatId_ = self:getAcceptTrucoSeatId()
	if self.acceptTrucoSeatId_ == TableId.DEFAULT_TRUCO_STATUS or self.acceptTrucoSeatId_ == seatId then
		return true
	else
		local gamePlayerList = self:getStartGamePlayerList()
		if not gamePlayerList then
			return true
		end
		local aceeptHeadStyleIdx = nil
		local selfHeadStyleIdx = nil
		for i,player in ipairs(gamePlayerList) do
			if not aceeptHeadStyleIdx and player.seatId == self.acceptTrucoSeatId_ then
				aceeptHeadStyleIdx = player.headStyleIdx
			end
			-- 
			if not selfHeadStyleIdx and player.seatId == seatId then
				selfHeadStyleIdx = player.headStyleIdx
			end
		end
		-- 
		-- return selfHeadStyleIdx == aceeptHeadStyleIdx and true or false
		if aceeptHeadStyleIdx == selfHeadStyleIdx then
			return true
		else
			return false
		end
	end
end
-- 
function TableId:init(data)
	-- body
	self:setId(data.tableId or 0);
	self:setIsInTable(data.isInTable or 0);
	self:setGameLevel(data.gameLevel or 0);
	self:setGameId(data.gameId or 0);
	self:setAnte(0);
	self:setRound(0);
	self:setCount(0);
	self:setCurrentRound(0)
	self:setName('');
	self:setStart(false);
	self:setPath(-1);
	self:setTimes(0);
	self:setReadyTime(0);
	self:setStatus(0)
	self:setLeftTime(0)
end
-- 
function TableId:init1007(data)
	-- body
	self:setGameLevel(data.gameLevel or 0)			  -- 桌子所在游戏场次
	self:setAnte(data.ante)							  -- 游戏底注
	self:setStatus(data.status)						  -- 桌子状态 0 已结束 1 游戏进行中 
	self:setLeftTime(data.leftTime)					  -- 当前状态超时剩余时间 (-1---表示无超时时间)	
	self:setCurrentRound(data.currentRound)			  -- 当前是第几回合
	self:setMatchCnt(data.matchCnt)					  -- 共几场
	self:setCurrentMatch(data.currentMatch)			  -- 当前第几场
	self:setBaseScore(data.baseScore or 1)			                  -- 该轮底分1,3,6,12
	self:setTotalCardTime(data.outCardTm)
	self:setPlayCardTime(data.outCardTm)
end
-- 
function TableId:isTwoMatch()
	if self:getMatchCnt() == TWO_MATCH_CNT then
		return true
	end
	return false
end
-- 断开重连的时候显示自己回合状态
function TableId:initRoundStatus(roundStatus)
	local selfRoundStatus = {-1, -1, -1}
	local rivalRoundStatus = {-1, -1, -1}
	if roundStatus then
		for i=1,#roundStatus do
			local status = roundStatus[i]
			if status == 1 then
				selfRoundStatus[i] = 1
			else
				rivalRoundStatus[i] = 1
			end
		end
	end
	self:setSelfRoundStatus(selfRoundStatus)
	self:setRivalRoundStatus(rivalRoundStatus)
end
-- 重置回合状态
function TableId:resetRoundStatus()
	self:setSelfRoundStatus({-1, -1, -1})
	self:setRivalRoundStatus({-1, -1, -1})
end
function TableId:resetMatchCnt()
	self:setSelfWinMathCnt(0)
	self:setRivalWinMathCnt(0)
end
-- 0x4015	-- 广播一回合的结束
function TableId:onBroadCastOneRoundOver(d)
	local currentRound = self:getCurrentRound()
	if currentRound > 0 and currentRound < 4 then
		local gamePlayerList = self:getStartGamePlayerList()
		if not gamePlayerList then
			printInfo("Error:TableId:onBroadCastOneRoundOver(d)")
			return
		end
		for i=1,#gamePlayerList do
			local player = gamePlayerList[i]
			if player.uid == d.uid then
				if player.headStyleIdx == 1  then
					local selfRoundStatus = self:getSelfRoundStatus()
					selfRoundStatus[currentRound] = 1
					self:setSelfRoundStatus(selfRoundStatus)
				else
					local rivalRoundStatus = self:getRivalRoundStatus()
					rivalRoundStatus[currentRound] = 1
					self:setRivalRoundStatus(rivalRoundStatus)
				end
				break
			end

			if d.uid == 0 then
				if player.headStyleIdx == 1  then
					local selfRoundStatus = self:getSelfRoundStatus()
					selfRoundStatus[currentRound] = 1
					self:setSelfRoundStatus(selfRoundStatus)
				else
					local rivalRoundStatus = self:getRivalRoundStatus()
					rivalRoundStatus[currentRound] = 1
					self:setRivalRoundStatus(rivalRoundStatus)
				end
			end
		end
	end
end
-- 0x4006 	-- 广播一局结束
function TableId:onBroadCastOneRound(d,flag)
	if d then
		local gamePlayerList = self:getStartGamePlayerList()
		if not gamePlayerList then
			return
		end
		-- 
		for i=1,#d do
			local user = d[i]
			for j=1,#gamePlayerList do
				local player = gamePlayerList[j]
				if player.uid == user.uid then
					player.score =  user.score
					break
				end
			end
		end
		self:setScore(true)
	end
end
-- 处理回合数
function TableId:onMatchDataList(matchDataList)
	local selfWinMathCnt = 0
	local rivalWinMathCnt = 0
	if matchDataList then
		local gamePlayerList = self:getStartGamePlayerList()
		if not gamePlayerList then
			self:setSelfWinMathCnt(selfWinMathCnt)
			self:setRivalWinMathCnt(rivalWinMathCnt)
			if DEBUG_MODE then
				-- AlarmTip.play("onMatchDataList 处理回合数 gamePlayerList is nil")
			end
			return
		end
		-- 
		for i=1,#matchDataList do
			local matchData = matchDataList[i]
			for j=1,#gamePlayerList do
				local player = gamePlayerList[j]
				if player.uid == matchData.uid then
					if player.headStyleIdx == 1 then
						selfWinMathCnt = selfWinMathCnt + 1
					elseif player.headStyleIdx == 2 then
						rivalWinMathCnt = rivalWinMathCnt + 1
					end
					break
				end
			end
		end
	end

	self:setSelfWinMathCnt(selfWinMathCnt)
	self:setRivalWinMathCnt(rivalWinMathCnt)
end
-- 初始化玩牌阶段桌子数据
function TableId:initPlaying(data)
	self:setOprUid(data.oprUid or -1)				  -- 当前操作的玩家
	self:setOprSeatId(data.oprSeatId or 0)			  -- 当前操作玩家的座位号
	self:setRound(data.round or 0)					  -- 当前是第几回合（一轮三回合）
	self:setMatch(data.match or -1)					  -- 当前是第几局（一共打三局）
	self:setIsTruco(data.isTruco or -1)               -- 1标识为有人叫分
	self:setLastTrucoUid(data.lastTrucoUid or -1)     -- 最近一次叫分的玩家
	self:setLastTrucoScore(data.lastTrucoScore or -1) -- 叫分的分数
	self:setBaseScore(data.baseScore or 1)			  -- 该轮底分1,3,6,12
	self:setManilhascard(data.manilhascard or -1)     -- 最大的牌（是比被翻过来的那张牌大一点的牌）
	--self:setViraCardValue(data.viraCardValue or -1)   -- 被翻过来的那张牌
end
-- 检测uid是否为队友或自己
function TableId:checkUidIsFriend(uid)
	if uid then
		local gamePlayerList = self:getStartGamePlayerList()
		if not gamePlayerList then
			return false
		end
		
		for i=1,#gamePlayerList do
			local player = gamePlayerList[i]
			if player.uid == uid then
				if player.uid == MyUserData:getId() or player.friendUid == MyUserData:getId() then
					return true
				end
				return false
			end
		end
	end
	return false
end
function TableId:checkSeatIdIsFriend(seatId)
	if seatId then
		local gamePlayerList = self:getStartGamePlayerList()
		if not gamePlayerList then
			return false
		end
		
		local seatIdPlayer
		local seatIdFriendPlayer
		for i=1,#gamePlayerList do
			local player = gamePlayerList[i]
			if player.uid == MyUserData:getId() and player.seatId == seatId then
				return true
			end

			if player.friendSeatId and player.friendSeatId == seatId and player.uid == MyUserData:getId() then
				return true
			end
		end
	end
	return false
end
-- 初始化玩家出牌数据信息
function TableId:initPlayerOutCardInfo()
	self.playerHandCardInfos_ = {}
	local gamePlayerList = self:getStartGamePlayerList()
	for i=1,#gamePlayerList do
		local player = gamePlayerList[i]
		self.playerHandCardInfos_[player.seatId] = {}
	end
end
-- 根据SeatId获取玩家出了多少张牌
function TableId:getPlayerCardsCntBySeatId(seatId)
	if self.playerHandCardInfos_[seatId] then
		local arr = self.playerHandCardInfos_[seatId]
		return #arr
	else
		return -1
	end
end
-- 保存玩家出牌数据信息
function TableId:outCardOptAnsyPlayerCardInfo(seatId, cardValue)
	if self.playerHandCardInfos_ and self.playerHandCardInfos_[seatId] then
		local isExist = nil  -- 判断之前是否已经保存过这张牌
		local arr = self.playerHandCardInfos_[seatId]
		for _,v in pairs(arr) do
			if v == cardValue then
				isExist =true
			end
		end
		-- 
		if not isExist then
			table.insert(arr, cardValue)
			return true
		end
	end
	return false
end

-----------------------------------------------------------------
-- 0x4002	-- 广播玩家站起
function TableId:onBroadCastStandUp(data)
	local playerList = self:getStartGamePlayerList()
	if playerList then
		local isExist = false
		for i=1,#playerList do
			local playerData = playerList[i]
			if playerData.uid == data.uid then
				table.remove(playerList, i)
				isExist = true
				break
			end
		end

		if isExist then
			self:setStartGamePlayerList(playerList)
		end
	end
end
-- 0x4010          //！开始游戏 玩家同伴关系 server -> client
function TableId:onBroadCastStartGame(data)
	
	if data and data.playerList then
		self:setStartGamePlayerList(data.playerList)
	end
	self:setScore(false)
	self:initPlayerOutCardInfo()
end
-- 0x4011	-- 广播开始发牌
function TableId:onBroadCastDealCard(data)
	self:setStatus(1)
	self:setOprUid(data.uid)
	self:setOprSeatId(data.seatId)
end
-- 0x1054    -- 发3张手牌 server -> client
function TableId:onDealerCard(data)
	
	--self:setHandCardValues(data.cardValues)
	--self:setViraCardValue(data.viraCardValue)
	print_string("data.viraCardValue :"..data.viraCardValue)
end
-- 
function TableId:getHandCardValueByPos(idx)
	local cardValues = self:getHandCardValues()
	if cardValues and cardValues[idx] then
		return cardValues[idx]
	else
		return nil
	end
end
-- 0x4012    -- 广播vira牌和底分 server -> client
function TableId:onBroadCastViraCard(data)
	--self:setViraCardValue(data.viraCardValue)
	self:setBaseScore(data.basescore)
	self:setMaxCard(data.max_card)
	if data.betScore ~= -1 then 
		self:setBetScore(data.betScore)
	end
end
-- 0x4013	-- 广播当前轮到操作用户 server -> client
function TableId:onBroadCastCurrentUser(data)
	self:setOprUid(data.uid)
	self:setOprSeatId(data.seatId)
	-- self:setLeftTime(data.leftTime)
	if data.betScore ~= -1 then
		self:setBetScore(data.betScore)
	end
end
-- 
function TableId:updatePlayerHeadStyleId()

end
-- 
function TableId:clear()
	self:setLeftTime(-1)			  -- 当前状态超时剩余时间 (-1---表示无超时时间)
	self:setOprUid(-1)				  -- 当前操作的玩家
	self:setOprSeatId(0)			  -- 当前操作玩家的座位号
	self:setRound(0)				  -- 当前是第几回合（一轮三回合）
	self:setMatch(-1)				  -- 当前是第几局（一共打三局）
	self:setIsTruco(-1) -- 1标识为有人叫分
	self:setLastTrucoUid(-1)     -- 最近一次叫分的玩家
	self:setLastTrucoScore(-1) -- 叫分的分数
	self:setBaseScore(1)			-- 该轮底分1,3,6,12
	self:setManilhascard(-1)   -- 最大的牌（是比被翻过来的那张牌大一点的牌）
	--self:setViraCardValue(-1) -- 被翻过来的那张牌
	self:setAcceptTrucoSeatId(TableId.DEFAULT_TRUCO_STATUS) -- 接受叫分的玩家SeatId
	self:setAcceptTrucoRound(TableId.INVALIDE_ROUND_ID)  -- 接受叫分的回合
end

return TableId