--
-- Author: HLF(IdaHuang@boyaa.com)
-- Date: 2016-12-29 18:54:08
--
local AUDIO 	= require('truco.res.audio.config')
local playerLayout = requireview("view.truco.trucoPlayerLayout")
local TrucoFailGameResult = class(BaseLayer)

local PLAYER_POS_CFG = {{{0, 0}},{{-43, 0}, {43, 0}}}

function TrucoFailGameResult:ctor(layout, ctrl, data)
	self.ctrl_ = ctrl
	self.data_ = data
	self.layout_ = layout
	self:initView()
	self:renderMoney(self.data_.totalMoney)
	local scoreDic = {}
	local headStylePlayerList = {}
	for _,v in ipairs(self.data_.playerList) do
		local headStyleIdx = v.playerData:getHeadStyleIdx()
		if headStyleIdx == 0 then  --容错
			headStyleIdx = 2
		end
		if not headStylePlayerList[headStyleIdx] then
			headStylePlayerList[headStyleIdx] = {}
		end
		table.insert(headStylePlayerList[headStyleIdx], v)
		scoreDic[headStyleIdx] = v.scores

		if v.uid == MyUserData:getId() then
			self:renderMoney(v.turnmoney)
		end
	end
	-- -- 
	for headStyleIdx,list in pairs(headStylePlayerList) do
		self:initPlayerList(list, self:findChildByName("view_playerList"..headStyleIdx))
	end
	-- -- 
	self:initScoreList(scoreDic[1], scoreDic[2])
	
	self:showClockNum(self.data_.leftTime or 15)
	self:initAnim()
	kEffectPlayer:play(AUDIO.TRUCO_LOSE)
end

-- 
function TrucoFailGameResult:initScoreList(winScores, loseScores)
	winScores = winScores or {0, 0, 0}
	loseScores = loseScores or {0, 0, 0}
	
	local matchCnt = 0
	local winCnt = 0
	local loseCnt = 0
	for i=1,3 do
		if winScores[i] > 0 or loseScores[i] > 0 then
			matchCnt = matchCnt + 1
			if winScores[i] and winScores[i] > 11 then
				winCnt = winCnt + 1
			end

			if loseScores[i] and loseScores[i] > 11 then
				loseCnt = loseCnt + 1
			end
			self:findChildByName("view_scoreList"..i):findChildByName("txt_winScore"):setText(winScores[i])
			self:findChildByName("view_scoreList"..i):findChildByName("txt_loseScore"):setText(loseScores[i])
			self:findChildByName("view_scoreList"..i):setVisible(true)
		end
	end
	-- 
	local bg = self:findChildByName("view_scoreList"..matchCnt)
	if bg and bg:findChildByName("img_scoreBg") then
		bg:findChildByName("img_scoreBg"):setVisible(false)
	end
	
	-- 
	self:findChildByName("txt_winCnt"):setText(winCnt)
	self:findChildByName("txt_loseCnt"):setText(loseCnt)

	if matchCnt == 1 then
		self:findChildByName("view_scoreList1"):setPos(0, 40)
		self:findChildByName("view_score"):setPos(0, 120)
		self:findChildByName("view_score"):findChildByName("img_scoreBg"):setSize(360, 74)
	end
end
-- 初始化玩家数据 self:findChildByName("view_playerList")
function TrucoFailGameResult:initPlayerList(playerList, parentContain)
	if not parentContain then
		return
	end

	local cnt = #playerList
	cnt = cnt or 1
	-- local playerLayoutList = {}
	local posList = PLAYER_POS_CFG[cnt]
	if not posList then
		posList = PLAYER_POS_CFG[1]
	end
	for i=1,cnt do
		local pos = posList[i]
		local playerItem = playerList[i]
		if playerItem.playerData then
			self:renderPlayer(parentContain, playerItem, pos)
		end
	end
end
-- 
function TrucoFailGameResult:renderPlayer(parentContain, playerItem, pos)
	local player = SceneLoader.load(playerLayout)
	player:findChildByName("view_style1"):setVisible(false)
	player:findChildByName("view_style2"):setVisible(false)
	parentContain:addChild(player)
	player:setAlign(kAlignCenter)
	player:setPos(pos[1], pos[2])
	player:findChildByName('img_ai'):setVisible(false)
	player:findChildByName('btn_gift'):setVisible(false)
	-- 
	if playerItem.playerData:getHeadStyleIdx() == 1 then
		player:findChildByName("relationIcon1"):setVisible(true)
		player:findChildByName("relationIcon2"):setVisible(false)
	else
		player:findChildByName("relationIcon1"):setVisible(false)
		player:findChildByName("relationIcon2"):setVisible(true)
	end
	if player and playerItem and playerItem.playerData then
		local currentPlayerData = playerItem.playerData
		player:findChildByName("img_noReady"):setVisible(false)
		UIEx.bind(player, playerItem.playerData, "headName", function(value)
			-- if currentPlayerData:getId() ~= 0 then
				local nick = currentPlayerData:getNick()
				local headView = player:findChildByName("view_phead");
				headView:removeAllChildren();
				local width, height = headView:getSize()
				local imgHead 		= new(Mask, value, "truco/head_mask.png");
				imgHead:setSize(width, height)
				headView:addChild(imgHead);
				currentPlayerData:checkHeadAndDownload()
			-- end
		end)
		-- 

		playerItem.playerData:setSex(playerItem.playerData:getSex())
		currentPlayerData:checkHeadAndDownload()
		local nick1 = currentPlayerData:getNick()
		-- 
		-- table.insert(playerLayoutList, layout)
	end
end
-- 
function TrucoFailGameResult:initView()
	local rightBg = self.m_root:findChildByName("img_borderBgRight")
	rightBg:addPropScaleSolid(1, -1, 1, kCenterDrawing, 0, 0)
	-- 返回大厅
	self.m_root:findChildByName("btn_gotoHall"):setOnClick(self, function (self)
		self.ctrl_:onGotoHall()
	end)
	-- 再来一局
	self.m_root:findChildByName("btn_again"):setOnClick(self, function (self)
		self.ctrl_:onContinue()
	end)
end
-- 呈现筹码
function TrucoFailGameResult:renderMoney(value)
	local viewAnte = self:findChildByName('chip_node')
	local nodeAnte
	local sign = "+"
	if tonumber(value) > 0 then
		nodeAnte = new(require('truco.common.imageNumber'), {
		    ['0'] = 'truco/room/truco_gameResult/0.png',
		    ['1'] = 'truco/room/truco_gameResult/1.png',
		    ['2'] = 'truco/room/truco_gameResult/2.png',
		    ['3'] = 'truco/room/truco_gameResult/3.png',
		    ['4'] = 'truco/room/truco_gameResult/4.png',
		    ['5'] = 'truco/room/truco_gameResult/5.png',
		    ['6'] = 'truco/room/truco_gameResult/6.png',
		    ['7'] = 'truco/room/truco_gameResult/7.png',
		    ['8'] = 'truco/room/truco_gameResult/8.png',
		    ['9'] = 'truco/room/truco_gameResult/9.png',
		    ['+'] = 'truco/room/truco_gameResult/+.png',
		    ['k'] = 'truco/room/truco_gameResult/K.png',
		    ['m'] = 'truco/room/truco_gameResult/M.png',
		    ['.'] = 'truco/room/truco_gameResult/P.png',
	    })
	else
		nodeAnte = new(require('truco.common.imageNumber'), {
		    ['0'] = 'truco/room/truco_gameResult/00.png',
		    ['1'] = 'truco/room/truco_gameResult/01.png',
		    ['2'] = 'truco/room/truco_gameResult/02.png',
		    ['3'] = 'truco/room/truco_gameResult/03.png',
		    ['4'] = 'truco/room/truco_gameResult/04.png',
		    ['5'] = 'truco/room/truco_gameResult/05.png',
		    ['6'] = 'truco/room/truco_gameResult/06.png',
		    ['7'] = 'truco/room/truco_gameResult/07.png',
		    ['8'] = 'truco/room/truco_gameResult/08.png',
		    ['9'] = 'truco/room/truco_gameResult/09.png',
		    ['-'] = 'truco/room/truco_gameResult/-.png',
		    ['k'] = 'truco/room/truco_gameResult/KK.png',
		    ['m'] = 'truco/room/truco_gameResult/OM.png',
		    ['.'] = 'truco/room/truco_gameResult/OP.png',
	    })
	    sign = "-"
	end
	viewAnte:removeAllChildren()
    viewAnte:addChild(nodeAnte)
    nodeAnte:setNumber(string.format("%s", sign..ToolKit.formatMoney(math.abs(value))));
    nodeAnte:setVisible(true)
    nodeAnte:setAlign(kAlignCenter)
end
-- 显示倒计时
function TrucoFailGameResult:showClockNum(value)
	self.downClockNum_ = value
	self:renderClockNum(self.downClockNum_)
	-- 
	local animEvent = self:addPropTranslate(10, kAnimLoop, 1000, 0, 0, 0, 0, 0)
	animEvent:setEvent(self, function()
		self.downClockNum_ = self.downClockNum_ - 1
		if self.downClockNum_ >= 0 then
			self:renderClockNum(self.downClockNum_)
			if self.downClockNum_<=5 then
				kEffectPlayer:play(AUDIO.TIME_WARNING)
			end
		else
			checkAndRemoveOneProp(self, 10)
		end
	end)
end
-- 呈现倒计时
function TrucoFailGameResult:renderClockNum(value)
	if not self.viewClockNum_ then
		self.viewClockNum_ = self:findChildByName('view_clockNum')
	end
	-- 
	local nodeClock = new(require('truco.common.imageNumber', -5), {
		    ['0'] = 'truco/room/truco_downTime/0.png',
		    ['1'] = 'truco/room/truco_downTime/1.png',
		    ['2'] = 'truco/room/truco_downTime/2.png',
		    ['3'] = 'truco/room/truco_downTime/3.png',
		    ['4'] = 'truco/room/truco_downTime/4.png',
		    ['5'] = 'truco/room/truco_downTime/5.png',
		    ['6'] = 'truco/room/truco_downTime/6.png',
		    ['7'] = 'truco/room/truco_downTime/7.png',
		    ['8'] = 'truco/room/truco_downTime/8.png',
		    ['9'] = 'truco/room/truco_downTime/9.png',
	    })
	self.viewClockNum_:removeAllChildren()
    self.viewClockNum_:addChild(nodeClock)
    nodeClock:setNumber(string.format("%s", tostring(value)));
    nodeClock:setVisible(true)
    nodeClock:setAlign(kAlignCenter)
    nodeClock:setPos(0, 0)
end
-- 
function TrucoFailGameResult:initAnim()
	self:playDownAnim(self:findChildByName("img_crownBg"), function()
		self:playDownUpAnim(self:findChildByName("img_crownBg"), 1000, 12)
	end)
	-- 
	self:playZoomInToOut(self:findChildByName("img_failBg"))
	-- 
	self.viewWin_ = self:findChildByName("view_borderBg")
	local dw, dh = self.viewWin_:getSize()
	local scaleAnim = self.viewWin_:addPropScale(1, kAnimNormal, 240, 100, 1, 1, 0.1, 1.0, kCenterXY, dw/2, 0)
	scaleAnim:setEvent(nil, function()
		checkAndRemoveOneProp(self.viewWin_, 1)
	end)
end
-- 播放掉落动画(皇冠、旗子)
function TrucoFailGameResult:playDownAnim(spriteMC, callback)
	checkAndRemoveOneProp(spriteMC, 1)
	checkAndRemoveOneProp(spriteMC, 3)
	local w, h = spriteMC:getSize()
	local scaleAnim = spriteMC:addPropScaleWithEasing(3, kAnimNormal, 300, 200, "easeOutBounce", "easeOutBounce", 4.0, -3.0, kCenterDrawing);
	local inAnim = spriteMC:addPropTranslateWithEasing(1, kAnimNormal, 300, 200, "easeInSine", "easeInSine", 0, 0, -4.5 * h, 4.5 * h);
	inAnim:setEvent(self, function()
		checkAndRemoveOneProp(spriteMC, 1)
		checkAndRemoveOneProp(spriteMC, 3)
		-- 整体上挤压
		local scaleAnim = spriteMC:addPropScaleYWithEasing(2, kAnimNormal, 180, 0, "easeOutBounce", "easeOutBounce", 0.7, 0.3, kCenterXY, w/2, h*2);
		scaleAnim:setEvent(self, function()
			checkAndRemoveOneProp(spriteMC, 2);
			if callback then
				callback()
			end
		end)
	end)
end
-- 播放上下浮动动画
function TrucoFailGameResult:playDownUpAnim(spriteMC, ts, upVal)
	local inAnim = spriteMC:addPropTranslateWithEasing(10, kAnimLoop, ts, 0, "easeInSine", "easeInSine", 0, 0, upVal, -upVal);
end
-- 播放放大缩小动画(用于文字)
function TrucoFailGameResult:playZoomInToOut(spriteMC)
	local w, h 	= spriteMC:getSize();
	checkAndRemoveOneProp(spriteMC, 1)
	checkAndRemoveOneProp(spriteMC, 2)
	spriteMC:addPropTransparency(1, kAnimNormal, 600, 200, 0, 1);
	local scaleAnim = spriteMC:addPropScaleWithEasing(2, kAnimNormal, 600, 200, "easeOutBounce", "easeOutBounce", 4.0, -3.0, kCenterDrawing);
	scaleAnim:setEvent(self, function()
		checkAndRemoveOneProp(spriteMC, 1)
		checkAndRemoveOneProp(spriteMC, 2)
	end)
end
-- 
function TrucoFailGameResult:onCleanup()
	-- 
	checkAndRemoveOneProp(self:findChildByName("img_crownBg"), 1)
	checkAndRemoveOneProp(self:findChildByName("img_crownBg"), 3)
	checkAndRemoveOneProp(self:findChildByName("img_crownBg"), 10)
	-- 
	checkAndRemoveOneProp(self:findChildByName("img_failBg"), 1)
	checkAndRemoveOneProp(self:findChildByName("img_failBg"), 2)
end

return TrucoFailGameResult