--
-- Author: HLF(IdaHuang@boyaa.com)
-- Date: 2016-12-29 14:34:52
-- truco的4个人玩的11点选择牌型框
local AUDIO 	= require('truco.res.audio.config')
local Card 		= require("truco.card.card")
local TrucoGameMatchElevelTwoPopup = class(BaseLayer)

TrucoGameMatchElevelTwoPopup.ACCEPT_TYPE = 1  
TrucoGameMatchElevelTwoPopup.REFUSE_TYPE = 2
TrucoGameMatchElevelTwoPopup.WAITING_TYPE = 3

function TrucoGameMatchElevelTwoPopup:ctor(layout, ctrl, data)
	-- if DEBUG_MODE then
		
	-- 	self:renderSelfCardValues({1,2,3})
	-- 	return
	-- end
	self.ctrl_ = ctrl
	self.data_ = data
	self.layout_ = layout
	self:initView()
	self:renderRivalScore(self.data_.rivalScore)
	self:showClockNum(self.data_.leftTime)
	self:renderViraCard(self.data_.viraCardValue)
	-- 
	self:renderFriendCardValues(self.data_.friendCardValues)
	self:renderSelfCardValues(self.data_.cardValues)
	self:setTipsType(TrucoGameMatchElevelTwoPopup.WAITING_TYPE)
end

function TrucoGameMatchElevelTwoPopup:dctor()

end
-- 呈现对手分值
function TrucoGameMatchElevelTwoPopup:renderRivalScore(value)
	local viewAnte = self:findChildByName('view_rivalScore')
	local nodeAnte = new(require('truco.common.imageNumber'), {
		    ['0'] = 'truco/room/truco_score/00.png',
		    ['1'] = 'truco/room/truco_score/01.png',
		    ['2'] = 'truco/room/truco_score/02.png',
		    ['3'] = 'truco/room/truco_score/03.png',
		    ['4'] = 'truco/room/truco_score/04.png',
		    ['5'] = 'truco/room/truco_score/05.png',
		    ['6'] = 'truco/room/truco_score/06.png',
		    ['7'] = 'truco/room/truco_score/07.png',
		    ['8'] = 'truco/room/truco_score/08.png',
		    ['9'] = 'truco/room/truco_score/09.png',
	    })
	nodeAnte:addPropScaleSolid(111,0.6,0.6,kCenterDrawing)
	viewAnte:removeAllChildren()
    viewAnte:addChild(nodeAnte)
    nodeAnte:setNumber(string.format("%s", tostring(value)));
    nodeAnte:setVisible(true)

    checkAndRemoveOneProp(viewAnte, 11)
	viewAnte:addPropScaleSolid(11, 0.5, 0.5, kNotCenter)
end
-- 显示倒计时
function TrucoGameMatchElevelTwoPopup:showClockNum(value)
	self.downClockNum_ = value or 8
	self:renderClockNum(self.downClockNum_)
	-- 
	local animEvent = self:addPropTranslate(10, kAnimLoop, 1000, 0, 0, 0, 0, 0)
	animEvent:setEvent(self, function()
		self.downClockNum_ = self.downClockNum_ - 1
		if self.downClockNum_ >= 0 then
			self:renderClockNum(self.downClockNum_)
		else
			checkAndRemoveOneProp(self, 10)
		end
	end)
end
-- 呈现倒计时
function TrucoGameMatchElevelTwoPopup:renderClockNum(value)
	self:findChildByName('text_clock_num'):setText(value)
	-- if not self.viewClockNum_ then
	-- 	self.viewClockNum_ = self:findChildByName('view_clockNum')
	-- 	checkAndRemoveOneProp(self.viewClockNum_, 11)
	-- 	self.viewClockNum_:addPropScaleSolid(11, 0.6, 0.6, kNotCenter)
	-- end
	-- -- 
	-- local nodeClock = new(require('truco.common.imageNumber', -5), {
	-- 	    ['0'] = 'truco/room/truco_downTime/0.png',
	-- 	    ['1'] = 'truco/room/truco_downTime/1.png',
	-- 	    ['2'] = 'truco/room/truco_downTime/2.png',
	-- 	    ['3'] = 'truco/room/truco_downTime/3.png',
	-- 	    ['4'] = 'truco/room/truco_downTime/4.png',
	-- 	    ['5'] = 'truco/room/truco_downTime/5.png',
	-- 	    ['6'] = 'truco/room/truco_downTime/6.png',
	-- 	    ['7'] = 'truco/room/truco_downTime/7.png',
	-- 	    ['8'] = 'truco/room/truco_downTime/8.png',
	-- 	    ['9'] = 'truco/room/truco_downTime/9.png',
	--     })
	-- self.viewClockNum_:removeAllChildren()
 --    self.viewClockNum_:addChild(nodeClock)
 --    nodeClock:setNumber(string.format("%s", tostring(value)));
 --    nodeClock:setVisible(true)
 --    nodeClock:setAlign(kAlignCenter)
 --    nodeClock:setPos(18, 20)
end
-- 呈现vira牌
function TrucoGameMatchElevelTwoPopup:renderViraCard(value)

	local cardType, cardValue = math.floor(value/16),value%16
	local card = new(Card, cardType, cardValue, 4)

	card:scale(0.8*0.35, 0.82*0.35)
	card:setPos(-15, 6)
	self:findChildByName("view_viraCard"):addChild(card)
	card:addPropRotateSolid(12, -10, kNotCenter, 0, 0)
end
-- 
function TrucoGameMatchElevelTwoPopup:renderFriendCardValues(values)
	local cardContain = self:findChildByName("view_friendCardContain")
	--local px, py = 10, 5
	local px = {17,115,213}
	for i=1,#values do

		local cardType, cardValue = math.floor(values[i]/16),values[i]%16
		local card = new(Card, cardType, cardValue, 4)

		card:scale(0.97, 0.87)
		--card:scale(0.72, 0.72)
		--card:setPos(px, py)
		card:setPos(px[i], 5)
		cardContain:addChild(card)
		--px = px + 105
	end
end
-- 
function TrucoGameMatchElevelTwoPopup:renderSelfCardValues(values)
	local cardContain = self:findChildByName("view_selfCardContain")
	--local px, py = 10, 5
	local px = {17,115,213}
	for i=1,#values do
		local cardType, cardValue = math.floor(values[i]/16),values[i]%16
		local card = new(Card, cardType, cardValue, 4)
		--card:scale(0.72, 0.72)
		card:scale(0.97, 0.87)
		--card:setPos(px, py)
		card:setPos(px[i], 5)
		cardContain:addChild(card)
		--px = px + 105
	end
end
-- 
function TrucoGameMatchElevelTwoPopup:initView()
	-- “接收”当前牌型
	self.m_root:findChildByName("btn_accept"):setOnClick(self, function (self)
		self.ctrl_:onAcceptCurrentCards()
		self:setButtonEnable(false)
	end)
	-- “拒绝”当前牌型
	self.m_root:findChildByName("btn_refuse"):setOnClick(self, function (self)
		self.ctrl_:onRefuseCurrentCards()
		self:setButtonEnable(false)
	end)
	if self.ctrl_.mGameId == 13007 then
		self.m_root:findChildByName("img_titleTxtBg"):setFile("truco/room/13007/15.png")
		self.m_root:findChildByName("img_borderBg"):setFile("truco/room/13007/12.png")
		self.m_root:findChildByName("img_friendCardContain"):setFile("truco/room/13007/14.png")
		self.m_root:findChildByName("img_selfCardContain"):setFile("truco/room/13007/14.png")
	end
end
-- 
function TrucoGameMatchElevelTwoPopup:setButtonEnable(value)
	self.m_root:findChildByName("btn_accept"):setVisible(value)
	self.m_root:findChildByName("btn_refuse"):setVisible(value)
end
-- 
function TrucoGameMatchElevelTwoPopup:setTipsType(type_)
	-- self:findChildByName("img_clockAcceptTxtBg"):setVisible(false)
	-- self:findChildByName("img_clockRefuseTxtBg"):setVisible(false)
	-- self:findChildByName("img_clockWaitSelectCardTxtBg"):setVisible(false)
	-- if type_ == TrucoGameMatchElevelTwoPopup.ACCEPT_TYPE then
	-- 	self:findChildByName("img_clockAcceptTxtBg"):setVisible(true)
	-- elseif type_ == TrucoGameMatchElevelTwoPopup.REFUSE_TYPE then
	-- 	self:findChildByName("img_clockRefuseTxtBg"):setVisible(true)
	-- elseif type_ == TrucoGameMatchElevelTwoPopup.WAITING_TYPE then
	-- 	self:findChildByName("img_clockWaitSelectCardTxtBg"):setVisible(true)
	-- end
	local wenan = self:findChildByName("text_wenan")
	if type_ == TrucoGameMatchElevelTwoPopup.ACCEPT_TYPE then
		wenan:setText('Seu parceiro aceitou!')
	elseif type_ == TrucoGameMatchElevelTwoPopup.REFUSE_TYPE then
		wenan:setText('Seu parceiro abandonou!')
	elseif type_ == TrucoGameMatchElevelTwoPopup.WAITING_TYPE then
		wenan:setText('Seu parceiro está escolhendo...')
	end
end

return TrucoGameMatchElevelTwoPopup