--
-- Author: HLF(IdaHuang@boyaa.com)
-- Date: 2016-12-29 18:54:08
--
local AUDIO 	= require('truco.res.audio.config')
local playerLayout = requireview("view.truco.trucoPlayerLayout1")
--local TrucoFailGameResult = class(BaseLayer)
local TrucoFailGameResult = class(require("popu.gameWindow"))
local TrucoBaseController = require('truco.room.trucoBaseController')


function TrucoFailGameResult:ctor(data)
	local bg = self.m_root:findChildByName("img_bg")
	if bg then
		bg:setEventTouch(self, function(self)
			if self.bgTouchHide then
	            self:dismiss()
	        end
        end)
	end
end

function TrucoFailGameResult:dtor()
	
end

function TrucoFailGameResult:initView(data)
	-- if DEBUG_MODE then 
	-- 	self:showClockNum(15)
	-- 	return
	-- end
	self.ctrl_ = data.ctrl
	self.data_ = data.out_data

	self:showClockNum(self.data_.leftTime or 15)
	
	self:renderMoney(self.data_.totalMoney)
	local scoreDic = {}
	local headStylePlayerList = {}
	for _,v in ipairs(self.data_.playerList) do
		local headStyleIdx = v.playerData:getHeadStyleIdx()
		if headStyleIdx == 0 then  --容错
			headStyleIdx = 2
		end
		if not headStylePlayerList[headStyleIdx] then
			headStylePlayerList[headStyleIdx] = {}
		end
		table.insert(headStylePlayerList[headStyleIdx], v)
		scoreDic[headStyleIdx] = v.scores

		if v.uid == MyUserData:getId() then
			self:renderMoney(v.turnmoney)
		end
	end
	-- -- 
	for headStyleIdx,list in pairs(headStylePlayerList) do
		self:initPlayerList(list, self:findChildByName("view_playerList"..headStyleIdx),headStyleIdx)
	end
	-- -- 
	self:initScoreList(scoreDic[1], scoreDic[2])
	
	
	self:initAnim()

	self.m_root:findChildByName("btn_gotoHall"):setOnClick(self, function (self)
		self.ctrl_:onGotoHall()
	end)
	-- 再来一局
	self.m_root:findChildByName("btn_again"):setOnClick(self, function (self)
		self.ctrl_:onContinue()
	end)

	if data.is_win then
		kEffectPlayer:play(AUDIO.TRUCO_WIN)
	else
		kEffectPlayer:play(AUDIO.TRUCO_LOSE)
	end

	--13007主题
	if self.ctrl_.mGameId == 13007 then
		local lbl_pontos = self.m_root:findChildByName("lbl_pontos")
		local w, h = lbl_pontos:getSize()
		lbl_pontos:setText(lbl_pontos:getText(), w, h, 255, 255, 255)
		local img_vs = self.m_root:findChildByName("img_vs")
		img_vs:setVisible(true)
		-- img_vs:setFile("truco/room/13007/game_result/vs.png")
		-- img_vs:setSize(img_vs.m_res.m_width, img_vs.m_res.m_height)
		self.m_root:findChildByName("img_scoreBg"):setFile("truco/room/13007/game_result/31.png")
		self.m_root:findChildByName("view_borderBg"):setPos(0, 65)
		self.m_root:findChildByName("btn_again"):setPos(135, 175)
		self.m_root:findChildByName("btn_gotoHall"):setPos(-135, 175)
		self.m_root:findChildByName("chip_node"):setPos(0, -195)
	end
end

-- 
function TrucoFailGameResult:initScoreList(winScores, loseScores)
	winScores = winScores or {0, 0, 0}
	loseScores = loseScores or {0, 0, 0}
	
	local matchCnt = 0
	local winCnt = 0
	local loseCnt = 0
	for i=1,1 do
		if winScores[i] > 0 or loseScores[i] > 0 then
			matchCnt = matchCnt + 1
			if winScores[i] and winScores[i] > 11 then
				winCnt = winCnt + 1
			end

			if loseScores[i] and loseScores[i] > 11 then
				loseCnt = loseCnt + 1
			end
			self:findChildByName("view_scoreList"..i):findChildByName("txt_winScore"):setText(winScores[i])
			self:findChildByName("view_scoreList"..i):findChildByName("txt_loseScore"):setText(loseScores[i])
			self:findChildByName("view_scoreList"..i):setVisible(true)
		end
	end
	-- 
	
end
-- 初始化玩家数据 self:findChildByName("view_playerList")
function TrucoFailGameResult:initPlayerList(playerList, parentContain,headStyleIdx)
	if not parentContain then
		return
	end

	local PLAYER_POS_CFG = {{{20, 0}},{{-55, 0}, {55, 0}}}

	local cnt = #playerList
	cnt = cnt or 1
	-- local playerLayoutList = {}
	local posList = PLAYER_POS_CFG[cnt]
	if not posList then
		posList = PLAYER_POS_CFG[1]
	end
	for i=1,cnt do
		local pos = posList[i]
		if cnt == 1 and headStyleIdx == 2 then
			pos[1] = -pos[1]
		end
		local playerItem = playerList[i]
		if playerItem.playerData then
			if not pos then pos = posList[1] end
			self:renderPlayer(parentContain, playerItem, pos, i)
		end
	end
end
-- 
function TrucoFailGameResult:renderPlayer(parentContain, playerItem, pos, i)
	local player = SceneLoader.load(playerLayout)
	--player:findChildByName("view_style1"):setVisible(false)
	--player:findChildByName("view_style2"):setVisible(false)
	parentContain:addChild(player)
	player:setAlign(kAlignCenter)
	player:setPos(pos[1], pos[2])
	player:findChildByName('img_ai'):setVisible(false)
	player:findChildByName('btn_gift'):setVisible(false)
	player:findChildByName('player_info'):setVisible(false)
	-- 
	if self.ctrl_.mGameId == 13007 then
		local relationIcon1 = player:findChildByName("relationIcon1")
		player:findChildByName("relationIcon2"):setVisible(false)
		relationIcon1:setVisible(true)
		if playerItem.playerData:getHeadStyleIdx() == 1 then
			local winImage = new(Image,"truco/room/13007/103.png");
			winImage:setPos(-2, -19)
			winImage:setSize(50, 44)
			relationIcon1:addChild(winImage)
		else
			relationIcon1:setFile("truco/room/13007/11.png")
		end
	else
		if playerItem.playerData:getHeadStyleIdx() == 1 then
			player:findChildByName("relationIcon1"):setVisible(true)
			player:findChildByName("relationIcon2"):setVisible(false)
		else
			player:findChildByName("relationIcon1"):setVisible(false)
			player:findChildByName("relationIcon2"):setVisible(true)
		end
	end
	if player and playerItem and playerItem.playerData then
		local currentPlayerData = playerItem.playerData
		player:findChildByName("img_noReady"):setVisible(false)
		UIEx.bind(player, playerItem.playerData, "headName", function(value)
			-- if currentPlayerData:getId() ~= 0 then
				local nick = currentPlayerData:getNick()
				local headView = player:findChildByName("view_phead");
				headView:removeAllChildren();
				local width, height = headView:getSize()
				local imgHead 		= new(Mask, value, "truco/head_mask.png");
				imgHead:setSize(width, height)
				headView:addChild(imgHead);
				currentPlayerData:checkHeadAndDownload()
			-- end
		end)
		-- 

		playerItem.playerData:setSex(playerItem.playerData:getSex())
		currentPlayerData:checkHeadAndDownload()
		local nick1 = currentPlayerData:getNick()
		-- 
		-- table.insert(playerLayoutList, layout)
	end
end
-- 

-- 呈现筹码
function TrucoFailGameResult:renderMoney(value)
	local viewAnte = self:findChildByName('chip_node')
	local nodeAnte
	local sign = "+"
	if tonumber(value) > 0 then
		nodeAnte = new(require('truco.common.imageNumber'), {
		    ['0'] = 'truco/room/truco_gameResult/0.png',
		    ['1'] = 'truco/room/truco_gameResult/1.png',
		    ['2'] = 'truco/room/truco_gameResult/2.png',
		    ['3'] = 'truco/room/truco_gameResult/3.png',
		    ['4'] = 'truco/room/truco_gameResult/4.png',
		    ['5'] = 'truco/room/truco_gameResult/5.png',
		    ['6'] = 'truco/room/truco_gameResult/6.png',
		    ['7'] = 'truco/room/truco_gameResult/7.png',
		    ['8'] = 'truco/room/truco_gameResult/8.png',
		    ['9'] = 'truco/room/truco_gameResult/9.png',
		    ['+'] = 'truco/room/truco_gameResult/+.png',
		    ['k'] = 'truco/room/truco_gameResult/K.png',
		    ['m'] = 'truco/room/truco_gameResult/M.png',
		    ['.'] = 'truco/room/truco_gameResult/P.png',
	    })
	else
		nodeAnte = new(require('truco.common.imageNumber'), {
		    ['0'] = 'truco/room/truco_gameResult/00.png',
		    ['1'] = 'truco/room/truco_gameResult/01.png',
		    ['2'] = 'truco/room/truco_gameResult/02.png',
		    ['3'] = 'truco/room/truco_gameResult/03.png',
		    ['4'] = 'truco/room/truco_gameResult/04.png',
		    ['5'] = 'truco/room/truco_gameResult/05.png',
		    ['6'] = 'truco/room/truco_gameResult/06.png',
		    ['7'] = 'truco/room/truco_gameResult/07.png',
		    ['8'] = 'truco/room/truco_gameResult/08.png',
		    ['9'] = 'truco/room/truco_gameResult/09.png',
		    ['-'] = 'truco/room/truco_gameResult/-.png',
		    ['k'] = 'truco/room/truco_gameResult/KK.png',
		    ['m'] = 'truco/room/truco_gameResult/OM.png',
		    ['.'] = 'truco/room/truco_gameResult/OP.png',
	    })
	    sign = "-"
	end
	viewAnte:removeAllChildren()
    viewAnte:addChild(nodeAnte)
    nodeAnte:setNumber(string.format("%s", sign..ToolKit.formatMoney(math.abs(value))));
    nodeAnte:setVisible(true)
    nodeAnte:setAlign(kAlignCenter)
end
-- 显示倒计时
function TrucoFailGameResult:showClockNum(value)
	self.downClockNum_ = value
	self:renderClockNum(self.downClockNum_)
	-- 
	local animEvent = self:addPropTranslate(101, kAnimLoop, 1000, 0, 0, 0, 0, 0)
	animEvent:setEvent(self, function()
		self.downClockNum_ = self.downClockNum_ - 1
		if self.downClockNum_ >= 0 then
			self:renderClockNum(self.downClockNum_)
			if self.downClockNum_<=5 then
				kEffectPlayer:play(AUDIO.TIME_WARNING)
			end
		else
			checkAndRemoveOneProp(self, 101)
		end
	end)
end
-- 呈现倒计时
function TrucoFailGameResult:renderClockNum(value)
	if not self.viewClockNum_ then
		self.viewClockNum_ = self:findChildByName('view_clockNum')
	end
	-- 
	local nodeClock = new(require('truco.common.imageNumber', -5), TrucoBaseController.TRUCO_DOWNTIME_RES_CONFIG)
	-- local nodeClock = new(require('truco.common.imageNumber', -5), self.ctrl_.mGameId == 13007 and TrucoBaseController.TRUCO_DOWNTIME_RES_CONFIG_13007 or TrucoBaseController.TRUCO_DOWNTIME_RES_CONFIG)
	self.viewClockNum_:removeAllChildren()
    self.viewClockNum_:addChild(nodeClock)
    nodeClock:setNumber(string.format("%s", tostring(value)));
    nodeClock:setVisible(true)
    nodeClock:setAlign(kAlignCenter)
    nodeClock:setPos(0, 0)
end
-- 
function TrucoFailGameResult:initAnim()
	self:playDownAnim(self:findChildByName("img_crownBg"), function()
		self:playDownUpAnim(self:findChildByName("img_crownBg"), 1000, 12)
	end)
	-- 
	--self:playZoomInToOut(self:findChildByName("img_failBg"))
	-- 
	--self:playRotateAnim(self:findChildByName("img_light"))

	self.viewWin_ = self:findChildByName("view_borderBg")
	local dw, dh = self.viewWin_:getSize()
	local scaleAnim = self.viewWin_:addPropScale(1, kAnimNormal, 240, 100, 1, 1, 0.1, 1.0, kCenterXY, dw/2, 0)
	scaleAnim:setEvent(nil, function()
		checkAndRemoveOneProp(self.viewWin_, 1)
	end)
end

function TrucoFailGameResult:playRotateAnim(spriteMC)
	local dw, dh = spriteMC:getSize()
	spriteMC:addPropRotate(1, kAnimRepeat, 6000, 0, 0, 360, kCenterXY, dw / 2, dh / 2)
	spriteMC:addPropTransparency(2, kAnimLoop, 1000, 0, 1.0, 0.5)
end

-- 播放掉落动画(皇冠、旗子)
function TrucoFailGameResult:playDownAnim(spriteMC, callback)
	checkAndRemoveOneProp(spriteMC, 1)
	checkAndRemoveOneProp(spriteMC, 3)
	local w, h = spriteMC:getSize()
	local scaleAnim = spriteMC:addPropScaleWithEasing(3, kAnimNormal, 300, 200, "easeOutBounce", "easeOutBounce", 4.0, -3.0, kCenterDrawing);
	local inAnim = spriteMC:addPropTranslateWithEasing(1, kAnimNormal, 300, 200, "easeInSine", "easeInSine", 0, 0, -4.5 * h, 4.5 * h);
	inAnim:setEvent(self, function()
		checkAndRemoveOneProp(spriteMC, 1)
		checkAndRemoveOneProp(spriteMC, 3)
		-- 整体上挤压
		local scaleAnim = spriteMC:addPropScaleYWithEasing(2, kAnimNormal, 180, 0, "easeOutBounce", "easeOutBounce", 0.7, 0.3, kCenterXY, w/2, h*2);
		scaleAnim:setEvent(self, function()
			checkAndRemoveOneProp(spriteMC, 2);
			if callback then
				callback()
			end
		end)
	end)
end
-- 播放上下浮动动画
function TrucoFailGameResult:playDownUpAnim(spriteMC, ts, upVal)
	local inAnim = spriteMC:addPropTranslateWithEasing(10, kAnimLoop, ts, 0, "easeInSine", "easeInSine", 0, 0, upVal, -upVal);
end
-- 播放放大缩小动画(用于文字)
function TrucoFailGameResult:playZoomInToOut(spriteMC)
	local w, h 	= spriteMC:getSize();
	checkAndRemoveOneProp(spriteMC, 1)
	checkAndRemoveOneProp(spriteMC, 2)
	spriteMC:addPropTransparency(1, kAnimNormal, 600, 200, 0, 1);
	local scaleAnim = spriteMC:addPropScaleWithEasing(2, kAnimNormal, 600, 200, "easeOutBounce", "easeOutBounce", 4.0, -3.0, kCenterDrawing);
	scaleAnim:setEvent(self, function()
		checkAndRemoveOneProp(spriteMC, 1)
		checkAndRemoveOneProp(spriteMC, 2)
	end)
end
-- 
function TrucoFailGameResult:onCleanup()
	-- 
	checkAndRemoveOneProp(self:findChildByName("img_crownBg"), 1)
	checkAndRemoveOneProp(self:findChildByName("img_crownBg"), 3)
	checkAndRemoveOneProp(self:findChildByName("img_crownBg"), 10)
	-- 
	--checkAndRemoveOneProp(self:findChildByName("img_failBg"), 1)
	--checkAndRemoveOneProp(self:findChildByName("img_failBg"), 2)
end

return TrucoFailGameResult