--
-- Author: HLF(IdaHuang@boyaa.com)
-- Date: 2017-03-16 16:25:21
--
local STRING 	= require('truco.res.config')
local AUDIO 	= require('truco.res.audio.config')
local TrucoGameResult = require("truco.popu.trucoGameResult")
local TrucoGameResult_ = require("truco.popu.trucoGameResult_")
local TrucoGameResult_2 = require("truco.popu.trucoGameResult_2")
local TrucoFailGameResult = require("truco.popu.trucoFailGameResult")
local TrucoGameMatchElevelTwoPopup = require("truco.popu.trucoGameMatchElevelTwoPopup")
local TrucoGameMatchElevelOnePopup = require("truco.popu.trucoGameMatchElevelOnePopup")
local TrucoNotGameMatchElevelPopup = require("truco.popu.trucoNotGameMatchElevelPopup")

local TrucoPopuManager = class()

function TrucoPopuManager:ctor(ctrl, viewRoot)
	self.viewRoot_ = viewRoot
	self.ctrl_ = ctrl
end

-- 获胜结算框
function TrucoPopuManager:openTrucoGameResultPopup(data)
	if not self.victoryView_ then
		--local layout = requireview("view.truco.trucoGameResultLayout")
		--self.victoryView_ = new(TrucoGameResult, layout, self.ctrl_, data)

		-- local layout = requireview("view.truco.trucoGameResultLayout_")
		-- self.victoryView_ = new(TrucoGameResult_, layout, self.ctrl_, data)
		-- self.victoryView_:setName("trucoGameResult")
		-- self.viewRoot_:addChild(self.victoryView_)
		-- self.victoryView_:setAlign(kAlignCenter)
		
		WindowManager:showWindow(WindowTag.TrucoGameResult_2, {is_win = true,ctrl = self.ctrl_, out_data=data}, WindowStyle.POPUP)

		kEffectPlayer:play(AUDIO.OpenWindow)
	end
end
-- 失败结算框
function TrucoPopuManager:openFailTrucoGameResultPopup(data)
	if not self.failView_ then
		--local layout = requireview("view.truco.truco_gameFailResultLayout")
		--self.failView_ = new(TrucoFailGameResult, layout, self.ctrl_, data)

		-- local layout = requireview("view.truco.trucoGameResultLayout_")
		-- self.failView_ = new(TrucoGameResult_, layout, self.ctrl_, data)
		-- self.failView_:setName("trucoFailGameResult")
		-- self.viewRoot_:addChild(self.failView_)
		-- self.failView_:setAlign(kAlignCenter)
		WindowManager:showWindow(WindowTag.TrucoGameResult_, {is_win = false,ctrl = self.ctrl_,out_data=data}, WindowStyle.POPUP)

		kEffectPlayer:play(AUDIO.OpenWindow)
	end
end
-- 打开truco的4个人玩的11点选择牌型框
function TrucoPopuManager:openGameMatchElevenTwoPopup(data)
	if not self.gameElevenTwoView_ then
		local layout = requireview("view.truco.truco_gameMatchElevelLayout")
		self.gameElevenTwoView_ = new(TrucoGameMatchElevelTwoPopup, layout, self.ctrl_, data)
		self.gameElevenTwoView_:setName("trucoGameMatchElevenTwo")
		self.viewRoot_:addChild(self.gameElevenTwoView_)
		self.gameElevenTwoView_:setAlign(kAlignCenter)
		kEffectPlayer:play(AUDIO.OpenWindow)
	end
end
-- 打开truco的2个人玩的11点选择牌型框
function TrucoPopuManager:openGameMatchElevenOnePopup(data)
	if not self.gameElevenOneView_ then
		local layout = requireview("view.truco.truco_gameMatchElevelOneLayout")
		self.gameElevenOneView_ = new(TrucoGameMatchElevelOnePopup, layout, self.ctrl_, data)
		self.gameElevenOneView_:setName("trucoGameMatchElevelTwoPopup")
		self.viewRoot_:addChild(self.gameElevenOneView_)
		self.gameElevenOneView_:setAlign(kAlignCenter)
		kEffectPlayer:play(AUDIO.OpenWindow)
	end
end
-- 非11点玩家等待11点玩家选牌
function TrucoPopuManager:openNotGameMatchElevelPopup(data)
	if not self.notGameElevenView_ then
		local layout = requireview("view.truco.truco_notGameMatchElevelLayout")
		self.notGameElevenView_ = new(TrucoNotGameMatchElevelPopup, layout, self.ctrl_, data)
		self.notGameElevenView_:setName("TrucoNotGameMatchElevelPopup")
		self.viewRoot_:addChild(self.notGameElevenView_)
		self.notGameElevenView_:setAlign(kAlignCenter)
		kEffectPlayer:play(AUDIO.OpenWindow)
	end
end
-- 关闭 获胜结算框
function TrucoPopuManager:reomveVictoryAnimation()
	if self.victoryView_ then
		self.victoryView_:getParent():removeChild(self.victoryView_, true)
		self.victoryView_ = nil
	end
end
-- 关闭 失败结算框
function TrucoPopuManager:reomveFailAnimation()
	if self.failView_ then
		self.failView_:getParent():removeChild(self.failView_, true)
		self.failView_ = nil
	end
end
-- 关闭 truco的4个人玩的11点选择牌型框
function TrucoPopuManager:reomveGameMatchTwoAnimation()
	if self.gameElevenTwoView_ then
		self.gameElevenTwoView_:getParent():removeChild(self.gameElevenTwoView_, true)
		self.gameElevenTwoView_ = nil
	end
end
-- 关闭 truco的2个人玩的11点选择牌型框
function TrucoPopuManager:reomveGameMatchOneAnimation()
	if self.gameElevenOneView_ then
		self.gameElevenOneView_:getParent():removeChild(self.gameElevenOneView_, true)
		self.gameElevenOneView_ = nil
	end
end
-- 关闭 非11点玩家等待11点玩家选牌
function TrucoPopuManager:reomveNotGameMatchViewAnimation()
	if self.notGameElevenView_ then
		self.notGameElevenView_:getParent():removeChild(self.notGameElevenView_, true)
		self.notGameElevenView_ = nil
	end
end
-- 清理所有弹框
function TrucoPopuManager:cleanAllPopup()
	self:reomveVictoryAnimation()
	self:reomveFailAnimation()
	self:reomveGameMatchTwoAnimation()
	self:reomveGameMatchOneAnimation()
	self:reomveNotGameMatchViewAnimation()

	WindowManager:closeWindowByTag(WindowTag.TrucoGameResult_2)
	WindowManager:closeWindowByTag(WindowTag.TrucoGameResult_)
end

return TrucoPopuManager