--[[
游戏流程:
c->s 	118		请求分配桌子ID
s->c  	210		Server把匹配的桌子返回
c->s 	1001	客户端拿Server给的Tid请求登录游戏
s->c 	1007	登录成功，Server返回桌面玩家信息

S->C  	0x4008  广播准备倒计时
C->S    0x1032
S->C    0x1054 发手牌  开始给玩家发9张手牌（庄家10张），对于客户端来说就是广播发牌
-- 
----------
----------
1、0x1007			登陆成功 server -> client
2、0x1031->0x1051	请求坐下 client -> server  坐下返回  server -> client
3、0x4010 			开始游戏 server -> client
4、0x4011			广播开始发牌
5、0x1054			发3张手牌 server -> client
6、0x4012			广播vira牌和底分 server -> client
7、0x4013			广播当前轮到操作用户 server -> client
-- 
----------
----------
--叫分
1、0x1035			叫分 client -> server
2、0x4003			广播玩家叫分
3、0x4013			广播当前轮到操作用户 server -> client
4、0x1037->0x4005	接受TRUCO 或放弃  广播玩家回应叫分
----------
----------
--11分
1、0x4010			开始游戏 server -> client
2、0x4011			广播开始发牌
3、0x1054			发3张手牌 server -> client
4、0x4012			广播vira牌和底分 server -> client
5、0x4013			广播当前轮到操作用户 server -> client
.
.
.
6、0x4006			广播一轮或一局结束
]]--

ERROR_TABLE_MAX_COUNT    = 2          -- 桌子人满
ERROR_NOT_ENOUGH_MONEY   = 3          -- 钱太少
ERROR_TOO_MUCH_MONEY	 = 4          -- 钱太多
ERROR_WRONG_UID			 = 5          -- 无效的用户ID
ERROR_TABLE_NOT_EXIST	 = 6          -- 桌子不存在
ERROR_ANTE_MONEY         = 7		   -- 携带金额错误
ERROR_SEAT_HAS_PLAYER	 = 8		   -- 座位上有人

TABLE_STATUS_STOP 		= 0
TABLE_STATUS_PLAYING	= 1
TABLE_STATUS_TRUCO		= 2 -- 叫分
TABLE_STATUS_CMP		= 3 -- 玩家出牌

PLAYER_STATUS_DISCONNECT = -1
PLAYER_STATUS_LOGIN = 0       -- 登录
PLAYER_STATUS_SIT = 1         -- 坐下
PLAYER_STATUS_PLAYING = 2     -- 叫分
PLAYER_STATUS_TRUCO = 3       -- 玩牌


--Truco 协议
TRUCO_GET_TABLEID_REQ           		= 0x118    -- 请求分配桌子ID
TRUCO_GET_TABLEID_RSP       			= 0x210    -- 
TRUCO_FOLLOW_REQ           				= 0x123    -- 跟踪玩家
TRUCO_FOLLOW_RSP           				= 0x214    -- 跟踪玩家
TRUCO_FOLLOWED_RSP 						= 0x215    -- 被跟踪玩家

------------------ Client recv from Server ------------------------------------------------
TRUCO_SERVER_CMD_DEAL_CARD 		 				= 0x3001	-- 广播游戏发牌
TRUCO_SERVER_BROADCAST_USER_LOGIN     			= 0x100D    -- 广播用户进入
TRUCO_SEND_PROP_RSP              				= 0x7854    -- 响应发送道具
TRUCO_SEND_FACE									= 0x1004	-- 发送表情
TRUCO_SEND_CHAT									= 0x1003	-- 发送聊天
TRUCO_EXIT_ROOM_RSP 							= 0x1008 	-- 退出房间

TRUCO_CREATE_BUDDY_ROOM_REQ            			= 0x0114     --用户请求创建私人房

----------------- Client send to Server ---------------------------------------------------
TRUCO_LOGIN_GAME_REQ 							= 0x1001	-- 请求登录某个游戏
TRUCO_SITDOWN_IN_GAME_REQ 						= 0x1031	-- 请求坐下
TRUCO_STANDUP_REQ 								= 0x1033	-- 玩家站起
TRUCO_TRUCO_REQ 								= 0x1035	-- 叫分 client -> server
TRUCO_DROP_CARD_REQ 							= 0x1036	-- 出牌 client -> server
TRUCO_ACCEPT_OR_REFUSE_TRUCO_REQ				= 0x1037	-- 接受TRUCO 或放弃
TRUCO_CANCEL_DELEGATE_REQ						= 0x1038    -- 取消托管  托管类型  1--托管，0--取消托管
TRUCO_EXIT_ROOM_REQ 							= 0x1002    -- 退出房间
TRUCO_ABANDON_CARD_REQ							= 0x1041	-- 玩家请求弃牌
TRUCO_PUTDARKCARD_REQ							= 0x1042	-- 玩家请求本回合出暗牌
TRUCO_PUTDARKCARD_RESP                          = 0x1060    -- 玩家请求本回合出暗牌返回


--S->C-----------------------------------------------------------------------------------------
TRUCO_LOGIN_GAME_ERROR_RSP 						= 0x1005    -- 登录失败返回
TRUCO_LOGIN_GAME_RSP							= 0x1007    -- 登录成功
TRUCO_RELOGIN_GAME_RSP							= 0x1009    -- 重连
TRUCO_SITDOWN_IN_GAME_RSP 						= 0x1051   	-- 坐下返回
TRUCO_STANDUP_RSP 								= 0x1053	-- 站起返回
TRUCO_BROADCAST_SITDOWN_IN_GAME_RSP				= 0x4001	-- 广播坐下 SERVER_BROADCAST_USER_READY
TRUCO_BROADCAST_STANDUP_RSP						= 0x4002	-- 广播玩家站起
TRUCO_BROADCAST_NESTMATCH_START_RSP				= 0x4009	-- 广播下一场开始
TRUCO_BROADCAST_STARTGAME_RSP					= 0x4010	-- 广播开始游戏，发牌结束之后的一个广播
TRUCO_BROADCAST_DEALCARD_RSP 					= 0x4011	-- 广播开始发牌

TRUCO_DEALCARD_RSP 								= 0x1054    -- 发3张手牌 server -> client
TRUCO_COMMAND_ERROR_RSP 						= 0x1056    -- 错误信息
TRUCO_GAMEPOINT_RSP								= 0x1057	-- 发送给11分玩家桌面的信息
TRUCO_NOPOINT_OPTTIME_RSP						= 0x1058	-- 发送给非11分玩家等待时间
TRUCO_PUTCARD_RSP						        = 0x1059	-- 协议号 SERVER_COMMAND_PUTCARD_RESP = 0x1059 //玩家出牌返回

TRUCO_BROADCAST_VIRACARD_RSP 					= 0x4012    -- 广播vira牌和底分 server -> client
TRUCO_BROADCAST_CURRENT_USER_RSP				= 0x4013	-- 广播当前轮到操作用户 server -> client
TRUCO_BROADCAST_SPECIALOPT_RSP					= 0x4014	-- 广播当前应该 (回应叫分 或 赛点选择是否要牌) 的玩家
TRUCO_BROADCAST_ONEROUND_OVER_RSP				= 0x4015	-- 广播一回合的结束
TRUCO_BROADCAST_ABANDON_CARD					= 0x4017	-- 广播玩家弃牌
TRUCO_BROADCAST_USER_READY						= 0x4018	-- 广播玩家准备

TRUCO_BROADCAST_USER_AI_RSP						= 0x4016 	-- 广播托管结果					server -> client
TRUCO_BROADCAST_TRUCO_RSP						= 0x4003 	-- 广播玩家叫分
TRUCO_BROADCAST_TRUCO_REPLY_RSP					= 0x4005 	-- 广播玩家回应叫分
TRUCO_BROADCAST_DROP_CARD_RSP					= 0x4004 	-- 广播玩家出牌
TRUCO_BROADCAST_ONE_ROUND_RSP					= 0x4006 	-- 广播一轮或一局结束
TRUCO_BROADCAST_GAME_OVER_RSP					= 0x4007 	-- 广播游戏结束（有一个玩家最先两次拿到12分）

TRUCO_DROPTHREE_CAR_REQ							= 0x1039	-- 优先到达赛点的玩家对3张手牌的处理
TRUCO_PLAY_AGAIN_REQ							= 0x2001	-- 请求在玩一局
TRUCO_BROADCAST_USER_DROPCARD_RSP				= 0x4008 	-- 广播玩家选择


TRUCO_ENTER_BUDDY_ROOM_REQ             			= 0x0115     --用户请求进入私人房
TRUCO_ENTER_BUDDY_ROOM_RSP             			= 0x0212     --返回用户进入私人房结果

TRUCO_BROADCAST_CHANGE_BASESCORE 				= 0x4019 	 --赛点玩家选择要手牌后 广播底分改变


TRUCO_CLIENT_SEND_USERINFOR 			    	= 0x1010 	 --更新个人信息，主要是礼物变动