--[[
	骰子协议的处理
]]
local RoomProcesser = class(SocketProcesser)
local printInfo, printError = overridePrint("RoomProcesser")
----------------------------------------------------
-- 
function RoomProcesser:onGetTableId(data)
	writeTabToLog(data,"onGetTableId","1ddd.lua",2)
	self.m_controller:onGetTableId(data)
end
-- 
function RoomProcesser:onFollow(data)
	writeTabToLog(data,"onFollow","1ddd.lua")
	self.m_controller:onFollow(data)
end
-- 
function RoomProcesser:onFollowed(data)
	writeTabToLog(data,"onFollowed","1ddd.lua")
	self.m_controller:onFollowed(data)
end
-- 0x1005    -- 登录失败返回
function RoomProcesser:onLoginErrorGame(data)
	writeTabToLog(data,"0x1005 onLoginErrorGame","1ddd.lua")
	self.m_controller:onLoginErrorGame(data)
end
-- 0x1009    -- 重连
function RoomProcesser:onReLoginGame(data)
	writeTabToLog(data,"0x1009 onReLoginGame","1ddd.lua")
	self.m_controller:onReLoginGame(data)
end
-- 0x1007 //登陆成功 server -> client
function RoomProcesser:onLoginGame(data)
	writeTabToLog(data,"0x1007 onLoginGame","1ddd.lua")
	self.m_controller:onLoginGame(data)
end
-- 0x1051   	-- 坐下返回
function RoomProcesser:onSitDownInGame(data)
	writeTabToLog(data,"0x1051 onSitDownInGame","1ddd.lua")
	self.m_controller:onSitDownInGame(data)
end
-- 0x1053//站起返回
function RoomProcesser:onStandUp(data)
	writeTabToLog(data,"0x1053 onStandUp","1ddd.lua")
	self.m_controller:onStandUp(data)
end
-- 0x4001	-- 广播坐下
function RoomProcesser:onBroadCastSitDownInGame(data)
	writeTabToLog(data,"0x4001 onBroadCastSitDownInGame","1ddd.lua")
	self.m_controller:onBroadCastSitDownInGame(data)
end
-- 0x4002	-- 广播玩家站起 
function RoomProcesser:onBroadCastStandUp(data)
	writeTabToLog(data,"0x4002 onBroadCastStandUp","1ddd.lua")
	self.m_controller:onBroadCastStandUp(data)
end
-- 0x4010	-- 广播开始游戏，发牌结束之后的一个广播(只在整个游戏开始的时候发)
function RoomProcesser:onBroadCastStartGame(data)
	writeTabToLog(data,"0x4010 onBroadCastStartGame","1ddd.lua")
	self.m_controller:onBroadCastStartGame(data)
end
-- 0x4011	-- 广播开始发牌
function RoomProcesser:onBroadCastDealCard(data)
	writeTabToLog(data,"0x4011 onBroadCastDealCard","1ddd.lua")
	self.m_controller:onBroadCastDealCard(data)
end
-- 0x1054    -- 发3张手牌 server -> client
function RoomProcesser:onDealerCard(data)
	writeTabToLog(data,"0x1054 onDealerCard","1ddd.lua")
	self.m_controller:onDealerCard(data)
end
-- 0x4012    -- 广播vira牌和底分 server -> client
function RoomProcesser:onBroadCastViraCard(data)
	writeTabToLog(data,"0x4012 onBroadCastViraCard","1ddd.lua")
	self.m_controller:onBroadCastViraCard(data)
end
-- 0x4013	-- 广播当前轮到操作用户 server -> client
function RoomProcesser:onBroadCastCurrentUser(data)
	writeTabToLog(data,"0x4013 onBroadCastCurrentUser","1ddd.lua")
	self.m_controller:onBroadCastCurrentUser(data)
end
-- 0x4016 	-- 广播托管结果					server -> client
function RoomProcesser:onBroadCastUserAI(data)
	writeTabToLog(data,"0x4016 onBroadCastUserAI","1ddd.lua")
	self.m_controller:onBroadCastUserAI(data)
end
-- 0x4017 	-- 广播玩家弃牌
function RoomProcesser:onBroadCastAbandonCard(data)
	writeTabToLog(data,"0x4017 onBroadCastAbandonCard","1ddd.lua")
	self.m_controller:onBroadCastAbandonCard(data)
end
-- 0x4018  广播玩家准备 TRUCO_BROADCAST_USER_READY
function RoomProcesser:onBroadCastUserReady(data)
	writeTabToLog(data,"0x4018 onBroadCastUserReady","1ddd.lua")
	self.m_controller:onBroadCastUserReady(data)
end
-- 0x4003 	-- 广播玩家叫分
function RoomProcesser:onBroadCastTruco(data)
	writeTabToLog(data,"0x4003 onBroadCastTruco","1ddd.lua")
	self.m_controller:onBroadCastTruco(data)
end
-- 0x4005 	-- 广播玩家回应叫分
function RoomProcesser:onBroadCastTrucoReply(data)
	writeTabToLog(data,"0x4005 onBroadCastTrucoReply","1ddd.lua")
	self.m_controller:onBroadCastTrucoReply(data)
end
-- 0x4004 	-- 广播玩家出牌
function RoomProcesser:onBroadCastDropCard(data)
	writeTabToLog(data,"0x4004 onBroadCastDropCard","1ddd.lua")
	self.m_controller:onBroadCastDropCard(data)
end
-- 0x4006 	-- 广播一轮或一局结束
function RoomProcesser:onBroadCastOneRound(data)
	writeTabToLog(data,"0x4006 onBroadCastOneRound","1ddd.lua")
	self.m_controller:onBroadCastOneRound(data)
end
-- 0x4007 	-- 广播游戏结束（有一个玩家最先两次拿到12分）
function RoomProcesser:onBroadCastGameOver(data)
	writeTabToLog(data,"0x4007 onBroadCastGameOver","1ddd.lua")
	self.m_controller:onBroadCastGameOver(data)
end
-- 0x1008 //退出成功 server -> client
function RoomProcesser:onExitRoom(data)
	writeTabToLog(data,"0x1008 onExitRoom","1ddd.lua")
	self.m_controller:onExitRoom(data)
end
-- 0x7854    -- 响应发送道具
--  type 	: int (类型)
--	mid 	: int (触发用户id)
--	dest_mid: int (目标用户id)
--	msg_info: string (发给客户端的json串)
--	default : string (预留字段,默认传空字符串即可)字段,默认传空字符串即可)
    -- 发送互动道具
function RoomProcesser:onSendProp(data)
	writeTabToLog(data,"0x7854 onSendProp","1ddd.lua")
	self.m_controller:onSendProp(data)
end
-- 0x1004	-- 发送表情
function RoomProcesser:onSendFace(data)
	writeTabToLog(data,"0x1004 onSendFace","1ddd.lua")
	self.m_controller:onSendFace(data)
end
-- 0x1003	-- 发送聊天
function RoomProcesser:onSendChat(data)
	writeTabToLog(data,"0x1003 onSendChat","1ddd.lua")
	self.m_controller:onSendChat(data)
end
-- 0x100D    -- 广播用户进入
function RoomProcesser:onBroadcastUserLogin(data)
	writeTabToLog(data,"0x100D onBroadcastUserLogin","1ddd.lua")
	self.m_controller:onBroadcastUserLogin(data)
end
-- 0x3001	-- 广播游戏发牌
function RoomProcesser:onServerCmdDealCard(data)
	writeTabToLog(data,"0x3001 onServerCmdDealCard","1ddd.lua")
	self.m_controller:onServerCmdDealCard(data)
end
-- 0x1056	-- 错误信息
function RoomProcesser:onCommandError(data)
	writeTabToLog(data,"0x1056 onCommandError","1ddd.lua")
	self.m_controller:onCommandError(data)
end
--
function RoomProcesser:onEnterBuddyRoom(data)
	writeTabToLog(data,"onEnterBuddyRoom","1ddd.lua")
	self.m_controller:onEnterBuddyRoom(data)
end
-- 0x4014	-- 广播当前轮到操作用户 server -> client
function RoomProcesser:onBroadCastSpecialOpt(data)
	writeTabToLog(data,"0x4014 onBroadCastSpecialOpt","1ddd.lua")
	self.m_controller:onBroadCastSpecialOpt(data)
end
-- 0x4015	-- 广播一回合的结束
function RoomProcesser:onBroadCastOneRoundOver(data)
	writeTabToLog(data,"0x4015 onBroadCastOneRoundOver","1ddd.lua")
	self.m_controller:onBroadCastOneRoundOver(data)
end
-- 0x4009	-- 广播下一场开始
function RoomProcesser:onBroadCastNestMathStart(data)
	writeTabToLog(data,"0x4009 onBroadCastNestMathStart","1ddd.lua")
	self.m_controller:onBroadCastNestMathStart(data)
end
-- 0x1057	 --发送给11分玩家桌面的信息
function RoomProcesser:onGamePoint(data)
	writeTabToLog(data,"0x1057 onGamePoint","1ddd.lua")
	self.m_controller:onGamePoint(data)
end
-- 0x1058    --发送给非11分玩家的等待时间
function RoomProcesser:onNotPointOptTime(data)
	writeTabToLog(data,"0x1058 onNotPointOptTime","1ddd.lua")
	self.m_controller:onNotPointOptTime(data)
end
-- 0x1059    --TRUCO_PUTCARD_RSP = 0x1059 //玩家出牌返回
function RoomProcesser:onPutCard(data)
	writeTabToLog(data,"0x1059 onPutCard","1ddd.lua")
	self.m_controller:onPutCard(data)
end
-- 0x4008 -- 广播玩家选择
function RoomProcesser:onBroadCastUserDropCard(data)
	writeTabToLog(data,"0x4008 onBroadCastUserDropCard","1ddd.lua")
	self.m_controller:onBroadCastUserDropCard(data)
end
-- 0x4008 -- 广播玩家选择
function RoomProcesser:onBroadCastUserDropCard(data)
	writeTabToLog(data,"0x4008 onBroadCastUserDropCard","1ddd.lua")
	self.m_controller:onBroadCastUserDropCard(data)
end
-- 1060 玩家请求本回合出暗牌返回
function RoomProcesser:onPutDarkCard(data)
    writeTabToLog(data,"1060 onPutDarkCard","1ddd.lua")
	self.m_controller:onPutDarkCard(data)
end
function RoomProcesser:onBroadcastChangeBaseScore(data)
	self.m_controller:onBroadcastChangeBaseScore(data)
end
------------------------------------------------------------------
RoomProcesser.s_severCmdEventFuncMap = {
    [TRUCO_GET_TABLEID_RSP] 						= RoomProcesser.onGetTableId,	--
	[TRUCO_FOLLOW_RSP] 								= RoomProcesser.onFollow,	    --
	[TRUCO_FOLLOWED_RSP] 							= RoomProcesser.onFollowed,	    --

	[TRUCO_LOGIN_GAME_ERROR_RSP]					= RoomProcesser.onLoginErrorGame, -- 0x1005    -- 登录失败返回
	[TRUCO_LOGIN_GAME_RSP] 							= RoomProcesser.onLoginGame,		 -- 0x1007    -- 登录成功
	[TRUCO_RELOGIN_GAME_RSP] 						= RoomProcesser.onReLoginGame,	 -- 0x1009    -- 重连
	[TRUCO_SITDOWN_IN_GAME_RSP]						= RoomProcesser.onSitDownInGame,	 -- 0x1051   	-- 坐下返回
	[TRUCO_STANDUP_RSP]								= RoomProcesser.onStandUp,		 -- 0x1053	 -- 站起返回
	[TRUCO_BROADCAST_SITDOWN_IN_GAME_RSP] 			= RoomProcesser.onBroadCastSitDownInGame, -- 0x4001	-- 广播坐下 SERVER_BROADCAST_USER_READY
	[TRUCO_BROADCAST_STANDUP_RSP]					= RoomProcesser.onBroadCastStandUp, -- 0x4002	-- 广播玩家站起
	[TRUCO_BROADCAST_STARTGAME_RSP]					= RoomProcesser.onBroadCastStartGame,-- 0x4010	-- 广播开始游戏，发牌结束之后的一个广播
	[TRUCO_BROADCAST_DEALCARD_RSP]					= RoomProcesser.onBroadCastDealCard,	-- 0x4011	-- 广播开始发牌
	[TRUCO_DEALCARD_RSP]							= RoomProcesser.onDealerCard,		-- 0x1054    -- 发3张手牌 server -> client
	[TRUCO_COMMAND_ERROR_RSP]						= RoomProcesser.onCommandError,		-- 0x1056	 --错误信息
	[TRUCO_GAMEPOINT_RSP]							= RoomProcesser.onGamePoint,		    -- 0x1057	 --发送给11分玩家桌面的信息
    [TRUCO_NOPOINT_OPTTIME_RSP]                     = RoomProcesser.onNotPointOptTime,   -- 0x1058    --发送给非11分玩家的等待时间
    [TRUCO_PUTCARD_RSP]                   			= RoomProcesser.onPutCard,           -- 0x1059 //玩家出牌返回

	[TRUCO_BROADCAST_VIRACARD_RSP]					= RoomProcesser.onBroadCastViraCard,	-- 0x4012    -- 广播vira牌和底分 server -> client
	[TRUCO_BROADCAST_CURRENT_USER_RSP]				= RoomProcesser.onBroadCastCurrentUser, -- 0x4013	-- 广播当前轮到操作用户 server -> client
	[TRUCO_BROADCAST_SPECIALOPT_RSP]				= RoomProcesser.onBroadCastSpecialOpt, -- 0x4014	-- 广播当前轮到操作用户 server -> client
	[TRUCO_BROADCAST_ONEROUND_OVER_RSP]				= RoomProcesser.onBroadCastOneRoundOver, -- 0x4015	-- 广播一回合的结束

	[TRUCO_BROADCAST_USER_AI_RSP]					= RoomProcesser.onBroadCastUserAI,	-- 0x4016 	-- 广播托管结果					server -> client
	[TRUCO_BROADCAST_ABANDON_CARD]					= RoomProcesser.onBroadCastAbandonCard,	-- 0x4017 	-- 广播玩家弃牌
	[TRUCO_BROADCAST_USER_READY]					= RoomProcesser.onBroadCastUserReady,	-- 0x4018 	-- 广播玩家准备
	[TRUCO_BROADCAST_NESTMATCH_START_RSP]			= RoomProcesser.onBroadCastNestMathStart, -- 0x4009	-- 广播下一场开始
	[TRUCO_BROADCAST_TRUCO_RSP]						= RoomProcesser.onBroadCastTruco,	-- 0x4003 	-- 广播玩家叫分
	[TRUCO_BROADCAST_TRUCO_REPLY_RSP]				= RoomProcesser.onBroadCastTrucoReply,-- 0x4005 	-- 广播玩家回应叫分
	[TRUCO_BROADCAST_DROP_CARD_RSP]					= RoomProcesser.onBroadCastDropCard,	-- 0x4004 	-- 广播玩家出牌
	[TRUCO_BROADCAST_ONE_ROUND_RSP]					= RoomProcesser.onBroadCastOneRound,	-- 0x4006 	-- 广播一轮或一局结束
	[TRUCO_BROADCAST_GAME_OVER_RSP]					= RoomProcesser.onBroadCastGameOver,	-- 0x4007 	-- 广播游戏结束（有一个玩家最先两次拿到12分）
	[TRUCO_BROADCAST_USER_DROPCARD_RSP]				= RoomProcesser.onBroadCastUserDropCard, -- 0x4008 -- 广播玩家选择

			
	[TRUCO_EXIT_ROOM_RSP]							= RoomProcesser.onExitRoom,			-- 0x1008 	-- 退出房间
    [TRUCO_SEND_PROP_RSP] 							= RoomProcesser.onSendProp, 			-- 0x7854    -- 响应发送道具
    [TRUCO_SEND_FACE]								= RoomProcesser.onSendFace,			-- 0x1004	-- 发送表情
    [TRUCO_SEND_CHAT]								= RoomProcesser.onSendChat,			-- 0x1003	-- 发送聊天
    [TRUCO_SERVER_BROADCAST_USER_LOGIN] 			= RoomProcesser.onBroadcastUserLogin,
    [TRUCO_SERVER_CMD_DEAL_CARD] 		  			= RoomProcesser.onServerCmdDealCard,
    [TRUCO_ENTER_BUDDY_ROOM_RSP]					= RoomProcesser.onEnterBuddyRoom,
    [TRUCO_PUTDARKCARD_RESP]						= RoomProcesser.onPutDarkCard,
    [TRUCO_BROADCAST_CHANGE_BASESCORE]              = RoomProcesser.onBroadcastChangeBaseScore,
}
return RoomProcesser