--[[
	骰子socket接收协议  2015-03-03
]]
local CommonUtil = require("truco.utils.commonUtil") 
local BaseReader = require("mjSocket.game.baseReader")
local RoomReader = class(BaseReader)
local printInfo, printError = overridePrint("RoomReader")
function RoomReader:ctor()
    --printInfo("trucoRoomReader:ctor()")
end
function RoomReader:setCtrl(ctlr)
    self.ctrl_ = ctlr
end
----------------------------------------------------
-- 
function RoomReader:onGetTableId(packetId)
	local data = {};
	data.tableId 	= self.m_socket:readInt(packetId, -1);
	data.isInTable	= self.m_socket:readInt(packetId, -1);
	data.gameLevel	= self.m_socket:readInt(packetId, -1);
	data.gameId		= self.m_socket:readInt(packetId, -1);
	return data;
end
-- 
function RoomReader:onFollow(packetId)
	local data = {};
	data.code = self.m_socket:readInt(packetId, -1);
	return data;
end
-- 
function RoomReader:onFollowed(packetId)
	local data = {};
	data.code = self.m_socket:readInt(packetId, -1);
	data.uid = self.m_socket:readInt(packetId, -1);
	data.nick= self.m_socket:readString(packetId);
	return data;
end
-- 0x1005    -- 登录失败返回
function RoomReader:onLoginErrorGame(packetId)
	local data = {};
	data.retcode = self.m_socket:readInt(packetId, -1);
	return data;
end
-- 0x1009    -- 重连
function RoomReader:onReLoginGame(packetId)
	local data = self:onLoginGame(packetId);
    return data
end
-- 0x1007 //登陆成功 server -> client
function RoomReader:onLoginGame(packetId)

	local data 		= {};
    data.gameLevel	= self.m_socket:readInt(packetId, -1) -- 桌子所在游戏场次
    data.ante		= self.m_socket:readInt(packetId, -1) -- 游戏底注
    data.status 	= self.m_socket:readInt(packetId, -1) -- 桌子状态 0 已结束 1 游戏进行中 2结算中 3 准备倒计时
    data.leftTime 	= self.m_socket:readInt(packetId, -1) -- 当前状态超时剩余时间 (-1---表示无超时时间)
    data.outCardTm 	= self.m_socket:readInt(packetId, -1) -- 桌子出牌阶段，统一出牌超时时间
    data.cardCnt 	= self.m_socket:readInt(packetId, -1) -- 玩家手牌数目(0--表示无手牌)
    data.cardValues = {}
    local cardValue
    for i=1,data.cardCnt do
    	cardValue = self.m_socket:readByte(packetId, -1) -- 牌值
    	table.insert(data.cardValues, cardValue)
    end
    -- 
    data.currentRound = self.m_socket:readInt(packetId, -1)  -- 当前是第几回合 0, 1, 2
    data.matchCnt 	  = self.m_socket:readInt(packetId, -1)     -- 共几场 3为2人场 1为4人场
    data.currentMatch = self.m_socket:readInt(packetId, -1) + 1 -- 当前第几场 0,1,2
    data.winnerCnt    = self.m_socket:readInt(packetId, -1) -- 赢家人数
    data.matchDataList = {} -- 用于处理场次个数
    for i=1,data.currentMatch-1 do
        local matchData = {}
        matchData.uid           = self.m_socket:readInt(packetId, -1) -- 赢家1 id
        matchData.seatId        = self.m_socket:readInt(packetId, -1) + 1 -- 赢家1座位id
        matchData.friendUid     = self.m_socket:readInt(packetId, -1) -- 赢家2 id
        matchData.friendSeatId  = self.m_socket:readInt(packetId, -1) + 1 -- 赢家2座位id
        table.insert(data.matchDataList, matchData)
    end
    -- 
    data.roundStatus = {}
    data.roundWinIds = {}
    for i=1,data.currentRound do
    	data.roundWinIds[i] = self.m_socket:readInt(packetId, -1) -- 每一回合状态
    end
    -- 
    data.mySelfUser = nil
    data.isSitDown  = nil
    data.userCnt 	= self.m_socket:readInt(packetId, -1) -- 桌子上玩家数量
    data.userList 	= {}

    for i=1,data.userCnt do
    	local user = {}
    	user.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 玩家座位号
    	user.uid 		= self.m_socket:readInt(packetId, -1) -- 用户id
    	user.chip 		= self.m_socket:readInt64(packetId, -1) -- 携带金额
    	user.userInfo 	= self.m_socket:readString(packetId, -1) -- 用户个人信息
    	user.status		= self.m_socket:readInt(packetId, -1) -- 玩家坐下后的状态，详见PLAYER_STATUS
    	user.cardCnt 	= self.m_socket:readInt(packetId, -1) -- 在玩玩家剩余手牌数
    	user.score 		= self.m_socket:readInt(packetId, -1) -- 玩家分数
        user.isAi       = self.m_socket:readInt(packetId, -1) -- (是否托管 1：是 0：不是)
    	data.userList[i] = user

    	if user.uid == MyUserData:getId() then
    		data.isSitDown 	= true
    		data.mySelfUser = user
    	end
    end
    if data.status == 0 then
        self.m_socket:readInt(packetId, -1)
    end
    -- 玩牌阶段
    if data.status == 1 then
    	data.oprUid 	= self.m_socket:readInt(packetId, -1) -- 当前操作的玩家
    	data.oprSeatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 当前操作玩家的座位号）
    	data.isTruco	= self.m_socket:readInt(packetId, -1) -- 该轮是否有人叫分 1w为叫分
    	if 1 == data.isTruco then
    		data.lastTrucoUid 	= self.m_socket:readInt(packetId, -1) -- 最近一次叫分的玩家
    		data.lastTrucoScore = self.m_socket:readInt(packetId, -1) -- 叫分的分数
    	end

        data.baseScore      = self.m_socket:readInt(packetId, -1) -- 该轮底分1,3,6,12
    	data.viraCardValue  = self.m_socket:readByte(packetId, -1) -- 被翻过来的那张牌
    	data.playerCnt  	= self.m_socket:readInt(packetId, -1) -- 玩家数
    	data.playerList 	= {}
        data.totalDropCardCnt = 0
    	for j=1,data.playerCnt do
    		local user = {}
    		user.seatId 		= self.m_socket:readInt(packetId, -1) + 1 -- 座位号
    		user.uid 			= self.m_socket:readInt(packetId, -1) -- 用户id
    		user.score 			= self.m_socket:readInt(packetId, -1) -- 获得的分数
    		user.status 		= self.m_socket:readInt(packetId, -1) -- 用户状态
    		user.friendFlag 	= self.m_socket:readInt(packetId, -1) -- 是否有队友的标志  如果没有 friendflag == 0，如果有 friendflag == 1
    		if 1 == user.friendFlag then
    			user.friendUid 	= self.m_socket:readInt(packetId, -1)     -- 队友uid
    			user.friendSeatId = self.m_socket:readInt(packetId, -1) + 1 -- 队友座位号
    		end
    		-- 
    		user.dropCardCnt = self.m_socket:readInt(packetId, -1) -- 该轮玩家弃牌数
    		user.dropCardValues = {}
    		for k=1,user.dropCardCnt do
                if k == 1 then
                    local cardValue = self.m_socket:readByte(packetId, -1) -- 弃牌值 -1 没有 0  牌值>0 
                    table.insert(user.dropCardValues, cardValue)
                else
                    self.m_socket:readByte(packetId, -1)
                end
    		end
    		-- 
    		data.playerList[j] = user
            data.totalDropCardCnt = data.totalDropCardCnt + user.dropCardCnt
    	end
        -- 
        if data.viraCardValue < 1 then
            for i,v in ipairs(data.playerList) do
                v.dropCardCnt = 0
                v.dropCardValues = {}
            end
        else
            data.cardValues = CommonUtil.sortCards(data.viraCardValue, data.cardValues)     -- 进行大小排序
        end


    	-- 设置自己与队友为头像1的标识
    	local playerUidDic = {}
        local userUidDic = {}
        
    	for i=1,#data.playerList do
    		local user = data.playerList[i]
            local id = nil
            if self.ctrl_.mFollowId then
               id =  tonumber(self.ctrl_.mFollowId) 
            else
               id = MyUserData:getId()
            end
            
    		if user.uid == id  or (user.friendUid and user.friendUid ==id) then
                user.headStyleIdx = 1
                data.selfScore = user.score
    		else
    			user.headStyleIdx = 2
                data.rivalScore = user.score
    		end
    		playerUidDic[user.uid] = user.headStyleIdx
            userUidDic[user.uid] = user
    	end
    	-- 计算玩家回合状态
    	for i=1,#data.roundWinIds do
    		local uid = data.roundWinIds[i]
    		if playerUidDic[uid] then
    			if playerUidDic[uid] == 1 then
    				data.roundStatus[i] = 1
    			else
                    data.roundStatus[i] = -1
                end
    		end
    	end

        -- 
        if 1 == data.isTruco then
            local trucoPlayer = userUidDic[data.lastTrucoUid]
            if trucoPlayer then
                data.trucoOtherPlayers = {}
                for _,user in pairs(userUidDic) do
                    if user.headStyleIdx ~= trucoPlayer.headStyleIdx then                        
                        table.insert(data.trucoOtherPlayers, user)
                    end
                end
            end
        end
    end

    -- 播放结算动画是重来你回来
	if data.status == 2 then
		data.endPlayerCnt = self.m_socket:readInt(packetId, -1) -- 玩家人数
        data.endPlayerList = {}
		for i=1,data.endPlayerCnt do
			local endUser = {}
			endUser.uid = self.m_socket:readInt(packetId, -1)   -- uid
			endUser.seatId = self.m_socket:readInt(packetId, -1) + 1   -- seatId
			endUser.matchCnt = self.m_socket:readInt(packetId, -1)   -- 场数（4 人场 match_cnt = 1  2人场 match_cnt = 3）
			endUser.scores = {}
			for j=1,3 do
				local score = self.m_socket:readInt(packetId, -1)
				table.insert(endUser.scores, score)
			end
			endUser.turnmoney = self.m_socket:readInt64(packetId, -1) -- 输赢的钱    （扣过台费）
			endUser.money 	= self.m_socket:readInt64(packetId, -1) -- 玩家身上的钱
			endUser.turnExp = self.m_socket:readInt(packetId, -1) -- 赢得的经验
			endUser.exp 	= self.m_socket:readInt(packetId, -1) -- 玩家的经验

            table.insert(data.endPlayerList, endUser)
		end
	end


    local user_count = self.m_socket:readInt(packetId, -1)
    data.readys = {}
    for i=1,user_count do
        local ready = {}
        ready.uid = self.m_socket:readInt(packetId, -1)
        ready.readylefttime = self.m_socket:readInt(packetId, -1)
        table.insert(data.readys,ready)
    end

    data.max_card = self.m_socket:readByte(packetId, -1)

    writeTabToLog(data, "RoomReader 0x1007", "1dddkk_mk"..MyUserData:getId()..".lua")
    return data
end
-- 0x1051   	-- 坐下返回
function RoomReader:onSitDownInGame(packetId)
	--printInfo("RoomReader:onStandUp"..packetId);
	local data 		= {};
    data.retcode	= self.m_socket:readByte(packetId, -1) -- 
    data.money 		= self.m_socket:readInt64(packetId, -1) -- 站起是玩家身上的钱
    if data.retcode == 0 then
    	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 座位ID
    	data.status 	= self.m_socket:readInt(packetId, -1) -- 玩家坐下后的状态，0，非游戏，1游戏中
    end
    writeTabToLog(data, "RoomReader 0x1051", "1dddkk_mk"..MyUserData:getId()..".lua")
    return data
end
-- 0x1053//站起返回
function RoomReader:onStandUp(packetId)
	--printInfo("RoomReader:onStandUp"..packetId);
	local data 		= {};
    data.code 		= self.m_socket:readByte(packetId, -1) -- 
	data.seatId 	= self.m_socket:readByte(packetId, -1) + 1 -- 站起座位号
	data.reason 	= self.m_socket:readByte(packetId, -1) -- 1玩家主动站起或者掉线超时， 2携带不够最下买入 3连续未操作
    writeTabToLog(data, "RoomReader 0x1053", "1dddkk_mk"..MyUserData:getId()..".lua")
    return data
end
-- 0x4001	-- 广播坐下
function RoomReader:onBroadCastSitDownInGame(packetId)
	--printInfo("RoomReader:onBroadCastSitDownInGame"..packetId);
	local data 		= {};
    data.uid 		= self.m_socket:readInt(packetId, -1) -- 用户ID
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 座位ID
	data.money 		= self.m_socket:readInt64(packetId, -1) -- 身上的总钱数
	data.userInfo 	= self.m_socket:readString(packetId)	--(用户个人信息)
	data.status 	= self.m_socket:readInt(packetId, -1) -- 玩家坐下后的状态,见枚举PLAYER_STATUS
    writeTabToLog(data, "RoomReader 0x4001", "1dddkk_mk"..MyUserData:getId()..".lua")
    return data
end
-- 0x4002	-- 广播玩家站起 
function RoomReader:onBroadCastStandUp(packetId)
	--printInfo("RoomReader:onBroadCastStandUp"..packetId);
	local data 		= {};
    data.uid 		= self.m_socket:readInt(packetId, -1) -- 退出用户id
	data.seatId 	= self.m_socket:readByte(packetId, -1) + 1 -- 退出用户座位号
    data.code       = self.m_socket:readByte(packetId, -1) -- 
    writeTabToLog(data, "RoomReader 0x4002", "1dddkk_mk"..MyUserData:getId()..".lua")
    return data
end
-- 0x4010	-- 广播开始游戏，发牌结束之后的一个广播(只在整个游戏开始的时候发)
function RoomReader:onBroadCastStartGame(packetId)
	--printInfo("RoomReader:onBroadCastStartGame"..packetId);
    local user
	local data 		= {};
    data.playerCnt	= self.m_socket:readInt(packetId, -1) 		-- 游戏玩家个数
	data.playerList = {}
	for i=1,data.playerCnt do
		user = {}
		user.uid 		= self.m_socket:readInt(packetId, -1) -- uid
		user.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 座位号
		user.friendFlag = self.m_socket:readInt(packetId, -1) -- 是否有队友  针对4人游戏  如果是2人 这里是0 就没有信息
		user.score 		= 0
		user.status     = 2
		if 1 == user.friendFlag then
			user.friendUid 		= self.m_socket:readInt(packetId, -1) 	-- 队友uid
			user.friendSeatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 队友座位号
		end
		data.playerList[i] = user
	end
        -- 设置自己与队友为头像1的标识
    for i=1,#data.playerList do
        user = data.playerList[i]

        if self.ctrl_.mFollowId then
           id =  tonumber(self.ctrl_.mFollowId) 
        else
           id = MyUserData:getId()
        end

        if user.uid == id or (user.friendUid and user.friendUid == id) then
            user.headStyleIdx = 1
        else
            user.headStyleIdx = 2
        end
    end
 
    return data
end
-- 0x4011	-- 广播开始发牌
function RoomReader:onBroadCastDealCard(packetId)
	--printInfo("RoomReader:onBroadCastDealCard"..packetId);
	local data 		= {};
	data.uid 		= self.m_socket:readInt(packetId, -1) -- 第一个操作玩家的uid
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 第一个操作玩家的作为id

	return data
end
-- 0x1054    -- 发3张手牌 server -> client
function RoomReader:onDealerCard(packetId)
	--printInfo("RoomReader:onDealerCard"..packetId);
	local data 		= {};
    data.cardValues = {}
    data.cardCnt	= self.m_socket:readInt(packetId, -1) 		-- 手牌数
	for i=1,data.cardCnt do
		data.cardValues[i] = self.m_socket:readByte(packetId, -1) 	-- 牌值
	end
    data.baseScore = self.m_socket:readInt(packetId, -1)        -- 底分1，3，6，12
    data.viraCardValue = self.m_socket:readByte(packetId, -1)    -- vira牌
    data.cardValues = CommonUtil.sortCards(data.viraCardValue, data.cardValues)     -- 进行大小排序
    data.betScore = self.m_socket:readInt(packetId, -1)
   
    return data
end
-- 0x4012    -- 广播vira牌和底分 server -> client
function RoomReader:onBroadCastViraCard(packetId)
	--printInfo("RoomReader:onBroadCastViraCard"..packetId);
	local data 		= {};
    data.viraCardValue	= self.m_socket:readByte(packetId, -1)
	data.basescore 		= self.m_socket:readInt(packetId, -1) -- 底分1，3，6，12
    data.max_card  = self.m_socket:readByte(packetId, -1)
    if data.basescore == 0 then
        data.basescore = 1
    end
    data.betScore = self.m_socket:readInt(packetId, -1)
    
    return data
end
-- 0x4013	-- 广播当前轮到操作用户 server -> client
function RoomReader:onBroadCastCurrentUser(packetId)
	--printInfo("RoomReader:onBroadCastCurrentUser"..packetId);
	local data 		= {};
    data.uid 		= self.m_socket:readInt(packetId, -1)
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 即将出牌的座位
	data.leftTime	= self.m_socket:readInt(packetId, -1)     -- 操作定时器时长
    data.betScore = self.m_socket:readInt(packetId, -1)
    return data
end
-- 0x4016 	-- 广播托管结果					server -> client
function RoomReader:onBroadCastUserAI(packetId)
	--printInfo("RoomReader:onBroadCastUserAI"..packetId);
	local data 		= {};
    data.uid 		= self.m_socket:readInt(packetId, -1)     -- 用户ID
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 用户座位ID
	data.aiType		= self.m_socket:readInt(packetId, -1)     -- 托管类型  1--托管，0--取消托管
  
    return data
end
-- 0x4017  广播玩家弃牌
function RoomReader:onBroadCastAbandonCard(packetId)
    --printInfo("RoomReader:onBroadCastAbandonCard"..packetId);
    local data      = {};
    data.uid        = self.m_socket:readInt(packetId, -1)     -- 用户ID
    data.seatId     = self.m_socket:readInt(packetId, -1) + 1 -- 用户座位ID
   
    return data
end
-- 0x4018  广播玩家准备 TRUCO_BROADCAST_USER_READY
function RoomReader:onBroadCastUserReady(packetId)
   -- printInfo("RoomReader:onBroadCastUserReady"..packetId);
    local data      = {};
    data.uid        = self.m_socket:readInt(packetId, -1)     -- 用户ID
    data.seatId     = self.m_socket:readInt(packetId, -1) + 1 -- 用户座位ID
 
    return data
end
-- 0x4003 	-- 广播玩家叫分
function RoomReader:onBroadCastTruco(packetId)
	--printInfo("RoomReader:onBroadCastTruco"..packetId);
	local data 		= {};
    data.uid 		= self.m_socket:readInt(packetId, -1)
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 叫分玩家座位号
	data.score 		= self.m_socket:readInt(packetId, -1)     -- 叫的分数
  
    return data
end
-- 0x4005 	-- 广播玩家回应叫分
function RoomReader:onBroadCastTrucoReply(packetId)
	--printInfo("RoomReader:onBroadCastTrucoReply"..packetId);
	local data 		= {};
    data.uid 		= self.m_socket:readInt(packetId, -1)
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 座位id
	data.flag 		= self.m_socket:readInt(packetId, -1) -- //回应 （接受 1 拒绝 0 加倍 2）
    data.score      = self.m_socket:readInt(packetId, -1) -- //叫分值
    data.betScore = self.m_socket:readInt(packetId, -1)
    return data
end
-- 0x4004 	-- 广播玩家出牌
function RoomReader:onBroadCastDropCard(packetId)
	--printInfo("RoomReader:onBroadCastDropCard"..packetId);
	local data 		= {};
    data.uid 		= self.m_socket:readInt(packetId, -1)
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 出牌玩家座位号
	data.cardValue 	= self.m_socket:readByte(packetId, -1)    -- 玩家出的牌
    data.cardPos    = self.m_socket:readInt(packetId, -1)    -- 出的是第几张牌
    data.flag       = self.m_socket:readInt(packetId, -1)    -- 0：表示暗牌  1：表示明牌
 
    return data
end
-- 0x4006 	-- 广播一轮或一局结束
function RoomReader:onBroadCastOneRound(packetId)
	--printInfo("RoomReader:onBroadCastOneRound"..packetId);
	local data 		= {};
    data.playerList = {}
    data.flag = self.m_socket:readInt(packetId, -1); -- 表示一句还是一场结束    1 一局结束 2 一场结束
    data.playerCnt	= self.m_socket:readInt(packetId, -1); -- 玩家人数
    for i=1,data.playerCnt do
    	local user = {}
        user.isWinner = self.m_socket:readInt(packetId, -1)   -- 是否是赢家 1 是 0 不是
    	user.uid 	= self.m_socket:readInt(packetId, -1)
    	user.seatId = self.m_socket:readInt(packetId, -1) + 1 -- 座位id
    	user.turnscore	= self.m_socket:readInt(packetId, -1) -- 获得的分数
        user.score  = self.m_socket:readInt(packetId, -1)     -- 当前的分数

    	data.playerList[i] = user
    end

    return data
end
-- 0x4007 	-- 广播游戏结束（有一个玩家最先两次拿到12分）
function RoomReader:onBroadCastGameOver(packetId)
	--printInfo("RoomReader:onBroadCastGameOver"..packetId);
	local data 		= {};
    data.playerCnt	= self.m_socket:readInt(packetId, -1); -- 玩家人数
    data.startTime	= self.m_socket:readInt(packetId, -1); -- 游戏开始倒计时
    data.matchCnt   = self.m_socket:readInt(packetId, -1); -- 场数  1:4人一场 3:2人3场
    data.selfPlayer = nil
    data.selfScore = 0
    data.rivalScore = 0
    data.playerList = {}
    local mySeatid=0

    for i=1,data.playerCnt do
    	local user = {}
    	user.uid 	= self.m_socket:readInt(packetId, -1);
    	user.seatId = self.m_socket:readInt(packetId, -1) + 1
    	user.scores = {0, 0, 0}
    	for i=1,data.matchCnt do
    		user.scores[i] = self.m_socket:readInt(packetId, -1); -- 三局中每一局获得的分数
    	end
    	user.turnmoney 	= self.m_socket:readInt64(packetId, -1) -- 输赢的钱
    	user.money 	   	= self.m_socket:readInt64(packetId, -1) -- 玩家身上的钱
    	user.turnExp	= self.m_socket:readInt(packetId, -1)   -- 赢得的经验
    	user.exp		= self.m_socket:readInt(packetId, -1)   -- 玩家的经验
    	user.fee		= self.m_socket:readInt(packetId, -1)   -- 扣的台费
    	data.playerList[i] = user
        -- 
         if user.uid == MyUserData:getId() then
            mySeatid = user.seatId
       end
    end
    for i=1,data.playerCnt do
        local user = data.playerList[i]
        if user.uid == MyUserData:getId() or user.seatId == (mySeatid - 2 > 1 and mySeatid - 2 > 1 or mySeatid + 2) then
            data.selfPlayer = user
            data.selfScore = 0
            for i=1,#user.scores do
                if user.scores[i] > 11 then
                    data.selfScore = data.selfScore + 1
                end
            end
        else
             data.rivalScore = 0
            for i=1,#user.scores do
                if user.scores[i] > 11 then
                    data.rivalScore = data.rivalScore + 1
                end
            end
        end
    end

    data.leftTime = self.m_socket:readInt(packetId, -1); -- 游戏开始时间

   
    return data
end
-- 0x1008 //退出成功 server -> client
function RoomReader:onExitRoom(packetId)
	--printInfo("RoomReader:::::::::0x1008")
	local data = {};
	data.money	= self.m_socket:readInt64(packetId, -1)		--(身上的总钱数)
   
	return data;
end
-- 0x7854    -- 响应发送道具
--  type 	: int (类型)
--	mid 	: int (触发用户id)
--	dest_mid: int (目标用户id)
--	msg_info: string (发给客户端的json串)
--	default : string (预留字段,默认传空字符串即可)字段,默认传空字符串即可)
    -- 发送互动道具
function RoomReader:onSendProp(packetId)
	--printInfo("RoomReader:onSendProp"..packetId);
	local data 		= {};
    data.type 		= self.m_socket:readInt(packetId, -1);
	data.mid 		= self.m_socket:readInt(packetId, -1);
    data.dest_mid 	= self.m_socket:readInt(packetId, -1);
    data.msg_info 	= self.m_socket:readString(packetId);
    data.default 	= self.m_socket:readString(packetId);
    
	return data;
end
-- 0x1004	-- 发送表情
function RoomReader:onSendFace(packetId)
	--printInfo("RoomReader:onSendFace"..packetId);
	local data = {};
	data.mid = self.m_socket:readInt(packetId, -1);
	data.type = self.m_socket:readInt(packetId, -1);
	data.isVipFace	= self.m_socket:readInt(packetId, -1);

	return data;
end
-- 0x1003	-- 发送聊天
function RoomReader:onSendChat(packetId)
	--printInfo("RoomReader:onSendChat"..packetId);
	local data = {};
	data.mid = self.m_socket:readInt(packetId, -1);
	data.msg = self.m_socket:readString(packetId);

	return data;
end
-- 0x100D    -- 广播用户进入
function RoomReader:onBroadcastUserLogin(packetId)
	local data = {}
	data.uid = self.m_socket:readInt(packetId, -1)
	data.seatId = self.m_socket:readInt(packetId, -1) + 1
	data.userState = self.m_socket:readByte(packetId, -1)
	data.money = self.m_socket:readInt64(packetId, -1)
	data.userInfo = self.m_socket:readString(packetId)
	return data
end
-- 0x3001	-- 广播游戏发牌
function RoomReader:onServerCmdDealCard(packetId)
	local data = {}
	data.cardCount = self.m_socket:readByte(packetId, -1)
	data.cards = {}
	for i=1,data.cardCount do
		local card = self.m_socket:readByte(packetId, -1)
		table.insert(data.cards, card)
	end
	return data
end
-- 0x1056    --错误信息
function RoomReader:onCommandError(packetId)
	local data 		= {};
    data.uid 		= self.m_socket:readInt(packetId, -1)
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1 -- 座位id
	data.errorCode 	= self.m_socket:readInt(packetId, -1) -- -- success = 0, 成功  Err_NoFound_Card = 1,没有这张牌	Err_Status = 2,   //当前状态错误（没有轮到当前玩家操作）
    return data
end
-- 
function RoomReader:onEnterBuddyRoom(packetId)
	return {}
end
-- 0x4008 -- 广播玩家选择
function RoomReader:onBroadCastUserDropCard(packetId)
	local data = {}
	data.action = self.m_socket:readInt(packetId, -1)     -- 0: 弃掉  1：使用
	data.uid 	= self.m_socket:readInt(packetId, -1)     -- 玩家uid
	data.seatid	= self.m_socket:readInt(packetId, -1) + 1 -- 玩家座
	return data
end
-- 0x4014    //广播当前应该 (回应叫分 或 赛点选择是否要牌) 的玩家
function RoomReader:onBroadCastSpecialOpt(packetId)
	local data = {}
	data.action 	= self.m_socket:readInt(packetId, -1)       -- 操作动作    （1 回应叫分  2 赛点操作）
	data.playerCnt 	= self.m_socket:readInt(packetId, -1)       -- 操作人数
	data.playerList = {}
	for i=1,data.playerCnt do
		local user  = {}
		user.uid 	= self.m_socket:readInt(packetId, -1)
		user.seatId	= self.m_socket:readInt(packetId, -1) + 1
		table.insert(data.playerList, user)
	end
	data.leftTime = self.m_socket:readInt(packetId, -1)     -- 操作定时器时长
    if data.action == 1 then
        data.score  = self.m_socket:readInt(packetId, -1)       -- 顺带叫分值
    end
	return data
end
-- 0x4015	-- 广播一回合的结束
function RoomReader:onBroadCastOneRoundOver(packetId)
	local data = {}
	data.uid 		= self.m_socket:readInt(packetId, -1)       -- 一回合的赢家id
	data.seatId 	= self.m_socket:readInt(packetId, -1) + 1   -- 赢家座位id
    data.round      = self.m_socket:readInt(packetId, -1) + 1   -- 当前第几个回合
	return data
end
-- 0x1057	 --发送给11分玩家桌面的信息
function RoomReader:onGamePoint(packetId)
	local cardValue
	local data = {}
	data.friendCardCnt = self.m_socket:readInt(packetId, -1)       -- 队友的三张手牌
	data.friendCardValues = {}
	for i=1,data.friendCardCnt do
		cardValue =  self.m_socket:readByte(packetId, -1)       -- 牌值
		table.insert(data.friendCardValues, cardValue)
	end
	-- 
	data.cardCnt = self.m_socket:readInt(packetId, -1)       -- 自己的3张牌
	data.cardValues = {}
	for i=1,data.cardCnt do
		cardValue =  self.m_socket:readByte(packetId, -1)       -- 牌值
		table.insert(data.cardValues, cardValue)
	end
	-- 
	data.rivalScore 	= self.m_socket:readInt(packetId, -1)       -- 对手的分数
	data.viraCardValue 	= self.m_socket:readByte(packetId, -1)       -- Vira牌值
    data.leftTime       = self.m_socket:readInt(packetId, -1)       -- 倒计时
	return data
end
-- 0x1058 发送给非11分玩家的等待时间
function RoomReader:onNotPointOptTime(packetId)
    local data = {}
    data.leftTime = self.m_socket:readInt(packetId, -1) -- 非11分玩家的等待时间 
    return data
end
-- 0x1059   -- 协议号 SERVER_COMMAND_PUTCARD_RESP = 0x1059 //玩家出牌返回
function RoomReader:onPutCard(packetId)
    local data = {}
    data.uid = self.m_socket:readInt(packetId, -1)
    data.seatId = self.m_socket:readInt(packetId, -1)+1
    data.flag = self.m_socket:readInt(packetId, -1) -- 0：表示暗牌  1：表示明牌
    return data
end
-- 1060 玩家请求本回合出暗牌返回
function RoomReader:onPutDarkCard(packetId)
    local data = {}
    data.flag = self.m_socket:readInt(packetId, -1) -- 0表示暗牌 1表示明牌
    return data
end
-- 0x4009	-- 广播下一场开始
function RoomReader:onBroadCastNestMathStart(packetId)
	local data = {}
    data.matchDataList = {}
    data.currentMatch = self.m_socket:readInt(packetId, -1) -- 当前第几场
    data.winnerCnt    = self.m_socket:readInt(packetId, -1) -- 赢家人数
    for i=1,data.currentMatch-1 do
        local matchData = {}
        matchData.uid    = self.m_socket:readInt(packetId, -1)           -- 赢家1 id
        matchData.seatId = self.m_socket:readInt(packetId, -1) + 1       -- 赢家1座位id
        matchData.friendUid = self.m_socket:readInt(packetId, -1)        -- //赢家2id               //如果是2人场这里填充-1
        matchData.friendSeatId = self.m_socket:readInt(packetId, -1) + 1 -- //赢家2座位id        //如果是2人场填充-1
        table.insert(data.matchDataList, matchData)
    end
	return data
end
--赛点玩家选择要手牌后 广播底分改变

function RoomReader:onBroadcastChangeBaseScore(packetId)
    local  data = {}
    data.score   = self.m_socket:readInt(packetId, -1) 
    print_string("onBroadcastChangeBaseScore:  "..data.score) 
    return data
end
-- 
function RoomReader:initCommandFuncMap()
	RoomReader.super.initCommandFuncMap(self)
	require('truco.protocol.protocol')
	--[[
		truco 接收协议
	]]
	local s_severCmdFunMap = {
		[TRUCO_GET_TABLEID_RSP] 						= self.onGetTableId,	--
		[TRUCO_FOLLOW_RSP] 								= self.onFollow,	    --
		[TRUCO_FOLLOWED_RSP] 							= self.onFollowed,	    --

		[TRUCO_LOGIN_GAME_ERROR_RSP]					= self.onLoginErrorGame, -- 0x1005    -- 登录失败返回
		[TRUCO_LOGIN_GAME_RSP] 							= self.onLoginGame,		 -- 0x1007    -- 登录成功
		[TRUCO_RELOGIN_GAME_RSP] 						= self.onReLoginGame,	 -- 0x1009    -- 重连
		[TRUCO_SITDOWN_IN_GAME_RSP]						= self.onSitDownInGame,	 -- 0x1051   	-- 坐下返回
		[TRUCO_STANDUP_RSP]								= self.onStandUp,		 -- 0x1053	 -- 站起返回
		[TRUCO_BROADCAST_SITDOWN_IN_GAME_RSP] 			= self.onBroadCastSitDownInGame, -- 0x4001	-- 广播坐下 SERVER_BROADCAST_USER_READY
		[TRUCO_BROADCAST_STANDUP_RSP]					= self.onBroadCastStandUp, -- 0x4002	-- 广播玩家站起
		[TRUCO_BROADCAST_STARTGAME_RSP]					= self.onBroadCastStartGame,-- 0x4010	-- 广播开始游戏，发牌结束之后的一个广播
		[TRUCO_BROADCAST_DEALCARD_RSP]					= self.onBroadCastDealCard,	-- 0x4011	-- 广播开始发牌
		[TRUCO_DEALCARD_RSP]							= self.onDealerCard,		-- 0x1054    -- 发3张手牌 server -> client
		[TRUCO_COMMAND_ERROR_RSP]						= self.onCommandError,		-- 0x1056	 --错误信息
		[TRUCO_GAMEPOINT_RSP]							= self.onGamePoint,		    -- 0x1057	 --发送给11分玩家桌面的信息
        [TRUCO_NOPOINT_OPTTIME_RSP]                     = self.onNotPointOptTime,   -- 0x1058    --发送给非11分玩家的等待时间

		[TRUCO_BROADCAST_VIRACARD_RSP]					= self.onBroadCastViraCard,	-- 0x4012    -- 广播vira牌和底分 server -> client
		[TRUCO_BROADCAST_CURRENT_USER_RSP]				= self.onBroadCastCurrentUser, -- 0x4013	-- 广播当前轮到操作用户 server -> client
		[TRUCO_BROADCAST_SPECIALOPT_RSP]				= self.onBroadCastSpecialOpt, -- 0x4014	-- 广播当前轮到操作用户 server -> client
		[TRUCO_BROADCAST_ONEROUND_OVER_RSP]				= self.onBroadCastOneRoundOver, -- 0x4015	-- 广播一回合的结束

		[TRUCO_BROADCAST_USER_AI_RSP]					= self.onBroadCastUserAI,	-- 0x4016 	-- 广播托管结果					server -> client
		[TRUCO_BROADCAST_ABANDON_CARD]                  = self.onBroadCastAbandonCard,   -- 0x4017    -- 广播玩家弃牌
        [TRUCO_BROADCAST_USER_READY]                    = self.onBroadCastUserReady,     -- 0x4018    -- 广播玩家准备
        [TRUCO_BROADCAST_NESTMATCH_START_RSP]			= self.onBroadCastNestMathStart, -- 0x4009	-- 广播下一场开始
		[TRUCO_BROADCAST_TRUCO_RSP]						= self.onBroadCastTruco,	-- 0x4003 	-- 广播玩家叫分
		[TRUCO_BROADCAST_TRUCO_REPLY_RSP]				= self.onBroadCastTrucoReply,-- 0x4005 	-- 广播玩家回应叫分
		[TRUCO_BROADCAST_DROP_CARD_RSP]					= self.onBroadCastDropCard,	-- 0x4004 	-- 广播玩家出牌
		[TRUCO_BROADCAST_ONE_ROUND_RSP]					= self.onBroadCastOneRound,	-- 0x4006 	-- 广播一轮或一局结束
		[TRUCO_BROADCAST_GAME_OVER_RSP]					= self.onBroadCastGameOver,	-- 0x4007 	-- 广播游戏结束（有一个玩家最先两次拿到12分）
		[TRUCO_BROADCAST_USER_DROPCARD_RSP]				= self.onBroadCastUserDropCard, -- 0x4008 -- 广播玩家选择
        [TRUCO_PUTDARKCARD_RESP]                        = self.onPutDarkCard, -- 0x4008 -- 玩家请求本回合出暗牌返回

		[TRUCO_EXIT_ROOM_RSP]							= self.onExitRoom,			-- 0x1008 	-- 退出房间
        [TRUCO_SEND_PROP_RSP] 							= self.onSendProp, 			-- 0x7854    -- 响应发送道具
        [TRUCO_SEND_FACE]								= self.onSendFace,			-- 0x1004	-- 发送表情
        [TRUCO_SEND_CHAT]								= self.onSendChat,			-- 0x1003	-- 发送聊天
        [TRUCO_SERVER_BROADCAST_USER_LOGIN] 			= self.onBroadcastUserLogin,
        [TRUCO_SERVER_CMD_DEAL_CARD] 		  			= self.onServerCmdDealCard,
        [TRUCO_ENTER_BUDDY_ROOM_RSP]					= self.onEnterBuddyRoom,	
        [TRUCO_BROADCAST_CHANGE_BASESCORE]              = self.onBroadcastChangeBaseScore, --0x4019 赛点玩家选择要手牌后 广播底分改变z

	}
	-- 避免覆盖baseReader的方法
	table.merge(self.s_severCmdFunMap, s_severCmdFunMap)
end

return RoomReader
