-- truco_4
local Game = class(require('base.basegame'))

addProperty(Game, "roomList", nil)
addProperty(Game, "update", false)
addProperty(Game, "name", '')
addProperty(Game, "iconFile", "")

function Game:ctor(roomList)
	-- body
	-- self:setName(STR_APP_TRUCO or "Truco")
	self:setName("Truco 4 pessoas")
    self:setIconFile("truco/truco_icon.png")
	self:setRoomList(new(require('data.dataList')))
	self:initRoom(roomList)
end

function Game:initRoom(roomList)
	-- body
	if roomList then
		local mRoomList = self:getRoomList()
		for i = 1, roomList:count() do
			local room = roomList:get(i)
			local adapterRoom = mRoomList:get(i) or setProxy(new(require('truco.data.room')))
			adapterRoom:init(room:getData())
			if not mRoomList:get(i) then
				mRoomList:add(adapterRoom)
			end
		end
		mRoomList:setInit(true)
	end
end

function Game:checkUpdate()

end

function Game:getRoomFromLevel(level)
	-- body
	repeat
		local roomList = self:getRoomList()
		if not roomList then break end
		for i = 1, roomList:count() do
			local room = roomList:get(i);
			if level == room:getLevel() then
				return room;
			end
		end
	until true
end

function Game:getRoomFromMoney(money)
	-- body
	repeat
		local roomList = self:getRoomList()
		if not roomList then break end
		for i = 1, roomList:count() do
			local room = roomList:get(i);
			if money <= room:getLimit()then return room end
			--默认最后一条
			if i == roomList:count() then return room end
 		end
	until true
end
--[[
	进入游戏房间
]]
function Game:enterRoom(from, room, friendId, friendNick)
	-- body
	-- 默认根据钱进房间
	room = room or self:getRoomFromMoney(MyUserData:getMoney())
	if room then
		-- States.GameLobby = 3
		-- States.GameRoom  = 4
		States.GameLobby = "truco.lobbyState"
		States.GameRoom  = "truco.roomState"
		StateFileMap[States.GameLobby] = 'truco/trucoLobbyState'
		StateFileMap[States.GameRoom] = 'truco/room/trucoRoomState'
		StatesMap[States.GameLobby] = nil
		StatesMap[States.GameRoom] = nil
		local fromState = from or States.Lobby 
		local level = room:getLevel()
		StateChange.changeState(States.GameRoom, fromState, nil, room, friendId, friendNick, 13007);
		self:checkUpdate()
		return true
	end

	return false
end
--[[
	进入游戏大厅
]]
function Game:enterLobby()
	-- body
	-- States.GameLobby = 3
	-- States.GameRoom  = 4
	States.GameLobby = "truco.lobbyState"
	States.GameRoom  = "truco.roomState"
	StateFileMap[States.GameLobby] = 'truco/trucoLobbyState'
	StateFileMap[States.GameRoom] = 'truco/room/trucoRoomState'
	StatesMap[States.GameLobby] = nil
	StatesMap[States.GameRoom] = nil
	StateChange.changeState(States.GameLobby, States.Lobby, nil, nil, nil, nil, 13007);
	self:checkUpdate()
	return true
end


function Game:dtor()
	-- body
end

return Game