--
-- Author: HLF(IdaHuang@boyaa.com)
-- Date: 2017-03-16 10:00:11
--
local AnimChat 		= require("truco.anim.animChat")
local AnimFace 		= require("animation.animFace")
local FaceConfig 	= require("room.chat.faceConfig")
local KSFaceConfig 	= require("truco.anim.expression.config")
local STRING 	= require('truco.res.config')
local AUDIO 	= require('truco.res.audio.config')

-- local SELF_DEBUG = true

local TrucoBaseController = class(BaseController)

local MAX_DELAY_NUM = 50
TrucoBaseController.MY_LOCAL_SEAT_ID 		  = 4
TrucoBaseController.BUDDY_ROOM_LEVEL          = 107

TrucoBaseController.PLAYER_STATUS = {
    PLAYER_STATUS_DISCONNECT = -1,
    PLAYER_STATUS_LOGIN = 0,    	 --登录
    PLAYER_STATUS_SIT = 1,      	 --坐下
    PLAYER_STATUS_PLAYING = 2,  	 --玩牌
	PLAYER_STATUS_TRUCO = 3,    	 --准备
    PLAYER_STATUS_USEAI = 4,    	 --托管
}


TrucoBaseController.CHIP_RES_CONFIG = {
	['0'] = "truco/room/chipnumber/0.png",
	['1'] = "truco/room/chipnumber/1.png",
	['2'] = "truco/room/chipnumber/2.png",
	['3'] = "truco/room/chipnumber/3.png",
	['4'] = "truco/room/chipnumber/4.png",
	['5'] = "truco/room/chipnumber/5.png",
	['6'] = "truco/room/chipnumber/6.png",
	['7'] = "truco/room/chipnumber/7.png",
	['8'] = "truco/room/chipnumber/8.png",
	['9'] = "truco/room/chipnumber/9.png",
	['b'] = "truco/room/chipnumber/_b.png",
	['m'] = "truco/room/chipnumber/m.png",
	['k'] = "truco/room/chipnumber/k.png",
	['.'] = "truco/room/chipnumber/p.png",
}

TrucoBaseController.EXCHANGE_CHIP_RES_CONFIG_ADD = {
	['0'] = "truco/room/truco_Chip/0.png",
	['1'] = "truco/room/truco_Chip/1.png",
	['2'] = "truco/room/truco_Chip/2.png",
	['3'] = "truco/room/truco_Chip/3.png",
	['4'] = "truco/room/truco_Chip/4.png",
	['5'] = "truco/room/truco_Chip/5.png",
	['6'] = "truco/room/truco_Chip/6.png",
	['7'] = "truco/room/truco_Chip/7.png",
	['8'] = "truco/room/truco_Chip/8.png",
	['9'] = "truco/room/truco_Chip/9.png",
	['+'] = "truco/room/truco_Chip/+.png",
}

TrucoBaseController.EXCHANGE_CHIP_RES_CONFIG_SUB = {
	['0'] = "truco/room/truco_Chip/-0.png",
	['1'] = "truco/room/truco_Chip/-1.png",
	['2'] = "truco/room/truco_Chip/-2.png",
	['3'] = "truco/room/truco_Chip/-3.png",
	['4'] = "truco/room/truco_Chip/-4.png",
	['5'] = "truco/room/truco_Chip/-5.png",
	['6'] = "truco/room/truco_Chip/-6.png",
	['7'] = "truco/room/truco_Chip/-7.png",
	['8'] = "truco/room/truco_Chip/-8.png",
	['9'] = "truco/room/truco_Chip/-9.png",
	['-'] = "truco/room/truco_Chip/-.png",
}
TrucoBaseController.TRUCO_DOWNTIME_RES_CONFIG = {
    ['0'] = 'truco/room/truco_downTime/0.png',
    ['1'] = 'truco/room/truco_downTime/1.png',
    ['2'] = 'truco/room/truco_downTime/2.png',
    ['3'] = 'truco/room/truco_downTime/3.png',
    ['4'] = 'truco/room/truco_downTime/4.png',
    ['5'] = 'truco/room/truco_downTime/5.png',
    ['6'] = 'truco/room/truco_downTime/6.png',
    ['7'] = 'truco/room/truco_downTime/7.png',
    ['8'] = 'truco/room/truco_downTime/8.png',
    ['9'] = 'truco/room/truco_downTime/9.png',
}

TrucoBaseController.TRUCO_DOWNTIME_RES_CONFIG_13007 = {
    ['0'] = 'truco/room/13007/truco_downTime/0.png',
    ['1'] = 'truco/room/13007/truco_downTime/1.png',
    ['2'] = 'truco/room/13007/truco_downTime/2.png',
    ['3'] = 'truco/room/13007/truco_downTime/3.png',
    ['4'] = 'truco/room/13007/truco_downTime/4.png',
    ['5'] = 'truco/room/13007/truco_downTime/5.png',
    ['6'] = 'truco/room/13007/truco_downTime/6.png',
    ['7'] = 'truco/room/13007/truco_downTime/7.png',
    ['8'] = 'truco/room/13007/truco_downTime/8.png',
    ['9'] = 'truco/room/13007/truco_downTime/9.png',
}

TrucoBaseController.ANTE_RES_CONFIG = {
    ['0'] = 'truco/room/antenumber/0.png',
    ['1'] = 'truco/room/antenumber/1.png',
    ['2'] = 'truco/room/antenumber/2.png',
    ['3'] = 'truco/room/antenumber/3.png',
    ['4'] = 'truco/room/antenumber/4.png',
    ['5'] = 'truco/room/antenumber/5.png',
    ['6'] = 'truco/room/antenumber/6.png',
    ['7'] = 'truco/room/antenumber/7.png',
    ['8'] = 'truco/room/antenumber/8.png',
    ['9'] = 'truco/room/antenumber/9.png',
}

TrucoBaseController.ANTE_RES_CONFIG_13007 = {
    ['0'] = 'truco/room/13007/antenumber/0.png',
    ['1'] = 'truco/room/13007/antenumber/1.png',
    ['2'] = 'truco/room/13007/antenumber/2.png',
    ['3'] = 'truco/room/13007/antenumber/3.png',
    ['4'] = 'truco/room/13007/antenumber/4.png',
    ['5'] = 'truco/room/13007/antenumber/5.png',
    ['6'] = 'truco/room/13007/antenumber/6.png',
    ['7'] = 'truco/room/13007/antenumber/7.png',
    ['8'] = 'truco/room/13007/antenumber/8.png',
    ['9'] = 'truco/room/13007/antenumber/9.png',
}

TrucoBaseController.SCORE_RES_CONFIG = {
    ['0'] = 'truco/room/truco_score2/0.png',
    ['1'] = 'truco/room/truco_score2/1.png',
    ['2'] = 'truco/room/truco_score2/2.png',
    ['3'] = 'truco/room/truco_score2/3.png',
    ['4'] = 'truco/room/truco_score2/4.png',
    ['5'] = 'truco/room/truco_score2/5.png',
    ['6'] = 'truco/room/truco_score2/6.png',
    ['7'] = 'truco/room/truco_score2/7.png',
    ['8'] = 'truco/room/truco_score2/8.png',
    ['9'] = 'truco/room/truco_score2/9.png',
}

TrucoBaseController.SCORE_RES_CONFIG2 = {
    ['0'] = 'truco/room/truco_score2/00.png',
    ['1'] = 'truco/room/truco_score2/01.png',
    ['2'] = 'truco/room/truco_score2/02.png',
    ['3'] = 'truco/room/truco_score2/03.png',
    ['4'] = 'truco/room/truco_score2/04.png',
    ['5'] = 'truco/room/truco_score2/05.png',
    ['6'] = 'truco/room/truco_score2/06.png',
    ['7'] = 'truco/room/truco_score2/07.png',
    ['8'] = 'truco/room/truco_score2/08.png',
    ['9'] = 'truco/room/truco_score2/09.png',
}

TrucoBaseController.BASE_SCORE_RES_CONFIG = {
    ['0'] = 'truco/room/truco_score/00.png',
    ['1'] = 'truco/room/truco_score/01.png',
    ['2'] = 'truco/room/truco_score/02.png',
    ['3'] = 'truco/room/truco_score/03.png',
    ['4'] = 'truco/room/truco_score/04.png',
    ['5'] = 'truco/room/truco_score/05.png',
    ['6'] = 'truco/room/truco_score/06.png',
    ['7'] = 'truco/room/truco_score/07.png',
    ['8'] = 'truco/room/truco_score/08.png',
    ['9'] = 'truco/room/truco_score/09.png',
}

function TrucoBaseController:ctor(viewConfig, param1, param2, param3)
	printInfo("TrucoBaseController:ctor()")
	-- 
   -- self.mGameId    = param3[5] or GAME_ID.Truco
	self:initDelayPoopl()
	--加入Truco SERVER协议
	self.m_reader		= new(require('truco.protocol.room.roomReader'))
	self.m_writer		= new(require('truco.protocol.room.roomWriter'))
	self.m_processer 	= new(require('truco.protocol.room.roomProcesser'), self)
	self.m_reader:setCtrl(self)
	GameSocketMgr:addCommonSocketReader(self.m_reader);
	GameSocketMgr:addCommonSocketWriter(self.m_writer);
	GameSocketMgr:addCommonSocketProcesser(self.m_processer);

	--HTTP
	EventDispatcher.getInstance():register(HttpModule.s_event, self, self.onHttpRequestsCallBack);
	EventDispatcher.getInstance():register(Event.onEventResume,self,self.onEventResume);
	EventDispatcher.getInstance():register(Event.onEventPause,self,self.onEventPause);

	 --记录最近玩的游戏
    -- GameSetting:addGameRecord(self.mGameId)
    --发送游戏注册统计，以前没有注册过
    -- local registerGames = GameSetting:getRegisterGame()
    -- if not string.find(registerGames, tostring(self.mGameId)) then
    --     HttpModule.getInstance():execute(HttpModule.s_cmds.SEND_REGISTER_GAME_STA, {gameId = self.mGameId}, false, false)
    --     registerGames = registerGames..","..self.mGameId
    --     GameSetting:setRegisterGame(registerGames)
    --     GameSetting:save()
    -- end
    --[[]]
	self:findChildByName('btn_chat'):setOnClick(self, function(self)
		local seatId = self:getMySeatId() or 0
		if seatId <= 0 then
			AlarmTip.play(STR_SORRY_FOR_SEND_CHAT_BEFORE_SITDOWN)
		else
			WindowManager:showWindow(WindowTag.RoomChat, {gameid = self.mGameId, chatwords = self.mGameId == 13004 and STRING.TRUCO_CHAT or STRING.TRUCO_CHAT_13007}, WindowStyle.POPUP)
		end
		--self:test111()
	end)

    local btnTask = self:findChildByName('btn_task')
	btnTask:setOnClick(self, function(self)

		

		if true == SELF_DEBUG then
			self.cardsMgr_:test1()
		else
			WindowManager:showWindow(WindowTag.TaskPopu, {inRoom = true}, WindowStyle.POPUP)
		end

		-- self.cardsMgr_:test1()
		-- self:onEventPause()
		-- GameSocketMgr:closeSocketSync();
	end)
	--添加反馈弹窗
	self:findChildByName("btn_feedback"):setVisible(false)
    -- self:findChildByName("btn_feedback"):setOnClick(self, function(self)
    --     WindowManager:showWindow(WindowTag.FeedbackPopu, {feedbackId = 3, chooseGame = false}, WindowStyle.POPUP)
    -- end)

	local light_bg = btnTask:findChildByName('light_bg')
	light_bg:addPropRotate(4, kAnimRepeat, 5000, 0, 0, 360, kCenterDrawing)

	UIEx.bind(self, MyUserData, "taskAward", function(value)
		JLog.d('inroom taskAward',value)
        btnTask:findChildByName("img_hasAward"):setVisible(value > 0)
        btnTask:findChildByName("img_noAward"):setVisible(value <= 0)
        light_bg:setVisible(MyUserData:getBoxAward() or value > 0)
	end)
    MyUserData:setTaskAward(MyUserData:getTaskAward())

    self:initButtonMore()
end

function TrucoBaseController:dtor()
	printInfo("TrucoBaseController:dtor()")
	GameSocketMgr:removeCommonSocketReader(self.m_reader);
	GameSocketMgr:removeCommonSocketWriter(self.m_writer);
	GameSocketMgr:removeCommonSocketProcesser(self.m_processer);
	-- 
	EventDispatcher.getInstance():unregister(HttpModule.s_event, self, self.onHttpRequestsCallBack);
	EventDispatcher.getInstance():unregister(Event.onEventResume,self,self.onEventResume);
	EventDispatcher.getInstance():unregister(Event.onEventPause,self,self.onEventPause);

	delete(self.m_reader);
	delete(self.m_writer);
	delete(self.m_processer);
	self.m_reader 	= nil;
	self.m_writer 	= nil;
	self.m_processer= nil;
end

function TrucoBaseController:initButtonMore()
    local viewMore = self:findChildByName("view_more")
    local imgMore = viewMore:findChildByName("img_moreBg")
    local btnHideMore = viewMore:findChildByName("btn_hideMore")
    -- 隐藏
    local hideViewMoreFunc = function()
    	checkAndRemoveOneProp(viewMore, 1001)
        local animHide = viewMore:addPropScaleYWithEasing(1001, kAnimNormal, 300, 0, "easeOutSine", "easeOutSine", 1, -1, kCenterXY, viewMore:getPos()/2, 0)
        animHide:setEvent(nil, function()
        	checkAndRemoveOneProp(viewMore, 1001)
            viewMore:setVisible(false)
        end)
        self:findChildByName("btn_more"):setVisible(true)
	end
	-- 显示
	local showViewMoreFunc = function()
		checkAndRemoveOneProp(viewMore, 1001)
        local animShow = viewMore:addPropScaleYWithEasing(1001, kAnimNormal, 200, 0, "easeOutSine", "easeOutSine", 0, 1, kCenterXY, viewMore:getPos()/1, 0)
        animShow:setEvent(nil, function()
        	checkAndRemoveOneProp(viewMore, 1001)
        end)
        viewMore:setVisible(true)
        self:findChildByName("btn_more"):setVisible(false)
	end
    btnHideMore:setOnClick(self, function(self)
        hideViewMoreFunc()
    end)
    self:findChildByName("btn_more"):setOnClick(self, function(self)
        WindowManager:showWindow(WindowTag.TrucoMenuPopup,{backFunc=function()
    			-- 隐藏
		    	hideViewMoreFunc()
				--退出房间
				local contentxt = STRING.STR_EXIT_ROOM_CONTENT
				local user = self:getMyPlayer()
				if user then
					local state = user:getStatus()
					if state == TrucoBaseController.PLAYER_STATUS.PLAYER_STATUS_PLAYING then
						contentxt = STRING.STR_EXIT_ROOM_PLAYING
					end
				end

				WindowManager:showWindow(WindowTag.LobbyExitPopu, {
				title 	= STR_EXIT_ROOM_TITLE,
				content = contentxt,
				cancel 	= STR_EXIT_GAME_CANCEL,
				confirm = STR_EXIT_GAME_CONFIRM,
				confirmFunc = function ()
					-- body
					GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
					printInfo("StateChange.changeState()  10")
					printInfo("self.mStateFrom::"..tostring(self.mStateFrom))
					printInfo("States.GameLobby::"..tostring(States.GameLobby))
					-- StateChange.changeState(self.mStateFrom or States.GameLobby);
                    self:exchangeSceneState()
					kEffectPlayer:play(AUDIO.LeaveRoom)
				end
				}, WindowStyle.POPUP);
    		end,ruleFunc=function ( ... )
    			if self.mGameId == 13007 then
    				WindowManager:showWindow(WindowTag.TrucoRulePopup_13007,{},WindowStyle.POPUP)
    			else
    				WindowManager:showWindow(WindowTag.TrucoRulePopup,{ctrl = self},WindowStyle.POPUP)
    			end
    		end,feedbackFunc = function()
    			WindowManager:showWindow(WindowTag.FeedbackPopu, {feedbackId = 3, chooseGame = false}, WindowStyle.POPUP)
    		end},WindowStyle.NORMAL)
    end)
    local btnBack = imgMore:findChildByName("btn_back")
    btnBack:findChildByName("text_button"):setText(STRING.STR_LEAVE_GAME)
    btnBack:setOnClick(self, function(self)
    	-- 隐藏
    	hideViewMoreFunc()
		--退出房间
		local contentxt = STRING.STR_EXIT_ROOM_CONTENT
		local user = self:getMyPlayer()
		if user then
			local state = user:getStatus()
			if state == TrucoBaseController.PLAYER_STATUS.PLAYER_STATUS_PLAYING then
				contentxt = STRING.STR_EXIT_ROOM_PLAYING
			end
		end

		WindowManager:showWindow(WindowTag.LobbyExitPopu, {
		title 	= STR_EXIT_ROOM_TITLE,
		content = contentxt,
		cancel 	= STR_EXIT_GAME_CANCEL,
		confirm = STR_EXIT_GAME_CONFIRM,
		confirmFunc = function ()
			-- body
			GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
			printInfo("StateChange.changeState()  10")
			printInfo("self.mStateFrom::"..tostring(self.mStateFrom))
			printInfo("States.GameLobby::"..tostring(States.GameLobby))
			-- StateChange.changeState(self.mStateFrom or States.GameLobby);
            self:exchangeSceneState()
			kEffectPlayer:play(AUDIO.LeaveRoom)
		end
		}, WindowStyle.POPUP);
    end)



    local btnHelp = imgMore:findChildByName("btn_help")
    btnHelp:findChildByName("text_button"):setText(STRING.CHANGE_TABLE_DESC)
    btnHelp:setOnClick(self, function(self)
    		

    	--隐藏
    	hideViewMoreFunc()
    	self:changeTableGame()        -- WindowManager:showWindow(WindowTag.RoomHelpPopu, { }, WindowStyle.POPUP);
    end)
end
----------------------------------------------------------
--显示loading
function TrucoBaseController:showLoadingAnim()
	-- body
	if not self.toastShade then
		self.toastShade = new(ToastShade, true, STR_LOAING, true)
		self:addChild(self.toastShade)
	end
    self.toastShade:play()
end
-- 隐藏loading
function TrucoBaseController:hideLoadingAnim()
	if self.toastShade then
		self.toastShade:stop()
	end
end
-- 请求换桌
function TrucoBaseController:changeTableGame()
	self.mSendExitRoom = true
	--先退出房间
	GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ)
	--请求桌子ID
	self:getTableId()
end
--创建和申请进入好友房之后返回消息
function TrucoBaseController:onEnterBuddyRoom(data)
   
end
-- 0x1008 	-- 退出房间
function TrucoBaseController:onExitRoom(data)
	--退回大厅
	if not self.mSendExitRoom then
		printInfo("self.mStateFrom::"..tostring(self.mStateFrom))
		printInfo("States.GameLobby::"..tostring(States.GameLobby))
		self:delayCall(function()
			-- StateChange.changeState(self.mStateFrom or States.GameLobby, nil, nil, nil, nil, self.mGameId);
            self:exchangeSceneState()
		end, 200)
		-- StateChange.changeState(self.mStateFrom or States.GameLobby);
		kEffectPlayer:play(AUDIO.LeaveRoom)
	end
	self.mSendExitRoom = false
	-- 同步筹码
	MyUserData:setMoney(data.money)
    if self.acceptPrivateRoom then
        --如果私人房邀请来自其他游戏，那么要先切换游戏
        -- StateChange.changeState(self.mStateFrom or States.GameLobby);
        self:exchangeSceneState()
        local game = app:getGame(self.acceptPrivateRoom.gameId)
        if game and game.enterPrivateRoom then
            game:enterPrivateRoom(self.mStateFrom or States.GameLobby, kFalse, self.acceptPrivateRoom.code)
        end
        self.acceptPrivateRoom = nil
    end
end
function TrucoBaseController:exchangeSceneState()
    StateChange.changeState(self.mStateFrom or States.GameLobby, nil, nil, nil, nil, nil, self.mGameId);
end
--跟随 (只有跟随失败才回包)
function TrucoBaseController:onFollow( data )
	self:hideLoadingAnim();
	if data.code == 0 then
		WindowManager:showWindow(WindowTag.LobbyExitPopu, {
			title 	= STR_FRIEND_FOLLOW_TITLE,
			content = STR_FRIEND_FOLLOW_CONTENT,
			confirm = STR_EXIT_GAME_CONFIRM,
			confirmFunc = function ()
				-- body
				self.mFollowId = nil
				--获取tableId
				GameSocketMgr:sendMsg(TRUCO_GET_TABLEID_REQ, {u16_gameLevel = self.mRoomInfo:getLevel(), u32_gameId = self.mGameId});
			end
		}, WindowStyle.POPUP);
	end
end
-- 
function TrucoBaseController:onFollowed( data )
	if data.code == 0 then
		AlarmTip.play(string.format(STR_FRIEND_FOLLOWED_TIPS, data.nick or ""))
	end
end
-- 
function TrucoBaseController:onBack()
	WindowManager:showWindow(WindowTag.LobbyExitPopu, {
		title 	= STR_EXIT_ROOM_TITLE,
		content = STR_EXIT_ROOM_CONTENT,
		cancel 	= STR_EXIT_GAME_CANCEL,
		confirm = STR_EXIT_GAME_CONFIRM,
		confirmFunc = function ()
			-- body
			GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
			-- StateChange.changeState(self.mStateFrom or States.GameLobby);	
            self:exchangeSceneState()
			kEffectPlayer:play(AUDIO.LeaveRoom)
		end
	}, WindowStyle.POPUP);
end
-- 返回大厅
function TrucoBaseController:onGotoHall()
	GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
	-- StateChange.changeState(self.mStateFrom or States.GameLobby);
    self:exchangeSceneState()
	kEffectPlayer:play(AUDIO.LeaveRoom)
end
-- 
function TrucoBaseController:onLoginErrorGame( data )
	WindowManager:showWindow(WindowTag.LobbyExitPopu, {
		title 	= STR_EXIT_ROOM_TITLE,
		content = STR_ENTER_ROOM_FAILED,
		confirm = STR_EXIT_GAME_CONFIRM,
		confirmFunc = function ()
			-- body
			GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
			-- StateChange.changeState(self.mStateFrom or States.GameLobby);
            self:exchangeSceneState()
			kEffectPlayer:play(AUDIO.LeaveRoom)
		end
	}, WindowStyle.POPUP);
	self:hideLoadingAnim();
end
-- 0x1056	 --错误信息
function TrucoBaseController:onCommandError(data)
	if DEBUG_MODE then
		-- AlarmTip.play("0x1056::"..data.errorCode)
		printInfo("0x1056::"..data.errorCode)
	end
end
-----------------------------------------------------------------
-----------------------------------------------------------------
--[[
处理玩家坐下、站起操作
]]
-----------------------------------------------------------------
-----------------------------------------------------------------
-- 自动坐下
function TrucoBaseController:autoSitDownAction()
	for i = 1, 4 do
		--跟随好友不是自动坐下
		if self.mPlayer[i]:getId() == 0 and (not self.mFollowId) then
			printInfo("Client uid::"..tostring(MyUserData:getId()).." seatId::"..tostring(i))
			GameSocketMgr:sendMsg(TRUCO_SITDOWN_IN_GAME_REQ, {u32_seatId = i, u64_ante = MyUserData:getMoney()});
			break;
		end
	end
end
-- 0x4002	-- 广播玩家站起
function TrucoBaseController:onBroadCastStandUp(data)
	local player = self.mPlayer[data.seatId]
	if not player then
		return
	end
	-- 
	local ui =  player:getUi()
	if ui then
		ui:findChildByName("btn_invite"):setVisible(true)  
	end
	player:clear()	
	-- 更新人数
	local cnt = self:getPlayerCount()
    self.mTableId:setCount(self:getPlayerCount())
    self.mTableId:onBroadCastStandUp(data)
    if cnt < 2 then
    	self.mTableId:setStatus(0)
    end
    self:sitdownAnimCallback()
end
-- 0x4001	-- 广播坐下 SERVER_BROADCAST_USER_READY
function TrucoBaseController:onBroadCastSitDownInGame(data)
	JLog.d('onBroadCastSitDownInGame',data)
	if not data then
		return
	end

	if data.uid == MyUserData:getId() then
		return
	end

	local player = self.mPlayer[data.seatId]
	if player then
		player:setId(data.uid)
		local userInfo = json.decode(data.userInfo) or {}
		player:setHeadUrl(userInfo.micon or "")
		player:setSex(userInfo.sex or 0)
		player:setNick(userInfo.nick or "")
		player:setGiftId(userInfo.giftId)
		player:setChip(data.money)
		player:setStatus(data.status)
		player:setSeatId(data.seatId)
		player:setLocalSeatId(self:getLocalSeatId(data.seatId, self:getMySeatId()));
		player:setShowInfo(true)
		-- 
		if self.mRoomInfo then
			local downNum = self.mRoomInfo:getDownNum()
			player:setDownNum(downNum)
		else
			player:setDownNum(13)
		end
		--更新人数
	    self.mTableId:setCount(self:getPlayerCount());
	    self:reLocateSeat()
        self:updatePlayerHeadStyleId()
        self:sitdownAnimCallback()
	else
		self.mFollowId = nil
        self:getTableId()
	end
end
-- 0x1051   	-- 坐下返回(单播)
function TrucoBaseController:onSitDownInGame(data)
	JLog.d('onSitDownInGame',data)
	if data.retcode == 0 then
		MyUserData:setMoney(data.money)
		-- 房间人数
		local player = self.mPlayer[data.seatId]
		if not player then
			return 
		end
		-- 设置自己坐下
		self.mIsSitDown = true
		--设置玩家信息
		local nick = MyUserData:getNick()
		local headurl = player:getHeadName(1)
		player:setHeadUrl(MyUserData:getHeadUrl())
		player:setId(MyUserData:getId())
		player:setSex(MyUserData:getSex())
		player:setNick(nick)		
        player:setGiftId(MyUserData:getGiftId() and {MyUserData:getGiftId()[1], MyUserData:getGiftId()[2]})
		player:setChip(data.money)
		player:setSeatId(data.seatId)
		player:setStatus(data.status)
		self:reLocateSeat()
		self:playSitdownAnim()
		player:setShowInfo(true)
		--更新人数
		local cnt = self:getPlayerCount()
		self.mTableId:setCount(cnt)
		-- 向Server发送准备操作
		-- GameSocketMgr:sendMsg(TRUCO_PLAY_AGAIN_REQ);
		self:showReadyClockNum()
        self:resetScoreZero()
        self:updateRoomStatus(1)
        self:updatePlayerHeadStyleId()
        self.mFollowId = nil
	else
		if data.retcode == ERROR_WRONG_UID or 
			data.retcode == ERROR_TABLE_NOT_EXIST then 		--重新坐下
				WindowManager:showWindow(WindowTag.LobbyExitPopu, {
				title 	= STR_EXIT_ROOM_TITLE,
				content = STR_SITDOWN_FAILED,
				confirm = STR_EXIT_GAME_CONFIRM,
				confirmFunc = function ()
					-- body
					GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
					-- StateChange.changeState(self.mStateFrom or States.GameLobby);
                    self:exchangeSceneState()
					kEffectPlayer:play(AUDIO.LeaveRoom)
				end
			}, WindowStyle.POPUP);
		elseif data.retcode == ERROR_TABLE_MAX_COUNT then
			WindowManager:showWindow(WindowTag.LobbyExitPopu, {
				close 	= true,
				title 	= STR_EXIT_ROOM_TITLE,
				content = STR_TABLE_LIMITED,
				confirm = STR_EXIT_GAME_CONFIRM,
				confirmFunc = function ()
					-- body
					GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
					-- StateChange.changeState(self.mStateFrom or States.GameLobby);
                    self:exchangeSceneState()
					kEffectPlayer:play(AUDIO.LeaveRoom)
				end
			}, WindowStyle.POPUP);
			--房间满了，需要换桌
			if not self.mFollowId then
				--先退出房间
				GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ)
				--请求桌子ID
				self:getTableId()
			end
		elseif data.retcode == ERROR_ANTE_MONEY or data.retcode == ERROR_NOT_ENOUGH_MONEY then
			WindowManager:showWindow(WindowTag.LobbyExitPopu, {
				title 	= STR_NOT_ENOUGH_MONEY_TITLE,
				content = STR_MONEY_NOT_ENOUGH,
				confirm = STR_EXIT_GAME_CONFIRM,
				confirmFunc = function ()
					-- body
					GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
					-- StateChange.changeState(self.mStateFrom or States.GameLobby);
                    self:exchangeSceneState()
					kEffectPlayer:play(AUDIO.LeaveRoom)
				end
			}, WindowStyle.POPUP);
        elseif data.retcode == ERROR_NOT_ENOUGH_MONEY then 	--钱不够下限
            WindowManager:showWindow(WindowTag.LobbyExitPopu, {
				title 	= STR_NOT_ENOUGH_MONEY_TITLE,
				content = STR_MONEY_NOT_ENOUGH,
				confirm = STR_EXIT_GAME_CONFIRM,
				confirmFunc = function ()
					-- body
					GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
					-- StateChange.changeState(self.mStateFrom or States.GameLobby);
                    self:exchangeSceneState()
					kEffectPlayer:play(AUDIO.LeaveRoom)
				end
			}, WindowStyle.POPUP);
		elseif data.retcode == ERROR_TOO_MUCH_MONEY then 	--破产
			WindowManager:showWindow(WindowTag.LobbyExitPopu, {
				title 	= STR_EXIT_ROOM_TITLE,
				content = STR_TOO_MUCH_MONEY,
				confirm = STR_EXIT_GAME_CONFIRM,
				confirmFunc = function ()
					-- body
					GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
					-- StateChange.changeState(self.mStateFrom or States.GameLobby);
                    self:exchangeSceneState()
					kEffectPlayer:play(AUDIO.LeaveRoom)
				end
			}, WindowStyle.POPUP);
		elseif data.retcode == ERROR_SEAT_HAS_PLAYER then
			if self.retryAutoSitDownCnt_ < 2 then
				self:autoSitDownAction()
				self.retryAutoSitDownCnt_ = self.retryAutoSitDownCnt_ + 1
			else
				--房间满了，需要换桌
				if not self.mFollowId then
					self.mSendExitRoom = true
					--先退出房间
					GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ)
					--请求桌子ID
					self:getTableId()
				end
			end
		end
	end
end
-- 0x1053	-- 站起返回
function TrucoBaseController:onStandUp(data)
	if data.code == 0 then
		--玩家站起
		local player = self.mPlayer[data.seatId]
		if player then 
			player:clear() 
			if player:getId() == MyUserData:getId() then
		        self.mIsSitDown = false
		    end
		end
		if data.reason == 2 then  -- 资产不足
			if MyUserData:getMoney() < gBankrupt then
				--破产弹框
				WindowManager:showWindow(WindowTag.BankruptPopu, {state = 1, gameId = self.mGameId, level = self.mRoomInfo:getLevel()}, WindowStyle.POPUP)
			else
				WindowManager:showWindow(WindowTag.LobbyExitPopu, {
					close   = true,
					title 	= STR_NOT_ENOUGH_MONEY_TITLE,
					content = STR_MONEY_LESS_THAN_MIN,
					confirm = STR_EXIT_GAME_CONFIRM,
					confirmFunc = function ()
						-- body
						self.mSendExitRoom = false
						GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
						-- StateChange.changeState(self.mStateFrom or States.GameLobby);
                        self:exchangeSceneState()
						kEffectPlayer:play(AUDIO.LeaveRoom)
					end
				}, WindowStyle.POPUP);
			end
		elseif data.reason == 3 then  -- 托管无操作“站起”
			-- WindowManager:showWindow(WindowTag.LobbyExitPopu, {
			-- 		close   = true,
			-- 		title 	= STR_NOT_ENOUGH_MONEY_TITLE,
			-- 		content = STR_MONEY_LESS_THAN_MIN,
			-- 		confirm = STR_EXIT_GAME_CONFIRM,
			-- 		confirmFunc = function ()
			-- 			-- body
			-- 			self.mSendExitRoom = false
			-- 			GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
			-- 			StateChange.changeState(self.mStateFrom or States.GameLobby);
			-- 		end
			-- }, WindowStyle.POPUP);
			self.mSendExitRoom = false
			-- GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
			-- StateChange.changeState(self.mStateFrom or States.GameLobby);
            -- self:exchangeSceneState()
			kEffectPlayer:play(AUDIO.LeaveRoom)
		end

        self:sitdownAnimCallback()
	end
end
-----------------------------------------------------------------
-----------------------------------------------------------------
--[[
处理获取桌子流程
游戏流程:
c->s 	118		请求分配桌子ID
s->c  	210		Server把匹配的桌子返回
c->s 	1001	客户端拿Server给的Tid请求登录游戏
s->c 	1007	登录成功，Server返回桌面玩家信息

S->C  	0x4008  广播准备倒计时
C->S    0x1032
S->C    0x1054 发手牌  开始给玩家发9张手牌（庄家10张），对于客户端来说就是广播发牌
]]--
-----------------------------------------------------------------
-----------------------------------------------------------------
-- TRUCO_GET_TABLEID_REQ           			= 0x118    -- 请求分配桌子ID
function TrucoBaseController:getTableId()
	if SELF_DEBUG then
		return
	end
	-- body
	print_string("truco headName:::getTableId:"..tostring(MyUserData:getHeadUrl()))
	local userInfo = {appid = 0, nick = MyUserData:getNick(), sex = MyUserData:getSex(), micon = MyUserData:getHeadUrl(), giftId = MyUserData:getGiftId()}
    if self.mRoomInfo:getLevel() == TrucoBaseController.BUDDY_ROOM_LEVEL then
    --申请创建好友房
        if self.mRoomInfo.isCreate == kTrue then
            printInfo(" 申请创建好友房")
            GameSocketMgr:sendMsg(TRUCO_CREATE_BUDDY_ROOM_REQ, {i16_gameId = self.mGameId, i32_baseChips = self.mRoomInfo:getAnte(),
                str_roomName = "", str_password = "", i32_requireChips = self.mRoomInfo:getMinchip(), str_guid = PhpManager:getDevice_id(),
                str_userInfo= json.encode(userInfo),
                i32_flag = 0, i32_escapeflag = 0,
            })
        else
    		printInfo("申请进入好友房")
            --申请进入已经存在的好友房
            GameSocketMgr:sendMsg(TRUCO_ENTER_BUDDY_ROOM_REQ, {i16_gameId = self.mGameId, i32_serverId = self.mRoomInfo.serverId or -1, i32_showTid = self.mRoomInfo.tableId or -1, 
                i32_reserved = 0, str_guid = PhpManager:getDevice_id(), 
                str_userInfo = json.encode(userInfo),
                i32_flag = 0, str_password = "",    
            })
        end
    elseif self.mFollowId then
		self.mTableId:init({tableId = self.mRoomInfo.tableId or 0, isInTable = 0,gameLevel = 0, gameId = self.mGameId});
	else
		JLog.d("TEST_GHJ", {u16_gameLevel = self.mRoomInfo:getLevel(), u32_gameId = self.mGameId})
		GameSocketMgr:sendMsg(TRUCO_GET_TABLEID_REQ, {u16_gameLevel = self.mRoomInfo:getLevel(), u32_gameId = self.mGameId});
	end
end
--获取桌子ID
function TrucoBaseController:onGetTableId(data)
	self.mTableId:init(data);
    self.mRoomInfo:setLevel(tonumber(data.gameLevel) or self.mRoomInfo:getLevel())
end
-----------------------------------------------------------------
-----------------------------------------------------------------
--[[
处理发送表情、聊天内容、礼物
]]--
-----------------------------------------------------------------
-----------------------------------------------------------------
function TrucoBaseController:onAcceptPrivateRoomInvite(data)
    GameSocketMgr:sendMsg(TRUCO_EXIT_ROOM_REQ);
    self.acceptPrivateRoom = data
end
-- 
function TrucoBaseController:onServerRetire(data)
    StateChange.changeState(States.Lobby)
    kEffectPlayer:play(AUDIO.LeaveRoom)
end
-- 
function TrucoBaseController:onLoginServer( data )
	-- body
	--重连重置
	self.mSendExitRoom = false

	if data.isInTable > 0 then
		AlarmTip.play(STR_BACK_TO_GAME)
		local roomInfo = data.roomInfo;
		self.mTableId:init({
			tableId = roomInfo.tid, 
			isInTable = 1, 
			gameLevel = roomInfo.serverLvl, 
			gameId = roomInfo.gameID 
		});
    	--不在桌子上，同时记录的playerid上没有你的ID，回大厅去
    else
        local backToLobby = true
        for i = 1, #self.mPlayer do
            local player = self.mPlayer[i]
            if player:getId() == MyUserData:getId() then
                --其中有个号是我，表示可能没开局但是我在桌子上
                backToLobby = false
                break;
            end
        end
        if backToLobby then
            -- StateChange.changeState(self.mStateFrom or States.GameLobby);
            self:exchangeSceneState()
            kEffectPlayer:play(AUDIO.LeaveRoom)
            return
        end
	end

	if data.isInMatch > 0 then

	end

	if data.isInTable == 0 and data.isInMatch == 0 then
		self:getTableId()
	end
end
-- 
function TrucoBaseController:requestSendFace(faceType)
	if not faceType then return end
	GameSocketMgr:sendMsg(TRUCO_SEND_FACE, {
		iFaceType = faceType,
		isVipFace = 0,
	})
end
-- 
function TrucoBaseController:requestSendWord(chatInfo)
	if not chatInfo then return end
	GameSocketMgr:sendMsg(TRUCO_SEND_CHAT, {
		iChatInfo = chatInfo,
	})
end
--接收server返回道具信息
function TrucoBaseController:onSendProp(data)
 	--此处处理广播消息,收到发送道具之后
 	printInfo('接收到互动道具广播='..data.type..'mid = '..data.mid..'destid='..data.dest_mid.."  MyUserData:getId()::"..tostring(MyUserData:getId()))
 	local msgInfo 	 = json.decode(data.msg_info);   	
	local srcPlayer  = self:getUserByUid(data.mid)
	local dstPlayer  = self:getUserByUid(data.dest_mid)
	if not srcPlayer or not dstPlayer then
   		return 
   	end
    if data.type == 1 then --道具
   		local srcx, srcy = srcPlayer:getUi():getPos()
	   	local dstx, dsty = dstPlayer:getUi():getPos()
	   	self.mAnimFriend:play(msgInfo.id, {x = srcx, y = srcy}, {x = dstx, y = dsty})
    elseif data.type == 2 then --处理送筹码
    	local dstx, dsty = dstPlayer:getUi():getPos()
		local dstw, dsth = dstPlayer:getUi():getSize()
		if data.mid ~= MyUserData:getId() then
			srcPlayer:setChip(srcPlayer:getChip() - math.abs(tonumber(msgInfo.addMoney or 0)))
		end
    	dstPlayer:setChip(dstPlayer:getChip() + math.abs(tonumber(msgInfo.addMoney or 0)))
		self:playSendChipAnim(srcPlayer, {dstx = dstx, dsty = dsty, dstw = dstw, dsth = dsth}, tonumber(msgInfo.addMoney or 0))
	elseif data.type == 4 then --添加好友
   		local srcx, srcy = srcPlayer:getUi():getPos()
	   	local dstx, dsty = dstPlayer:getUi():getPos()
	   	self.mAnimFriend:play(3000, {x = srcx, y = srcy}, {x = dstx, y = dsty})
	end
end
-- 
function TrucoBaseController:onSendFace(data)
	if data.mid and data.type and data.isVipFace then
		self:showChatFace(data.type, data.mid);
	else

	end
end
-- 聊天相关
function TrucoBaseController:showChatWord(chatInfo, x, y, w, h, seatId)
	local srcx, srcy = x, y
	local srcw, srch = w, h
	local localSeatId 		= seatId
	local offx, offy = 0, 0
	if seatId == 1 then
		offx = -360
		offy = -50
	elseif seatId == 2 then
		offx = 0
		offy = 50
	elseif seatId == 3 then
		offx = 360
		offy = 0
	else
		offx = -35
		offy = 0
	end
	local imgFace 			= new(Image, 'animation/roomAnim/word_bg_left.png')
	local imgChipW,imgChipH = imgFace.m_width, imgFace.m_height
	if not self.m_chatWord then
		self.m_chatWord = new(Node)
			:addTo(self, 1000)
	end
	self.m_chatWord:removeAllChildren()
	local x, y = self:getChatPosition(localSeatId, srcx, srcy, srcw, srch, imgChipW, imgChipH)
	if not x or not y then return end

	local params = {
		seat = localSeatId,
		chatInfo = chatInfo,
		pos = ccp(x+offx, y+offy),
		isGame = true
	}
	new(AnimChat):addTo(self.m_chatWord, 1000):play(params)
	-- playChatSound(chatInfo, self.m_userData:getSex())
	self:playChatSound(chatInfo)
end

function TrucoBaseController:playChatSound(chatInfo)
	local sound = {
		[1] = Effects.AudioChatCommon2;
		[2] = Effects.AudioChatCommon14;
		[3] = Effects.AudioChatMakhos1;
		[4] = Effects.AudioChatMakhos2;
		[5] = Effects.AudioChatCommon3;
		[6] = Effects.AudioChatCommon7;
		[7] = Effects.AudioChatCommon8;
		[8] = Effects.AudioChatMakhos4;
		[9] = Effects.AudioChatCommon11;
	}
	for i = 1, #STRING.TRUCO_CHAT do
		if STRING.TRUCO_CHAT[i] == chatInfo then
			kEffectPlayer:play(sound[i])
		end
	end
end
-- 
function TrucoBaseController:showChatFace(faceIndex, mid)
	local player  = self:getUserByUid(mid);
	if not player then return end
	local srcx, srcy = player:getUi():getPos();
	local srcw, srch = player:getUi():getSize();
	if not srcx or not srcy then return end
    if not FaceConfig[1][faceIndex] then return end;
	local faceName = nil;
	local facePrefix = FaceConfig[1].expNamePrefix
	local img = FaceConfig[1].expressInfo .. faceIndex .. "0%02d.png"
	if type(facePrefix) == "table" then
		faceName = facePrefix[img]
	elseif type(facePrefix) == "string" then
		faceName = img
	end
	local imgCount = FaceConfig[1][faceIndex].imgCount
	local playCount = FaceConfig[1][faceIndex].playCount
	local playTime = FaceConfig[1][faceIndex].ms
	local imgFace 		= new(Image, img)
	local imgChipW,imgChipH = imgFace.m_width, imgFace.m_height
	local x,y = srcx + (srcw - 110)/2, srcy + (srch - 110)/2
	--printInfo("玩家%d发送了表情%d", self.m_seat, faceIndex)
	local params = {
		num = imgCount,
		playCount = playCount,
		faceName = faceName,
		duration = playTime,
		pos = ccp(x, y),
	}
	new(AnimFace):addTo(self, 1001):play(params)
end

function TrucoBaseController:onSendFaceNew(data)
    if data.mid and data.type and data.isVipFace then
        local player  = self:getUserByUid(data.mid);
	    if not player then return end
	    local srcx, srcy = player:getUi():getPos();
	    local srcw, srch = player:getUi():getSize();
	    if not srcx or not srcy then return end     
        local expression = KSFaceConfig[data.type]
        if not expression then
            return
        end
        local expressionName = expression.imgName
        local packFile = expression.packFile
        local animExpression = new(require("animation.animFrame"), expression.imgName, 
            require(expression.packFile), expression.deltaTime, expression.repeatTime)
        animExpression:setPos(srcx + (srcw - 110)/2, srcy + (srch - 110)/2)
        animExpression:play()
        self:findChildByName("view_players"):addChild(animExpression)
    end
end
-- 
function TrucoBaseController:onSendChat(data)
	if data.mid and data.msg then
		local player  = self:getUserByUid(data.mid);
		if not player then return end
		local srcx, srcy = player:getUi():getPos();
		local srcw, srch = player:getUi():getSize();
		local localSeatId = player:getLocalSeatId();
		self:showChatWord(data.msg, srcx, srcy, srcw, srch, localSeatId);
		local player  = self:getUserByUid(data.mid);
		if player then
			G_RoomCfg:addChatRecord(player:getNick(), data.msg)
		end
	end
end
-- 
function TrucoBaseController:onGiftSendBroadcast(data)
	if DEBUG_MODE then
		printInfo("TrucoBaseController:onGiftSendBroadcast ")
		dump(data)
	end
    local receiver = data.receiver
    local giftId = data.gift
    --找到送礼人的人
    local sendPlayer = nil
    for i = 1, #self.mPlayer do
        if self.mPlayer[i]:getId() == data.sender then
            sendPlayer = self.mPlayer[i]
            break;
        end
    end 
    --找到礼物对应的图片
    local imgName = ""
    local giftList = MyUserData:getGiftList() or {}
    local gift = giftList[giftId[1]] and giftList[giftId[1]][giftId[2]]
    if gift then
        imgName = gift:getImgName()
    else
    	--礼物不存在
        printInfo("gift not exists")
        return
    end
    --找到需要接收礼物的人
    for i = 1, #receiver do
        for j = 1, #self.mPlayer do
            printInfo("receiver[i] "..type(receiver[i]).." "..receiver[i] )
            if self.mPlayer[j]:getId() == receiver[i] then
                --如果送礼物的人和这个收礼物的人是同一个人，那么礼物本来就是从他的位置送出，不需要动画
                if self.mPlayer[j]:getId() ~= data.sender then
                    --找不到赠送人，从屏幕中送出
                    local startX, startY = CONFIG_SCREEN_WIDTH / 2, CONFIG_SCREEN_HEIGHT / 2
                    if sendPlayer then
                        startX, startY = sendPlayer:getUi():findChildByName("btn_gift"):getAbsolutePos()
                    elseif data.sender ~= MyUserData:getId() then
                        AlarmTip.play(string.format(STR_GIFT_GET_FROM_FRIEND, data.name, data.sender, gift:getName()))
                    end
                    --送礼物的动画
                    local endX, endY = self.mPlayer[j]:getUi():findChildByName("btn_gift"):getAbsolutePos()
                    local node = new(Node)
                    local imgGift = new(Image, imgName)
                    imgGift:setAlign(kAlignCenter)
                    node:setSize(imgGift:getSize())
                    node:addChild(imgGift)
                    node:setPos(startX, startY)
                    self:addChild(node)
                    local animGift = node:addPropTranslateWithEasing(1, kAnimNormal, 500, 0, "easeOutSine", "easeOutSine", 0, endX - startX, 0, endY - startY)
                    animGift:setEvent(self, function()
                    	checkAndRemoveOneProp(node, 1)
                        self.mPlayer[j]:setGiftId(giftId)
                        self:removeChild(node, true)
                    end)
                else
                    self.mPlayer[j]:setGiftId(giftId)
                end
                break
            end
        end
    end
end
-- 
function TrucoBaseController:getChatPosition(seatId, x, y, w, h, mx, my)
	if seatId == 1 then
		return (x + w), y
	elseif seatId == 2 then
		return (x - mx), (y - my/2)
	elseif seatId == 3 then
		return (x - mx), (y - my/2)
	elseif seatId == 4 then
		return (x + w), (y - my/2)
	end
end
-- 
function TrucoBaseController:playSendChipAnim(srcPlayer, dstPlayer, money)
	money = money or 0
	local srcx, srcy = srcPlayer:getUi():getPos()
	local srcw, srch = srcPlayer:getUi():getSize()
	local dstx, dsty = dstPlayer.dstx, dstPlayer.dsty
	local dstw, dsth = dstPlayer.dstw, dstPlayer.dsth
	local imgChip 		= new(Image, chip_map[string.format('%s.png', money)])
	local textChip 		= new(Text, ToolKit.formatChip(money), 0, 0, kAlignCenter, "", 24, 0xff, 0xff, 0xff);
	local chipW, chipH 	= imgChip.m_res.m_width, imgChip.m_res.m_height
	local textW, textH 	= textChip.m_res.m_width, textChip.m_res.m_height
	srcx, srcy = srcx + (srcw - math.max(chipW, textW)) / 2, srcy + (srch - chipH - textH) / 2
	dstx, dsty = dstx + (dstw - math.max(chipW, textW)) / 2, dsty + (dsth - chipH - textH) / 2
	imgChip:setPos(srcx, srcy)
	-- imgChip:addChild(textChip)
	textChip:setPos((chipW - textW) / 2, chipH)
	self:addChild(imgChip)
	local moveAnim = imgChip:addPropTranslateWithEasing(1, kAnimNormal, 1200, 0, "easeOutSine", "easeOutSine", 0, dstx - srcx, 0, dsty - srcy);
	moveAnim:setEvent(self, function()
		checkAndRemoveOneProp(imgChip, 1)
	end)
	local endAnim = imgChip:addPropTransparency(2, kAnimNormal, 500, 1200, 1.0, 0);
	endAnim:setEvent(self, function()
		checkAndRemoveOneProp(imgChip, 2)
		self:removeChild(imgChip, true)
	end)
	kEffectPlayer:play(Effects.AudioCall)
end
-----------------------------------------------------------------
-----------------------------------------------------------------
-- 获取玩家头像位置
function TrucoBaseController:getLocalSeatPos(localSeatId, sitdown)
	printInfo("getLocalSeatPos localSeatId "..localSeatId)
	if localSeatId<=0 or localSeatId > 4 then
		return
	end
	local width, height = System.getScreenScaleWidth(), System.getScreenScaleHeight()
	local playerWidth, playerHeight = 110, 110
	local pos = {
		[3] = {x = 30, y = height*0.5 - 90},
		[2] = {x = width*0.5-120, y = 30},
		[1] = {x = width - playerWidth - 5, y = height*0.5 - 90},
		[4] = {x = width*0.5 - 610, y = height - 105},
	}
	if localSeatId == TrucoBaseController.MY_LOCAL_SEAT_ID and not sitdown then
		return pos[TrucoBaseController.MY_LOCAL_SEAT_ID].x, pos[TrucoBaseController.MY_LOCAL_SEAT_ID].y, width, height
	end
	return pos[localSeatId].x, pos[localSeatId].y, width, height
end
--取得用户 
function TrucoBaseController:getUserByUid(uid)
    for k, v in pairs(self.mPlayer) do
		if v:getId() == uid then
			return v
		end
	end
    return nil;
end
-- 
function TrucoBaseController:getPlayers()
	return self.mPlayer
end
--[[
	获取自己的绝对桌位号
]]
function TrucoBaseController:getMySeatId()
	for i = 1, #self.mPlayer do
		local player = self.mPlayer[i];
		if player:getId() == MyUserData:getId() --[[or (self.mFollowId and tonumber(self.mFollowId) == player:getId())]] then
			return player:getSeatId();
		end
	end
	return nil
end

function TrucoBaseController:getFollowSeatId()
	for i = 1, #self.mPlayer do
		local player = self.mPlayer[i];
		if self.mFollowId and tonumber(self.mFollowId) == player:getId() then
			return player:getSeatId();
		end
	end
	return nil
end

function TrucoBaseController:getUidByLocalseatid( localSeatId )
	for i = 1, #self.mPlayer do
		local player = self.mPlayer[i];
		local uid = player:getId()
		local localseat = player:getLocalSeatId()
		if uid>0 and localSeatId == localseat then
			return uid
		end
	end
end
--[[
	获取自己对应的玩家
]]
function TrucoBaseController:getMyPlayer()
	local seatId = self:getMySeatId()
	if seatId then
		return self.mPlayer[seatId]
	end
end
-- 
function TrucoBaseController:updatePlayerHeadStyleId()
    local myPlayer = self:getMyPlayer()
    if myPlayer then
        local mySeatId = myPlayer:getSeatId()
        if self.mTableId:isTwoMatch() then
            -- 2人场
            myPlayer:setHeadStyleIdx(1)
            for i,player in ipairs(self.mPlayer) do
                if myPlayer ~= player and player:getSeatId() > 0 then
                    player:setHeadStyleIdx(2)
                    -- if player:getUi() then
                    --     player:getUi():findChildByName("btn_invite"):setVisible(false)
                    -- end
                end
            end
        else
            -- 4 人场
            myPlayer:setHeadStyleIdx(1)
            for _,player in ipairs(self.mPlayer) do
                local seatId = player:getSeatId()
                if myPlayer ~= player and player:getId() > 0 and seatId > 0 then
                    if seatId == mySeatId + 2 or seatId == mySeatId - 2 then
                        player:setHeadStyleIdx(1)
                    else
                        player:setHeadStyleIdx(2)
                    end
                end
            end
        end
    end
end

-- 
function TrucoBaseController:initDelayPoopl()
	self.delayId_ = 0
end

function TrucoBaseController:cancelDelay(id)
	if id and type(id)=="number" then
		checkAndRemoveOneProp(self,id)
	end
end
-- 
function TrucoBaseController:cleanAllDelayProp()
	for i=1,MAX_DELAY_NUM do
		checkAndRemoveOneProp(self, i)
	end
end
-- 
function TrucoBaseController:delayCall(callback, delay, ...)
	self.delayId_ = self.delayId_ + 1
	if self.delayId_%MAX_DELAY_NUM == 0 then
		self.delayId_ = 1
	end

	local currentDelayId = self.delayId_
	-- printInfo("currentDelayId:::1::"..currentDelayId)
	checkAndRemoveOneProp(self,currentDelayId)
	local delayAnim = self:addPropTranslate(currentDelayId,kAnimNormal,0,delay,0,0,0,0);
	if delayAnim then
		delayAnim:setEvent(self,function()
			-- printInfo("currentDelayId:::2::"..currentDelayId)
			checkAndRemoveOneProp(self,currentDelayId)
			callback()
		end)
	else
		callback()
	end
	return self.delayId_
end
-- 用于检测按钮点击间隔
function TrucoBaseController:checkBtnCanClick(btnType)
	if not self.clickTimeDic_ then
		self.clickTimeDic_ = {}
	end
	-- 
	local result = true
	local currentTs = os.clock()
	if not self.clickTimeDic_[btnType] then
		self.clickTimeDic_[btnType] = currentTs
	else
		local diffVal = currentTs - self.clickTimeDic_[btnType]
		if diffVal < 0.6 then
			result = false
		else
			self.clickTimeDic_[btnType] = currentTs
		end
		printInfo("diffVal:::"..tostring(diffVal))
	end
	return result
end
-- 
function TrucoBaseController:getPlayerCount()
	local count = 0
    for k, v in pairs(self.mPlayer) do
		if v:getId() > 0 then
			count = count + 1
		end
	end
    return count
end
-----------------------------------------------------------------
-----------------------------------------------------------------
-- 
function TrucoBaseController:onGetBrokenMoneyResponse(isSuccess, data)
	WindowManager:closeWindowByTag(WindowTag.LobbyExitPopu)
end
--相当于android的resume
function TrucoBaseController:onEventResume()
	-- TrucoBaseController.super.resume(self)
	GameSocketMgr:tryReconnect()
end

--相当于android的pause
function TrucoBaseController:onEventPause()
    if self.mRoomInfo:getLevel() == TrucoBaseController.BUDDY_ROOM_LEVEL then
        local userCount = 0
        --断网的时候，如果房间只有一个人，回来重新建房间，
        --如果房间多于一个人，回来重新进房间
        for i = 1, #self.mPlayer do
            if self.mPlayer[i]:getId() ~= 0 then
                userCount = userCount + 1
            end
        end
        if userCount > 1 then
            self.mRoomInfo.isCreate = kFalse
        else
            self.mRoomInfo.isCreate = kTrue
        end
    end
	GameSocketMgr:closeSocketSync();
end

--HTTP回调
function TrucoBaseController:onHttpRequestsCallBack(command, ...)
	if self.s_severCmdEventFuncMap[command] then
     	self.s_severCmdEventFuncMap[command](self,...)
	end 
end
--HTTP事件
TrucoBaseController.s_severCmdEventFuncMap = {
	[HttpModule.s_cmds.GET_BROKEN_MONEY] 		= TrucoBaseController.onGetBrokenMoneyResponse,
}

TrucoBaseController.messageFunMap = {
	["loginserver"] 			= TrucoBaseController.onLoginServer,
	["sendChatFace"] 			= TrucoBaseController.requestSendFace,
	["sendChatWord"] 			= TrucoBaseController.requestSendWord,
    ["giftSendBroadcast"]       = TrucoBaseController.onGiftSendBroadcast,
    ["acceptPrivateRoomInvite"] = TrucoBaseController.onAcceptPrivateRoomInvite,
    ["serverRetire"]    		= TrucoBaseController.onServerRetire,
}

return TrucoBaseController