
local CircleProgress = class(Node);

function CircleProgress:ctor(fileName)
    CircleProgress.super.ctor(self)
    -- self.colorR = 0
    -- self.colorG = 249
    -- self.colorB = 0
    drawing_set_node_renderable(self.m_drawingID, kRenderTriangleFan, kRenderDataTexture);
    local image  = new(ResImage,fileName,0,1); 
    self.m_image = image;
end


--设置圈的切割百分比 
function CircleProgress:setProgressPecent(rate)    
    local angle = 360 * rate;
   
    local curX, curY  = 0,0;

    local coord = {};
    local index = {};

    if (angle > 0 and angle <= 45) then
		curX = 0.5 * (1 + math.tan(math.rad(angle)));
		curY = 1;

        coord = {0.5, 0.5, 0.5,1.0, curX, curY};
        index = {0,1,2};
	elseif (angle > 45 and angle <= 90) then
		curX = 1;
		curY = 1/2 * (1 + math.tan(math.rad(90-angle)));

        coord = {0.5, 0.5, 0.5,1.0, 1.0,1.0,  curX, curY};
        index = {0,1,2,3};

	elseif (angle > 90 and angle <= 135) then
		curX = 1;
		curY = 1/2 * (1- math.tan(math.rad(angle- 90)));
        coord = {0.5, 0.5, 0.5,1.0, 1.0,1.0, 1.0, 0.5, curX, curY};
        index = {0,1,2,3 ,4};
	elseif (angle > 135 and angle <= 180) then

		curX = 1/2 * (1 + math.tan(math.rad( 180 - angle )));
		curY = 0;
         
        coord = {0.5, 0.5, 0.5,1.0, 1.0,1.0, 1.0, 0.5, 1.0, 0, curX, curY};
        index = {0,1,2,3 ,4, 5};
	elseif (angle > 180 and angle <= 225) then
		curX = 1/2 * (1 - math.tan(math.rad(angle - 180)));
	    curY = 0;

        coord = {0.5, 0.5, 0.5,1.0, 1.0,1.0,1.0,0.5,1.0,0,0.5, 0, curX, curY};
        index = {0,1,2,3 ,4,5,6};

	elseif (angle > 225 and angle <= 270) then
		curX = 0;
		curY = 1/2 * (1 - math.tan(math.rad(270 - angle)));

        coord = {0.5,0.5,0.5,1.0,1.0,1.0,1.0,0.5,1.0,0,0.5,0,0,0, curX, curY};
        index = {0,1,2,3,4,5,6,7};

	elseif (angle > 270 and angle <= 315) then
		curX = 0;
		curY = 1/2 * (1 + math.tan(math.rad(angle - 270)));

        coord = {0.5,0.5,0.5,1.0,1.0,1.0,1.0,0.5,1.0,0,0.5,0,0,0,0,0.5, curX, curY};
        index = {0,1,2,3,4,5,6,7,8};


	elseif (angle > 315 and angle <= 360) then
		curX = 1/2 * (1- math.tan(math.rad(360 - angle)));
		curY = 1;

        coord = {0.5,0.5,0.5,1.0,1.0,1.0,1.0,0.5,1.0,0,0.5,0,0,0,0,0.5,0,1.0, curX, curY};
        index = {0,1,2,3,4,5,6,7,8,9};
    else    
        return;
	end

    --  开始颜色变化 
	--  一开始从 Red 0 -255 后面 Green 249 - 172 达到黄色
	-- if (angle > 135 and angle < 180) then
 --        if self.colorR  < 255 then
 --            self.colorR = math.floor( ((angle - 135) / 45) * 255 );
 --        else
 --            self.colorR = 255
 --            self.colorG = 249  -  math.floor( (angle - 135) / 45 *  (249 - 170) );
 --        end
	-- end

	-- -- 从 260开始 Green 172 - 52 达到红色
	-- if angle > 260 then	
 --        self.colorR = 255	
 --        self.colorG = 172  -  math.floor( (angle - 135) / 45 *  (172 - 52) );          
	-- end

    local w, h   = self:getSize()
    local pw, ph = w * System.getLayoutScale(), h * System.getLayoutScale();
   
    -- self:setColor(self.colorR,self.colorG,self.colorB);
    local image = self.m_image;
    
    local  vertex =  {};

    for i = 1, #coord, 2 do
		vertex[i] = (coord[i] * pw)
		vertex[i+1] =  ph - coord[i+1] * ph
	end

    for i = 1, #coord, 2 do
        coord[i] = coord[i]
        coord[i + 1] = 1.0 - coord[i + 1]
    end

    if (self.m_vertexId) then
		res_set_ushort_array2(self.m_indexId, index);	
		res_set_double_array2(self.m_coordId, coord);
		res_set_double_array2(self.m_vertexId, vertex);
	else
		self.m_vertexId = res_alloc_id();
		self.m_coordId = res_alloc_id();
		self.m_indexId = res_alloc_id();
		res_create_ushort_array2(0, self.m_indexId, index);	
		res_create_double_array2(0, self.m_coordId, coord);
		res_create_double_array2(0, self.m_vertexId, vertex);
	end
	drawing_set_node_vertex(self.m_drawingID, self.m_vertexId, self.m_indexId);
	drawing_set_node_texture(self.m_drawingID, image.m_resID, self.m_coordId);  

end

function CircleProgress:dtor()
   
end
return CircleProgress;